BEGIN				EQU	0
QWDEL				EQU	6
QRDEL				EQU	7
L0026				EQU	26H
CHECKSTACK			EQU	86H
ERROR2				EQU	9BH
PRINTERRMSG			EQU	0A7H
L0168				EQU	0168H
INTFROMFLOAT			EQU	0566H
L05DC				EQU	05DCH
DIGITERWITHCHECMODEPARAM	EQU	08BFH
LONGDELAY			EQU	172BH
PEC				EQU	1DE2H
CHECKADDOPERCODE		EQU	1F33H
INPUTNEXTBYTE			EQU	2142H
INPUTBYTE			EQU	2144H
PROGRAMTXT			EQU	2268H
COWITHEI			EQU	2800H
PORT1				EQU	2EF3H
TAPEMASKA			EQU	3DACH
TAPENAME			EQU	3F08H
CONTROLSUM			EQU	4015H
FLAGSHOWONDISPLEY		EQU	4017H
ADRESBASICBEGINPROGRAM		EQU	4043H
ADRESBASICBEGINDATA		EQU	4045H

	ORG	1A2DH

CHECKALLNAME:				;1A2DH
	PUSH	H
	MOV	A,M
	CPI	'"'	;22H
	JNZ	ERROR2					;9BH

CHECKNAME:				;1A34H
	INX	H
	MOV	A,M
	ORA	A
	JZ	ERROR2					;9BH
	CPI	'"'	;22H
	JNZ	CHECKNAME				;1A34H
	POP	H
	RET

SETEOFANDSUMPROGRAM:			;1A41H
	PUSH	H
	LHLD	ADRESBASICBEGINPROGRAM			;4043H
	LXI	D,BEGIN					;0

L1A48:					;1A48H
	MVI	B,3

L1A4A:					;1A4AH
	MOV	A,M
	ADD	E
	MOV	E,A
	MVI	A,0
	ADC	D
	MOV	D,A
	MOV	A,M
	INX	H
	ORA	A
	JNZ	L1A48					;1A48H
	DCR	B
	JNZ	L1A4A					;1A4AH
	XCHG
	SHLD	CONTROLSUM				;4015H
	POP	H
	RET

LONGWHISTLE:				;1A61H
	MVI	B,0

L1A63:					;1A63H
	CALL	PO					;2B5EH
	DCR	B
	JNZ	L1A63					;1A63H
	DCR	E
	JNZ	LONGWHISTLE				;1A61H
	RET

REPEATWRITE:				;1A6FH
	CALL	PO					;2B5EH
	DCR	E
	JNZ	REPEATWRITE				;1A6FH
	RET

OUTNAMEPROGRAM:				;1A77H
	CALL	WAITINTERRUPT				;1B48H
	PUSH	D
	LXI	D,L05DC					;05DCH
	CALL	LONGDELAY				;172BH
	POP	D
	XRA	A
	MVI	E,1
	CALL	LONGWHISTLE				;1A61H
	MVI	A,0E6H
	CALL	PO					;2B5EH

MODOUT:					;1A8DH
	MVI	A,0D3H
	MVI	E,4
	CALL	REPEATWRITE				;1A6FH

L1A94:					;1A94H
	INX	H
	MOV	A,M
	CPI	'"'	;22H
	JZ	L1AA1					;1AA1H
	CALL	PO					;2B5EH
	JMP	L1A94					;1A94H

L1AA1:					;1AA1H
	INX	H
	XRA	A
	MVI	E,3
	CALL	REPEATWRITE				;1A6FH
	RET

CSAVE:					;1AA9H
	MVI	A,0D3H
	STA	MODOUT+1				;1A8EH
	CALL	CHECKALLNAME				;1A2DH
	CALL	SETEOFANDSUMPROGRAM			;1A41H
	CALL	OUTNAMEPROGRAM				;1A77H
	PUSH	H
	MVI	A,'U'	;55H
	MVI	E,3
	CALL	LONGWHISTLE				;1A61H
	MVI	A,0E6H
	CALL	PO					;2B5EH
	MVI	A,0D3H
	MVI	E,3
	CALL	REPEATWRITE				;1A6FH
	LHLD	ADRESBASICBEGINPROGRAM			;4043H
	DCX	H

L1ACF:					;1ACFH
	MVI	B,3

L1AD1:					;1AD1H
	MOV	A,M
	CALL	PO					;2B5EH
	ORA	A
	INX	H
	JNZ	L1ACF					;1ACFH
	DCR	B
	JNZ	L1AD1					;1AD1H
	LHLD	CONTROLSUM				;4015H
	MOV	A,L
	CALL	PO					;2B5EH
	MOV	A,H
	CALL	PO					;2B5EH

TURNOFFMOTOR:				;1AE9H
	CALL	SETBIT1INPORT1				;1B4FH
	POP	H
	RET

BSAVE:					;1AEEH
	CALL	CHECKADDOPERCODE			;1F33H
	MVI	A,0D2H
	STA	MODOUT+1				;1A8EH
	CALL	CHECKALLNAME				;1A2DH
	CALL	OUTNAMEPROGRAM				;1A77H
	DCX	H
	RST	2
	RST	1
	DB	','
	CALL	DIGITERWITHCHECMODEPARAM		;08BFH
	RST	5
	CALL	INTFROMFLOAT				;0566H
	PUSH	D
	RST	1
	DB	','
	CALL	DIGITERWITHCHECMODEPARAM		;08BFH
	RST	5
	CALL	INTFROMFLOAT				;0566H
	POP	B
	PUSH	H
	PUSH	B
	POP	H
	CALL	CADDR					;1CE4H
	XCHG
	CALL	CADDR					;1CE4H
	XCHG
	MVI	B,0

L1B1F:					;1B1FH
	XRA	A
	CALL	PO					;2B5EH
	DCR	B
	XTHL
	XTHL
	JNZ	L1B1F					;1B1FH
	MVI	A,0E6H
	CALL	PO					;2B5EH
	CALL	HLTOPO					;1D12H
	XCHG
	CALL	HLTOPO					;1D12H
	XCHG

L1B36:					;1B36H
	MOV	A,M
	CALL	POA					;2B60H
	ADD	B
	MOV	B,A
	RST	4
	INX	H
	JNZ	L1B36					;1B36H
	MOV	A,B
	CALL	POA					;2B60H
	JMP	TURNOFFMOTOR				;1AE9H

WAITINTERRUPT:				;1B48H
	XRA	A

SETPORT1CELL:				;1B49H
	STA	PORT1					;2EF3H
	EI
	HLT
	RET

SETBIT1INPORT1:				;1B4FH
	MVI	A,2
	JMP	SETPORT1CELL				;1B49H

BLOAD:					;1B54H
	CALL	CHECKADDOPERCODE			;1F33H
	MVI	A,0D2H
	STA	L1CBE					;1CBEH
	MOV	A,M
	CPI	','	;2CH
	JZ	BLOADNAMELESS				;1B6FH
	CALL	SEARCHNAMEONTAPE			;1C73H
	XCHG
	RST	2
	CPI	','	;2CH
	LXI	D,BEGIN					;0
	JNZ	BLOADSHIFTLESS				;1B78H

BLOADNAMELESS:				;1B6FH
	RST	1
	DB	','
	CALL	DIGITERWITHCHECMODEPARAM		;08BFH
	RST	5
	CALL	INTFROMFLOAT				;0566H

BLOADSHIFTLESS:				;1B78H
	PUSH	D
	POP	B
	PUSH	H
	MVI	H,0

L1B7D:					;1B7DH
	CALL	INPUTNEXTBYTE				;2142H
	CPI	0
	JZ	L1B93					;1B93H
	CPI	0FFH
	JZ	L1B93					;1B93H
	DCR	H
	JNZ	L1B7D					;1B7DH

L1B8E:					;1B8EH
	MVI	E,18H
	JMP	PRINTERRMSG				;0A7H

L1B93:					;1B93H
	MVI	H,14H
	MOV	L,A

L1B96:					;1B96H
	CALL	INPUTNEXTBYTE				;2142H
	CMP	L
	JNZ	L1B8E					;1B8EH
	DCR	H
	JNZ	L1B96					;1B96H
	PUSH	B
	POP	H
	MVI	A,' '	;20H
	PUSH	B
	CALL	CONOUT					;1D0EH
	POP	B
	MVI	A,0FFH
	CALL	INPUTTWOBYTES				;1CDBH
	PUSH	H
	DAD	B
	XCHG
	CALL	INPUTNEXTTWOBYTES			;1CD9H
	POP	H
	DAD	B
	XCHG
	MVI	A,'B'	;42H
	CMP	H
	JNC	ERRCANNNOTUSED				;1BE6H
	PUSH	H
	MVI	B,0

L1BC1:					;1BC1H
	CALL	INPUTNEXTBYTE				;2142H
	MOV	M,A
	ADD	B
	MOV	B,A
	RST	4
	INX	H
	JNZ	L1BC1					;1BC1H
	CALL	INPUTNEXTBYTETOREGC			;1CDFH
	POP	H
	PUSH	B
	CALL	CADDR					;1CE4H
	XCHG
	CALL	CADDR					;1CE4H
	XCHG
	POP	B
	CALL	SETBIT1INPORT1				;1B4FH
	MOV	A,C
	CMP	B
	POP	H
	RZ
	MVI	E,18H
	JMP	PRINTERRMSG				;0A7H

ERRCANNNOTUSED:				;1BE6H
	MVI	E,' '	;20H
	JMP	PRINTERRMSG				;0A7H

VERIFY:					;1BEBH
	LXI	B,0100H
	JMP	L1C10					;1C10H

MERGE:					;1BF1H
	LXI	B,1
	CNZ	CHECKALLNAME				;1A2DH
	PUSH	H
	LHLD	ADRESBASICBEGINDATA			;4045H
	DCX	H
	DCX	H
	SHLD	ADRESBASICBEGINPROGRAM			;4043H
	POP	H
	CALL	L1C17					;1C17H
	LHLD	L0026					;26H
	SHLD	ADRESBASICBEGINPROGRAM			;4043H
	JMP	L1C6B					;1C6BH

CLOAD:					;1C0DH
	LXI	B,BEGIN					;0

L1C10:					;1C10H
	PUSH	PSW
	MVI	A,0D3H
	STA	L1CBE					;1CBEH
	POP	PSW

L1C17:					;1C17H
	ORA	A
	PUSH	PSW
	PUSH	B
	CNZ	SEARCHNAMEONTAPE			;1C73H
	POP	B
	MVI	E,3
	CALL	SEARCHD3BYTES				;1CB3H
	LHLD	ADRESBASICBEGINPROGRAM			;4043H
	CALL	INPUTNEXTBYTE				;2142H

L1C29:					;1C29H
	MVI	E,3

L1C2B:					;1C2BH
	CALL	INPUTNEXTBYTE				;2142H
	INR	B
	DCR	B
	JNZ	L1C3B					;1C3BH
	MOV	M,A
	CALL	CHECKSTACK				;86H
	MOV	A,M
	JMP	L1C3F					;1C3FH

L1C3B:					;1C3BH
	CMP	M
	JNZ	L1C60					;1C60H

L1C3F:					;1C3FH
	ORA	A
	INX	H
	JNZ	L1C29					;1C29H
	DCR	E
	JNZ	L1C2B					;1C2BH
	POP	PSW
	PUSH	H
	JZ	L1C60					;1C60H
	CALL	INPUTNEXTBYTE				;2142H
	MOV	L,A
	CALL	INPUTNEXTBYTE				;2142H
	MOV	H,A
	CALL	SETBIT1INPORT1				;1B4FH
	CALL	SETEOFANDSUMPROGRAM			;1A41H
	XCHG
	LHLD	CONTROLSUM				;4015H
	RST	4

L1C60:					;1C60H
	MVI	E,18H
	JNZ	PRINTERRMSG				;0A7H
	POP	H
	SHLD	ADRESBASICBEGINDATA			;4045H
	DCR	C
	RZ

L1C6B:					;1C6BH
	MVI	A,1
	STA	FLAGSHOWONDISPLEY			;4017H
	JMP	L0168					;0168H

SEARCHNAMEONTAPE:			;1C73H
	MOV	A,M
	CPI	'"'	;22H
	JNZ	ERROR2					;9BH
	CALL	CHECKALLNAME				;1A2DH
	INX	H
	PUSH	H
	LXI	H,RI					;2B05H
	SHLD	INPUTBYTE+2				;2146H

L1C84:					;1C84H
	LXI	H,TAPENAME					;3F08H
	PUSH	H
	MVI	E,4
	CALL	SEARCHD3BYTES				;1CB3H
	CALL	INPUTFLASHOFPROGRAM			;1CC9H
	LXI	H,PROGRAMTXT				;2268H
	CALL	PEC					;1DE2H
	POP	H
	PUSH	H
	EI
	CALL	PEC					;1DE2H
	CALL	WAITINTERRUPT				;1B48H
	POP	H
	POP	D
	PUSH	D

L1CA2:					;1CA2H
	LDAX	D
	CPI	'"'	;22H
	JZ	L1CB1					;1CB1H
	CMP	M
	JNZ	L1C84					;1C84H
	INX	H
	INX	D
	JMP	L1CA2					;1CA2H

L1CB1:					;1CB1H
	POP	H
	RET

SEARCHD3BYTES:				;1CB3H
	MOV	D,E

L1CB4:					;1CB4H
	MOV	E,D
	CALL	WAITINTERRUPT				;1B48H
	MVI	A,0FFH

L1CBA:					;1CBAH
	CALL	INPUTBYTE				;2144H

L1CBE	SET	$+1
	CPI	0D3H
	JNZ	L1CB4					;1CB4H
	DCR	E
	RZ
	MVI	A,8
	JMP	L1CBA					;1CBAH

INPUTFLASHOFPROGRAM:			;1CC9H
	MVI	E,3

L1CCB:					;1CCBH
	CALL	INPUTNEXTBYTE				;2142H
	MOV	M,A
	INX	H
	ORA	A
	JNZ	INPUTFLASHOFPROGRAM			;1CC9H
	DCR	E
	JNZ	L1CCB					;1CCBH
	RET

INPUTNEXTTWOBYTES:			;1CD9H
	MVI	A,8

INPUTTWOBYTES:				;1CDBH
	CALL	INPUTBYTE				;2144H
	MOV	B,A

INPUTNEXTBYTETOREGC:			;1CDFH
	CALL	INPUTNEXTBYTE				;2142H
	MOV	C,A
	RET

CADDR:					;1CE4H
	PUSH	B
	MOV	A,H
	CALL	CBYTE					;1CFAH
	MOV	A,L
	CALL	CBYTEWITHSPACE				;1CEFH
	POP	B
	RET

CBYTEWITHSPACE:				;1CEFH
	PUSH	B
	CALL	CBYTE					;1CFAH
	MVI	A,' '	;20H
	CALL	CONOUT					;1D0EH
	POP	B
	RET

CBYTE:					;1CFAH
	PUSH	PSW
	RRC
	RRC
	RRC
	RRC
	CALL	CLOW					;1D03H
	POP	PSW

CLOW:					;1D03H
	ANI	0FH
	CPI	0AH
	JM	L1D0C					;1D0CH
	ADI	7

L1D0C:					;1D0CH
	ADI	'0'	;30H

CONOUT:					;1D0EH
	MOV	C,A
	JMP	COWITHEI				;2800H

HLTOPO:					;1D12H
	MOV	A,H
	CALL	PO					;2B5EH
	MOV	A,L
	JMP	PO					;2B5EH

;-------------------------------------------------------------

	ORG	2B05H

RI:					;2B05H
	PUSH	B
	PUSH	D
	MVI	C,0
	MOV	D,A
	IN	1
	ANI	10H
	MOV	E,A

L2B0F:					;2B0FH
	IN	1
	ANI	'@'	;40H
	JZ	BEGIN					;0
	IN	1
	ANI	10H
	CMP	E
	JZ	L2B0F					;2B0FH
	RLC
	RLC
	RLC
	RLC
	MOV	A,C
	RAL
	MOV	C,A
	CALL	L2B56					;2B56H
	IN	1
	ANI	10H
	MOV	E,A
	MOV	A,D
	ORA	A
	JP	L2B4B					;2B4BH
	MOV	A,C
	CPI	0E6H
	JNZ	L2B3F					;2B3FH
	XRA	A
	STA	TAPEMASKA					;3DACH
	JMP	L2B49					;2B49H

L2B3F:					;2B3FH
	CPI	19H
	JNZ	L2B0F					;2B0FH
	MVI	A,0FFH
	STA	TAPEMASKA					;3DACH

L2B49:					;2B49H
	MVI	D,9

L2B4B:					;2B4BH
	DCR	D
	JNZ	L2B0F					;2B0FH
	LDA	TAPEMASKA					;3DACH
	XRA	C
	POP	D
	POP	B
	RET

L2B56:					;2B56H
	LDA	QWDEL					;6

DELAY:					;2B59H
	DCR	A
	JNZ	DELAY					;2B59H
	RET

PO:					;2B5EH
	DI
	MOV	C,A

POA:					;2B60H
	PUSH	B
	PUSH	D
	PUSH	PSW
	MOV	D,A
	MVI	C,8

CLCRBIT:				;2B66H
	MOV	A,D
	RLC
	MOV	D,A
	MVI	A,1
	XRA	D
	ANI	1
	OUT	0
	CALL	RDELAY					;2B85H
	MVI	A,0
	XRA	D
	ANI	1
	OUT	0
	CALL	RDELAY					;2B85H
	DCR	C
	JNZ	CLCRBIT					;2B66H
	POP	PSW
	POP	D
	POP	B
	RET

RDELAY:					;2B85H
	LDA	QRDEL					;7
	JMP	DELAY					;2B59H


;-------------------------------------------------------------

	ORG	2414H
	DW	CLOAD
	DW	CSAVE

	ORG	241EH
	DW	VERIFY

	ORG	2426H
	DW	MERGE

	ORG	2446H
	DW	BSAVE
	DW	BLOAD

	END
