;        
;  -------------------------------

	maclib	TEST
	IF	TEST = 1
	Common	/FlPrtD/
	db	'FlPrtD		v.3.48	23-jan-94$'
	ENDIF

Inkey	equ	0f81bh
Buf512	equ	8000h-512		;  DMA

	CSeg

	maclib	STRCT
	STRUCTURE

System	macro	NN
	push	d
	mvi	c,NN
	call	5
	pop	d
	ora	a
	endm

MYSTOP	macro	NN,ZZ
	mIF Z
	lda Count
	dcr a
	sta Count
	mTHEN
	public LStop&ZZ
   LStop&ZZ:  mvi a,NN
	  sta Count
	mENDIF
	DSeg
	public Count
	Count: db NN
	CSeg
	ENDM


extrn OneMarker, ToBigBufer, FromBigBufer, ToOut, FromIn
extrn Find2100, OutHowMany, Stop
extrn IniAll, IniBIn, IniBOut, IniModem, modeOut
extrn HLDE, HLsubDE, HLaddA, MakeFCBName, MakeCName

TRUE		equ	Low -1
FALSE		equ	0

SENDDWNLD	equ	1
WAITBELL	equ	2
SENDFDSCR	equ	3
WAITENQ		equ	4
WAITENUMB	equ	5
SENDBLOCK	equ	6
SENDEOT		equ	7
SENDSOH		equ	8
SENDDATA	equ	9
WAITACK		equ	10

SENDBELL	equ	51
WAITPKT		equ	52
RCVFDSCR	equ	53
SENDENQ		equ	54
RCVPKT		equ	55
RCVLENBLK	equ	56
RCVDATA		equ	57
SENDACK		equ	58
SENDNAK		equ	59

ABEND		equ	91
COMPLETE	equ	92
FMEXIT		equ	93

SOH	equ	1
EOT	equ	4
ENQ	equ	5
ACK	equ	6
NAK	equ	15h
SYN	equ	16h
BELL	equ	7

OK		equ	0
TRABRT		equ	1
USAbort		equ	4
NoBgnConnect	equ	5
NOFILE		equ	6
ERRDISK		equ	7

BELLREPEAT	equ	6
PKTREPEAT	equ	10

SEND	macro	What,NN
	lxi	h,What
	lxi	d,NN
	call	OutMBlk
	endm
RCV	macro	What,NN
	lxi	h,What
	lxi	d,NN
	call	InpMBlk
	endm
DIVHL2	macro
	ora	a
	mov	a,h
	rar
	mov	h,a
	mov	a,l
	rar
	mov	l,a
	endm
	DSeg

int File		; . 
int LENBLK
int AdrDATA

AENQ: db ENQ		;   
int ENUMB
MAXLENBLK: dw 200h

char PKT,1
char excode,1
char path,1
char FMarker,1
char PKTCNT,1
char BELLCNT,1
char RCVF,1		;   
char What,1		;   (false) /  (true)

ADDLINK: db BELL,'ADD_link?',BELL
ANAK: db NAK
AEOT: db EOT
BellV: db BELL,'V'
AACK: db ACK
ASOH: db SOH			;   
int LENBYTES

char FCBF,32+1		; fcb  
char R012,3		;  

public	FD, flen, flen0, dttm, dttm0, bfname, blklen
LineFD	equ	25
FD:
typPKT: db SYN
modeFl: db 'V'
flen:   dw 8	;        
flen0:  dw 0
dttm:   ds 2
dttm0:  ds 2
bfname: db '12345678.$$$',0	;      
blklen: dw 512

EoFD:

	CSeg

public	FileExchange
FileExchange:
	ei
	call	modeOut

	mIF NZ
	lda What
	ora a
	mTHEN					; 
	  lxi h,bfname
	  lxi d,FCBF
	  call MakeFCBName		;  FCBF  bfname
	  mIF P
	    lxi d,FCBF
	    call OpenFile		;  
	    ora a
	  mTHEN
	    LETBC modeFl,'V'
	    System 35			;     128-. 
	    lhld R012
	    shld flen
	    LETBC path,SENDDWNLD
	    call KA
	  mELSE
	    LETBC excode,NOFILE		;    
	  mENDIF
	mELSE					; 
	  LETBC BELLCNT,BELLREPEAT
	  LETBC path,SENDBELL
	  call KA
	mENDIF
	ei
	call Message
	LETBC excode,OK
	ret

;    

public KA
KA:
	call IniMBlk
	DO
	  LETBC FMarker,TRUE

	  SWITCH
	  lda path
	  CASE SENDDWNLD
	    SEND ADDLINK,11
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      LETBC path,WAITBELL
	    mENDIF
	    BREAK

	  CASE WAITBELL
	    RCV PKT,1
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      LETBC path,SENDFDSCR
	      LETBC FMarker,FALSE
	    mENDIF
	    BREAK

	  CASE SENDFDSCR
	    SEND FD,LineFD
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      LETBC path,WAITENQ
	    mENDIF
	    BREAK

	  CASE WAITENQ
	    RCV PKT,1
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      SWITCH
	      lda PKT
	      CASE ENQ
	        LETBC path,WAITENUMB
	        BREAK
	      CASE ACK
	        LETBC excode,OK
	        LETBC path,COMPLETE
	        BREAK
	      CASE NAK
	        LETBC excode,TRABRT
	        LETBC path,ABEND
	        BREAK
	      CASE BELL
	      CASE 'P'
	      CASE 'V'
	        LETBC FMarker,TRUE
	        BREAK
	      DEFAULT
	        LETBC excode,TRABRT
	        LETBC path,ABEND
	      ENDCASE
	    mENDIF
	    BREAK

	  CASE WAITENUMB
	    RCV ENUMB,4		;  MAXLENBLK 
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      LETBC FMarker,FALSE
	      LETBC path,SENDBLOCK
	      call PrepBlkInfo
	    mENDIF
	    BREAK

	  CASE SENDBLOCK
	;    512 ,   (ENUMB-1) 512-. 
	;   LENBLK.   :  ABEND

	    lhld ENUMB
	    dcx h
	    dad h
	    dad h			; 4*(ENUMB-1)
	    shld R012
	    LETWC LENBYTES,0
	    DO
	      lxi d,Buf512
	      lhld LENBYTES
	      dad d
	      xchg
	      System 26		;  DMA
	      SWITCH
	        lxi d,FCBF
	        System 33		;  
	      CASE 0
	        lhld R012
	        inx h
	        shld R012
	        lhld LENBYTES
	        lxi d,80h
	        dad d
	        shld LENBYTES		;   
	        mov a,h
	        cpi 2
	        LEAVE Z		;  512  (200h)
	        BREAK
	      CASE 1
	      CASE 4
	      CASE 6
	        LEAVE			;   
	      DEFAULT
	        LETBC excode,ERRDISK
	        LEAVE
	      ENDCASE
	    ENDDO

	    mIF Z
	      lda excode
	      cpi ERRDISK
	    mTHEN			;      !!!
	      LETBC path,ABEND
	    mENDIF

	    mIF Z
	      lhld LENBYTES
	      dad h
	      mov a,h
	      sta LENBLK		;     128 
	      ora a
	    mTHEN
	      LETBC excode,OK
	      LETBC path,SENDEOT	;   
	    mELSE
	      call ShowBlk		; .   
	      LETBC path,SENDSOH	;  
	    mENDIF

	    mIF Z
	      in 1
	      ani 20h
	    mTHEN
	      LETBC excode,USAbort
	      LETBC path,SENDEOT
	    mENDIF
	    BREAK

	  CASE SENDEOT
	    SEND AEOT,1
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      LETBC path,COMPLETE
	    mENDIF
	    BREAK

	  CASE SENDSOH
	    SEND ASOH,3		;  LENBYTES 
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      LETBC FMarker,FALSE
	      LETBC path,SENDDATA
	    mENDIF
	    BREAK

	  CASE SENDDATA
	    lhld LENBYTES
	    xchg
	    lxi h,Buf512		;   . 
	    call OutMBlk	    
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      lxi h,ENUMB
	      inr m
	      LETBC path,WAITACK
	    mENDIF
	    BREAK

	  CASE WAITACK
	    RCV PKT,1
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      LETBC FMarker,FALSE
	      SWITCH
	      lda PKT
	      CASE ACK
	        LETBC path,SENDBLOCK
	        BREAK
	      DEFAULT
	        LETBC path,ABEND
	        LETBC excode,TRABRT
	      ENDCASE
	    mENDIF
	    BREAK

;------------------------------------------------

	  CASE SENDBELL
	    mIF Z
	      lxi h,BELLCNT
	      dcr m
	    mTHEN
	      LETBC excode,TRABRT
	      LETBC path,ABEND
	      LETBC FMarker,false
	    mELSE
	      SEND BellV,2
	      mIF Z
	        mov a,h
	        ora l
	      mTHEN
	        LETBC path,WAITPKT
	        LETBC PKTCNT,PKTREPEAT
	      mENDIF
	    mENDIF
	    BREAK

	  CASE WAITPKT
	    RCV PKT,1
	    mIF Z
	      mov a,h
	      ora l 
	    mTHEN
	      mIF Z
		lda PKT
	        cpi SYN
	      mTHEN
	        LETBC FMarker,false
	        LETBC path,RCVFDSCR
	        LETBC rcvf,false		;   
	      mELSE
	        mIF Z
	          lxi h,PKTCNT
	          dcr m
	        mTHEN
	          LETBC path,SENDBELL
	        mENDIF
	      mENDIF
	    mENDIF
	    BREAK

	  CASE RCVFDSCR
	    RCV FD+1,LineFD-1
	    mIF Z
	      mov a,h
	      ora l
	    mTHEN
	      LETBC FMarker,false
	     ;        .
	     ;  :
	     ;      - ENUMB:=   512 . ;
	     ;     -  NAK  ABEND;
	     ;      -    ENUMB:=1.
	      lxi h,bfname
	      lxi d,FCBF
	      call MakeFCBName		;  FCBF  bfname
	      mIF P
	        lxi d,FCBF
	        call OpenFile
	      mTHEN
	        System 35		;    128.
	        lhld R012
	        DIVHL2
	        DIVHL2
	        inx h
	        shld ENUMB		;  .512    
	      mELSE
	        mIF P
	          lxi d,FCBF
	          lxi h,12
	          dad d
	          mvi m,0
	          System 22		;  
	        mTHEN
	          LETBC path,SENDENQ
	          LETWC ENUMB,1		;   
	        mELSE
	          LETBC excode,ERRDISK
	          LETBC path,ABEND
	        mENDIF
	      mENDIF
	      mIF NZ
	        lda excode
	        cpi ERRDISK
	      mTHEN
	        LETBC path,SENDENQ
		PRINT <FILE: >
		PRINTDZ bfname		;  .  
	        call CRLF
	        DECW ENUMB		; ENUMB    
	        call PrepBlkInfo
	        INCW ENUMB		;  ENUMB
	      mENDIF
	    mENDIF
	    BREAK

	  CASE SENDNAK
	    SEND ANAK,1
	    mIF Z
	      mov a,h
	      ora l
	    mTHEN
	      LETBC path,ABEND
	    mENDIF
	    BREAK

	  CASE SENDENQ
	    SEND AENQ,5
	    mIF Z
	      mov a,h
	      ora l
	    mTHEN
	      LETBC path,RCVPKT
	    mENDIF
	    BREAK

	  CASE RCVPKT
	    RCV PKT,1
	    mIF Z
	      mov a,h
	      ora l
	    mTHEN
	      LETBC FMarker,false
	      SWITCH
	        lda PKT
	      CASE EOT
	        mIF P
	          lxi d,FCBF
	          System 16		;  
	        mTHEN
	          LETBC path,COMPLETE	; 
	          LETBC rcvf,true
	          LETBC excode,OK
	        mELSE
	          LETBC path,ABEND	;   
	          LETBC excode,ERRDISK
	        mENDIF
	        BREAK
	      CASE SOH
	        LETBC path,RCVLENBLK
	        BREAK
	      DEFAULT
	        LETBC path,ABEND
	        LETBC excode,TRABRT
	      ENDCASE
	      BREAK
	    mENDIF
	    BREAK

	  CASE RCVLENBLK
	    RCV LENBLK,2
	    mIF Z
	      mov a,h
	      ora l
	    mTHEN
	      LETBC FMarker,false
	      LETBC path,RCVDATA
	      LETWC AdrDATA,Buf512
	    mENDIF
	    BREAK

	  CASE RCVDATA
	    lhld LENBLK
	    xchg
	    lhld AdrDATA
	    call InpMBlk	    
	    mIF Z
	      mov a,h
	      ora l
	    mTHEN
	    ;     LENBLK 
	      lhld ENUMB
	      dcx h
	      dad h
	      dad h
	      shld R012
	      lxi d,Buf512
	      DO
	        System 26		;   DMA
	        mIF NZ
	          push d
	          lxi d,FCBF
	          System 34		;     
	          pop d
	        mTHEN
	          LETBC excode,ERRDISK
	          LEAVE
	        mENDIF

	        lxi h,80h		;   DAM
	        dad d
	        xchg
	        INCW R012
	        lhld LENBLK		;     ?
	        lxi b,-80h
	        dad b
	        shld LENBLK
	        mov a,h
	        ora a
	        LEAVE M			;  0
	        ora l
	        LEAVE Z			;  0
	      ENDDO

	      mIF NZ
	        lda excode
	        cpi ERRDISK
	      mTHEN
	        call ShowBlk		;    
	        INCW ENUMB		;    
	        LETBC FMarker,false
	        LETBC path,SENDACK
	      mELSE
	        LETBC path,ABEND
	      mENDIF

	      mIF Z
	        in 1
	        ani 20h
	      mTHEN
	        LETBC excode,USAbort
	        LETBC path,SENDNAK
	      mENDIF

	    mENDIF
	    BREAK

	  CASE SENDACK
	    SEND AACK,1
	    mIF Z
	      mov a,h
	      ora l
	    mTHEN
	      LETBC path,RCVPKT
	    mENDIF
	    BREAK

;------------------------------------------------

	  CASE COMPLETE
	    LETBC path,FMEXIT
	    LETBC FMarker,false
	    BREAK

	  CASE ABEND
	   ;     :  
	    lxi d,FCBF
	    System 16		;  
	    LETBC path,FMEXIT
	    LETBC FMarker,false
	    BREAK

	  CASE FMEXIT
	    mIF Z			;     
	      call OutHowMany		;     
	      mov a,h
	      ora l
	    mTHEN
	      LEAVE
	    mENDIF
	    BREAK

	  DEFAULT
	    LETBC excode,99h		;   
	    LEAVE

	  ENDCASE

	  ei
	  mIF NZ
	    lda FMarker
	    ora a
	  mTHEN
	    SWITCH
	      call OneMarker
	      mov a,l
	    CASE OK
	      BREAK
	    CASE USAbort
	      mIF Z
	        in 1			;    + -  
	        ani 60h			;   
	      mTHEN
	        jmp Stop
	      mENDIF
	      BREAK
	    DEFAULT
	      sta excode
	      LETBC path,ABEND
	    ENDCASE
	  mENDIF

	ENDDO

	ret


;     .    

PrepBlkInfo:
	PRINTLN <NUMBER BLOCK(S)>
	lhld flen
	lxi d,3
	dad d
	DIVHL2
	DIVHL2
	lxi b,AllBlocks
	call DecHex
	lhld ENUMB
	lxi b,NBlocks
	Call DecHex
	PRINTD TBlocks
	PRINTD ABlocks
	ret

ShowBlk:
	lhld ENUMB		;  .    
	lxi b,NBlocks
	call DecHex
	PRINTD TBlocks
	ret

	DSeg
public	TBlocks
TBlocks:
	db	' '		;     /
NBlocks:
	db	'0000',0dh,'$'
ABlocks:
	db	18h,18h,18h,18h,18h,18h,18h,18h
AllBlocks:
	db	'0000',0dh,'$'
	CSeg


; /     
; :
;     ( Line=0)
;     <de> -  
;     <hl> - /
;        (Line<>0)
;     Line -  ;     
;     Where - /
; :
;   <hl> -  

public	OutMBlk,InpMBlk, IniMBlk
IniMBlk:
	LETWC	Line,0
	ret

OutMBlk:
	push	h
	lxi	h,ToBigBufer
	jmp	PrepMBlk
InpMBlk:
	push	h
	lxi	h,FromBigBufer
PrepMBlk:
	shld	modMBlk

	lhld	Line
	mov	a,h
	ora	l
	jz	FirstMBlk
	xchg				; 
	pop	h
	lhld	Where
	jmp	WorkMBlk
FirstMBlk:
	pop	h			;    
WorkMBlk:
	push	d			;  
	push	h			; /
modMBlk	equ	$+1
	call	0
	xchg				; <de> -  
	pop	h			;   /
	dad	d
	shld	Where			;   /
	pop	h			; <hl> -  
	call	HLsubDE			; <hl>:=()-()->
	shld	Line
	ret

	DSeg

public	Line, Where
Line:
	ds	2
Where:
	ds	2

	CSeg

;   
;  :
;    <de> - fcb
;  :
;    <a> -  

public	OpenFile
OpenFile:
	xra	a
	lxi	h,32
	dad	d
	mov	m,a
	lxi	h,12
	dad	d
	mov	m,a
	System	15
	ret


;   DEC 
;  :
;    <hl> - HEX
;    <bc> -   4-  DEC ASCII 

ChDec	macro	Decimal
	lxi	d,Decimal
	call	ODeHe
	endm

public	DecHex
DecHex:
	push	b
	mvi	a,'#'
	rept 4 ! stax b ! inx b ! endm
	pop	b
	lxi	d,10000		;    4- . 
	call	HLDE
	rnc
	push	b
	ChDec	1000
	ChDec	100
	ChDec	10
	ChDec	1
	pop	h
	mvi	b,3
clDHS:	mov	a,m
	cpi	'0'
	rnz
	mvi	m,' '
	inx	h
	jmp	clDHS
ODeHe:
	push	b
	mvi	b,'0'-1
clODH:	call	HLsubDE
	inr	b
	jnc	clODH
	dad	d
	mov	a,b
	pop	b
	stax	b
	inx	b
	ret


public	Message, CRLF
CRLF:
	lxi	d,TCRLF
	jmp	Type
Message:
	call	CRLF
	lda	excode
	cpi	8
	jc	$+5
	mvi	a,8
	add	a
	lxi	h,TabAMsg
	call	HLaddA
	mov	e,m
	inx	h
	mov	d,m
Type:	mvi	c,9
	call	5
	ret

	DSeg
TabAMsg:
	dw	MsgGood, MsgBadLine, MsgBadLine, MsgBadLine, MsgCTRL
	dw	MsgNoConnect, MsgNoFile, MsgErrDisk
	dw	MsgBad

MsgGood:
	db	'FILE TRANSFEARED',0dh,0ah,'$'
MsgBadLine:
	db	'BAD LINE',0dh,0ah,'$'
MsgCTRL:
	db	'USER ABORT',0dh,0ah,'$'
MsgNoConnect:
	db	'NO CONNECT',0dh,0ah,'$'
MsgNoFile:
	db	'FILE IS ABSENT',0dh,0ah,'$'
MsgErrDisk:
	db	'DISK ERROR',0dh,0ah,'$'
MsgBad:
	db	'ERROR'
TCRLF:	db	0dh,0ah,'$'

	end


