;;						- 1 -
;;******************************************************
;;    blok poddervki apparatnyh sredstw 'wektor-06c'
;;  --------------------------------------------------
;;  wers.1.1				data:21-DEC-90
;;******************************************************
;;
BLOCK	EQU	999
;;
	MACLIB	LIFE
;;
	ORG	0100H
;;
	JMP	BEGIN
	JMP	RI
	JMP	PO
	JMP	INKEY
	JMP	BORD
	JMP	SCROLL
	JMP	SETCLR
;;
BEGIN:
	DI
	LXI	SP,100H
	XRA	A
	OUT	10H
	MVI	A,JMP
	STA	0
	STA	38H
	LXI	H,100H
	SHLD	1
	LXI	H,IRQ8
	SHLD	39H
	EI
	JMP	LIFE0
;;
COUNTKEYS:		DB	0
FIRSTDELAY:		DB	0
FLGRUSLATKEYONOFF:	DB	0
LASTKEY:		DB	0FFH
NEXTDELAY:		DB	0
READMASKA:		DB	0
RINGBUFERKEYS:		DB	0,0,0,0,0,0,0,0
			DB	0,0,0,0,0,0,0,0
SCROLLCELL:		DB	0
SHIFTKEYFROMBUF:	DB	0
SHIFTKEYTOBUF:		DB	0
TIMEWORD:		DW	0
;;
BORD: 
	STA	BORDCELL
	RET
SCROLL: 
	PUSH	PSW
	PUSH	B
	STA	SCROLLCELL
	POP	B
	POP	PSW
	RET
;;;;						- 2 -
SETCLR: 
	PUSH	H
	PUSH	D
	PUSH	B
	PUSH	PSW
	MVI	C,10H
	LXI	H,TABCLR
CSETCLR: 
	LDAX	D
	MOV	M,A
	INX	D
	INX	H
	DCR	C
	JNZ	CSETCLR
	POP	PSW
	POP	B
	POP	D
	POP	H
	RET
RI:
	PUSH	B
	PUSH	D
	MVI	C,0
	MOV	D,A
	IN	1
	ANI	00110000B
	MOV	E,A
CHLEVEL: 
	IN	1
	ANI	00110000B	; ss
	CMP	E
	JZ	CHLEVEL
	RLC
	RLC
	RLC
	CMC
	JC	EXREAD
	RLC
	MOV	A,C
	RAL
	MOV	C,A
	CALL	RDELAY
	IN	1
	ANI	00110000B	; ss
	MOV	E,A
	MOV	A,D
	ORA	A
	JP	NEXTBIT
	MOV	A,C
	CPI	0E6H
	JNZ	NOT0E6H
	XRA	A
	STA	READMASKA
	JMP	FINDSYNHRO
;;;;						- 3 -
NOT0E6H: 
	CPI	19H
	JNZ	CHLEVEL
	MVI	A,0FFH
	STA	READMASKA
FINDSYNHRO: 
	MVI	D,9
NEXTBIT: 
	DCR	D
	JNZ	CHLEVEL
	LDA	READMASKA
	XRA	C
EXREAD:
	POP	D
	POP	B
	RET
RDELAY: 
	PUSH	PSW
	LDA	RDCELL
	DCR	A		; poprawka na wyhod po us
DELAY: 
	MOV	B,A
	POP	PSW
DELC: 
	DCR	B
	JNZ	DELC
	RET
PO: 
	PUSH	B
	PUSH	D
	PUSH	PSW
	MOV	D,A
	MVI	C,8
NEXTWRTBIT: 
	MOV	A,D
	RLC
	MOV	D,A
	MVI	A,1
	XRA	D
	ANI	1
	OUT	0
	CALL	WDELAY
	MVI	A,0
	XRA	D
	ANI	1
	OUT	0
	CALL	WDELAY
	DCR	C
	JNZ	NEXTWRTBIT
	POP	PSW
	POP	D
	POP	B
	RET
WDELAY: 
	PUSH	PSW
	LDA	WRTCELL
	JMP	DELAY
WRTCELL: 
	DB	'2'
RDCELL:
	DB	'K'
;;;;						- 4 -
INKEY: 
	PUSH	B
	PUSH	H
	LXI	H,COUNTKEYS
	MOV	A,M
	ORA	A
	JNZ	L0BF7
	DCR	A
	POP	H
	POP	B
	RET
L0BF7: 
	DCR	M
	LXI	H,RINGBUFERKEYS
	LDA	SHIFTKEYFROMBUF
	MOV	C,A
	MVI	B,0
	DAD	B
	INR	A
	ANI	0FH
	STA	SHIFTKEYFROMBUF
	MOV	A,M
	POP	H
	POP	B
	RET
FKEY: 
	LDA	COUNTKEYS
	ANA	A
	RZ
	MVI	A,0FFH
	RET
TABCLR: 
	DB	'@',80H,' ',0D0H,6,86H,16H
	DB	'6',0,0C5H,'"',0C0H,2,98H,'R'
	DB	0ADH
IRQ8: 
	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	LXI	D,100FH
	LXI	H,TABCLR+15
SETCOLOR: 
	MOV	A,E
	OUT	2
	MOV	A,M
	OUT	0CH
	DCX	H
	OUT	0CH
	DCR	E
	OUT	0CH
	DCR	D
	OUT	0CH
	INR	D
	OUT	0CH
	DCR	D
	OUT	0CH
	JNZ	SETCOLOR
;;;;						- 5 -
	LHLD	TIMEWORD
	INX	H
	SHLD	TIMEWORD
	MVI	A,8AH
	OUT	0
	MVI	A,2
	OUT	1
	IN	1
	ANI	80H
	JNZ	OFFRUSLATKEY
	LDA	FLGRUSLATKEYONOFF
	ORA	A
	JZ	ALREADYRUSLATKEYON
	XRA	A
	STA	FLGRUSLATKEYONOFF
	LDA	RUSLATCELL
;	XRI	8
	STA	RUSLATCELL
	JMP	ALREADYRUSLATKEYON
OFFRUSLATKEY: 
	MVI	A,0FFH
	STA	FLGRUSLATKEYONOFF
ALREADYRUSLATKEYON: 
	XRA	A
	OUT	3
	IN	2
	CPI	0FFH
	JNZ	ONESKEYISON
; ALL KEYS ARE NOT PUSH
	STA	LASTKEY
	CMA
	STA	FIRSTDELAY
	JMP	EXIRQ8
ONESKEYISON: 
	LXI	B,0FE08H
	LXI	D,0800H
	MOV	A,B
LINEKEY: 
	OUT	3
	IN	2
	CPI	0FFH
	JNZ	FINDONEKEY
	MOV	A,E
	ADD	D
	MOV	E,A
	MOV	A,B
	RLC
	MOV	B,A
	DCR	C
	JNZ	LINEKEY
; ALL KEYS ARE NOT PUSH
	XRA	A
	STA	FIRSTDELAY
	CMA
	STA	LASTKEY
	JMP	EXIRQ8
FINDONEKEY: 
	RAR
	JNC	EXFINDONEKEY
	INR	E
	JMP	FINDONEKEY
;;;;						- 6 -
EXFINDONEKEY: 
	MOV	A,E
	CPI	'?'	;3FH
	JNZ	FINDNOTSPACEKEY
; IT IS FIND SPACE KEY
	CALL	FINDBITSSUS
	ANI	'@'	;40H
	MVI	A,' '	;20H
	JNZ	PUSHKEYTOBUFER
	ADD	E
	JMP	PUSHKEYTOBUFER
FINDNOTSPACEKEY: 
	CPI	10H
	JP	NORMALKEYS
	LXI	H,TABSPECIALKEYS
	ADD	L
	MOV	L,A
	JNC	ITISINXH
	INR	H
ITISINXH: 
	MOV	A,M
	JMP	PUSHKEYTOBUFER
TABSPECIALKEYS: 
	DB	9,0AH,0DH,7FH,8,19H,18H,1AH
	DB	0CH,1FH,1BH,0,1,2,3,4
NORMALKEYS: 
	CPI	' '	;20H
	JP	FORKEYSFROM40TO7FH
	CPI	1CH
	JP	CHCHAR
	CALL	FINDBITSSUS
	ANI	' '	;20H
CH4CHAR: 
	MOV	A,E
	JZ	SETKEYSBYSSKEY
	ADI	10H
SETKEYSBYSSKEY: 
	ADI	10H
	JMP	PUSHKEYTOBUFER
; CHANGE PRIORITET CHARACT. , - . /
CHCHAR: 
	CALL	FINDBITSSUS
	ANI	' '	;20H
	SUI	' '	;20H
	JMP	CH4CHAR
FORKEYSFROM40TO7FH: 
	CALL	FINDBITSSUS
	ANI	'@'	;40H
	JNZ	KEYUSISOFF
	MOV	A,E
	SUI	' '	;20H
	JMP	PUSHKEYTOBUFER
KEYUSISOFF: 
	LDA	RUSLATCELL
	ANI	8
	MOV	A,E
	JZ	SETLATKEYS
	ADI	' '	;20H
;;;;						- 7 -
SETLATKEYS: 
	ADI	' '	;20H
PUSHKEYTOBUFER: 
	MOV	B,A
	LDA	LASTKEY
	CMP	B
	JNZ	THATKEYWASOFF
	LDA	FIRSTDELAY
	CPI	'('	;28H
	JZ	FIRSTDELAYISENDED
	INR	A
	STA	FIRSTDELAY
	JMP	EXIRQ8
FIRSTDELAYISENDED: 
	LDA	NEXTDELAY
	CPI	0AH
	JZ	NEXTDELAYISENDED
	INR	A
	STA	NEXTDELAY
	JMP	EXIRQ8
NEXTDELAYISENDED: 
	XRA	A
	STA	NEXTDELAY
THATKEYWASOFF: 
	MOV	A,B
	STA	LASTKEY
	CALL	PUSHKEYTORINGBUFER
	JMP	EXIRQ8
PUSHKEYTORINGBUFER: 
	LDA	COUNTKEYS
	CPI	10H
	RZ
	INR	A
	STA	COUNTKEYS
	LDA	SHIFTKEYTOBUF
	MOV	E,A
	MVI	D,0
	LXI	H,RINGBUFERKEYS
	DAD	D
	INR	A
	ANI	0FH
	STA	SHIFTKEYTOBUF
	MOV	M,B
	RET
;;;						- 8 -
EXIRQ8: 
	LDA	RUSLATCELL
	ANI	9
	MOV	H,A
	LDA	BITONOFFTV
	ANI	2
	ADD	H
	MOV	H,A
	MVI	A,88H
	OUT	0
	MOV	A,H
	OUT	1
	LDA	SCROLLCELL
	OUT	3
	LDA	BORDCELL
	ANI	0FH
	OUT	2
	POP	H
	POP	D
	POP	B
	POP	PSW
	EI
	RET
FINDBITSSUS: 
	IN	1
	ANI	60H
	RNZ
	MVI	A,60H
	RET
RUSLATCELL: 
	DB	2
BORDCELL: 
	DB	1
COLORFORDCOLOR: 
	DB	0
BITONOFFTV: 
	DB	2
;;
	END

