
;         '-06'
;  ---------------------------------------------------
;  vers.1.3				data:16-oct-92

	CSeg

public	Begin
Begin:
	di
	xra	a
	out	10h
	mvi	a,jmp
	sta	0
	sta	38h
	lxi	h,100h
	shld	1
	lxi	h,irq7
	shld	39h
	ei
	ret

	DSeg

CountKeys:		db	0
FirstDelay:		db	0
lastkey:		db	0ffh
nextdelay:		db	0
readmaska:		db	0
ringbuferkeys:		ds	16
scrollcell:		db	0ffh
shiftkeyfrombuf:	db	0
shiftkeytobuf:		db	0
timeword:		dw	0
wrtcell: 		db	32h
rdcell:			db	4bh
bordcell: 		db	1
colorfordcolor: 	db	0
bitonofftv: 		db	2

flgruslat:		db	0
ruslat: 		db	2

flgregister:		db	0
register:		db	0

	CSeg

public	SetBord
SetBord:
	sta	BordCell
	ret

public	SetScroll
SetScroll: 
	sta	ScrollCell
	ret

public	SeeScroll
SeeScroll:
	lda	ScrollCell
	ret

public	SetTime
SetTime:
	shld	TimeWord
	ret

public	SeeTime
SeeTime:
	lhld	TimeWord
	ret

public	SetClr
SetClr: 
	push	h
	push	b
	mvi	c,10h
	lxi	h,TabClr
	call	copy
	pop	b
	pop	h
	ret

public	Copy
Copy:
	ldax	d
	mov	m,a
	inx	d
	inx	h
	dcr	c
	jnz	Copy
	ret

;     
;  :
;    <a> = -1 -  
;	 =  8 - . 
;  :
;     =1 -      ()

public	RI
RI:
	push	b
	push	d
	mvi	c,0
	mov	d,a
	in	1
	ani	00110000b
	mov	e,a
chlevel: 
	in	1
	ani	00110000b	; ss
	cmp	e
	jz	chlevel
	rlc
	rlc
	rlc
	cmc
	jc	exread
	rlc
	mov	a,c
	ral
	mov	c,a
	call	rdelay
	in	1
	ani	00110000b	; ss
	mov	e,a
	mov	a,d
	ora	a
	jp	nextbit
	mov	a,c
	cpi	0e6h
	jnz	not0e6h
	xra	a
	sta	readmaska
	jmp	findsynhro

not0e6h: 
	cpi	19h
	jnz	chlevel
	mvi	a,0ffh
	sta	readmaska
findsynhro: 
	mvi	d,9
nextbit: 
	dcr	d
	jnz	chlevel
	lda	readmaska
	xra	c
exread:
	pop	d
	pop	b
	ret
rdelay: 
	push	psw
	lda	rdcell
	dcr	a		; poprawka na wyhod po us
delay: 
	mov	b,a
	pop	psw
delc: 
	dcr	b
	jnz	delc
	ret

public	PO
PO: 
	push	b
	push	d
	push	psw
	mov	d,a
	mvi	c,8
nextwrtbit: 
	mov	a,d
	rlc
	mov	d,a
	mvi	a,1
	xra	d
	ani	1
	out	0
	call	wdelay
	mvi	a,0
	xra	d
	ani	1
	out	0
	call	wdelay
	dcr	c
	jnz	nextwrtbit
	pop	psw
	pop	d
	pop	b
	ret

wdelay: 
	push	psw
	lda	wrtcell
	jmp	delay

public	Inkey
Inkey: 
	push	b
	push	h
	lxi	h,CountKeys
	mov	a,m
	ora	a
	jnz	l0bf7
	dcr	a
	pop	h
	pop	b
	ret
l0bf7: 
	dcr	m
	lxi	h,ringbuferkeys
	lda	shiftkeyfrombuf
	mov	c,a
	mvi	b,0
	dad	b
	inr	a
	ani	0fh
	sta	shiftkeyfrombuf
	mov	a,m
	pop	h
	pop	b
	ret

public	FKey
FKey: 
	lda	CountKeys
	ana	a
	rz
	mvi	a,0ffh
	ret

public	TabClr
TabClr: 
	db	000h,080h,020h,0d0h,006h,086h,016h,036h
	db	0ffh,0c5h,022h,0c0h,002h,098h,052h,0adh

public	irq7
irq7: 
	push	psw
	push	b
	push	d
	push	h
	lxi	d,100fh
	lxi	h,TabClr+15
setcolor: 
	mov	a,e
	out	2
	mov	a,m
	out	0ch
	dcx	h
	out	0ch
	dcr	e
	out	0ch
	dcr	d
	out	0ch
	inr	d
	out	0ch
	dcr	d
	out	0ch
	jnz	setcolor
	lhld	timeword
	inx	h
	shld	timeword
	mvi	a,8ah
	out	0
	mvi	a,2
	out	1

	in	1
	ani	80h
	jnz	offruslatkey
	lda	flgruslat
	ora	a
	jz	skipruslat
	xra	a
	sta	flgruslat
	lda	ruslat
	xri	8				; tolxko russkie bukwy
	sta	ruslat
	jmp	skipruslat
offruslatkey: 
	mvi	a,0ffh
	sta	flgruslat
skipruslat:

	in	1
	ani	60h
	jnz	offregister
	lda	flgregister
	ora	a
	jz	skipregister
	xra	a
	sta	flgregister
	lda	register
	xri	8				; tolxko russkie bukwy
	sta	register
	jmp	skipregister
offregister:
	mvi	a,0ffh
	sta	flgregister
skipregister:

	xra	a
	out	3
	in	2
	cpi	0ffh
	jnz	oneskeyison
; all keys are not push
	sta	lastkey
	cma
	sta	FirstDelay
	jmp	exirq7
oneskeyison: 
	lxi	b,0fe08h
	lxi	d,0800h
	mov	a,b
linekey: 
	out	3
	in	2
	cpi	0ffh
	jnz	findonekey
	mov	a,e
	add	d
	mov	e,a
	mov	a,b
	rlc
	mov	b,a
	dcr	c
	jnz	linekey
; all keys are not push
	xra	a
	sta	FirstDelay
	cma
	sta	lastkey
	jmp	exirq7
findonekey: 
	rar
	jnc	exfindonekey
	inr	e
	jmp	findonekey

exfindonekey: 
	mov	a,e
	cpi	3fh
	jnz	findnotspacekey
; it is find space key
	call	findbitssus
	ani	40h
	mvi	a,20h
	jnz	pushkeytobufer
	add	e
	jmp	pushkeytobufer
findnotspacekey: 
	cpi	10h
	jp	normalkeys
	lxi	h,tabspecialkeys
	add	l
	mov	l,a
	jnc	itisinxh
	inr	h
itisinxh: 
	mov	a,m
	jmp	pushkeytobufer

tabspecialkeys: 
	db	9,0ah,0dh,7fh,8,19h,18h,1ah
	db	0ch,1fh,1bh,0,1,2,3,4

normalkeys: 
	cpi	20h
	jp	forkeysfrom40to7fh
	cpi	1ch
	jp	chchar
	call	findbitssus
	ani	20h
ch4char: 
	mov	a,e
	jz	setkeysbysskey
	adi	10h
setkeysbysskey: 
	adi	10h
	jmp	pushkeytobufer

; change prioritet charact. , - . /
chchar: 
	call	findbitssus
	ani	20h
	sui	20h
	jmp	ch4char
forkeysfrom40to7fh: 
	call	findbitssus
	ani	40h
	jnz	keyusisoff
	mov	a,e
	sui	20h
	jmp	pushkeytobufer
keyusisoff: 
	lda	register
	ani	8
	mov	a,e
	jz	setupreg
	adi	20h
setupreg: 
	adi	20h
pushkeytobufer: 
	mov	b,a
	lda	lastkey
	cmp	b
	jnz	thatkeywasoff
	lda	FirstDelay
	cpi	28h
	jz	FirstDelayisEnded
	inr	a
	sta	FirstDelay
	jmp	exirq7
FirstDelayisEnded: 
	lda	nextdelay
	cpi	0ah
	jz	nextdelayisended
	inr	a
	sta	nextdelay
	jmp	exirq7
nextdelayisended: 
	xra	a
	sta	nextdelay
thatkeywasoff: 
	mov	a,b
	sta	lastkey
	call	pushkeytoringbufer
	jmp	exirq7
pushkeytoringbufer: 
	lda	CountKeys
	cpi	10h
	rz
	inr	a
	sta	CountKeys
	lda	shiftkeytobuf
	mov	e,a
	mvi	d,0
	lxi	h,ringbuferkeys
	dad	d
	inr	a
	ani	0fh
	sta	shiftkeytobuf
	mov	a,b
	cpi	20h
	jc	specandss

	lda	ruslat
	ani	8
	jnz	ruschar
	mov	m,b
	ret

ruschar:
	mov	a,b
	cpi	40h
	jnc	rchar
	mov	m,b
	ret
rchar:
	cpi	60h
	mvi	a,60h
	jnc	$+5
	mvi	a,0a0h
	add	b
	mov	m,a
	ret

specandss:
	in	1			; <> + . . -->  7 := 1
	ani	20h
	mvi	a,80h
	jz	$+4
	xra	a
	ora	b
	mov	m,a
	ret

exirq7: 
	lda	ruslat
	ani	9
	mov	h,a
	lda	bitonofftv
	ani	2
	add	h
	mov	h,a
	mvi	a,88h
	out	0
	mov	a,h
	out	1
	lda	scrollcell
	out	3
	lda	bordcell
	ani	0fh
	out	2
	pop	h
	pop	d
	pop	b
	pop	psw
	ei
	ret
findbitssus: 
	in	1
	ani	60h
	rnz
	mvi	a,60h
	ret

	end

