
;************************************************
;	wwod/wywod na magn. w formate 'MON'
;  -------------------------------------------
;  wers.2.5			data:19-MAR-92
;************************************************

PO	EQU	0F80CH
RI	EQU	0F806H
TYPE	EQU	0230EH
CONIN	EQU	0F803H
CONOUT	EQU	0F809H
CRLF	EQU	024E3H

	CSEG

;  wywod fajla na magnitofon w formate 'MON'
;  whod:
;    (FILE) - adres na~ala fajla
;    (FILENAME) - adres imeni fajla (11 liter)
;    (LINE) - dlina fajla w bajt
;  dop.whod:
;    (BOF) - adres zagruzki w monitore (100H)

PUBLIC	WRITETAPE
WRITETAPE:
	LXI	H,0
	DAD	SP
	SHLD	STACK

	CALL	POCTRL
	CALL	WAITMOTOR
	DI
	CALL	WRITENAMETOTAPE
	MVI	B,0

SECONDWHISTLE:
	XRA	A
	CALL	POCTRL
	DCR	B
	XTHL
	XTHL
	JNZ	SECONDWHISTLE
	MVI	A,0E6H
	CALL	POCTRL
	LHLD	BOF
	CALL	POHL		; adres zagruzki
	XCHG
	LHLD	LINE
	XCHG
	DAD	D
	DCX	H
	CALL	POHL		; adres konca fajla
	LHLD	FILE

WRITEBYTE:
	MOV	A,M
	CALL	POCTRL
	ADD	B
	MOV	B,A

	INX	H
	MOV	A,L		; propustitx |kran
	ORA	A
	JNZ	NOTSCR
	MOV	A,H
	CPI	0A0H
	JNZ	NOTSCR
	MVI	H,0E0H
NOTSCR:
	DCX	D
	MOV	A,D
	ORA	E
	JNZ	WRITEBYTE
	MOV	A,B
	CALL	POCTRL

EXIT:
	LHLD	STACK
	SPHL
	RET

TXTWAIT:
	DB	0DH,0AH
	DB	'TURN ON RECORDER AND '

PUBLIC	TXTKEY
TXTKEY:
	DB	'PUSH ANY KEY',0DH,0AH,0

LONGWHISTLE:
	MVI	B,0

L02D2:
	CALL	POCTRL
	DCR	B
	JNZ	L02D2
	DCR	E
	JNZ	LONGWHISTLE
	RET

SHORTWHISTLE:
	CALL	POCTRL
	DCR	E
	JNZ	SHORTWHISTLE
	RET

WRITENAMETOTAPE:
	XRA	A
	MVI	E,1
	CALL	LONGWHISTLE
	MVI	A,0E6H
	CALL	POCTRL
	MVI	A,0D2H
	MVI	E,4
	CALL	SHORTWHISTLE

	MVI	E,11
	LHLD	FILENAME
CLCNAME:
	MOV	A,M
	INX	H
	CALL	POCTRL
	DCR	E
	JNZ	CLCNAME

	XRA	A
	MVI	E,3
	CALL	SHORTWHISTLE
	RET

POHL:
	MOV	A,H
	CALL	POCTRL
	MOV	A,L
	JMP	POCTRL

WAITMOTOR:
	MVI	A,96H

WAIT:
	HLT
	PUSH	PSW
	IN	1
	ANI	40H
	JZ	TYBADDATA
	POP	PSW
	DCR	A
	JNZ	WAIT
	RET


POCTRL:
	PUSH	PSW
	IN	1
	ANI	'@'
	JZ	TYBADDATA
	POP	PSW
	JMP	PO

;------------------------------------------

;  wwod fajla s magnitofona w formate 'MON'
;  whod:
;    (FILE) - adres na~ala fajla
;    (FILENAME) - adres imeni fajla (11 liter)
;    (LINE) - MAX razre{. dlina fajla w bajt
;  wyhod:
;    flag C=1 - o{ibka pri wwode

PUBLIC	READTAPE
READTAPE:
	LXI	H,0
	DAD	SP
	SHLD	STACK

	CALL	PREPTAPE

	CALL	PO
	HLT
	DI
	CALL	FINDNAMEONTAPE
	CALL	PODI
	MVI	H,0

FINDBGOW:
	CALL	RINEXTCTRLKEY
	CPI	0
	JZ	FRSTOFWHISTLE
	CPI	0FFH
	JZ	FRSTOFWHISTLE
	DCR	H
	JNZ	FINDBGOW

FINDBADDATA:
	JMP	TYBADDATA

FRSTOFWHISTLE:
	MVI	H,14H
	MOV	L,A

FINDLONGWHISTLE:
	CALL	RINEXTCTRLKEY
	CMP	L
	JNZ	FINDBADDATA
	DCR	H
	JNZ	FINDLONGWHISTLE
	MVI	A,0FFH
	CALL	RIBC
	MOV	H,B
	MOV	L,C
	SHLD	BOF
	CALL	RINEXTBC
	MOV	H,B
	MOV	L,C
	XCHG
	LDA	BOF
	CMA
	MOV	L,A
	LDA	BOF+1
	CMA
	MOV	H,A
	INX	H
	DAD	D
	INX	H
	XCHG			; dlina fajla na magn.

PUBLIC	TESTR
TESTR:
	LHLD	LINE
	CALL	HLDE
	XCHG
	JC	VERYLONG

	SHLD	LINE		; dlina fajla
	XCHG
	LXI	H,0		; dlina dopoln.
	JMP	FLRD

PUBLIC	VERYLONG
VERYLONG:			; sli{kom dlinnyj fajl
	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
FLRD:
	SHLD	LINEND		; dlina ostatka

	LHLD	FILE
	PUSH	H
	PUSH	D
	MVI	B,0

READFILE:
	CALL	RINEXTCTRLKEY
	MOV	M,A
	ADD	B
	MOV	B,A
	INX	H
	MOV	A,L
	ORA	A
	JNZ	RNOTSCR
	MOV	A,H
	CPI	0A0H
	JNZ	RNOTSCR
	MVI	H,0E0H
RNOTSCR:
	DCX	D
	MOV	A,D
	ORA	E
	JNZ	READFILE

	LHLD	LINEND
REND:					; proweritx ostatok sli{kom 
	MOV	A,H			;   dlinnogo fajla
	ORA	L
	JZ	EOF
	CALL	RINEXTCTRLKEY
	ADD	B			; dos~et kontr. summy
	MOV	B,A
	DCX	H
	JMP	REND

EOF:
	CALL	RINEXTC
	POP	D
	POP	H
	MOV	A,C
	CMP	B
	JNZ	TYBADDATA
	DAD	D
	XCHG
	CALL	PREPFILETODISK
	XRA	A
	JMP	EXIT

RINEXTCTRLKEY:
	MVI	A,8

RICTRLKEY:
	PUSH	PSW
	IN	1
	ANI	'@'
	JZ	TYBADDATA
	POP	PSW
	JMP	RI

PREPFILETODISK:
	PUSH	D

ADDED1AHTOFILE:
	MOV	A,E
	ANI	7FH
	JZ	L02ED
	MVI	A,1AH
	STAX	D
	INX	D
	JMP	ADDED1AHTOFILE


L02ED:
	POP	D
	RET

RINEXTBC:
	MVI	A,8

RIBC:
	CALL	RICTRLKEY
	MOV	B,A

RINEXTC:
	CALL	RINEXTCTRLKEY
	MOV	C,A
	RET

TYBADDATA:
	STC
	JMP	EXIT

PUBLIC	FINDNAMEONTAPE
FINDNAMEONTAPE:
	LHLD	FILENAME
	PUSH	H

SEARCHNAMEONTAPE:
	LXI	H,NAMEONTAPE
	PUSH	H
	MVI	E,4
	CALL	FINDSEQ0D2H
	CALL	READNAME
	POP	H
	PUSH	H
	CALL	TYPENAME
	POP	H
	POP	D
	PUSH	D

PUBLIC	CHECKNEXTLETTER
CHECKNEXTLETTER:
	LDAX	D
	CPI	'?'			; w imeni ispolxzuetsq ras{irenie ?
	JZ	LETTERISEQUAL
	ORA	A
	JZ	PRGWASFINDED
	CMP	M
	JZ	LETTERISEQUAL
	ADI	' '
	CMP	M
	JNZ	SEARCHNAMEONTAPE

LETTERISEQUAL:
	INX	H
	INX	D
	JMP	CHECKNEXTLETTER

TXTPRGIS:
	DB	0DH,0AH
	DB	'FILE: ',0

PRGWASFINDED:
	LXI	D,OK
	CALL	TYPE
	POP	H
	RET

OK:
	DB	' - O''k',0DH,0AH,0

FINDSEQ0D2H:
	MOV	D,E

L048C:
	MOV	E,D
	CALL	PODI
	MVI	A,0FFH

L0492:
	CALL	RICTRLKEY
	CPI	0D2H
	JNZ	L048C
	DCR	E
	RZ
	MVI	A,8
	JMP	L0492

PODI:
	CALL	PO
	DI
	RET

READNAME:
	MVI	E,11
CLRN:
	CALL	RINEXTCTRLKEY
	MOV	M,A
	INX	H
	DCR	E
	JNZ	CLRN
	MVI	M,0
	RET

;  whod:
;    <HL> - adres imeni
TYPENAME:
	PUSH	H
	LXI	D,TXTPRGIS
	CALL	TYPE
	POP	H
TYNAME:
	MVI	B,8+3
BM:
	MOV	C,M
	INX	H
	CALL	CONOUT
	DCR	B
	JNZ	BM
	RET

PUBLIC	PREPTAPE
PREPTAPE:
	CALL	CRLF
	LHLD	FILENAME
	CALL	TYPENAME
	LXI	D,TXTWAIT		; vdatx navatiq klawi{i
	CALL	TYPE
	CALL	CONIN
	JMP	CRLF

PUBLIC	HLDE
HLDE:
	MOV	A,H
	SUB	D
	RNZ
	MOV	A,L
	SUB	E
	RET

	DSEG

PUBLIC	FILE,FILENAME,BOF,LINE
FILE:				; adres na~ala fajla
	DS	2
LINE:				; dlina fajla
	DS	2
LINEND:				; dlina ostatoka sli{kom dl. fajla
	DS	2
FILENAME:			; adres imeni fajla
	DS	2
BOF:				; adres na~ala zagruzki
	DW	100H
NAMEONTAPE:			; imq fajla, s~iatnnoe s magnitofona
	DS	12
STACK:
	DS	2
