
;      wwod/wywod fajlow 
;  -----------------------------------
;  wers.1.2		data:29-MAY-92

PRINT	MACRO	TEXT
	LXI	D,TEXT
	MVI	C,9
	CALL	5
	ENDM


	ASEG
	ORG	4000H

PUBLIC	SOURCE,TARGET
SOURCE:
	DS	800H
TARGET:
	DS	800H

	CSEG

;  wwod teksta

PUBLIC	LOAD
LOAD:

	LXI	D,FCBIN
	CALL	COPYNAME

	LXI	D,FCBOUT
	CALL	COPYNAME

	LDA	6CH		; disk celi ukazan qwno ?
	ORA	A
	JZ	$+6
	STA	FCBOUT		; ustanowitx disk celi

	LXI	H,5CH+1
	MOV	A,M
	CPI	' '
	JZ	USAGE		; bez parametrow ?

	LXI	H,5CH+9
	CALL	CHECKDIM	; prowerka ras{ireniq
	JC	ERRPA

	LXI	H,6CH+1
	MOV	A,M
	CPI	' '
	JNZ	ERRPA		; estx wtoroj parametr ?

	LXI	H,6CH+9
	MOV	A,M
	CPI	' '
	JNZ	ERRPA		; ukazano ras{irenie ?

	LXI	H,5CH+1
	CALL	CHECKQ
	JZ	ERRQ		; neqwnoe imq ?

	LXI	D,IDSC
	MVI	C,50
	CALL	5		; wwod fajla
	ORA	A
	RZ
	LXI	D,RDERR1
	CPI	1
	JZ	EXERR
;	LXI	D,RDERR2
;	CPI	2
;	JZ	EXERR
	LXI	D,RDERR
EXERR:
	MVI	C,9
	CALL	5
	PRINT	TADD
	JMP	0

PUBLIC	CHECKDIM
CHECKDIM:
	MOV	A,M
	CPI	'G'
	JZ	CHKGRF
	CPI	'L'
	STC
	RNZ

	IRPC	CHRD,IN
	INX	H
	MOV	A,M
	CPI	'&CHRD'
	STC
	RNZ
	ENDM
	XRA	A
	DCR	A		; LIN --> GRF
	STA	CONTROL
	LXI	H,LINDIM
	LXI	D,IDIM
	CALL	COPYDIM
	LXI	H,GRFDIM
	LXI	D,ODIM
COPYDIM:
	MVI	C,3
	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCR	C
	JNZ	$-5
	RET

CHKGRF:
	IRPC	CHRD,RF
	INX	H
	MOV	A,M
	CPI	'&CHRD'
	STC
	RNZ
	ENDM
	XRA	A		; GRF --> LIN
	STA	CONTROL
	LXI	H,GRFDIM
	LXI	D,IDIM
	CALL	COPYDIM
	LXI	H,LINDIM
	LXI	D,ODIM
	CALL	COPYDIM
	RET

	DSEG

PUBLIC	CONTROL
CONTROL:			;  0 - GRF --> LIN
	DB	0		; -1 - GRF <-- LIN

	CSEG

PUBLIC	CHANGE
EXTRN	LINGRF,GRFLIN
CHANGE:
	LDA	CONTROL
	ORA	A
	LXI	H,SOURCE
	LXI	D,TARGET
	LXI	B,LINGRF
	JZ	$+6
	LXI	B,GRFLIN
	PUSH	B
	RET

PUBLIC	HLDE
HLDE:
	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET

ERRQ:
	LXI	D,TQERR
	JMP	EXERR

ERRPA:
	LXI	D,TERRPA
	JMP	EXERR

	DSEG

TADD:
	DB	'dlq dopolnitelxnoj informacii: LG <wk>',0DH,0AH,'$'

TQERR:
	DB	1BH,5CH
	DB	0DH,0AH
	DB	'o{ibka: neqwnoe imq fajla',0DH,0AH,'$'

TERRPA:
	DB	1BH,5CH
	DB	0DH,0AH
	DB	'o{ibka: newerno zadany parametry',0DH,0AH,'$'

	CSEG

PUBLIC	COPY,COPYNAME
COPYNAME:
	LXI	H,5CH
	LXI	B,9
COPY:
	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	COPY
	RET

CHECKQ:
	MVI	B,8		; prowerka na '?'
CQ:	MOV	A,M
	CPI	'?'
	RZ
	INX	H
	DCR	B
	JNZ	CQ
	ORA	A
	RET

;  wywod rezulxtata

PUBLIC	SAVE
SAVE:
	LXI	D,FCBOUT
	MVI	C,19		; udalitx fajl
	CALL	5
	LXI	H,FCBOUT+12
	MVI	M,0
	LXI	H,FCBOUT+32
	MVI	M,0
	LXI	D,ODSC
	MVI	C,50
	CALL	5
	ORA	A
	JZ	CLOSE

	LXI	D,WRERR1
	CPI	1
	JZ	WEXERR
	LXI	D,WRERR2
	CPI	2
	JZ	WEXERR
	LXI	D,WRERR
WEXERR:
	PUSH	D
	LXI	D,FCBOUT
	MVI	C,19		; udalitx nezawer{ennyj fajl
	POP	D
	JMP	EXERR

CLOSE:
	LXI	D,FCBOUT		; zakrytx fajl
	MVI	C,16
	CALL	5
	JMP	0

;  primer ispolxzowaniq

PUBLIC	USAGE
USAGE:
	PRINT	TXTUSAGE
	JMP	0

	DSEG

GRFDIM:	DB	'GRF'
LINDIM:	DB	'LIN'

PUBLIC	FCBIN,FCBOUT,SCREEN
SCREEN:
	DB	0			; 0 - wywod fajla |krana
					;-1 - prosmotr |krana
FCBIN:
	REPT	9		; disk i imq fajla
	DB	0
	ENDM
IDIM:	DB	'GRF'

	REPT	33-12
	DB	0
	ENDM

FCBOUT:
	REPT	9		; disk i imq fajla
	DB	0
	ENDM
ODIM:	DB	'LIN'

	REPT	33-12
	DB	0
	ENDM


TXTUSAGE:
	DB	1BH,5CH,0DH,0AH,'perekodirowka znakogeneratora',9,9,9,9
	DB	'(C) filippow e.w., 1992',0DH,0AH
	DB	'      LIN <--> GRF',9,9,9,9,9,9,'wers.1.1',0DH,0AH,0AH,0AH
	DB	'ispolxzowanie:',0DH,0AH,0AH
	DB	'  C>LG FILE.GRF <CR>',0DH,0AH
	DB	'      C:FILE.GRF --> C:FILE.LIN',0DH,0AH
	DB	'  A>LG FILE.GRF C: <CR>',0DH,0AH
	DB	'      A:FILE.GRF --> C:FILE.LIN',0DH,0AH
	DB	'  C>LG A:FILE.GRF <CR>',0DH,0AH
	DB	'      A:FILE.GRF --> A:FILE.LIN',0DH,0AH
	DB	'  C>LG FILE.LIN <CR>',0DH,0AH
	DB	'      C:FILE.LIN --> C:FILE.GRF',0DH,0AH
	DB	'  i t.d.',0DH,0AH
	DB	0AH
	DB	'prime~anie:',0DH,0AH
	DB	'  1. imq fajla ukazywatx s ras{ireniem:',0DH,0AH
	DB	'	*.LIN ili  *.GRF',0DH,0AH
	DB	'  2. ne dopuskaetsq ispolxzowanie w imeni fajla',0DH,0AH
	DB	'     simwolow ''*'' i ''?''.',0DH,0AH
	DB	'$'

PUBLIC	DSCRD,DSCWR,IDSC,ODSC
IDSC:
	DB	129
	DW	DSCRD
ODSC:
	DB	129
	DW	DSCWR

DSCRD:
	DB	0
	DW	FCBIN
	DW	SOURCE
	DW	SOURCE+801H
DSCWR:
	DB	-1
	DW	FCBOUT
	DW	TARGET
	DW	TARGET+7FFH


RDERR:
	DB	1BH,05CH
	DB	0DH,0AH
	DB	'o{ibka pri ~tenii ishodnogo fajla',0DH,0AH,'$'

RDERR1:
	DB	1BH,05CH
	DB	0DH,0AH
	DB	'o{ibka: net ishodnogo fajla',0DH,0AH,'$'

RDERR2:
	DB	1BH,05CH
	DB	0DH,0AH
	DB	'o{ibka: ishodnyj fajl koro~e 2K'
	DB	0DH,0AH,'$'

WRERR:
	DB	1BH,05CH
	DB	0DH,0AH
	DB	'o{ibka pri zapisi wyhodnogo fajla',0DH,0AH,'$'

WRERR1:
	DB	1BH,05CH
	DB	0DH,0AH
	DB	'o{ibka: net mesta w oglawlenii',0DH,0AH,'$'

WRERR2:
	DB	1BH,05CH
	DB	0DH,0AH
	DB	'o{ibka: net mesta na diske',0DH,0AH,'$'


	END
