ramka:
;	DB	11
;
;		-F----A----C----B----E----D----L----H--
;	DB	000H,012H,000H,000H,0FFH,000H,0FFH,001H
;	DB	000H,002H,0FEH,001H,0FFH,000H,0FAH,001H
;	DB	000H,012H,000H,000H,0FFH,0F8H,0FFH,001H
;	DB	000H,002H,000H,000H,0FFH,000H,0FAH,001H
;
;	DB	000H,012H,000H,000H,066H,0E4H,0FFH,001H
;
;	DB	000H,012H,000H,000H,0FFH,0D0H,0FFH,001H
;	DB	000H,012H,000H,000H,0FFH,0B0H,0FFH,001H
;	DB	000H,012H,000H,000H,0FFH,06BH,0FFH,001H
;	DB	000H,012H,000H,000H,0FFH,010H,0FFH,001H
;	DB	000H,002H,000H,001H,0FFH,000H,06BH,000H
;	DB	000H,012H,080H,000H,0FFH,040H,080H,000H
;
;  programma wywoda  linij po zadannomu bloku dannyh.
;-------------------------------------------------------
;
;  whod:	HL - na~alxnyj  adres  bloka
;

LNBLOCK:
	DI
	MOV	A,M		; ~islo linij
	INX	H
	SHLD	BUFSP
LNBL1:	PUSH	PSW

	LXI	H,0000		; sprqtatx  stek
	DAD	SP		;
	SHLD	STACK		;

	LHLD	BUFSP		; zagruzitx w SP na~. adres
	SPHL			; dannyh dlq LINE.

	POP	PSW		; wybratx dannye
	POP	B		;
	POP	D		;
	POP	H		;

	SHLD	BUFHL		; sprqtatx HL
	LXI	H,0000		; sprqtatx
	DAD	SP		;
	SHLD	BUFSP		; bufer steka linij
	LHLD	STACK		; wosstanowitx 
	SPHL			; stek
	LHLD	BUFHL		;

	CALL	LINE

	POP	PSW		; esli liniq poslednqq -
	DCR	A		; wyhod.
	JNZ	LNBL1		;
	EI

	RET


BUFHL:	DS	2
BUFSP:	DS	2
STACK:	DS	2

;**********************************************
;     p/programma  risowaniq  wertikalxnyh
;  i  gorizontalxnyh   linij   w " mikrodos."
;==============================================
;	V 1.2			15.06.91
;**********************************************
; whod:	BC - "X" koordinata na~ala linii.
;	D  - "Y" -----------konca-------
;	e = 0    -  pogasitx lini`
;	e = 0FFH -  wyswetitx
;	HL -  dlina  linii
;	a = 0X - wertikalx
;	  = 1X - gorizontalx
;	X = 1-8  {irina linii
;==============================================

SCRON	EQU	03H
SCROFF	EQU	23H
DOS	EQU	10H

;=====================================================
PUBLIC	LINE
LINE:	
	STA	BUFA
	ANI	0F0H
	MOV	A,E
	STA	BUFGASH
	MVI	A,SCRON
	OUT	DOS

	JZ	VERTLINE

; wywod	gorizontalxnoj linii
;---------------------------
	PUSH	H

	CALL	CLCADR
	MOV	L,D	;HL = abs. adres na~ala linii
	XCHG		;DE = abs. adres na~ala linii

	CALL	MASK
	STA	BFMSKST	; w bufer zanositsq maska perwogo bajta

	POP	B
	CALL	CLCADR
	MOV	L,E	;HL = abs.adr. konca linii

	CALL	MASK
	CMA
	STA	BFMSKEND	;maska poslednego bajta

	CALL	HORLINE
	JMP	EXLINE

; wywod wertikalxnoj linii
;-------------------------
VERTLINE:
	PUSH	H

	CALL	CLCADR
	MOV	L,D
	XCHG		;DE = abs. adres na~ala linii
	MOV	A,C
	STA	BUFC

	POP	H
	MOV	H,D
	XCHG		;DE=kon.adr. HL=na~.adr

	CALL	VERLINE

EXLINE:

	MVI	A,SCROFF
	OUT	DOS
	RET
	
VERLINE:
	LDA	BUFC
	MOV	C,A
	LDA	BUFA
	ADD	C
	CPI	09H
	JNC	VLINE2	;{irina	linii	ne ume{aetsq w 1 bajt.

	MOV	C,A
	CALL	MASK
	MOV	B,A	; maska a+C

	LDA	BUFC
	MOV	C,A
	CALL	MASK

	XRA	B
	MOV	C,A
	
	CALL	VERLNE
	JMP	EXVLN

VLINE2:
	SUI	08H
	MOV	C,A
	CALL	MASK
	CMA
	MOV	C,A
	PUSH	B

	LDA	BUFC
	MOV	C,A
	CALL	MASK

	MOV	C,A
	CALL	VERLNE

	POP	B
	INR	H
	INR	D

	CALL	VERLNE

EXVLN:	RET

VERLNE:
	PUSH	H
	PUSH	D; wywod wertik. linii

	CALL	VLNE
	MVI	A,20H
	ADD	H
	MOV	H,A
	MVI	A,20H
	ADD	D
	MOV	D,A
	CALL	VLNE

	POP	D
	POP	H
	RET
;--------------------------
; HL=na~.linii
; DE=konc linii
; C =maska {iriny linii

VLNE:
	PUSH	H
	PUSH	D

	LDA	BUFGASH
	ANA	C
	MOV	C,A	;C - maska wywoda
	CMA
	MOV	B,A	;B -inwersnaq maska

VL1:	MOV	A,E
	CMP	L
	JZ	EXVL

	MOV	A,M
	ANA	B
	ORA	C
	MOV	M,A

	INR	L
	JMP	VL1

EXVL:	POP	D
	POP	H
	RET


; wywod gorizontalxnoj linii
;----------------------------------------------
; DE - na~alo linii
; HL - konec linii

HORLINE:
	LDA	BUFA
	ANI	0FH
	ORA	A
	JZ	EXHORLN
	CALL	HORLNE
	INX	H
	INX	D
	LDA	BUFA
	DCR	A
	STA	BUFA
	JMP	HORLINE
EXHORLN:RET

HORLNE:
	PUSH	H
	PUSH	D
	CALL	HOR1
	MVI	A,20H
	ADD	H
	MOV	H,A
	MVI	A,20H
	ADD	D
	MOV	D,A
	CALL	HOR1
	POP	D
	POP	H
	RET
; wywod odnoj linii
HOR1:
	PUSH	H
	PUSH	D

	XCHG

	LDA	BUFGASH
	MOV	B,A
	LDA	BFMSKST
HLN2:	ANA	B
	MOV	C,A
	MOV	A,H
	CMP	D
	JZ	HLN1
	JNC	EXITHLN
; normalxnyj wywod
HLN3:	MOV	A,C
	CMA
	ANA	M
	MOV	M,A
	MOV	A,C
	ORA	M
	mOV	M,A

	INR	H
	MVI	A,0FFH
	JMP	HLN2

; poslednij bajt
HLN1:	LDA	BFMSKEND
	ANA	B
	MOV	C,A
	JMP	HLN3

EXITHLN:
	POP	D
	POP	H
	RET

	;poisk maski dlq perwogo bajta linii
;-----------------------------------
; whod:	C - nomer na~alxnoj (kone~noj) to~ki w maske
;wyhod:	a - maska
;	ostalxnye pary registrow sohranq`tsq

MASK:	MVI	A,0FFH
	INR	C

MSKST:	DCR	C
	JZ	MST1

	ANI	0FEH
	RAR

	JMP	MSKST
MST1:	RET


; wy~islenie abs. adresa na~ala linii
;--------------------------------------
; whod:	BC - koordinata X
;wyhod:	HL - abs.adres
;	C  - nomer na~alxnoj(kone~noj) to~ki w bajte
; para	DE - sohranqetsq.

CLCADR:	
	LXI	H,0A000H
	MOV	A,B
	ANI	1
	RAL
	RAL
	RAL
	RAL
	ADD	H
	MOV	H,A	; H=rab. polowine |krana
	
	MOV	A,C
	ANI	0FEH
	RAR
	
CLC1:	
	SUI	8

	JC	CLC2

	INR	H
	JMP	CLC1

CLC2:	ADI	8
	MOV	C,A
	RET

BUFA:	
	DB	0
BUFC:	
	DB	0
BUFGASH:
	DB	0
BFMSKST:
	DB	0
BFMSKEND:
	DB	0

