;;						- 1 -
;;*******************************************************
;;		operacii wywoda na |kran
;;  ---------------------------------------------------
;;  wers.1.9.44			         data:01-JUL-90
;;*******************************************************
;;
CO	EQU	0129H
SPIC	EQU	0138H
INKEY	EQU	013BH
BORD	EQU	015CH
SETCLR	EQU	0189H
;;
	MACLIB	CSCUBA
;;
CLEAR	MACRO
	MVI	C,1FH
	CALL	CO
	ENDM
;;
PRINT	MACRO	TXT
	LXI	H,TXT
	CALL	SPIC
	ENDM
;;
CONSOL	MACRO
	CALL	INKEY
	CPI	0FFH
	JZ	$-5
	ENDM
;;
	ORG	2000H
;;
	JMP	PROGRAM
STACK:
	DS	2
YXPLACE:
	DS	2
;;
TBC:
	DB	  0			; 0 ~ernyj
	DB	197			; 1 fioletowyj
	DB	  6			; 2 krasnyj
	DB	128			; 3 sinij
	DB	 16			; 4 zelenyj
	DB	208			; 5 goluboj
	DB	 54			; 6 veltyj
	DB	255			; 7 belyj
	DB	  0,197,  6,128, 16,208, 54,255
;;
COLORCELL:
	DB	0
;;;;						- 2 -
;;  steretx |kran zadannym cwetom
;;  <A> - cwet (zapominaetsq w COLORCELL)
CLRSCREEN:
	DI
	STA	COLORCELL
	LXI	H,0
	DAD	SP
	SHLD	STACK
	LXI	SP,0
;;
	MVI	B,32
CLS1:
	MVI	C,3
	LDA	COLORCELL
	RRC				; bity 3,4,5 - fon
	RRC	
	RRC
CLS2:
	RRC
	LXI	D,0
	JNC	$+6
	LXI	D,0FFFFH
;;
	MVI	L,12
CLS3:
	PUSH	D
	PUSH	D
	PUSH	D
	PUSH	D
	PUSH	D
	PUSH	D
	PUSH	D
	PUSH	D
	DCR	L
	JNZ	CLS3
	LXI	H,-2040H+100H
	DAD	SP
	SPHL
	DCR	C
	JNZ	CLS2
	LXI	H,6000H-100H
	DAD	SP
	SPHL
	DCR	B
	JNZ	CLS1
;;
	LHLD	STACK
	SPHL
	EI
	RET
;;;;						- 3 -
;;  podgotowka wywoda znaka SINCLAIR na wektore
;;  whod:
;;    <H,L> - Y,X koordinaty na |krane
;;  wyhod:
;;   <H,L> - adres znaka na |krane 0000H-1FFFH
DISPLEYFROMXY:
	PUSH	D
	MVI	A,0
	ADD	L
	MOV	D,A
	MVI	A,31
	SUB	H
	ADD	A
	ADD	A
	ADD	A
	ADI	7
	MOV	E,A
	XCHG
	POP	D
	RET
;;
;;  wywod posledowat. znakow po goriz. ili po wertikali
;;  whod:
;;    <D,E> - adres OUTX- ili OUTYCHANGE
MODOUTMANYCHAR:
	XCHG
	SHLD	MANYCHARMOD
	XCHG
;;
;;  wywod posledowatelxnosti znakow SINCLAIR
;;  whod:
;;    <A> - kod znaka (0-7FH - SINCLAIR, 80H-0FFH - SCUBA)
;;    <B,C> - Y,X koordinata na |krane SINCLAIR
OUTMANYCHAR:
	MOV	A,B
	STA	YXPLACE+1
	MOV	A,C
	STA	YXPLACE
	MOV	A,M
SEEONE:
	PUSH	H
MANYCHARMOD	EQU	$+1
	CALL	OUTXCHANGE
	POP	H
	INX	H
	MOV	A,M
	CPI	0FFH
	JNZ	SEEONE
	RET
;;
OUTXCHANGE:
	LHLD	YXPLACE
	INR	L
	SHLD	YXPLACE
	DCR	L
	JMP	SEEONECHAR
;;
OUTYCHANGE:
	LHLD	YXPLACE
	INR	H
	SHLD	YXPLACE
	DCR	H
;;;;						- 4 -
SEEONECHAR:
	PUSH	H
	PUSH	PSW
	CALL	DISPLEYFROMXY
	XCHG
	POP	PSW
	ADD	A
	MOV	L,A
	MVI	H,0
	JC	SETPLAYCHAR
	LXI	B,SINCLAIRCHAR
	JMP	SETPLAYCHAR+3
;;
SETPLAYCHAR:
	LXI	B,PLAYCHAR
	DAD	H
	DAD	H
	DAD	B
;;
	LDA	COLORCELL
	CALL	OUTCHARCOLOR
	POP	H
	RET
;;
;;  whod:
;;    <A> - cwet
OUTCHARCOLOR:
	MOV	C,A	; ~ernila
	RRC
	RRC
	RRC
	MOV	B,A	; fon
;;
;;  wywod znaka SINCLAIR na wektor
;;  whod:
;;    <B,C> - fon i ~ernila
;;    <D,E> - znak na |krane wektorA
;;    <H,L> - znakogenerator
OUTCHAR:
	PUSH	B
	PUSH	D
	CALL	OUTCLR
	CALL	OUTCLR
	CALL	OUTCLR
	POP	D
	POP	B
	INR	L
	DCR	E
	MOV	A,E
	INR	A
	ANI	7
	JNZ	OUTCHAR
	RET
;;;;						- 5 -
;;  wywod na |kran wektora bajta znaka SINCLAIR
;;  whod:
;;    <B,C> - cwet fona i ~ernil
;;    <D,E> - adres bajta na wektore
;;    <H,L> - adres bajta na SINCLAIR
OUTCLR:
	PUSH	H
	LXI	H,-2000H
	DAD	D
	XCHG
	POP	H
;;
	MOV	A,C
	RRC
	MOV	C,A
	MOV	A,M
	JC	$+4
	XRA	A
	STAX	D
	MOV	A,B
	RRC
	MOV	B,A
	MOV	A,M
	CMA
	RNC
	XCHG
	ORA	M
	MOV	M,A
	XCHG
	RET
;;;;						- 6 -
MACMOD	MACRO	TXT,YX,PROG
	LXI	H,TXT
	LXI	B,YX
	LXI	D,PROG
	CALL	MODOUTMANYCHAR
	ENDM
MACOUT	MACRO	TXT,YX
	LXI	H,TXT
	LXI	B,YX
	CALL	OUTMANYCHAR
	ENDM
TEST2:
	MVI	A,00DH
	CALL	CLRSCREEN
	LXI	B,001AH
	LXI	D,OUTYCHANGE
	LXI	H,LEF3A
	CALL	MODOUTMANYCHAR
	INX	H
	LXI	B,001BH
	CALL	OUTMANYCHAR
	INX	H
	LXI	B,0D1DH
	CALL	OUTMANYCHAR
	INX	H
	LXI	B,0D1EH
	CALL	OUTMANYCHAR
	CONSOL
	JMP	TEST
;;
LEF3A:
	DB	89H,8AH,0,8BH,8CH,0,8DH,8EH
	DB	0,8FH,90H,0,91H,92H,0FFH,93H
	DB	94H,0,95H,96H,0,97H,98H,0
	DB	99H,9AH,0,9BH,9CH,0FFH,9DH
	DB	9EH,0,9FH,0A0H,0,0A1H,0A2H,0
	DB	0A3H,0A4H,0FFH,0A5H,0A6H,0,0A7H
	DB	0A8H,0,0A9H,0AAH,0,0ABH,0ACH,0FFH
;;;;						- 7 -
panelx:
	MVI	A,30H
	CALL	CLRSCREEN
	MACMOD	LDC09,0018H,OUTXCHANGE
	MACOUT	LDC12,1718H
	MACOUT	LDC1B,011AH
	MACOUT	TSCORE,031AH
	MACOUT	THELD,051AH
	MACMOD	LDC32,0118H,OUTYCHANGE
	MACOUT	LDC32,011FH
	MACOUT	LDC49,0C1AH
	MACOUT	LDC50,0C1CH
	MACOUT	TLIVES,081EH
	MVI	A,38H
	STA	COLORCELL
	MACOUT	LDC65,0719H
	MACOUT	LDC65,071BH
	MVI	A,0DH
	STA	COLORCELL
	MACOUT	LDC76,071DH
	MACOUT	LDC76,101DH
	CONSOL
	JMP	TEST
;;
LDC09:
	DB	80H,81H,81H,81H,81H,81H,81H,85H,0FFH
LDC12:
	DB	83H,81H,81H,81H,81H,81H,81H,84H,0FFH
LDC1B:
	DB	'()''(',0FFH
	DB	10H,10H,10H,10H,10H,0FFH
TSCORE:
	DB	'3#/2%',0FFH
THELD:
	DB	'(%,$',0FFH
LDC32:
	DB	82H,82H,82H,82H,82H,82H,82H
	DB	82H,82H,82H,82H,82H,82H,82H
	DB	82H,82H,82H,82H,82H,82H,82H
	DB	82H,0FFH
LDC49:
	DB	'/89''%',0FFH
LDC50:
	DB	'$%04(',0FFH
TLIVES:
	DB	'3+),,',0,0,0,0,',)6%3',0FFH
LDC65:
	DB	86H,87H,87H,87H,87H,87H,87H,87H,87H
	DB	87H,87H,87H,87H,87H,87H,88H,0FFH
LDC76:
	DB	11H,00H,12H,00H,13H,00H,14H,0FFH
;;;;						- 8 -
PROGRAM:
	LXI	SP,100H
	XRA	A
	OUT	10H
;;
	LXI	D,TBC
	CALL	SETCLR
	MVI	A,0
	CALL	BORD
TEST:
	CLEAR
	PRINT	MENU
TST:
	CONSOL
	CPI	'1'
	JZ	TEST1
	CPI	'2'
	JZ	TEST2
	CPI	'3'
	JZ	TEST3
	CPI	'4'
	JZ	TEST4
	CPI	'5'
	JZ	panelx
	JMP	TST
;;
MENU:
	DB	0DH,0AH,' 1 - znakogenerator SINCLAIR '
	DB	0DH,0AH,' 2 - wariant zagolowka SCUBA '
	DB	0DH,0AH,' 3 - OCTOPUS                 '
	DB	0DH,0AH,' 4 - warianty pe}er          '
	DB	0DH,0AH,' 5 - panelx                  '
	DB	0
;;
TEST1:
	CLEAR
	LXI	H,SINCLAIRCHAR
	LXI	D,0A4FFH
	LXI	B,300H
CLCCHAR:
	MOV	A,M
	STAX	D
	DCR	L
	INX	D
	DCR	C
	JNZ	CLCCHAR
	INR	H
	DCR	B
	JNZ	CLCCHAR
	CONSOL
	JMP	TEST
;;;;						- 9 -
INCAVE:
	DS	2
;;
;;  najti adres dlq perekodirowki znaka w matricu 8*8
;;  whod:
;;    <A> - znak
;;  wyhod:
;;    INCAVE
FINDCAVE:
	RRC
	RRC
	PUSH	H
	PUSH	D
	MOV	H,A
	ANI	11000000B
	MOV	L,A
	MOV	A,H
	ANI	00111111B
	MOV	H,A
	LXI	D,CAVE
	DAD	D
	SHLD	INCAVE
	POP	D
	POP	H
	RET
;;
;;  najti adres znaka po kodu iz tabl.CODER
;;  whod:
;;    <A> - dannoe iz CAVE
;;  wyhod:
;;    <HL> - adres w znakogeneratore
FINDCHAR:
	ANI	7FH
	MOV	L,A
	MVI	H,0
	DAD	H
	DAD	H
	DAD	H
	PUSH	D
	LXI	D,CAVECHAR
	DAD	D
	POP	D
	RET
;;;;						- 10 -
;;  wywod bloka 8*8 znakow s pomo}x` CAVE
;;  whod:
;;    <DE> - Y,X koordinaty
;;    <A> - znak dlq CAVE
OUT88CHAR:
	CALL	FINDCAVE
	XCHG
	CALL	DISPLEYFROMXY
	XCHG				; <DE> - adres na displee
	MVI	B,8
COLUMN:
	PUSH	B
	PUSH	D
;;
	MVI	B,8
ROW:
	PUSH	B
	PUSH	D
;;
	PUSH	H			; najti o~erednoj znak
	LHLD	INCAVE
	MOV	A,M
	INX	H
	SHLD	INCAVE
	POP	H
	CALL	FINDCHAR		; <HL> - adres w znakogeneratore
;;
	MVI	A,00011110B
	CALL	OUTCHARCOLOR
	POP	D
	POP	B
	INR	D
	DCR	B
	JNZ	ROW
;;
	POP	D
	POP	B
	MOV	A,E
	SUI	8
	MOV	E,A
	DCR	B
	JNZ	COLUMN
	RET
;;
TEST4:
	CLEAR
	MVI	A,00000000B
TST3:
	PUSH	PSW
	LXI	D,0
	CALL	OUT88CHAR
	CONSOL
	POP	PSW
	INR	A
	CPI	1EH
	JNZ	TST3
	JMP	TEST
;;;;						- 11 -
CNT:	DB	0
TEST3:
	CLEAR
	MVI	A,1
	STA	CNT
;;
NEWCHAR:
	LDA	CNT
	DCR	A
	STA	CNT
	JNZ	OBHOD
	LXI	H,OCTOPUSCHAR
	MVI	A,5
	STA	CNT
;;
OBHOD:
	LXI	D,0C27FH
	MVI	B,4
OUT1:
	PUSH	D
	MVI	C,6
OUT2:
	PUSH	D
	PUSH	B
	MVI	B,8
OUT3:
	MOV	A,M
	INX	H
	STAX	D
	DCR	E
	DCR	B
	JNZ	OUT3
	POP	B
	POP	D
	INR	D
	DCR	C
	JNZ	OUT2
	POP	D
	MOV	A,E
	SUI	8
	MOV	E,A
	DCR	B
	JNZ	OUT1
	CONSOL
	CPI	'Y'
	JZ	NEWCHAR
	JMP	TEST
;;
	END
