ADRTXTBIOS			EQU	2415H
BIOSBEGIN			EQU	2400H
BIOSCHECKSTATUS			EQU	2406H
BIOSDISKOPERATION		EQU	2412H
BIOSDPH				EQU	240FH
BIOSINPUT			EQU	2409H
BIOSOUTPUT			EQU	240CH
BIOSUSERCOMAND			EQU	2418H
DISKTODAY			EQU	04H
FCB1				EQU	5CH
FCB2				EQU	6CH
GOTOBDOS			EQU	05H
INI2BIOS			EQU	2403H
LFF80				EQU	0FF80H
LFFEC				EQU	0FFECH
LFFFF				EQU	0FFFFH
SYSDMA				EQU	80H

	ORG	0100H

	LXI	H,KOI7KOI8				;2080H
	LXI	B,0349H

CLRDATAFIELD:				;0106H
	MVI	M,0
	INX	H
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	CLRDATAFIELD				;0106H
	LXI	SP,SYSTEMSTACK				;2376H
	CALL	BIOSBEGIN				;2400H
	MVI	A,7FH
	STA	COMANDBUFER				;2113H
	XRA	A
	STA	DISKTODAY				;4
;
; TYPE ADVERTISE <VECTOR-06C>
	MVI	A,0CH
	CALL	TYPEBIOSMSG				;1BFEH
	LXI	H,BDOSBEGIN				;0200H
	MOV	A,H
	ANI	0FCH
	RRC
	RRC
	CALL	PRTADECIMAL				;0D83H
	LXI	B,TXTMICRODOS				;0192H
	CALL	PEC					;0903H
	MVI	A,0C3H
	STA	GOTOBDOS				;5
	LXI	H,BDOSBEGIN				;0200H
	SHLD	GOTOBDOS+1				;6
	MVI	C,0

FINDSYSTEMTRACK:			;0141H
	PUSH	B
	CALL	BIOSDPH					;240FH
;
; DPH
	MOV	A,L
	ORA	H
	POP	B
	JZ	FINDLASTDISK				;0167H
	PUSH	B
	LXI	B,0AH
	DAD	B
	MOV	A,M
	INX	H
	MOV	H,M
	MOV	L,A
;
; DPB
	LXI	B,0DH
	DAD	B
	MOV	E,M
	INX	H
	MOV	D,M
;
; OFS - SYSTEM TRACK QUANTATY
	POP	B
	MOV	A,C
	CALL	SETSYSTRACKADR				;04D7H
	MOV	M,E
	INX	H
	MOV	M,D
	INR	C
	JMP	FINDSYSTEMTRACK				;0141H

FINDLASTDISK:				;0167H
	MOV	A,C
	CALL	SETSYSTRACKADR				;04D7H
	LXI	D,LFFFF					;0FFFFH
	MOV	M,E
	INX	H
	MOV	M,D
	MVI	C,0DH
	CALL	GOTOBDOS				;5
	LXI	D,FCBINITSUB				;01BBH
	MVI	C,11H
	CALL	GOTOBDOS				;5
	INR	A
	JZ	ENTERTOMICRODOS				;1C4DH
	LXI	D,BIOSBPINITIALSUB			;01B8H
	MVI	C,'2'	;32H
	CALL	GOTOBDOS				;5
	MVI	A,0FFH
	STA	KOI7KOI8				;2080H
	JMP	ENTERTOMICRODOS				;1C4DH

TXTMICRODOS:				;0192H
	DB	'K MicroDOS  Vers. 3.1',0DH
	DB	0AH,'    20.12.83$',0DH,0AH

BIOSBPINITIALSUB:			;01B8H
	DB	83H
	DW	FCBINITSUB				;01BBH

FCBINITSUB:				;01BBH
	DB	0,'INITIAL SUB',0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0

BDOSBEGIN:				;0200H
	JMP	SYSTEMFUNC				;0630H

BIOS01:					;0203H
	JMP	FUN00					;1C31H

BIOS02:					;0206H
	JMP	BIOSF02					;1E88H

BIOS03:					;0209H
	JMP	BIOSF03					;1F31H

BIOS04:					;020CH
	JMP	BIOSF04					;1F85H

BIOS05:					;020FH
	JMP	FUN05					;1E72H

BIOS06:					;0212H
	JMP	FUN04					;08B9H

BIOS07:					;0215H
	JMP	FUN03					;08B0H

BIOS08:					;0218H
	JMP	BIOSF08					;1E27H

BIOS09:					;021BH
	JMP	BIOSF09					;1E1AH

BIOS0A:					;021EH
	JMP	BIOSF0A					;1E29H

BIOS0B:					;0221H
	JMP	BIOSF0B					;1E2EH

BIOS0C:					;0224H
	JMP	BIOSF0C					;1093H

BIOS0D:					;0227H
	JMP	BIOSF0D					;1E3FH

BIOS0E:					;022AH
	JMP	BIOSF0E					;1E3AH

BIOS0F:					;022DH
	JMP	BIOSF0F					;1E78H

BIOS10:					;0230H
	JMP	BIOSF10					;1E33H

FONREGIM:				;0233H
	CALL	CRLF					;0D41H
	LDA	STATUSCTRLD				;2317H
	INR	A
	JNZ	NORMALWORK				;0242H
	MVI	A,'>'	;3EH
	CALL	TYPEAREG				;0DF6H

NORMALWORK:				;0242H
	LDA	USER					;2060H
	ORA	A
	CNZ	PRTADECIMAL				;0D83H
	LDA	DEFAULTDISK				;205AH
	ADI	'A'	;41H
	CALL	TYPEAREG				;0DF6H
	MVI	A,'>'	;3EH
	CALL	TYPEAREG				;0DF6H
	LXI	H,COMANDBUFER				;2113H
	SHLD	DESYSFUNC				;205BH
	CALL	FUN0A					;0913H
	LXI	H,COMANDBUFER+1				;2114H

RUNCOMANDFROMHL:			;0262H
	MOV	A,M
	ORA	A
	RZ
	MOV	B,A
	INX	H
	MOV	A,M
	CPI	';'	;3BH
	RZ
	CPI	':'	;3AH
	JNZ	NOTIFREGIM				;0279H
	LDA	RESULTLASTCOMAND			;202DH
	INR	A
	RZ
	DCR	B
	RZ
	INX	H
	MOV	A,M

NOTIFREGIM:				;0279H
	CPI	'-'	;2DH
	JNZ	NORMALMICRODOSCOMAND			;0286H
	DCR	B
	RZ
	MVI	A,0FFH
	STA	STATUSEXCHANGECONSOLE			;2081H
	INX	H

NORMALMICRODOSCOMAND:			;0286H
	SHLD	BEGINOFCOMAND				;2104H
	DCX	H

CBIGLETTER:				;028AH
	INX	H
	MOV	A,M
	CALL	MAKEBIGLETTER				;0321H
	MOV	M,A
	DCR	B
	JNZ	CBIGLETTER				;028AH
	INX	H
	MVI	M,0
	LXI	H,COPYFCB				;2194H
	CALL	PREPAREANDCHECKFILENAME			;0334H
	JNZ	TYPEMSGANDQUEST				;0347H
	LXI	H,COPYFCB+1				;2195H
	MOV	A,M
	CPI	' '	;20H
	JNZ	ISREALCOMAND				;02BDH
	DCX	H
	MOV	A,M
	ORA	A
	JZ	ISNOTCOMAND				;02B9H
	DCR	A
	CALL	SETADISK				;1746H
	LDA	DEFAULTDISK				;205AH
	STA	DISKTODAY				;4

ISNOTCOMAND:				;02B9H
	CALL	WORKEXCHANGECONSOLE			;0599H
	RET

ISREALCOMAND:				;02BDH
	LDA	STATUSCTRLD				;2317H
	ORA	A
	JZ	RUNFILE					;0516H
	LDA	COPYFCB					;2194H
	ORA	A
	JNZ	ISDISKINTOCOMAND			;0513H
	LXI	H,COPYFCB+2				;2196H
	MOV	A,M
	CPI	' '	;20H
	JNZ	ISNAMEINTOCOMAND			;02FCH
	DCX	H
	MOV	A,M
	CALL	DECFROMCHAR				;0629H
	JC	DIRECTIVE				;02E5H
	PUSH	PSW
	CALL	PREPAREPARAMETEROFCOMAND		;0548H
	POP	PSW
	MOV	D,A
	JMP	BIOSUSERCOMAND				;2418H

DIRECTIVE:				;02E5H
	MOV	C,M
	LXI	H,CHARDIRECTIVE				;0365H
	CALL	SEARCHBYTEC				;05FFH
	LXI	H,TABDIRECTIVE				;036CH
	JNC	ISNAMEINTOCOMAND			;02FCH
	PUSH	PSW
	PUSH	H
	CALL	WORKEXCHANGECONSOLE			;0599H
	POP	H
	POP	PSW
	JMP	GOTOFUN					;06D1H

ISNAMEINTOCOMAND:			;02FCH
	CALL	CHECKFONREGIM				;032AH
	LDA	COPYFCB+5				;2199H
	CPI	' '	;20H
	JNZ	RUNFILE					;0516H
	LDA	SPRSTATUS				;20BEH
	ORA	A
	JZ	RUNFILE					;0516H
	LHLD	REALBEGINOFCOMAND			;2106H
	XCHG
	LXI	B,COPYFCB				;2194H
	LHLD	ADRESSPRPROGRAM				;20BAH
	CALL	GOTOHL					;0507H
	JZ	RUNFILE					;0516H
	JMP	TYPEMSGANDQUEST				;0347H

MAKEBIGLETTER:				;0321H
	CPI	61H
	RC
	CPI	7BH
	RNC
	ANI	5FH
	RET

CHECKFONREGIM:				;032AH
	LDA	STATUSCTRLD				;2317H
	INR	A
	RNZ
	POP	H
	CALL	TYPEMSGANDQUEST				;0347H
	RET

PREPAREANDCHECKFILENAME:		;0334H
	PUSH	H
	XRA	A
	CALL	PREPAPLUSFCBFROMCOMAND			;1B34H
	POP	H
	JMP	CHECKUNDEFINEDFILE			;189BH

SETTODAYDISKANDREMEMBERRESULT:		;033DH
	LDA	RESULT					;210FH
	PUSH	PSW
	CALL	SETREADTODAYDISK			;172BH
	POP	PSW
	INR	A
	RET

TYPEMSGANDQUEST:			;0347H
	CALL	CRLF					;0D41H
	LHLD	REALBEGINOFCOMAND			;2106H

NEXTMSGSMBL:				;034DH
	MOV	A,M
	CALL	CHECK0D0A090820				;0B24H
	JZ	TYPEQUEST				;035FH
	ORA	A
	JZ	TYPEQUEST				;035FH
	CALL	TYPEAREG				;0DF6H
	INX	H
	JMP	NEXTMSGSMBL				;034DH

TYPEQUEST:				;035FH
	MVI	A,'?'	;3FH
	CALL	TYPEAREG				;0DF6H
	RET

CHARDIRECTIVE:				;0365H
	DB	'ABDEKOU'

TABDIRECTIVE:				;036CH
	DW	ADIRECTIVE				;050DH
	DW	BDIRECTIVE				;04DEH
	DW	DDIRECTIVE				;037AH
	DW	EDIRECTIVE				;043BH
	DW	KDIRECTIVE				;0508H
	DW	ODIRECTIVE				;0480H
	DW	UDIRECTIVE				;0462H

DDIRECTIVE:				;037AH
	LXI	H,COPYFCB				;2194H
	CALL	PREPAREANDCHECKFILENAME			;0334H
	LXI	H,COPYFCB+1				;2195H
	MOV	A,M
	CPI	' '	;20H
	JNZ	ISNAMEFORDDIRECTIVE			;0392H
	MVI	B,0BH

ALLNAMEFORDDIRECTIVE:			;038BH
	MVI	M,'?'	;3FH
	INX	H
	DCR	B
	JNZ	ALLNAMEFORDDIRECTIVE			;038BH

ISNAMEFORDDIRECTIVE:			;0392H
	MVI	E,0
	PUSH	D
	LXI	H,COPYFCB				;2194H
	SHLD	DESYSFUNC				;205BH
	XCHG
	CALL	FUN11					;18B7H
	LDA	RESULT					;210FH
	INR	A
	POP	D
	JZ	NOFILES					;045AH
	PUSH	D

NEXTDNAME:				;03A8H
	LDA	SHIFTINDIRECTORY			;20F5H
	MOV	C,A
	POP	D
	MOV	A,E
	INR	E
	PUSH	D
	ANI	3
	JNZ	FILESINONELINE				;03C0H
	PUSH	B
	CALL	CRLF					;0D41H
	CALL	TYPEDEFDISK				;042EH
	POP	B
	JMP	AFTERCRLFINDIR				;03C6H

FILESINONELINE:				;03C0H
	CALL	TYPESPACE				;0429H
	CALL	TYPE2POINT				;0436H

AFTERCRLFINDIR:				;03C6H
	MVI	B,1

LETTERINTONAME:				;03C8H
	MOV	A,B
	CALL	AEQUDMAPLUSAPLUSC			;0420H
	ANI	7FH
	CALL	TYPEAREG				;0DF6H
	INR	B
	MOV	A,B
	CPI	0CH
	JNC	ENDOFNAME				;03E5H
	CPI	9
	JNZ	LETTERINTONAME				;03C8H
	MVI	A,'.'	;2EH
	CALL	TYPEAREG				;0DF6H
	JMP	LETTERINTONAME				;03C8H

ENDOFNAME:				;03E5H
	CALL	TYPESPACE				;0429H
	MVI	A,9
	CALL	AEQUDMAPLUSAPLUSC			;0420H
	ANI	80H
	MVI	A,'R'	;52H
	JNZ	ONLYREAD				;03F6H
	MVI	A,' '	;20H

ONLYREAD:				;03F6H
	CALL	TYPEAREG				;0DF6H
	MVI	A,0AH
	CALL	AEQUDMAPLUSAPLUSC			;0420H
	ANI	80H
	MVI	A,'S'	;53H
	JNZ	SYSTEMFILE				;0407H
	MVI	A,' '	;20H

SYSTEMFILE:				;0407H
	CALL	TYPEAREG				;0DF6H
	CALL	CHECKCTRLCONIN				;0B37H
	ORA	A
	JNZ	ENDOFDDIRECTIVE				;041BH
	CALL	FINDNEXTFILE				;18EDH
	LDA	RESULT					;210FH
	INR	A
	JNZ	NEXTDNAME				;03A8H

ENDOFDDIRECTIVE:			;041BH
	CALL	SETREADTODAYDISK			;172BH
	POP	D
	RET

AEQUDMAPLUSAPLUSC:			;0420H
	LHLD	ADRDMA					;2058H

AEQUHLPLUSAPLUSC:			;0423H
	ADD	C
	CALL	HLADDA					;100FH
	MOV	A,M
	RET

TYPESPACE:				;0429H
	MVI	A,' '	;20H
	JMP	TYPEAREG				;0DF6H

TYPEDEFDISK:				;042EH
	LDA	DEFAULTDISK				;205AH

TYPEDISK:				;0431H
	ADI	'A'	;41H
	CALL	TYPEAREG				;0DF6H

TYPE2POINT:				;0436H
	MVI	A,':'	;3AH
	JMP	TYPEAREG				;0DF6H

EDIRECTIVE:				;043BH
	LXI	H,COPYFCB				;2194H
	CALL	PREPAREANDCHECKFILENAME			;0334H
	CPI	0BH
	JNZ	DELETEFILES				;044CH
	MVI	A,4
	CALL	BIOSMSGQUEST				;0D64H
	RNZ

DELETEFILES:				;044CH
	LXI	H,COPYFCB				;2194H
	SHLD	DESYSFUNC				;205BH
	CALL	FUN13					;18F3H
	LDA	RESULT					;210FH
	INR	A
	RNZ

NOFILES:				;045AH
	MVI	A,0AH
	CALL	TYPEBIOSMSG				;1BFEH
	JMP	SETREADTODAYDISK			;172BH

UDIRECTIVE:				;0462H
	LXI	H,COPYFCB				;2194H
	CALL	PREPFCBFROMCOMAND			;1B32H
	LXI	H,COPYFCB+1				;2195H
	CALL	HEXFROMDECSTRING			;0610H
	JC	TYPEMSGANDQUEST				;0347H
	MOV	A,H
	ORA	A
	JNZ	TYPEMSGANDQUEST				;0347H
	MOV	A,L
	CPI	10H
	JNC	TYPEMSGANDQUEST				;0347H
	STA	USER					;2060H
	RET

ODIRECTIVE:				;0480H
	LXI	H,COPYFCB				;2194H
	CALL	PREPFCBFROMCOMAND			;1B32H
	LXI	H,COPYFCB				;2194H
	SHLD	DESYSFUNC				;205BH
	CALL	SETDISKFORFCB				;16E2H
	LXI	H,COPYFCB+1				;2195H
	MOV	A,M
	CPI	' '	;20H
	JZ	SHOWSYSTEMTRACK				;04ABH
	CALL	HEXFROMDECSTRING			;0610H
	XCHG
	JC	TYPEMSGANDQUEST				;0347H
	CALL	DEFSYSTRACKADR				;04D4H
	MOV	M,E
	INX	H
	MOV	M,D
	CALL	DEACTIVATEDISKFROMCREG			;0FFCH
	JMP	SETREADTODAYDISK			;172BH

SHOWSYSTEMTRACK:			;04ABH
	LXI	H,SYSTRACKTABLET			;2096H
	XRA	A

CLCSHOWSYSTRACK:			;04AFH
	PUSH	PSW
	PUSH	H
	CALL	CRLF					;0D41H
	POP	H
	MOV	E,M
	INX	H
	MOV	D,M
	INX	D
	MOV	A,E
	ORA	D
	JZ	ENDSHOWSYSTRACK				;04D2H
	DCX	D
	POP	PSW
	PUSH	PSW
	CALL	TYPEDISK				;0431H
	CALL	TYPESPACE				;0429H
	PUSH	H
	CALL	FUNF332					;0D86H
	POP	H
	INX	H
	POP	PSW
	INR	A
	JMP	CLCSHOWSYSTRACK				;04AFH

ENDSHOWSYSTRACK:			;04D2H
	POP	PSW
	RET

DEFSYSTRACKADR:				;04D4H
	LDA	DEFAULTDISK				;205AH

SETSYSTRACKADR:				;04D7H
	ADD	A
	LXI	H,SYSTRACKTABLET			;2096H
	JMP	HLADDA					;100FH

BDIRECTIVE:				;04DEH
	LDA	STATUSCTRLD				;2317H
	CPI	1
	RNZ
	LXI	H,COPYFCB				;2194H
	CALL	PREPAREANDCHECKFILENAME			;0334H
	LDA	COPYFCB+1				;2195H
	CPI	' '	;20H
	JNZ	ISFILEINTOBDIRECTIVE			;04F8H
;
; MUST BE 0CFCH ADRESS
	CALL	THISADRESSISERROR			;0D01H
	JMP	RESETSYSWITHOUTJMP			;1CAAH

ISFILEINTOBDIRECTIVE:			;04F8H
	CALL	INPUTSPRFILE				;1CF2H
	JNZ	TYPEMSGANDQUEST				;0347H
	LXI	D,0
	MOV	B,D
	MOV	C,E
	CALL	GOTOHL					;0507H
	RET

GOTOHL:					;0507H
	PCHL

KDIRECTIVE:				;0508H
	XRA	A
	STA	KOI7KOI8				;2080H
	RET

ADIRECTIVE:				;050DH
	MVI	A,0FFH
	STA	KOI7KOI8				;2080H
	RET

ISDISKINTOCOMAND:			;0513H
	CALL	CHECKFONREGIM				;032AH

RUNFILE:				;0516H
	LXI	H,COPYFCB+9				;219DH
	MOV	A,M
	CPI	' '	;20H
	JNZ	TYPEMSGANDQUEST				;0347H
	MVI	M,'C'	;43H
	INX	H
	MVI	M,'O'	;4FH
	INX	H
	MVI	M,'M'	;4DH
	CALL	INPUTFILETO100H				;1CD8H
	CPI	1
	JZ	TYPEMSGANDQUEST				;0347H
	CPI	2
	JNZ	TYPESPECIALERRMSG			;05F1H
	CALL	PREPAREPARAMETEROFCOMAND		;0548H
	CALL	CRLF					;0D41H
	XRA	A
	STA	STATUSCTRLD				;2317H
	LXI	SP,STACKTOUSERPROGRAM			;23D3H
	LXI	H,0
	PUSH	H
	JMP	0100H

PREPAREPARAMETEROFCOMAND:		;0548H
	LXI	H,FCB1					;5CH
	CALL	PREPAREANDCHECKFILENAME			;0334H
	LXI	H,FCB2					;6CH
	CALL	PREPAREANDCHECKFILENAME			;0334H
	LXI	H,COMANDBUFER+2				;2115H
	XRA	A
	STA	FCB1+32					;7CH

FRSTSYMBLINCOMAND:			;055BH
	MOV	A,M
	ORA	A
	JZ	ISFRSTSYMBLINCOMAND			;0569H
	CPI	' '	;20H
	JZ	ISFRSTSYMBLINCOMAND			;0569H
	INX	H
	JMP	FRSTSYMBLINCOMAND			;055BH

ISFRSTSYMBLINCOMAND:			;0569H
	MVI	B,0
	LXI	D,SYSDMA+1				;81H

NEXTCHARINPARAMETER:			;056EH
	MOV	A,M
	STAX	D
	ORA	A
	JZ	EOCOMANDSTRING				;058DH
	MOV	C,A
	LDA	STATUSEXCHANGECONSOLE			;2081H
	INR	A
	MOV	A,C
	JZ	CANNOTEX				;0587H
	CPI	'<'	;3CH
	JZ	EOCOMANDSTRING				;058DH
	CPI	'>'	;3EH
	JZ	EOCOMANDSTRING				;058DH

CANNOTEX:				;0587H
	INR	B
	INX	H
	INX	D
	JMP	NEXTCHARINPARAMETER			;056EH

EOCOMANDSTRING:				;058DH
	XRA	A
	STAX	D
	LXI	H,SYSDMA				;80H
	MOV	M,B
	SHLD	ADRDMA					;2058H
	CALL	RESETDMABUFER				;1087H

WORKEXCHANGECONSOLE:			;0599H
	LDA	STATUSEXCHANGECONSOLE			;2081H
	INR	A
	RZ
	LHLD	BEGINOFCOMAND				;2104H
	XCHG

SEARCHEXCHANGECHAR:			;05A2H
	CALL	FINDFIRSTSYMBOL				;1B23H
	RZ
	INX	D
	CPI	'>'	;3EH
	JZ	CONOUTEXCHANGE				;05C7H
	CPI	'<'	;3CH
	JNZ	SEARCHEXCHANGECHAR			;05A2H
;
; CONIN EXCHANGE
	XCHG
	SHLD	BEGINOFCOMAND				;2104H
	LXI	H,FCBCONINFILE				;2249H
	CALL	PREPAREANDCHECKFILENAME			;0334H
	JNZ	TYPEMSGANDQUEST				;0347H
	CALL	PREPFILECONIN				;07D3H
	JZ	TYPEMSGANDQUEST				;0347H
	JMP	WORKEXCHANGECONSOLE			;0599H

CONOUTEXCHANGE:				;05C7H
	LDAX	D
	CPI	'>'	;3EH
	JNZ	SECONDP					;05CEH
	INX	D

SECONDP:				;05CEH
	XCHG
	SHLD	BEGINOFCOMAND				;2104H
	PUSH	PSW
	LXI	H,FCBCONOUTFILE				;22EDH
	CALL	PREPAREANDCHECKFILENAME			;0334H
	JNZ	TYPEMSGANDQUEST				;0347H
	POP	PSW
	JZ	FINDTWOP				;05E9H
	CALL	OPENCONOUTFILE				;0813H

CHECKGOODCONUOTFILE:			;05E3H
	JZ	TYPEMSGANDQUEST				;0347H
	JMP	WORKEXCHANGECONSOLE			;0599H

FINDTWOP:				;05E9H
	CALL	AMAKEZERO				;05EFH
	JMP	CHECKGOODCONUOTFILE			;05E3H

AMAKEZERO:				;05EFH
	XRA	A
	RET

TYPESPECIALERRMSG:			;05F1H
	LXI	B,SPECIALMSG				;05F7H
	JMP	PECUNTILDOLLAR				;1C08H

SPECIALMSG:				;05F7H
	DB	'>>  ??!$'

SEARCHBYTEC:				;05FFH
	MVI	B,0

NEXTSEARCH:				;0601H
	MOV	A,M
	ORA	A
	RZ
	CMP	C
	JZ	FINDC					;060DH
	INX	H
	INR	B
	JMP	NEXTSEARCH				;0601H

FINDC:					;060DH
	MOV	A,B
	STC
	RET

HEXFROMDECSTRING:			;0610H
	XCHG
	LXI	H,0

CLCHEXDEC:				;0614H
	LDAX	D
	CPI	' '	;20H
	RZ
	CALL	DECFROMCHAR				;0629H
	RC
	DAD	H
	MOV	B,H
	MOV	C,L
	DAD	H
	DAD	H
	DAD	B
	CALL	HLADDA					;100FH
	INX	D
	JMP	CLCHEXDEC				;0614H

DECFROMCHAR:				;0629H
	SUI	'0'	;30H
	RC
	CPI	0AH
	CMC
	RET

SYSTEMFUNC:				;0630H
	XCHG
	SHLD	DESYSFUNC				;205BH
	XCHG
	MOV	A,C
	STA	CSYSFUNC				;205FH
	CPI	0EH
	JC	CASESYSFUNC				;0691H
	LDA	MULTISEKTORCOUNT			;2066H
	DCR	A
	JZ	CASESYSFUNC				;0691H
	LXI	H,LISTFUNC2021333440			;0683H
	CALL	SEARCHBYTEC				;05FFH
	JNC	CASESYSFUNC				;0691H
	LXI	H,0
	DAD	SP
	SHLD	USERSTACK				;23BDH
	LXI	SP,STACKFORSYSTEMFUNC			;23C9H
	LXI	H,EXITMULTISEKTORFUNC			;0765H
	PUSH	H
	CALL	COPYADRDMA				;191FH
	CALL	COPYR0R1R2FROMFCB			;19ABH
	LDA	MULTISEKTORCOUNT			;2066H

CLCMULTISEKTOR:				;0665H
	PUSH	PSW
	STA	COPYOFMULTISEKTORCOUNT			;23BCH
	CALL	CASESYSMULTISECTORFUNC			;0689H
	ORA	A
	JNZ	ERRORMULTISEKTORFUNC			;077AH
	LDA	CSYSFUNC				;205FH
	CPI	'!'	;21H
	CNC	CHANGER1R2R3				;19A0H
	CALL	NEXTPDP					;1926H
	POP	PSW
	DCR	A
	JNZ	CLCMULTISEKTOR				;0665H
	MOV	L,A
	MOV	H,A
	RET
;
; 20..21..33..34..40...END OF LIST

LISTFUNC2021333440:			;0683H
	DB	14H,15H,'!"(',0

CASESYSMULTISECTORFUNC:			;0689H
	LDA	CSYSFUNC				;205FH
	MOV	C,A
	LHLD	DESYSFUNC				;205BH
	XCHG

CASESYSFUNC:				;0691H
	MOV	A,E
	STA	SYSEPARAM				;20E6H
	LXI	H,0
	SHLD	RESULT					;210FH
	DAD	SP
	SHLD	USERSTACKSTORE				;210CH
	LXI	SP,COPYOFMULTISEKTORCOUNT		;23BCH
	XRA	A
	STA	STATUSSHOWFILENAMEINBDOSMSG		;2108H
	STA	FLAGFORSETREADTODAYDISK			;205DH
	LXI	H,EXITCASEOFSYSFUNC			;0758H
	PUSH	H
	LDA	SYSEPARAM				;20E6H
	MOV	E,A
	MOV	A,C
	MOV	C,E
	CPI	98H
	LXI	H,GOTOFBDOS-0B8H			;0626H
	JZ	GOTOFUN					;06D1H
	CPI	80H
	JNC	FUN29					;11DCH
	CPI	71H
	RNC
	CPI	6CH
	LXI	H,GOTOFBDOS+06EH			;0674H
	JNC	GOTOFUN					;06D1H
	CPI	'3'	;33H
	RNC
	LXI	H,GOTOFBDOS				;06DEH

GOTOFUN:				;06D1H
	MOV	E,A
	MVI	D,0
	DAD	D
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M
	LHLD	DESYSFUNC				;205BH
	XCHG
	PCHL

GOTOFBDOS:				;06DEH
	DW	FUN00					;1C31H
	DW	FUN01					;0885H
	DW	FUN02					;089CH
	DW	FUN03					;08B0H
	DW	FUN04					;08B9H
	DW	FUN05					;1E72H
	DW	FUN06					;08C9H
	DW	FUN07					;08FBH
	DW	FUN08					;0A8FH
	DW	FUN09					;0901H
	DW	FUN0A					;0913H
	DW	FUN0B					;0A89H
	DW	FUN0C					;0A90H
	DW	FUN0D					;1712H
	DW	FUN0E					;1743H
	DW	FUN0F					;12ACH
	DW	FUN10					;1354H
	DW	FUN11					;18B7H
	DW	FUN12					;18E4H
	DW	FUN13					;18F3H
	DW	FUN14					;148CH
	DW	FUN15					;14E3H
	DW	FUN16					;13D7H
	DW	FUN17					;18FFH
	DW	FUN18					;1908H
	DW	FUN19					;190EH
	DW	FUN1A					;1918H
	DW	FUN1B					;1930H
	DW	FUN1C					;1936H
	DW	FUN1D					;194EH
	DW	FUN1E					;1954H
	DW	FUN1F					;195DH
	DW	FUN20					;1964H
	DW	FUN21					;1975H
	DW	FUN22					;1981H
	DW	FUN23					;16A3H
	DW	FUN24					;198DH
	DW	FUN25					;19C0H
	DW	FUN08					;0A8FH
	DW	FUN08					;0A8FH
	DW	FUN28					;19E1H
	DW	FUN29					;11DCH
	DW	FUN08					;0A8FH
	DW	FUN08					;0A8FH
	DW	FUN2C					;1A44H
	DW	FUN2D					;1A52H
	DW	FUN2E					;19F2H
	DW	FUN2F					;1A7EH
	DW	FUN08					;0A8FH
	DW	FUN31					;1A57H
	DW	FUN32					;0783H
	DW	FUN68					;1AA1H
	DW	FUN69					;1AA8H
	DW	FUN08					;0A8FH
	DW	FUN08					;0A8FH
	DW	FUN6C					;1AB8H
	DW	FUN6D					;1AC7H
	DW	FUN6E					;1ACDH
	DW	FUN6F					;1ADBH
	DW	FUN6F					;1ADBH
	DW	FUN98					;1BDFH

EXITCASEOFSYSFUNC:			;0758H
	CALL	SETREADTODAYDISK			;172BH
	LHLD	USERSTACKSTORE				;210CH
	SPHL
	LHLD	RESULT					;210FH
	MOV	A,L
	MOV	B,H
	RET

EXITMULTISEKTORFUNC:			;0765H
	PUSH	H
	CALL	COPYDMATODMA				;1914H
	LDA	CSYSFUNC				;205FH
	CPI	'!'	;21H
	CNC	COPYR0R1R2TOFCB				;19B7H
	POP	D
	LHLD	USERSTACK				;23BDH
	SPHL
	XCHG
	MOV	A,L
	MOV	B,H
	RET

ERRORMULTISEKTORFUNC:			;077AH
	POP	B
	INR	A
	RZ
	LDA	MULTISEKTORCOUNT			;2066H
	SUB	B
	MOV	H,A
	RET

FUN32:					;0783H
	LHLD	DESYSFUNC				;205BH
	MOV	A,M
	RAL
	JNC	FUN32IS007F				;086BH
	RAR
	ANI	7FH
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	SHLD	DESYSFUNC				;205BH
	MOV	C,L
	LXI	H,GOTOALTFBDOS				;07A7H
	CPI	70H
	JC	GOTOFUN					;06D1H
	SBI	70H
	LXI	H,GOTOALTFBDOS+0CH			;07B3H
	JMP	GOTOFUN					;06D1H

GOTOALTFBDOS:				;07A7H
	DW	FUN8032					;188FH
	DW	FUN8132					;17CBH
	DW	FUN8232					;18ADH
	DW	FUN8332					;07CBH
	DW	FUN8432					;0800H
	DW	FUN8532					;0805H
	DW	FUNF032					;085FH
	DW	FUNF132					;085BH
	DW	FUNF232					;0CD0H
	DW	FUNF332					;0D86H
	DW	FUNF432					;07BFH
	DW	FUNF532					;07C5H

FUNF432:				;07BFH
	LXI	H,USERSTACKSTORE			;210CH
	JMP	SETWORDRESULT				;1960H

FUNF532:				;07C5H
	LXI	H,COPYOFMULTISEKTORCOUNT		;23BCH
	JMP	SETWORDRESULT				;1960H

FUN8332:				;07CBH
	LXI	H,FCBCONINFILE				;2249H
	MVI	C,' '	;20H
	CALL	COPYCBYTEHLDE				;18DAH

PREPFILECONIN:				;07D3H
	LXI	H,FCBCONINFILE				;2249H
	SHLD	DESYSFUNC				;205BH
	CALL	SETDISKINTOFCB				;0852H
	XCHG
	CALL	FUN0F					;12ACH
	CALL	SETTODAYDISKANDREMEMBERRESULT		;033DH
	STA	STATUSCONINFILE				;226AH
	RZ
	MVI	A,0FFH
	STA	STATUSCONINFILE				;226AH
	STA	DATACONINFILE				;2011H
	LDA	USER					;2060H
	STA	USERCONINFILE				;226BH

TZSET0:					;07F5H
	MVI	A,0
	LHLD	DESYSFUNC				;205BH
	LXI	D,20H
	DAD	D
	MOV	M,A
	RET

FUN8432:				;0800H
	XRA	A
	STA	STATUSCONINFILE				;226AH
	RET

FUN8532:				;0805H
	XCHG
	MVI	A,0FFH
	STA	STATUSCONINBUF				;2310H
	SHLD	ADRCONINBUFER				;2312H
	INR	A
	STA	COUNTBUFERCONIN				;2311H
	RET

OPENCONOUTFILE:				;0813H
	LXI	H,FCBCONOUTFILE				;22EDH
	SHLD	DESYSFUNC				;205BH
	CALL	SETDISKINTOFCB				;0852H
	XCHG
;
; CREATE FILE
	CALL	FUN16					;13D7H
	CALL	SETTODAYDISKANDREMEMBERRESULT		;033DH
	STA	PRIZNAKCONOUTFILE			;230EH
	RZ
	LXI	H,DMACONOUTFILE				;226DH
	CALL	FILLEOFTOHL				;083FH
	XRA	A
	STA	DATACONOUTFILE				;2016H
	CALL	TZSET0					;07F5H
	DCR	A
	STA	PRIZNAKCONOUTFILE			;230EH
	LDA	USER					;2060H
	STA	USERCONOUTFILE				;230FH
	RET

FILLEOFTOHL:				;083FH
	LXI	B,SYSDMA				;80H
	MVI	E,1AH
	JMP	FILLETOHL				;0849H

FILLZEROTOHL:				;0847H
	MVI	E,0

FILLETOHL:				;0849H
	MOV	M,E
	INX	H
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	FILLETOHL				;0849H
	RET

SETDISKINTOFCB:				;0852H
	MOV	A,M
	ORA	A
	RNZ
	LDA	DEFAULTDISK				;205AH
	INR	A
	MOV	M,A
	RET

FUNF132:				;085BH
	MOV	A,E
	JMP	LBYTE					;0DE0H

FUNF032:				;085FH
	MOV	C,E
	MOV	B,D
	CALL	PEC					;0903H
	CALL	CHECKYES				;0D67H
	RZ
	JMP	DIRBUFISFFFF				;11D9H

FUN32IS007F:				;086BH
	RAR
	MOV	E,A
	MVI	D,0
	INX	H
	MOV	C,M
	INX	H
	MOV	B,M
	LXI	H,BDOSBEGIN				;0200H
	DAD	D
	DAD	D
	DAD	D
	XCHG
	LXI	H,EXITFUN32IS007F			;0881H
	PUSH	H
	XCHG
	MOV	D,B
	PCHL

EXITFUN32IS007F:			;0881H
	SHLD	RESULT					;210FH
	RET

FUN01:					;0885H
	CALL	REALFUN01				;0B16H
	JMP	SETBYTERESULT				;0A8CH

TYPEALLCHAR:				;088BH
	MOV	A,C
	CALL	CHECK0D0A090820				;0B24H
	JNC	FUN02					;089CH
;
; TYPE ^CHAR
	PUSH	PSW
	MVI	C,5EH
	CALL	TYPECHAR				;0A3CH
	POP	PSW
	ORI	'@'	;40H
	MOV	C,A

FUN02:					;089CH
	MOV	A,C
	CPI	9
	JNZ	TYPECHAR				;0A3CH

UNTIL8COLUMN:				;08A2H
	MVI	C,' '	;20H
	CALL	TYPECHAR				;0A3CH
	LDA	COLUMN					;2037H
	ANI	7
	JNZ	UNTIL8COLUMN				;08A2H
	RET

FUN03:					;08B0H
	LHLD	FLAGAUXIN				;2042H
	CALL	READCHANEL				;1EAFH
	JMP	SETBYTERESULT				;0A8CH

FUN04:					;08B9H
	LHLD	FLAGAUXOUT				;2044H

OUTDEVICE:				;08BCH
	LXI	D,0CH

CAUXOUTPUTDEVICE:			;08BFH
	DAD	H
	JC	BIOSOUTPUT				;240CH
	INR	D
	DCR	E
	RZ
	JMP	CAUXOUTPUTDEVICE			;08BFH

FUN06:					;08C9H
	MOV	A,C
	INR	A
	JZ	INPUTSTATUSCONIN			;08DCH
	INR	A
	JZ	ONLYSTATUSCONIN				;08F1H
	INR	A
	JNZ	BIOSF04					;1F85H
	CALL	BIOSF03					;1F31H
	JMP	SETBYTERESULT				;0A8CH

INPUTSTATUSCONIN:			;08DCH
	CALL	CHECKCTRLCONIN				;0B37H
	ORA	A
	RZ
	LXI	H,SMBLFROMCONINTODAY			;210BH
	MOV	A,M
	MVI	M,0
	ORA	A
	JNZ	SETBYTERESULT				;0A8CH
	CALL	BIOSF03					;1F31H
	JMP	SETBYTERESULT				;0A8CH

ONLYSTATUSCONIN:			;08F1H
	CALL	CHECKCTRLCONIN				;0B37H
	ORA	A
	JNZ	FUN29					;11DCH
	JMP	SETBYTERESULT				;0A8CH

FUN07:					;08FBH
	LHLD	FLAGAUXIN				;2042H
	JMP	CHECKSTATUSDEVICE			;1E8FH

FUN09:					;0901H
	MOV	C,E
	MOV	B,D

PEC:					;0903H
	LXI	H,EOSTRINGCHAR				;2053H
	LDAX	B
	CMP	M
	RZ
	INX	B
	PUSH	B
	MOV	C,A
	CALL	FUN02					;089CH
	POP	B
	JMP	PEC					;0903H

FUN0A:					;0913H
	LHLD	DESYSFUNC				;205BH

INPUTHLSTRING:				;0916H
	LDA	COLUMN					;2037H
	STA	CLMNBEGINSTRING				;210AH
	MOV	C,M
	INX	H
	PUSH	H
	MVI	B,0

CLSTRING:				;0921H
	PUSH	B
	PUSH	H

NEXTSMBLTOBUF:				;0923H
	CALL	READSMBLCONIN				;0A96H
	POP	H
	POP	B
	CPI	0DH
	JZ	EXFUN0A					;0A38H
	CPI	0AH
	JZ	EXFUN0A					;0A38H
	CPI	8
	JZ	MAKEZABOY				;093CH
	CPI	7FH
	JNZ	CHF0ACTRLE				;094BH

MAKEZABOY:				;093CH
	MOV	A,B
	ORA	A
	JZ	CLSTRING				;0921H

CTRLHZABOY:				;0941H
	DCR	B
	LDA	COLUMN					;2037H
	STA	CLMNENDSTRING				;2109H
	JMP	CTRLRCTRLHZABOY				;098DH

CHF0ACTRLE:				;094BH
	CPI	5
	JNZ	CHF0ACTRLP				;095CH
	PUSH	B
	PUSH	H
	CALL	CRLF					;0D41H
	XRA	A
	STA	CLMNBEGINSTRING				;210AH
	JMP	NEXTSMBLTOBUF				;0923H

CHF0ACTRLP:				;095CH
	CPI	10H
	JNZ	CHF0ACTRLX				;096DH
	PUSH	B
	PUSH	H
	LXI	H,COPYTOPRINTER				;2054H
	MVI	A,1
	SUB	M
	MOV	M,A
	JMP	NEXTSMBLTOBUF				;0923H

CHF0ACTRLX:				;096DH
	CPI	18H
	JNZ	CHF0ACTRLU				;097CH
	POP	H

CLCCTRLX:				;0973H
	CALL	MAKEBACKSPACE				;0A73H
	JNC	FUN0A					;0913H
	JMP	CLCCTRLX				;0973H

CHF0ACTRLU:				;097CH
	CPI	15H
	JNZ	CHF0ACTRLR				;0988H
	CALL	NEXTLINEFROMCOLUMN			;0AF9H
	POP	H
	JMP	FUN0A					;0913H

CHF0ACTRLR:				;0988H
	CPI	12H
	JNZ	CHF0ACTRLW				;09BFH

CTRLRCTRLHZABOY:			;098DH
	PUSH	B
	CALL	NEXTLINEFROMCOLUMN			;0AF9H
	POP	B
	POP	H
	PUSH	H
	PUSH	B

CLCALLSTRING:				;0995H
	MOV	A,B
	ORA	A
	JZ	ALLSTRING				;09A3H
	INX	H
	MOV	A,M
	DCR	B
	CALL	TYPEAREG				;0DF6H
	JMP	CLCALLSTRING				;0995H

ALLSTRING:				;09A3H
	PUSH	H
	LDA	CLMNENDSTRING				;2109H
	ORA	A
	JZ	NEXTSMBLTOBUF				;0923H
	LXI	H,COLUMN				;2037H
	SUB	M
	STA	CLMNENDSTRING				;2109H

ZABOY:					;09B2H
	CALL	TYPEBACKSPACE				;0AECH
	LXI	H,CLMNENDSTRING				;2109H
	DCR	M
	JNZ	ZABOY					;09B2H
	JMP	NEXTSMBLTOBUF				;0923H

CHF0ACTRLW:				;09BFH
	CPI	17H
	JNZ	CHF0ADELWORD				;09DCH
	MOV	E,A
	MOV	A,B
	ORA	A
	MOV	A,E
	JNZ	CHF0ADELWORD				;09DCH
	MOV	B,M
	MOV	E,B
	INR	E

CLCCTRLW:				;09CEH
	DCR	E
	JZ	CLSTRING				;0921H
	INX	H
	MOV	A,M
	PUSH	D
	CALL	TYPEAREG				;0DF6H
	POP	D
	JMP	CLCCTRLW				;09CEH

CHF0ADELWORD:				;09DCH
	CPI	1EH
	JNZ	TOSTRING				;0A22H

CLCDELSPACE:				;09E1H
	INR	B
	DCR	B
	JZ	CLSTRING				;0921H
	MOV	A,M
	CPI	' '	;20H
	JC	CTRLHZABOY				;0941H
	JNZ	DELCHARFROMWORD				;09F8H
	CALL	MAKEBACKSPACE				;0A73H
	JNC	CLSTRING				;0921H
	JMP	CLCDELSPACE				;09E1H

DELCHARFROMWORD:			;09F8H
	CALL	CHECKCHARTODELETE			;1B03H
	JZ	CTRLHZABOY				;0941H

DELWORD:				;09FEH
	INR	B
	DCR	B
	JZ	CLSTRING				;0921H
	MOV	A,M
	CALL	CHECKCHARTODELETE			;1B03H
	JZ	CLSTRING				;0921H
	CPI	0EH
	JZ	DELRUSLAT				;0A19H
	CPI	0FH

SET1TORESULT:				;0A11H
	JZ	DELRUSLAT				;0A19H
	CPI	' '	;20H
	JC	CLSTRING				;0921H

DELRUSLAT:				;0A19H
	CALL	MAKEBACKSPACE				;0A73H
	JNC	CLSTRING				;0921H
	JMP	DELWORD					;09FEH

TOSTRING:				;0A22H
	INX	H
	MOV	M,A
	INR	B
	CALL	TYPEAREG				;0DF6H
	MOV	A,M
	CPI	3
	MOV	A,B
	JNZ	NOTCTRLC				;0A34H
	CPI	1
	JZ	0

NOTCTRLC:				;0A34H
	CMP	C
	JC	CLSTRING				;0921H

EXFUN0A:				;0A38H
	POP	H
	MOV	M,B
	MVI	C,0DH

TYPECHAR:				;0A3CH
	LDA	CLMNENDSTRING				;2109H
	ORA	A
	JNZ	NOTBEGINLINE				;0A56H
	PUSH	B
	CALL	CHECKCTRLCONIN				;0B37H
	POP	B
	PUSH	B
	CALL	BIOSF04					;1F85H
	POP	B
	PUSH	B
	LDA	COPYTOPRINTER				;2054H
	ORA	A
	CNZ	FUN05					;1E72H
	POP	B

NOTBEGINLINE:				;0A56H
	MOV	A,C
	LXI	H,COLUMN				;2037H
	CPI	7FH
	RZ
	INR	M
	CPI	' '	;20H
	RNC
	DCR	M
	MOV	A,M
	ORA	A
	RZ
	MOV	A,C
	CPI	8
	JNZ	CASECTRLTYPE1				;0A6DH
	DCR	M
	RET

CASECTRLTYPE1:				;0A6DH
	CPI	0AH
	RNZ
	MVI	M,0
	RET

MAKEBACKSPACE:				;0A73H
	DCR	B
	DCX	H
	PUSH	B
	PUSH	H
	LDA	CLMNBEGINSTRING				;210AH
	LXI	H,COLUMN				;2037H
	CMP	M
	JNC	CLMNRIGHT				;0A86H
	DCR	M
	CALL	TYPEBACKSPACE				;0AECH
	STC

CLMNRIGHT:				;0A86H
	POP	H
	POP	B
	RET

FUN0B:					;0A89H
	CALL	CHECKCTRLCONIN				;0B37H

SETBYTERESULT:				;0A8CH
	STA	RESULT					;210FH

FUN08:					;0A8FH
	RET

FUN0C:					;0A90H
	LDA	VERSION					;2021H
	JMP	SETBYTERESULT				;0A8CH

READSMBLCONIN:				;0A96H
	CALL	FROMTOREADCONIN				;1E7EH
	JZ	CONINFILEORBUFER			;0AA4H
	LXI	H,SMBLFROMCONINTODAY			;210BH
	MOV	A,M
	MVI	M,0
	ORA	A
	RNZ

CONINFILEORBUFER:			;0AA4H
	CALL	BIOS03					;0209H
;
; CTRL-D --> EXIT TO DOS
	CPI	4
	RNZ
	LXI	H,STATUSCTRLD				;2317H
	MOV	A,M
	ORA	A
	JNZ	CONINFILEORBUFER			;0AA4H
	MVI	M,0FFH
	LDA	CLMNBEGINSTRING				;210AH
	PUSH	PSW
	LDA	COLUMN					;2037H
	PUSH	PSW
	LHLD	DESYSFUNC				;205BH
	PUSH	H
	LXI	H,0
	DAD	SP
	SHLD	STACKCTRLD				;231AH
	LXI	SP,SYSTEMSTACK				;2376H
	CALL	FONREGIM				;0233H

EXITREADONLYINTOFONREVIM:		;0ACDH
	CALL	CRLF					;0D41H
	MVI	A,'>'	;3EH
	CALL	TYPEAREG				;0DF6H
	XRA	A
	STA	STATUSCTRLD				;2317H
	LHLD	STACKCTRLD				;231AH
	SPHL
	POP	H
	SHLD	DESYSFUNC				;205BH
	POP	PSW
	STA	COLUMN					;2037H
	POP	PSW
	STA	CLMNBEGINSTRING				;210AH
	JMP	CONINFILEORBUFER			;0AA4H

TYPEBACKSPACE:				;0AECH
	CALL	TYPEBACKSPACE+8				;0AF4H
	MVI	C,' '	;20H
	CALL	BIOSF04					;1F85H
	MVI	C,8
	JMP	BIOSF04					;1F85H

NEXTLINEFROMCOLUMN:			;0AF9H
	MVI	C,'#'	;23H
	CALL	TYPECHAR				;0A3CH
	CALL	CRLF					;0D41H

NEXTSPACE:				;0B01H
	LDA	COLUMN					;2037H
	LXI	H,CLMNBEGINSTRING			;210AH
	CMP	M
	RNC
	MVI	C,' '	;20H
	CALL	TYPECHAR				;0A3CH
	JMP	NEXTSPACE				;0B01H

STOREONETORESULT:			;0B11H
	MVI	A,1
	JMP	SETBYTERESULT				;0A8CH

REALFUN01:				;0B16H
	CALL	READSMBLCONIN				;0A96H
	CALL	CHECK0D0A090820				;0B24H
	RC
	PUSH	PSW
	MOV	C,A
	CALL	FUN02					;089CH
	POP	PSW
	RET

CHECK0D0A090820:			;0B24H
	CALL	CHECKCRLF				;0B31H
	RZ
	CPI	9
	RZ
	CPI	8
	RZ
	CPI	' '	;20H
	RET

CHECKCRLF:				;0B31H
	CPI	0DH
	RZ
	CPI	0AH
	RET
;
; IF SMBL IS READY THEN RETURN STATUS 'YES' = 1 ELSE READ CONIN

CHECKCTRLCONIN:				;0B37H
	LDA	SMBLFROMCONINTODAY			;210BH
	ORA	A
	JNZ	SMBLISREADY				;0B8BH
	CALL	CHECKCONINDEVICESTATUS			;1E8CH
	ANI	1
	RZ
	CALL	READCONINDEVICE				;1EACH
;
; CTRL-S ?

L0B47:					;0B47H
	CPI	13H
	JNZ	SCREENISNOTLOCKED			;0B88H

CHECKEXITFROMCTRLS:			;0B4CH
	CALL	READCONINDEVICE				;1EACH
	CPI	3
	JZ	0
;
; CTRL-Q ?
	CPI	11H
	JZ	SCREENISOPEN				;0B6FH
;
; CTRL-F ?
	CPI	6
	JNZ	CHECKCTRLP				;0B71H
;
; DELETE USE FILE-CONIN
	LDA	PRIZNAKCONOUTFILE			;230EH
	INR	A
	CZ	CLOSECONOUTFILE				;1FB5H
	LDA	STATUSCONINFILE				;226AH
	INR	A
	JNZ	SCREENISOPEN				;0B6FH
	STA	STATUSCONINFILE				;226AH

SCREENISOPEN:				;0B6FH
	XRA	A
	RET

CHECKCTRLP:				;0B71H
	CPI	10H
	JNZ	MAKEBEEP				;0B80H
	LXI	H,COPYTOPRINTER				;2054H
	MVI	A,1
	SUB	M
	MOV	M,A
	JMP	SCREENISOPEN				;0B6FH
;
; BEEP

MAKEBEEP:				;0B80H
	MVI	C,7
	CALL	BIOSF04					;1F85H
	JMP	CHECKEXITFROMCTRLS			;0B4CH

SCREENISNOTLOCKED:			;0B88H
	STA	SMBLFROMCONINTODAY			;210BH

SMBLISREADY:				;0B8BH
	MVI	A,1
	RET

READFROMBUFER:				;0B8EH
	XRA	A

WORKWITHBUFER:				;0B8FH
	STA	STATUSFROMORTOBUFER			;201BH
	MOV	A,M
	CPI	80H
	JC	CANREADBUFER				;0BA6H
	PUSH	H
	PUSH	B
	CALL	RDWR80HFORCONSOLFILES			;0BBBH
	POP	B
	POP	H
	LDA	RESULT					;210FH
	ORA	A
	RNZ
	XRA	A
	MOV	M,A

CANREADBUFER:				;0BA6H
	INR	M
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	CALL	HLADDA					;100FH
	LDA	STATUSFROMORTOBUFER			;201BH
	INR	A
	JZ	WRBYTECONOUTBUFER			;0BB9H
	XRA	A
	MOV	A,M
	RET

WRBYTECONOUTBUFER:			;0BB9H
	MOV	M,C
	RET

RDWR80HFORCONSOLFILES:			;0BBBH
	INX	H
	MOV	C,M
	INX	H
	MOV	B,M
;
; <BC> --> DMA FOR CONIN OR CONOUT FILE
	PUSH	B
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
;
; <DE> --> FCB FOR CONIN OR CONOUT FILE
	LHLD	ADRDMA					;2058H
	PUSH	H
	CALL	BIOSF0C					;1093H
	XRA	A
	STA	RESULT					;210FH
	PUSH	D
	LXI	H,COPY2DISKDSC				;208CH
	CALL	MAKECOPYDISCDSC				;1E63H
	POP	H
	SHLD	DESYSFUNC				;205BH
	XCHG
	LDA	STATUSFROMORTOBUFER			;201BH
	INR	A
	JZ	WRTOCONOUTFILE				;0C02H
;
; RDFROMCONINFILE
	LDA	USER					;2060H
	PUSH	PSW
	LDA	USERCONINFILE				;226BH
	STA	USER					;2060H
	CALL	FUN14					;148CH
	POP	PSW
	STA	USER					;2060H
	POP	H
	XTHL

EXWRRDCONSOLFILE:			;0BF5H
	CALL	SETREADTODAYDISK			;172BH
	LXI	H,COPY2DISKDSC				;208CH
	CALL	RESETDISKDSC				;1E69H
	POP	B
	JMP	BIOSF0C					;1093H

WRTOCONOUTFILE:				;0C02H
	LDA	USER					;2060H
	PUSH	PSW
	LDA	USERCONOUTFILE				;230FH
	STA	USER					;2060H
	CALL	FUN15					;14E3H
	POP	PSW
	STA	USER					;2060H
	POP	H
	XTHL
	CALL	FILLEOFTOHL				;083FH
	JMP	EXWRRDCONSOLFILE			;0BF5H
;
; WRITE <C> TO CONOUT FILE (BUFER)

WRITETOBUF:				;0C1BH
	MVI	A,0FFH
	JMP	WORKWITHBUFER				;0B8FH

MSGDISKERROR:				;0C20H
	LDA	CSYSFUNC				;205FH
	CPI	'.'	;2EH
	JZ	WITHOUTFILENAME				;0C32H
	CPI	0FH
	JC	WITHOUTFILENAME				;0C32H
	MVI	A,0FFH
	STA	STATUSSHOWFILENAMEINBDOSMSG		;2108H

WITHOUTFILENAME:			;0C32H
	MVI	A,1
	CALL	MSGBDOSERR				;0CFCH
	LXI	B,TXTSTEQU				;0D4BH
	CALL	PECUNTILDOLLAR				;1C08H
	LDA	STATUSDISK				;2111H
	CALL	LBYTE					;0DE0H
	CALL	TYPETAB					;0D5DH
	LXI	B,TXTTEQU				;0D4CH
	CALL	PECUNTILDOLLAR				;1C08H
	LDA	TRACK					;1FF4H
	CALL	PRTADECIMAL				;0D83H
	CALL	TYPETAB					;0D5DH
	LXI	B,TXTSEQU				;0D50H
	CALL	PECUNTILDOLLAR				;1C08H
	LDA	SEKTOR					;1FF5H
	CALL	PRTADECIMAL				;0D83H
	CALL	CRLF					;0D41H
	LDA	STATUSCTRLD				;2317H
	INR	A
	JZ	EXITREADONLYINTOFONREVIM		;0ACDH
	LDA	FLAGQUESTFORDISKERROR			;1FEDH
	ORA	A
	MVI	A,0FFH
	STA	FLAGQUESTFORDISKERROR			;1FEDH
	JZ	0
	JMP	QUEST					;0CA6H

ERRFILEISONLYREAD:			;0C7AH
	MVI	A,0FFH
	STA	STATUSSHOWFILENAMEINBDOSMSG		;2108H
	MVI	A,8
	CALL	MSGBDOSERR				;0CFCH
	JMP	WHERERETURN				;0C92H

RESETLASTDEFDISK:			;0C87H
	MVI	A,2
	CALL	MSGBDOSERR				;0CFCH
	LDA	LASTDEFAULTDISK				;210EH
	STA	DEFAULTDISK				;205AH

WHERERETURN:				;0C92H
	LDA	STATUSCTRLD				;2317H
	INR	A
	JNZ	FUN00					;1C31H
	JMP	EXITREADONLYINTOFONREVIM		;0ACDH

QUESTFORDELETEROFILE:			;0C9CH
	MVI	A,0FFH
	STA	STATUSSHOWFILENAMEINBDOSMSG		;2108H
	MVI	A,3
	CALL	MSGBDOSERR				;0CFCH

QUEST:					;0CA6H
	LDA	DEFAULTDISK				;205AH
	MOV	C,A
	LXI	H,1
	CALL	STEPENTWO				;0FB1H
	CALL	DEACTIVATEDISK				;19C3H
	CALL	IGNOREQUEST				;0D62H
	JNZ	0
	CALL	CRLF					;0D41H
	RET

TYPENAMEFILE:				;0CBDH
	LDA	STATUSDISK				;2111H
	ORA	A
	JNZ	FUNF232					;0CD0H
	LHLD	DIRBUFDEFDISK				;20C9H
	LDA	SHIFTINDIRECTORY			;20F5H
	CALL	HLADDA					;100FH
	JMP	TYPEFILENAMEFROMHL			;0CD3H

FUNF232:				;0CD0H
	LHLD	DESYSFUNC				;205BH

TYPEFILENAMEFROMHL:			;0CD3H
	MVI	C,8
	INX	H
	CALL	TYPECBYTEFROMHL				;0CEDH
	INR	C

SPACEINNAME:				;0CDAH
	DCR	C
	JZ	EONAME					;0CE2H
	INX	H
	JMP	SPACEINNAME				;0CDAH

EONAME:					;0CE2H
	MOV	A,M
	CPI	' '	;20H
	RZ
	MVI	A,'.'	;2EH
	CALL	TYPEAREG				;0DF6H
	MVI	C,3

TYPECBYTEFROMHL:			;0CEDH
	MOV	A,M
	CPI	' '	;20H
	RZ
	ANI	7FH
	CALL	TYPEAREG				;0DF6H
	INX	H
	DCR	C
	JNZ	TYPECBYTEFROMHL				;0CEDH
	RET

MSGBDOSERR:				;0CFCH
	PUSH	PSW
	CALL	CRLF					;0D41H
;
; MESSAGE BDOS ERROR
	XRA	A

THISADRESSISERROR:			;0D01H
	CALL	TYPEBIOSMSG				;1BFEH
	CALL	TYPEDEFDISK				;042EH
	LDA	STATUSSHOWFILENAMEINBDOSMSG		;2108H
	INR	A
	CZ	TYPENAMEFILE				;0CBDH
	POP	PSW
	CALL	TYPEBIOSMSG				;1BFEH
	CALL	CRLF					;0D41H
	LDA	STATUSCTRLD				;2317H
	INR	A
	RZ
	CPI	2
	RZ
	LXI	B,TXTOEQU				;0D54H
	CALL	PECUNTILDOLLAR				;1C08H
	LDA	CSYSFUNC				;205FH
	CALL	PRTADECIMAL				;0D83H
	CALL	TYPETAB					;0D5DH
	LXI	B,TXTPCEQU				;0D58H
	CALL	PECUNTILDOLLAR				;1C08H
	LHLD	USERSTACKSTORE				;210CH
	MOV	A,M
	INX	H
	MOV	H,M
	MOV	L,A
	CALL	LADDR					;0DDBH
	MVI	A,'H'	;48H
	CALL	TYPEAREG				;0DF6H

CRLF:					;0D41H
	MVI	C,0DH
	CALL	TYPECHAR				;0A3CH
	MVI	C,0AH
	JMP	TYPECHAR				;0A3CH

TXTSTEQU:				;0D4BH
	DB	'S'

TXTTEQU:				;0D4CH
	DB	'T= $'

TXTSEQU:				;0D50H
	DB	'S= $'

TXTOEQU:				;0D54H
	DB	'O= $'

TXTPCEQU:				;0D58H
	DB	'PC= $'

TYPETAB:				;0D5DH
	MVI	A,9
	JMP	TYPEAREG				;0DF6H

IGNOREQUEST:				;0D62H
	MVI	A,6

BIOSMSGQUEST:				;0D64H
	CALL	TYPEBIOSMSG				;1BFEH

CHECKYES:				;0D67H
	LXI	H,COMANDBUFER				;2113H
	MVI	M,2
	CALL	INPUTHLSTRING				;0916H
	LXI	H,COMANDBUFER				;2113H
	MVI	M,7FH
	INX	H
	MOV	A,M
	CPI	1
	RNZ
	INX	H
	MOV	A,M
	ANI	0DFH
	CPI	'Y'	;59H
	RZ
	CPI	0C4H
	RET

PRTADECIMAL:				;0D83H
	MVI	D,0

PRTDEDECIMAL:				;0D85H
	MOV	E,A

FUNF332:				;0D86H
	PUSH	D
	MVI	B,85H
	LXI	H,DECIMALTAB				;0DD1H

READNEXTDEC:				;0D8CH
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	XTHL
	MVI	C,'0'	;30H

NEXTDECCHAR:				;0D93H
	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	JC	RESETSUB				;0DA0H
	INR	C
	JMP	NEXTDECCHAR				;0D93H

RESETSUB:				;0DA0H
	DAD	D
	MOV	A,B
	ORA	A
	JP	NOTDELETEZERO				;0DB7H
	PUSH	PSW
	MOV	A,C
	CPI	'0'	;30H
	JZ	DELETEFIRSTZERO				;0DBEH
	CALL	TYPEAREG				;0DF6H
	POP	PSW
	ANI	7FH
	MOV	B,A
	JMP	DROPDELETEZERO				;0DCAH

NOTDELETEZERO:				;0DB7H
	MOV	A,C
	CALL	TYPEAREG				;0DF6H
	JMP	DROPDELETEZERO				;0DCAH

DELETEFIRSTZERO:			;0DBEH
	POP	PSW
	ANI	7FH
	CPI	1
	JNZ	DROPDELETEZERO				;0DCAH
	MOV	B,A
	JMP	NOTDELETEZERO				;0DB7H

DROPDELETEZERO:				;0DCAH
	XTHL
	DCR	B
	JNZ	READNEXTDEC				;0D8CH
	POP	D
	RET

DECIMALTAB:				;0DD1H
	DW	2710H
	DW	03E8H
	DW	64H
	DW	0AH
	DW	1

LADDR:					;0DDBH
	MOV	A,H
	CALL	LBYTE					;0DE0H
	MOV	A,L

LBYTE:					;0DE0H
	PUSH	PSW
	RAR
	RAR
	RAR
	RAR
	ANI	0FH
	CALL	LLOW					;0DEDH
	POP	PSW
	ANI	0FH

LLOW:					;0DEDH
	ADI	'0'	;30H
	CPI	':'	;3AH
	JC	TYPEAREG				;0DF6H
	ADI	7

TYPEAREG:				;0DF6H
	PUSH	H
	PUSH	B
	PUSH	D
	MOV	C,A
	CALL	TYPEALLCHAR				;088BH
	POP	D
	POP	B
	POP	H
	RET

PREPAREDEFDISK:				;0E01H
	LDA	DEFAULTDISK				;205AH
	MOV	C,A
	CALL	BIOSF09					;1E1AH
	MOV	A,H
	ORA	L
	RZ
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	SHLD	ADRQELEMNDIR				;20C3H
	INX	H
	INX	H
	SHLD	ADRTRACKNOW				;20C5H
	INX	H
	INX	H
	SHLD	ADRSECTOTRACKNOW			;20C7H
	INX	H
	INX	H
	XCHG
	SHLD	XLTDEFAULTDISK				;20E0H
	LXI	H,DIRBUFDEFDISK				;20C9H
	MVI	C,8
	CALL	COPYCBYTEHLDE				;18DAH
	LHLD	ADRDPBDEFDISK				;20CBH
	XCHG
	LXI	H,DPBDEFDISK				;20D1H
	MVI	C,0FH
	CALL	COPYCBYTEHLDE				;18DAH
;
; STORE VOLUME DISK (BLOCK-1)
	LHLD	DPBDEFDISK+5				;20D6H
	MOV	A,H
	LXI	H,STATUSBIGQBLOCKONDEFDISK		;20E9H
	MVI	M,0FFH
	ORA	A
	JZ	LOWQBLOCK				;0E45H
	MVI	M,0

LOWQBLOCK:				;0E45H
	MVI	A,0FFH
	ORA	A
	RET

SETSECANDTRTOHOME:			;0E49H
	CALL	BIOSF08					;1E27H
	XRA	A
	LHLD	ADRTRACKNOW				;20C5H
	MOV	M,A
	INX	H
	MOV	M,A
	LHLD	ADRSECTOTRACKNOW			;20C7H
	MOV	M,A
	INX	H
	MOV	M,A
	RET

READDISK:				;0E5AH
	CALL	BIOSF0D					;1E3FH
	JMP	L0E63					;0E63H

WRITEDISK:				;0E60H
	CALL	BIOSF0E					;1E3AH

L0E63:					;0E63H
	ORA	A
	STA	STATUSDISK				;2111H
	RZ
	LDA	L2112					;2112H
	ORA	A
	JZ	MSGDISKERROR				;0C20H
	DCR	A
	STA	L2112					;2112H
	RET

SETTRANDSECFORCODEDIR:			;0E74H
	LHLD	CODEDIR					;2061H
	MVI	C,2
	CALL	HLRARCTIME				;0F97H
	SHLD	NUMBER128BL				;20F1H
	SHLD	NSECINDIR				;20F7H

SETTRSECFORN128BL:			;0E82H
	LXI	H,NUMBER128BL				;20F1H
	MOV	C,M
	INX	H
	MOV	B,M
	LHLD	ADRSECTOTRACKNOW			;20C7H
	MOV	E,M
	INX	H
	MOV	D,M
	LHLD	ADRTRACKNOW				;20C5H
	MOV	A,M
	INX	H
	MOV	H,M
	MOV	L,A

CMINUSSPERTR:				;0E95H
	MOV	A,C
	SUB	E
	MOV	A,B
	SBB	D
	JNC	CPLUSSPERTR				;0EABH
;
; NSEC-:= QSEC PER TRACK
	PUSH	H
	LHLD	DPBDEFDISK				;20D1H
	MOV	A,E
	SUB	L
	MOV	E,A
	MOV	A,D
	SBB	H
	MOV	D,A
	POP	H
	DCX	H
	JMP	CMINUSSPERTR				;0E95H

CPLUSSPERTR:				;0EABH
	PUSH	H
;
; NSEC+:= QSEC PER TRACK
	LHLD	DPBDEFDISK				;20D1H
	DAD	D
	JC	EXPLUSSPERTR				;0EC0H
	MOV	A,C
	SUB	L
	MOV	A,B
	SBB	H
	JC	EXPLUSSPERTR				;0EC0H
	XCHG
	POP	H
	INX	H
	JMP	CPLUSSPERTR				;0EABH

EXPLUSSPERTR:				;0EC0H
	POP	H
	PUSH	B
	PUSH	D
	PUSH	H
	XCHG
	CALL	DEFSYSTRACKADR				;04D4H
	MOV	A,M
	INX	H
	MOV	H,M
	MOV	L,A
	DAD	D
	MOV	B,H
	MOV	C,L
	CALL	BIOSF0A					;1E29H
	POP	D
	LHLD	ADRTRACKNOW				;20C5H
	MOV	M,E
	INX	H
	MOV	M,D
	POP	D
	LHLD	ADRSECTOTRACKNOW			;20C7H
	MOV	M,E
	INX	H
	MOV	M,D
	POP	B
	MOV	A,C
	SUB	E
	MOV	C,A
	MOV	A,B
	SBB	D
	MOV	B,A
	LHLD	XLTDEFAULTDISK				;20E0H
	MOV	A,L
	ORA	H
	INX	B
	JZ	BIOSF0B					;1E2EH
	DCX	B
	XCHG
	CALL	BIOSF10					;1E33H
	MOV	C,L
	MOV	B,H
	JMP	BIOSF0B					;1E2EH

FINDSHIFTINBLOCKFIELD:			;0EFAH
	LXI	H,DPBDEFDISK+2				;20D3H
	MOV	C,M
	LDA	TZ					;20EFH

FINDRAZMERINBLOCK:			;0F01H
	ORA	A
	RAR
	DCR	C
	JNZ	FINDRAZMERINBLOCK			;0F01H
	MOV	B,A
	MVI	A,8
	SUB	M
	MOV	C,A
	LDA	EXMANDZK				;20EEH

CLCOLDPART:				;0F0FH
	DCR	C
	JZ	EXOLDPART				;0F18H
	ORA	A
	RAL
	JMP	CLCOLDPART				;0F0FH

EXOLDPART:				;0F18H
	ADD	B
	RET

BLOCKFROMFCBBLFIELD:			;0F1AH
	LHLD	DESYSFUNC				;205BH
	LXI	D,10H
	DAD	D
	DAD	B
	LDA	STATUSBIGQBLOCKONDEFDISK		;20E9H
	ORA	A
	JZ	HLMADDBC				;0F2DH
	MOV	L,M
	MVI	H,0
	RET

HLMADDBC:				;0F2DH
	DAD	B

DEM:					;0F2EH
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	RET

FINDNUMBEROFBLOCK:			;0F33H
	CALL	FINDSHIFTINBLOCKFIELD			;0EFAH
	MOV	C,A
	MVI	B,0
	CALL	BLOCKFROMFCBBLFIELD			;0F1AH
	SHLD	NUMBER128BL				;20F1H
	RET

SETNUMBEROFBLOCK:			;0F40H
	LHLD	NUMBER128BL				;20F1H
	MOV	A,L
	ORA	H
	RET
;
; BSH

COMPUTENUMBEROF128BYTEBLOCK:		;0F46H
	LDA	DPBDEFDISK+2				;20D3H
	LHLD	NUMBER128BL				;20F1H

FINDFIRSTNUMBEROF128BLFORTHISBLOCK:	;0F4CH
	DAD	H
	DCR	A
	JNZ	FINDFIRSTNUMBEROF128BLFORTHISBLOCK	;0F4CH
	SHLD	NUMBFIRST128BLFORBLOCK			;20F3H
	LDA	DPBDEFDISK+3				;20D4H
	MOV	C,A
	LDA	TZ					;20EFH
	ANA	C
	ORA	L
	MOV	L,A
	SHLD	NUMBER128BL				;20F1H
	RET

SETADRZK:				;0F62H
	LHLD	DESYSFUNC				;205BH
	LXI	D,0CH
	DAD	D
	RET

FINDADRESR0INFCB:			;0F6AH
	LHLD	DESYSFUNC				;205BH
	XCHG
	LXI	H,21H
	DAD	D
	RET

SETADRDEC4HLTZ:				;0F73H
	LHLD	DESYSFUNC				;205BH
	LXI	D,0FH
	DAD	D
	XCHG
	LXI	H,11H
	DAD	D
	RET

STORETZC4:				;0F80H
	CALL	SETADRDEC4HLTZ				;0F73H
	MOV	A,M
	STA	TZ					;20EFH
	XCHG
	MOV	A,M
	STA	C4					;20EDH
	CALL	SETADRZK				;0F62H
	LDA	DPBDEFDISK+4				;20D5H
	ANA	M
	STA	EXMANDZK				;20EEH
	RET

HLRARCTIME:				;0F97H
	INR	C

CHLRAR:					;0F98H
	DCR	C
	RZ
	MOV	A,H
	ORA	A
	RAR
	MOV	H,A
	MOV	A,L
	RAR
	MOV	L,A
	JMP	CHLRAR					;0F98H

SUMALLBYTEOFDIRBUF:			;0FA4H
	LHLD	DIRBUFDEFDISK				;20C9H
	XRA	A
	MVI	C,80H

L0FAA:					;0FAAH
	ADD	M
	INX	H
	DCR	C
	JNZ	L0FAA					;0FAAH
	RET

STEPENTWO:				;0FB1H
	INR	C

AHLMUL2:				;0FB2H
	DCR	C
	RZ
	DAD	H
	ADC	A
	JMP	AHLMUL2					;0FB2H

ADDDEFDISK:				;0FB9H
	PUSH	B
	LDA	DEFAULTDISK				;205AH
	MOV	C,A
	LXI	H,1
	CALL	STEPENTWO				;0FB1H
	POP	B
	MOV	A,C
	ORA	L
	MOV	L,A
	MOV	A,B
	ORA	H
	MOV	H,A
	RET

FINDSTATUSONLYREADFORDEFDISK:		;0FCCH
	LHLD	ONLYREADSTATUSVECTOR			;20BFH
	LDA	DEFAULTDISK				;205AH
	MOV	C,A
	CALL	HLRARCTIME				;0F97H
	MOV	A,L
	ANI	1
	RET

CHECKSTATUSDELETEDFILES:		;0FDAH
	CALL	PLACEINTODIRECTORY			;1009H

CHECKSYSROFILES:			;0FDDH
	LXI	D,0AH
	DAD	D
	MOV	A,M
	RAL
;
; DELETE SYSTEM FILE
	JC	ERRFILEISONLYREAD			;0C7AH
	DCX	H
	MOV	A,M
	RAL
	RNC
;
; DELETE FILE R/O
	PUSH	H
	CALL	QUESTFORDELETEROFILE			;0C9CH
	POP	H
	MOV	A,M
	ANI	7FH
	MOV	M,A
	RET

DEACTIVATEDEFDISK:			;0FF4H
	CALL	FINDSTATUSONLYREADFORDEFDISK		;0FCCH
	RZ
	LDA	DEFAULTDISK				;205AH
	MOV	C,A

DEACTIVATEDISKFROMCREG:			;0FFCH
	LXI	H,1
	CALL	STEPENTWO				;0FB1H
	CALL	DEACTIVATEDISK				;19C3H
	CALL	SETDEFAULTDISK				;1752H
	RET

PLACEINTODIRECTORY:			;1009H
	LHLD	DIRBUFDEFDISK				;20C9H
	LDA	SHIFTINDIRECTORY			;20F5H

HLADDA:					;100FH
	ADD	L
	MOV	L,A
	RNC
	INR	H
	RET

READC2FROMFCB:				;1014H
	LHLD	DESYSFUNC				;205BH
	LXI	D,0EH
	DAD	D
	MOV	A,M
	RET

READC2ANDC2EQU0:			;101DH
	CALL	READC2FROMFCB				;1014H
	MVI	M,0
	RET

CHECKNUMBERINDIRECTORY:			;1023H
	LHLD	CODEDIR					;2061H
	XCHG
	LHLD	ADRQELEMNDIR				;20C3H
	MOV	A,E
	SUB	M
	INX	H
	MOV	A,D
	SBB	M
	RET

SETDIMDISK:				;1030H
	CALL	CHECKNUMBERINDIRECTORY			;1023H
	RC
	INX	D
	MOV	M,D
	DCX	H
	MOV	M,E
	RET

SUBHLDE:				;1039H
	MOV	A,E
	SUB	L
	MOV	L,A
	MOV	A,D
	SBB	H
	MOV	H,A
	RET

STORETOCSV:				;1040H
	MVI	C,0FFH

CHECKCSV:				;1042H
	LHLD	NSECINDIR				;20F7H
	XCHG
	LHLD	DPBDEFDISK+0BH				;20DCH
	CALL	SUBHLDE					;1039H
	RNC
	PUSH	B
	CALL	SUMALLBYTEOFDIRBUF			;0FA4H
	LHLD	ADRCSVDEFDISK				;20CDH
	XCHG
	LHLD	NSECINDIR				;20F7H
	DAD	D
	POP	B
	INR	C
	JZ	STORETOCSVECTOR				;1068H
	CMP	M
	RZ
	CALL	CHECKNUMBERINDIRECTORY			;1023H
	RNC
	CALL	FUN1C					;1936H
	RET

STORETOCSVECTOR:			;1068H
	MOV	M,A
	RET

CHANGECSV:				;106AH
	XRA	A
	STA	FLAGQUESTFORDISKERROR			;1FEDH
	CALL	STORETOCSV				;1040H
	CALL	SETDMAONDIRBUF				;108DH
	MVI	C,1
	CALL	WRITEDISK				;0E60H
	MVI	A,0FFH
	STA	FLAGQUESTFORDISKERROR			;1FEDH
	JMP	RESETDMABUFER				;1087H

READTODIRBUF:				;1081H
	CALL	SETDMAONDIRBUF				;108DH
	CALL	READDISK				;0E5AH

RESETDMABUFER:				;1087H
	LXI	H,ADRDMA				;2058H
	JMP	BCM					;1090H

SETDMAONDIRBUF:				;108DH
	LXI	H,DIRBUFDEFDISK				;20C9H

BCM:					;1090H
	MOV	C,M
	INX	H
	MOV	B,M
;
; SET DMA BUFER

BIOSF0C:				;1093H
	MOV	L,C
	MOV	H,B
	SHLD	ABUFF					;1FF6H
	RET

CHECKCODEDIREQUMINUSONE:		;1099H
	LXI	H,CODEDIR				;2061H
	MOV	A,M
	INX	H
	CMP	M
	RNZ
	INR	A
	RET

READNEXTDIR:				;10A2H
	LHLD	DPBDEFDISK+7				;20D8H
	XCHG
	LHLD	CODEDIR					;2061H
	INX	H
	SHLD	CODEDIR					;2061H
	CALL	SUBHLDE					;1039H
	JNC	GOODCODE				;10BAH

STOREMINUSONETOCODEDIR:			;10B3H
	LXI	H,LFFFF					;0FFFFH
	SHLD	CODEDIR					;2061H
	RET

GOODCODE:				;10BAH
	LDA	CODEDIR					;2061H
	ANI	3
	RRC
	RRC
	RRC
	STA	SHIFTINDIRECTORY			;20F5H
	ORA	A
	RNZ
	PUSH	B
	CALL	SETTRANDSECFORCODEDIR			;0E74H
	CALL	READTODIRBUF				;1081H
	POP	B
	JMP	CHECKCSV				;1042H

FINDBITINALVTABLET:			;10D2H
	MOV	A,C
	ANI	7
	INR	A
	MOV	E,A
	MOV	D,A
	MOV	A,C
	RRC
	RRC
	RRC
	ANI	1FH
	MOV	C,A
	MOV	A,B
	ADD	A
	ADD	A
	ADD	A
	ADD	A
	ADD	A
	ORA	C
	MOV	C,A
	MOV	A,B
	RRC
	RRC
	RRC
	ANI	1FH
	MOV	B,A
	LHLD	ADRALVDEFDISK				;20CFH
	DAD	B
	MOV	A,M

L10F3:					;10F3H
	RLC
	DCR	E
	JNZ	L10F3					;10F3H
	RET

SETTHISBLOCKASUNUSED:			;10F9H
	PUSH	D
	CALL	FINDBITINALVTABLET			;10D2H
	ANI	0FEH
	POP	B
	ORA	C

FINDBITFORBLOCK:			;1101H
	RRC
	DCR	D
	JNZ	FINDBITFORBLOCK				;1101H
	MOV	M,A
	RET
;
; <C>:  0 --> ALL BLOCKS FROM FCB MAKE IN ALV AS UNUSED, 1 --> USED

SETALLFCBBLOCKSINTOALV:			;1108H
	CALL	PLACEINTODIRECTORY			;1009H
	LXI	D,10H
	DAD	D
	PUSH	B
	MVI	C,11H

NEXTFCBBLOCK:				;1112H
	POP	D
;
; DE - PLACE IN TABLET OF BLOCK NUMBER FOR FILE
	DCR	C
	RZ
	PUSH	D
	LDA	STATUSBIGQBLOCKONDEFDISK		;20E9H
	ORA	A
	JZ	MORE100H				;1125H
	PUSH	B
	PUSH	H
	MOV	C,M
	MVI	B,0
	JMP	CHECKBLOCK				;112BH

MORE100H:				;1125H
	DCR	C
	PUSH	B
	MOV	C,M
	INX	H
	MOV	B,M
	PUSH	H

CHECKBLOCK:				;112BH
	MOV	A,C
	ORA	B
	JZ	BLOCKISNOTREAL				;113AH
	LHLD	DPBDEFDISK+5				;20D6H
	MOV	A,L
	SUB	C
	MOV	A,H
	SBB	B
	CNC	SETTHISBLOCKASUNUSED			;10F9H

BLOCKISNOTREAL:				;113AH
	POP	H
	INX	H
	POP	B
	JMP	NEXTFCBBLOCK				;1112H

FINDSIZEALVTABLET:			;1140H
	LHLD	DPBDEFDISK+5				;20D6H
	MVI	C,3
	CALL	HLRARCTIME				;0F97H
	INX	H
	RET

CHECKEXTENTS:				;114AH
	PUSH	B
	PUSH	PSW
	LDA	DPBDEFDISK+4				;20D5H
	CMA
	MOV	B,A
	MOV	A,C
	ANA	B
	MOV	C,A
	POP	PSW
	ANA	B
	SUB	C
	ANI	1FH
	POP	B
	RET
;
; EXIT: RESFINDFILE ==> 0 - FILE WAS FINDED, -1 - FILE WAS NOT FINDED

FINDFILEFOR15BYTE:			;115BH
	MVI	C,0FH
;
; <C> - QUANTATY OF CHECKED BYTE OF FCB

FINDFILEFORCBYTE:			;115DH
	MVI	A,0FFH
	STA	RESFINDFILE				;20E4H
	LXI	H,REGCHERE				;20E8H
	MOV	M,C
	LHLD	DESYSFUNC				;205BH
	SHLD	FCBFORSEARCH				;2063H
	CALL	STOREMINUSONETOCODEDIR			;10B3H
	CALL	SETSECANDTRTOHOME			;0E49H

CLCREADNEXTDIR:				;1172H
	MVI	C,0
	CALL	READNEXTDIR				;10A2H
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	JZ	DIRBUFISFFFF				;11D9H
	LHLD	FCBFORSEARCH				;2063H
	XCHG
	LDAX	D
	CPI	0E5H
	JZ	FILEWASDELETED				;118FH
	PUSH	D
	CALL	CHECKNUMBERINDIRECTORY			;1023H
	POP	D
	JNC	DIRBUFISFFFF				;11D9H

FILEWASDELETED:				;118FH
	CALL	PLACEINTODIRECTORY			;1009H
	LDA	REGCHERE				;20E8H
	MOV	C,A
	MVI	B,0

CLCNEXTBYTEFROMDIR:			;1198H
	MOV	A,C
	ORA	A
	JZ	ENDOFCHECKDIR				;11C8H
	LDAX	D
	CPI	'?'	;3FH
	JZ	CHECKNEXTBYTEFROMDIR			;11C1H
	MOV	A,B
	CPI	0DH
	JZ	CHECKNEXTBYTEFROMDIR			;11C1H
	CPI	0CH
	LDAX	D
	JZ	CHECKZKFROMDIR				;11B8H
	SUB	M
	ANI	7FH
	JNZ	CLCREADNEXTDIR				;1172H
	JMP	CHECKNEXTBYTEFROMDIR			;11C1H

CHECKZKFROMDIR:				;11B8H
	PUSH	B
	MOV	C,M
	CALL	CHECKEXTENTS				;114AH
	POP	B
	JNZ	CLCREADNEXTDIR				;1172H

CHECKNEXTBYTEFROMDIR:			;11C1H
	INX	D
	INX	H
	INR	B
	DCR	C
	JMP	CLCNEXTBYTEFROMDIR			;1198H

ENDOFCHECKDIR:				;11C8H
	LDA	CODEDIR					;2061H
	ANI	3
	STA	RESULT					;210FH
	LXI	H,RESFINDFILE				;20E4H
	MOV	A,M
	RAL
	RNC
	XRA	A
	MOV	M,A
	RET

DIRBUFISFFFF:				;11D9H
	CALL	STOREMINUSONETOCODEDIR			;10B3H

FUN29:					;11DCH
	MVI	A,0FFH
	MOV	B,A
	INR	B
	JMP	SETBYTERESULT				;0A8CH

DELETEFORFCB:				;11E3H
	CALL	DEACTIVATEDEFDISK			;0FF4H
	MVI	C,0CH
	CALL	FINDFILEFORCBYTE			;115DH

CLCDELFORFCB:				;11EBH
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	RZ
	CALL	CHECKSTATUSDELETEDFILES			;0FDAH
	CALL	PLACEINTODIRECTORY			;1009H
	MVI	M,0E5H
	MVI	C,0
	CALL	SETALLFCBBLOCKSINTOALV			;1108H
	CALL	CHANGECSV				;106AH
	CALL	CLCREADNEXTDIR				;1172H
	JMP	CLCDELFORFCB				;11EBH

SEARCHNEARESTFRREBLOCK:			;1205H
	MOV	D,B
	MOV	E,C

NEXTNEARBLOCK:				;1207H
	MOV	A,C
	ORA	B
	JZ	THEFIRSTBLOCKINEXTENT			;1218H
	DCX	B
	PUSH	D
	PUSH	B
	CALL	FINDBITINALVTABLET			;10D2H
	RAR
	JNC	ITISFREEBLOCK				;1233H
	POP	B
	POP	D
;
; DSM := VOLUME OF DISK INTO BLOCKS - 1

THEFIRSTBLOCKINEXTENT:			;1218H
	LHLD	DPBDEFDISK+5				;20D6H
	MOV	A,E
	SUB	L
	MOV	A,D
	SBB	H
	JNC	DISKISOVER				;123BH
	INX	D
	PUSH	B
	PUSH	D
	MOV	B,D
	MOV	C,E
	CALL	FINDBITINALVTABLET			;10D2H
	RAR
	JNC	ITISFREEBLOCK				;1233H
	POP	D
	POP	B
	JMP	NEXTNEARBLOCK				;1207H

ITISFREEBLOCK:				;1233H
	RAL
	INR	A
	CALL	FINDBITFORBLOCK				;1101H
	POP	H
	POP	D
	RET

DISKISOVER:				;123BH
	MOV	A,C
	ORA	B
	JNZ	NEXTNEARBLOCK				;1207H
	LXI	H,0
	RET

COPYALLFCB:				;1244H
	MVI	E,' '	;20H

COPYNAME:				;1246H
	MVI	C,0

COPYSECONDNAME:				;1248H
	PUSH	D
	MVI	B,0
	LHLD	DESYSFUNC				;205BH
	DAD	B
	XCHG
	CALL	PLACEINTODIRECTORY			;1009H
	POP	B
	CALL	COPYCBYTEHLDE				;18DAH

SETTRSECANDCHANGECSV:			;1257H
	CALL	SETTRANDSECFORCODEDIR			;0E74H
	JMP	CHANGECSV				;106AH

RENAMEALLFILES:				;125DH
	CALL	DEACTIVATEDEFDISK			;0FF4H
	LHLD	DESYSFUNC				;205BH
	PUSH	H
	MOV	A,M
	LXI	D,10H
	DAD	D
	SHLD	DESYSFUNC				;205BH
	MOV	M,A
	MVI	C,0CH
	CALL	FINDFILEFORCBYTE			;115DH
	POP	H
	SHLD	DESYSFUNC				;205BH
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	MVI	A,0FFH
	STA	RESFINDFILE				;20E4H
	RNZ
	MVI	C,0CH
	CALL	FINDFILEFORCBYTE			;115DH

RENAMENEXTFILE:				;1284H
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	RZ
	CALL	CHECKSTATUSDELETEDFILES			;0FDAH
	MVI	C,10H
	MVI	E,0CH
	CALL	COPYSECONDNAME				;1248H
	CALL	CLCREADNEXTDIR				;1172H
	JMP	RENAMENEXTFILE				;1284H

SETFILEATTRIBUTE:			;1298H
	MVI	C,0CH
	CALL	FINDFILEFORCBYTE			;115DH

L129D:					;129DH
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	RZ
	MVI	E,0CH
	CALL	COPYNAME				;1246H
	CALL	CLCREADNEXTDIR				;1172H
	JMP	L129D					;129DH

FUN0F:					;12ACH
	CALL	READC2ANDC2EQU0				;101DH
	CALL	SETDISKFORFCB				;16E2H

FINDEXTENT:				;12B2H
	CALL	FINDFILEFOR15BYTE			;115BH
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	CZ	SEARCHINUSER0ANDADISK			;12F6H
	RZ

OPENEXTENT:				;12BCH
	CALL	SETADRZK				;0F62H
	MOV	A,M
	PUSH	PSW
	PUSH	H
	CALL	PLACEINTODIRECTORY			;1009H
	XCHG
	LHLD	DESYSFUNC				;205BH
	MVI	C,' '	;20H
;
; COPY FCB FROM DIRECTORY
	PUSH	D
	CALL	COPYCBYTEHLDE				;18DAH
	CALL	SETBIT7INTOC2				;1485H
	POP	D
	LXI	H,0CH
	DAD	D
;
; TZ ==> EXTENT
	MOV	C,M
	LXI	H,0FH
	DAD	D
;
; C4 ==> COUNT OF ZAPIS
	MOV	B,M
	POP	H
	POP	PSW
;
; HL --> ADRESS C2  AND   A --> C2
	MOV	M,A
	MOV	A,C
	CMP	M
	MOV	A,B
	JZ	SETD4					;12EDH
	MVI	A,0
	JC	SETD4					;12EDH
	MVI	A,80H

SETD4:					;12EDH
	LHLD	DESYSFUNC				;205BH
	LXI	D,0FH
	DAD	D
	MOV	M,A
	RET

SEARCHINUSER0ANDADISK:			;12F6H
	LDA	USER					;2060H
	ORA	A
	JZ	USER0WASALREADY				;1308H
	LHLD	DESYSFUNC				;205BH
	MOV	A,M
	ANI	0E0H
	MOV	M,A
	CALL	FINDSYSTEMFILE				;1333H
	RNZ

USER0WASALREADY:			;1308H
	LDA	DEFAULTDISK				;205AH
	ORA	A
	RZ
	STA	REMEMBERDEFDISK				;20EBH
	XRA	A
	CALL	SETADISK				;1746H
	CALL	FINDSYSTEMFILE				;1333H
	PUSH	PSW
	LDA	REMEMBERDEFDISK				;20EBH
	CALL	SETADISK				;1746H
	POP	PSW
	JZ	FUN29					;11DCH
	LDA	READTODAYDISK				;20EAH
	ANI	0E0H
	ORI	1
	STA	READTODAYDISK				;20EAH
	LDA	REMEMBERDEFDISK				;20EBH
	STA	COPYDEFDISK				;20ECH
	RET

FINDSYSTEMFILE:				;1333H
	CALL	FINDFILEFOR15BYTE			;115BH
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	RZ
	CALL	PLACEINTODIRECTORY			;1009H
	MVI	A,0AH
	CALL	HLADDA					;100FH
	MOV	A,M
	ANI	80H
	RET

COPYWORDDETOHL:				;1346H
	MOV	A,M
	INX	H
	ORA	M
	DCX	H
	RNZ
	LDAX	D
	MOV	M,A
	INX	D
	INX	H
	LDAX	D
	MOV	M,A
	DCX	D
	DCX	H
	RET

FUN10:					;1354H
	CALL	SETDISKFORFCB				;16E2H

CLOSEEXTENT:				;1357H
	XRA	A
	STA	RESULT					;210FH
	STA	CODEDIR					;2061H
	STA	L20F6					;20F6H
	CALL	FINDSTATUSONLYREADFORDEFDISK		;0FCCH
	RNZ
	CALL	READC2FROMFCB				;1014H
	ANI	80H
	RNZ
	CALL	FINDFILEFOR15BYTE			;115BH
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	RZ
	LXI	B,10H
	CALL	PLACEINTODIRECTORY			;1009H
	DAD	B
	XCHG
	LHLD	DESYSFUNC				;205BH
	DAD	B
	MVI	C,10H

CLCCOPYBLOCKNUMBERS:			;1380H
	LDA	STATUSBIGQBLOCKONDEFDISK		;20E9H
	ORA	A
	JZ	CLOSEFORNUMBERFROM2BYTES		;139BH
	MOV	A,M
	ORA	A
	LDAX	D
	JNZ	BLFCBNE0				;138EH
	MOV	M,A

BLFCBNE0:				;138EH
	ORA	A
	JNZ	BLDIRNE0				;1394H
	MOV	A,M
	STAX	D

BLDIRNE0:				;1394H
	CMP	M
	JNZ	ERRCLOSEFILE				;13D2H
	JMP	NEXTNUMBBLC				;13B0H

CLOSEFORNUMBERFROM2BYTES:		;139BH
	CALL	COPYWORDDETOHL				;1346H
	XCHG
	CALL	COPYWORDDETOHL				;1346H
	XCHG
	LDAX	D
	CMP	M
	JNZ	ERRCLOSEFILE				;13D2H
	INX	D
	INX	H
	LDAX	D
	CMP	M
	JNZ	ERRCLOSEFILE				;13D2H
	DCR	C

NEXTNUMBBLC:				;13B0H
	INX	D
	INX	H
	DCR	C
	JNZ	CLCCOPYBLOCKNUMBERS			;1380H
;
; ADRESS OF ZK
	LXI	B,LFFEC					;0FFECH
	DAD	B
	XCHG
	DAD	B
	LDAX	D
	CMP	M
	JC	NOTCOPYZKANDC4				;13CAH
;
; ZK(DIR):=ZK(FCB) C4(DIR):=C4(FCB)
	MOV	M,A
	LXI	B,3
	DAD	B
	XCHG
	DAD	B
	MOV	A,M
	STAX	D

NOTCOPYZKANDC4:				;13CAH
	MVI	A,0FFH
	STA	L20E2					;20E2H
	JMP	SETTRSECANDCHANGECSV			;1257H

ERRCLOSEFILE:				;13D2H
	LXI	H,RESULT				;210FH
	DCR	M
	RET

FUN16:					;13D7H
	CALL	READC2ANDC2EQU0				;101DH
	CALL	SETDISKFORFCB				;16E2H
	MVI	C,0CH
	CALL	FINDFILEFORCBYTE			;115DH
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	MVI	A,0FFH
	JNZ	SETBYTERESULT				;0A8CH

CREATEEXTENT:				;13EAH
	CALL	DEACTIVATEDEFDISK			;0FF4H
	LHLD	DESYSFUNC				;205BH
	PUSH	H
	LXI	H,PRIZNAKDELETEDFILES			;1FECH
	SHLD	DESYSFUNC				;205BH
	MVI	C,1
	CALL	FINDFILEFORCBYTE			;115DH
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	POP	H
	SHLD	DESYSFUNC				;205BH
	RZ
	XCHG
	LXI	H,0FH
	DAD	D
	MVI	C,11H
	XRA	A

L140C:					;140CH
	MOV	M,A
	INX	H
	DCR	C
	JNZ	L140C					;140CH
	LXI	H,0DH
	DAD	D
	MOV	M,A
	CALL	SETDIMDISK				;1030H
	CALL	COPYALLFCB				;1244H
	JMP	SETBIT7INTOC2				;1485H

EXTENTCHANGE:				;1420H
	XRA	A
	STA	L20E2					;20E2H
	CALL	CLOSEEXTENT				;1357H
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	RZ
	LHLD	DESYSFUNC				;205BH
	LXI	B,0CH
	DAD	B
;
; ZK +:= 1
	MOV	A,M
	INR	A
	ANI	1FH
	MOV	M,A
	JZ	ZKISOVERFLOW				;1449H
	MOV	B,A
;
; EXM
	LDA	DPBDEFDISK+4				;20D5H
	ANA	B
	LXI	H,L20E2					;20E2H
	ANA	M
	JZ	FORCHANGE				;1454H
	JMP	FOROPENEXTENT				;1472H

ZKISOVERFLOW:				;1449H
	LXI	B,2
	DAD	B
;
; C2 +:= 1
	INR	M
	MOV	A,M
	ANI	0FH
	JZ	C2ISOVERFLOW				;1482H

FORCHANGE:				;1454H
	MVI	C,0FH
	CALL	FINDFILEFORCBYTE			;115DH
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	JNZ	FOROPENEXTENT				;1472H
;
; EXTENT IS NOT FINDED
	LDA	FLAGFFR00W				;20E3H
	INR	A
	JZ	FORREAD					;147CH
	CALL	CREATEEXTENT				;13EAH
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	JZ	C2ISOVERFLOW				;1482H
	JMP	REMEMBERC4TZ				;1475H

FOROPENEXTENT:				;1472H
	CALL	OPENEXTENT				;12BCH

REMEMBERC4TZ:				;1475H
	CALL	STORETZC4				;0F80H
	XRA	A
	JMP	SETBYTERESULT				;0A8CH

FORREAD:				;147CH
	CALL	SEARCHINUSER0ANDADISK			;12F6H
	JNZ	FOROPENEXTENT				;1472H

C2ISOVERFLOW:				;1482H
	CALL	STOREONETORESULT			;0B11H

SETBIT7INTOC2:				;1485H
	CALL	READC2FROMFCB				;1014H
	ORI	80H
	MOV	M,A
	RET

FUN14:					;148CH
	CALL	SETDISKFORFCB				;16E2H
	MVI	A,1
	STA	FLAG0D1S2W0				;20E5H

SEQREAD:				;1494H
	MVI	A,0FFH
	STA	FLAGFFR00W				;20E3H
	CALL	STORETZC4				;0F80H
	LDA	TZ					;20EFH
	LXI	H,C4					;20EDH
	CMP	M
	JC	NORMREAD				;14B9H
	CPI	80H
	JNZ	STOREONETORESULT			;0B11H
;
; TZ=80H
	CALL	EXTENTCHANGE				;1420H
	XRA	A
	STA	TZ					;20EFH
	LDA	RESULT					;210FH
	ORA	A
	JNZ	STOREONETORESULT			;0B11H

NORMREAD:				;14B9H
	CALL	FINDNUMBEROFBLOCK			;0F33H
	CALL	SETNUMBEROFBLOCK			;0F40H
	JZ	STOREONETORESULT			;0B11H
	CALL	COMPUTENUMBEROF128BYTEBLOCK		;0F46H
	CALL	SETTRSECFORN128BL			;0E82H
	CALL	READDISK				;0E5AH

CHANGETZC4:				;14CBH
	CALL	SETADRDEC4HLTZ				;0F73H
	LDA	FLAG0D1S2W0				;20E5H
	CPI	2
	JNZ	NOTWRTZERO				;14D7H
	XRA	A

NOTWRTZERO:				;14D7H
	MOV	C,A
	LDA	TZ					;20EFH
	ADD	C
	MOV	M,A
	XCHG
	LDA	C4					;20EDH
	MOV	M,A
	RET

FUN15:					;14E3H
	CALL	SETDISKFORFCB				;16E2H
	MVI	A,1
	STA	FLAG0D1S2W0				;20E5H

SEQWRITE:				;14EBH
	MVI	A,0
	STA	FLAGFFR00W				;20E3H
	CALL	DEACTIVATEDEFDISK			;0FF4H
	LHLD	DESYSFUNC				;205BH
	CALL	CHECKSYSROFILES				;0FDDH
	CALL	STORETZC4				;0F80H
	LDA	TZ					;20EFH
	CPI	80H
	JNC	STOREONETORESULT			;0B11H
	CALL	FINDNUMBEROFBLOCK			;0F33H
	CALL	SETNUMBEROFBLOCK			;0F40H
	MVI	C,0
	JNZ	THISBLOCKISALREADY			;1556H
	CALL	FINDSHIFTINBLOCKFIELD			;0EFAH
	STA	SHIFTINFCBBLOCKFIELD			;20E7H
	LXI	B,0
	ORA	A
	JZ	FIRSTBLOCK				;1523H
	MOV	C,A
	DCX	B
	CALL	BLOCKFROMFCBBLFIELD			;0F1AH
	MOV	B,H
	MOV	C,L

FIRSTBLOCK:				;1523H
	CALL	SEARCHNEARESTFRREBLOCK			;1205H
	MOV	A,L
	ORA	H
	JNZ	FREEBLOCKISREAL				;1530H
	MVI	A,2
	JMP	SETBYTERESULT				;0A8CH

FREEBLOCKISREAL:			;1530H
	SHLD	NUMBER128BL				;20F1H
	XCHG
	LHLD	DESYSFUNC				;205BH
	LXI	B,10H
	DAD	B
	LDA	STATUSBIGQBLOCKONDEFDISK		;20E9H
	ORA	A
	LDA	SHIFTINFCBBLOCKFIELD			;20E7H
	JZ	TWOBYTETONUMBER				;154CH
	CALL	HLADDA					;100FH
	MOV	M,E
	JMP	NEXTWRT					;1554H

TWOBYTETONUMBER:			;154CH
	MOV	C,A
	MVI	B,0
	DAD	B
	DAD	B
	MOV	M,E
	INX	H
	MOV	M,D

NEXTWRT:				;1554H
	MVI	C,2

THISBLOCKISALREADY:			;1556H
	LDA	RESULT					;210FH
	ORA	A
	RNZ
	PUSH	B
	CALL	COMPUTENUMBEROF128BYTEBLOCK		;0F46H
	LDA	FLAG0D1S2W0				;20E5H
	DCR	A
	DCR	A
	JNZ	WRITEINFORM				;15A3H
	POP	B
	PUSH	B
	MOV	A,C
	DCR	A
	DCR	A
	JNZ	WRITEINFORM				;15A3H
	PUSH	H
	LHLD	DIRBUFDEFDISK				;20C9H
;
; <A> = 0
	MOV	D,A

STOREZERO128BYTES:			;1574H
	MOV	M,A
	INX	H
	INR	D
	JP	STOREZERO128BYTES			;1574H
	CALL	SETDMAONDIRBUF				;108DH
	LHLD	NUMBFIRST128BLFORBLOCK			;20F3H
	MVI	C,2

ST0TOALLBLOCK:				;1582H
	SHLD	NUMBER128BL				;20F1H
	PUSH	B
	CALL	SETTRSECFORN128BL			;0E82H
	POP	B
	CALL	WRITEDISK				;0E60H
	LHLD	NUMBER128BL				;20F1H
	MVI	C,0
;
; BLM
	LDA	DPBDEFDISK+3				;20D4H
	MOV	B,A
	ANA	L
	CMP	B
	INX	H
	JNZ	ST0TOALLBLOCK				;1582H
	POP	H
	SHLD	NUMBER128BL				;20F1H
	CALL	RESETDMABUFER				;1087H

WRITEINFORM:				;15A3H
	CALL	SETTRSECFORN128BL			;0E82H
	POP	B
	PUSH	B
	CALL	WRITEDISK				;0E60H
	POP	B
	LDA	TZ					;20EFH
	LXI	H,C4					;20EDH
	CMP	M
	JC	TZLTC4					;15BAH
	MOV	M,A
	INR	M
	MVI	C,2

TZLTC4:					;15BAH
	DCR	C
	DCR	C
	JNZ	ITISNOTWRITEZEROBLOCK			;15C7H
	PUSH	PSW
	CALL	READC2FROMFCB				;1014H
	ANI	7FH
	MOV	M,A
	POP	PSW
;
; CHECK TZ

ITISNOTWRITEZEROBLOCK:			;15C7H
	CPI	7FH
	JNZ	INOLDEXTENT				;15E8H
	LDA	FLAG0D1S2W0				;20E5H
	CPI	1
	JNZ	INOLDEXTENT				;15E8H
	CALL	CHANGETZC4				;14CBH
	CALL	EXTENTCHANGE				;1420H
	LXI	H,RESULT				;210FH
	MOV	A,M
	ORA	A
	JNZ	ERROPENNEXTEXTENT			;15E6H
	DCR	A
	STA	TZ					;20EFH

ERROPENNEXTEXTENT:			;15E6H
	MVI	M,0

INOLDEXTENT:				;15E8H
	JMP	CHANGETZC4				;14CBH

PREPAREFROMR0R1:			;15EBH
	XRA	A
	STA	FLAG0D1S2W0				;20E5H

PREPFROMR0R1R2FORWRITEZERO:		;15EFH
	PUSH	B
	CALL	FINDADRESR0INFCB			;0F6AH
	MOV	A,M
	ANI	7FH
	PUSH	PSW
	MOV	A,M
	RAL
	INX	H
	MOV	A,M
	RAL
	ANI	1FH
;
; THIS IS ZK - EXTENT NUMBER
	MOV	C,A
	MOV	A,M
	RAR
	RAR
	RAR
	RAR
	ANI	0FH
;
; THIS IS C2
	MOV	B,A
	POP	PSW
	INX	H
	MOV	L,M
	INR	L
	DCR	L
	MVI	L,6
	JNZ	EXFINDDIRECT				;166EH
	LXI	H,20H
	DAD	D
;
; TZ := R0 AND 7FH
	MOV	M,A
	LXI	H,0CH
	DAD	D
	MOV	A,C
	SUB	M
	JNZ	CHECKNEXTEXTENT				;162AH
	LXI	H,0EH
	DAD	D
	MOV	A,B
	SUB	M
	ANI	7FH
	JZ	EXTENTWASFINDED				;1662H

CHECKNEXTEXTENT:			;162AH
	PUSH	B
	PUSH	D
	CALL	CLOSEEXTENT				;1357H
	POP	D
	POP	B
	MVI	L,3
	LDA	RESULT					;210FH
	INR	A
	JZ	UNCLOSEDEXTENT				;1667H
	LXI	H,0CH
	DAD	D
	MOV	M,C
	LXI	H,0EH
	DAD	D
	MOV	M,B
	CALL	FINDEXTENT				;12B2H
	LDA	RESULT					;210FH
	INR	A
	JNZ	EXTENTWASFINDED				;1662H
	POP	B
	PUSH	B
	MVI	L,4
	INR	C
	JZ	UNCLOSEDEXTENT				;1667H
	CALL	CREATEEXTENT				;13EAH
	MVI	L,5
	LDA	RESULT					;210FH
	INR	A
	JZ	UNCLOSEDEXTENT				;1667H

EXTENTWASFINDED:			;1662H
	POP	B
	XRA	A
	JMP	SETBYTERESULT				;0A8CH

UNCLOSEDEXTENT:				;1667H
	PUSH	H
	CALL	READC2FROMFCB				;1014H
	MVI	M,0C0H
	POP	H

EXFINDDIRECT:				;166EH
	POP	B
	MOV	A,L
	STA	RESULT					;210FH
	JMP	SETBIT7INTOC2				;1485H

PREPARER0R1:				;1676H
	XCHG
	DAD	D
;
; C4
	MOV	C,M
	MVI	B,0
	LXI	H,0CH
	DAD	D
;
; ZK --> NUMBER OF EXTENT
	MOV	A,M
	RRC
	ANI	80H
	ADD	C
	MOV	C,A
	MVI	A,0
	ADC	B
	MOV	B,A
	MOV	A,M
	RRC
	ANI	0FH
	ADD	B
	MOV	B,A
	LXI	H,0EH
	DAD	D
;
; C2
	MOV	A,M
	ADD	A
	ADD	A
	ADD	A
	ADD	A
;
; 16*C2
	PUSH	PSW
	ADD	B
	MOV	B,A
	PUSH	PSW
;
; WORK WITH FLAG C
	POP	H
	MOV	A,L
	POP	H
	ORA	L
	ANI	1
	RET

FUN23:					;16A3H
	CALL	SETDISKFORFCB				;16E2H
	MVI	C,0CH
	CALL	FINDFILEFORCBYTE			;115DH
	LHLD	DESYSFUNC				;205BH
	LXI	D,21H
	DAD	D
;
; ADRESS OF R0
	PUSH	H
;
; CLEAR R0,R1,R2
	MOV	M,D
	INX	H
	MOV	M,D
	INX	H
	MOV	M,D

SEARCHEOF:				;16B8H
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	JZ	EXDIMFILE				;16E0H
	CALL	PLACEINTODIRECTORY			;1009H
	LXI	D,0FH
	CALL	PREPARER0R1				;1676H
	POP	H
	PUSH	H
	MOV	E,A
	MOV	A,C
	SUB	M
	INX	H
	MOV	A,B
	SBB	M
	INX	H
	MOV	A,E
	SBB	M
	JC	UNCOPYR0R1R2				;16DAH
	MOV	M,E
	DCX	H
	MOV	M,B
	DCX	H
	MOV	M,C

UNCOPYR0R1R2:				;16DAH
	CALL	CLCREADNEXTDIR				;1172H
	JMP	SEARCHEOF				;16B8H

EXDIMFILE:				;16E0H
	POP	H
	RET

SETDISKFORFCB:				;16E2H
	XRA	A
	STA	READTODAYDISK				;20EAH
	DCR	A
	STA	FLAGFORSETREADTODAYDISK			;205DH
	LHLD	DESYSFUNC				;205BH
;
; NUMBER OF DISK
	MOV	A,M
	ANI	1FH
	DCR	A
	STA	SYSEPARAM				;20E6H
	CPI	1EH
	JNC	ITISDEFDISK				;1709H
	LDA	DEFAULTDISK				;205AH
	STA	COPYDEFDISK				;20ECH
	MOV	A,M
	STA	READTODAYDISK				;20EAH
	ANI	0E0H
	MOV	M,A
;
; SET DISK FROM SYSEFUNC
	CALL	FUN0E					;1743H

ITISDEFDISK:				;1709H
	LDA	USER					;2060H
	LHLD	DESYSFUNC				;205BH
	ORA	M
	MOV	M,A
	RET

FUN0D:					;1712H
	LXI	H,0
	SHLD	ONLYREADSTATUSVECTOR			;20BFH
	SHLD	DISKSTATUSVECTOR			;20C1H
	XRA	A
	STA	DEFAULTDISK				;205AH
	LXI	H,SYSDMA				;80H
	SHLD	ADRDMA					;2058H
	CALL	RESETDMABUFER				;1087H
	JMP	SETDEFAULTDISK				;1752H

SETREADTODAYDISK:			;172BH
	LXI	H,FLAGFORSETREADTODAYDISK		;205DH
	MOV	A,M
	ORA	A
	RZ
	XRA	A
	MOV	M,A
	LHLD	DESYSFUNC				;205BH
	MOV	M,A
	LDA	READTODAYDISK				;20EAH
	ORA	A
	RZ
	MOV	M,A
	LDA	COPYDEFDISK				;20ECH
	STA	SYSEPARAM				;20E6H
;
; DISK ELABORATE

FUN0E:					;1743H
	LDA	SYSEPARAM				;20E6H

SETADISK:				;1746H
	LXI	H,DEFAULTDISK				;205AH
	CMP	M
	RZ
	PUSH	PSW
	MOV	A,M
	STA	LASTDEFAULTDISK				;210EH
	POP	PSW
	MOV	M,A

SETDEFAULTDISK:				;1752H
	LHLD	DISKSTATUSVECTOR			;20C1H
	LDA	DEFAULTDISK				;205AH
	MOV	C,A
	CALL	HLRARCTIME				;0F97H
	PUSH	H
	XCHG
	CALL	PREPAREDEFDISK				;0E01H
	POP	H
;
; IS DISK REAL ?
	CZ	RESETLASTDEFDISK			;0C87H
	MOV	A,L
	RAR
	RC
	LHLD	DISKSTATUSVECTOR			;20C1H
	MOV	C,L
	MOV	B,H
	CALL	ADDDEFDISK				;0FB9H
	SHLD	DISKSTATUSVECTOR			;20C1H
	CALL	FINDSIZEALVTABLET			;1140H
	MOV	B,H
	MOV	C,L
	LHLD	ADRALVDEFDISK				;20CFH

CLEARALVPLACE:				;177BH
	MVI	M,0
	INX	H
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	CLEARALVPLACE				;177BH
;
; (AL1,AL0)
	LHLD	DPBDEFDISK+9				;20DAH
	XCHG
	LHLD	ADRALVDEFDISK				;20CFH
	MOV	M,E
	INX	H
	MOV	M,D
	CALL	SETSECANDTRTOHOME			;0E49H
	LHLD	ADRQELEMNDIR				;20C3H
	MVI	M,3
	INX	H
	MVI	M,0
	CALL	STOREMINUSONETOCODEDIR			;10B3H

SEARCHNOTDELFILE:			;179CH
	MVI	C,0FFH
	CALL	READNEXTDIR				;10A2H
	CALL	CHECKCODEDIREQUMINUSONE			;1099H
	RZ
	CALL	PLACEINTODIRECTORY			;1009H
	MVI	A,0E5H
	CMP	M
	JZ	SEARCHNOTDELFILE			;179CH
	LDA	USER					;2060H
	CMP	M
	JNZ	NORMFILE				;17C0H
	INX	H
;
; FIRST CHAR OF NAME
	MOV	A,M
	SUI	'$'	;24H
	JNZ	NORMFILE				;17C0H
	DCR	A
	STA	RESULT					;210FH

NORMFILE:				;17C0H
	MVI	C,1
	CALL	SETALLFCBBLOCKSINTOALV			;1108H
	CALL	SETDIMDISK				;1030H
	JMP	SEARCHNOTDELFILE			;179CH

FUN8132:				;17CBH
	CALL	PREPEXDSC				;1879H
	CALL	CHDESYSUNDEFINEDFILE			;1898H
	MVI	A,9
	JNZ	SETBYTERESULT				;0A8CH
	LHLD	DESYSFUNC				;205BH
	XCHG
;
; OPEN FILE
	CALL	FUN0F					;12ACH
	CALL	SETTODAYDISKANDREMEMBERRESULT		;033DH
	JNZ	FILEWASOPEND				;1800H
	LDA	EXDSC					;20FBH
	INR	A
	JZ	WRITEFOREXCHANGE			;17EFH
	MVI	A,1
	JMP	SETBYTERESULT				;0A8CH
;
; CREATE FILE

WRITEFOREXCHANGE:			;17EFH
	STA	RESULT					;210FH
	CALL	FUN16					;13D7H

ERROREXCHANGE:				;17F5H
	MVI	A,1
	JZ	SETBYTERESULT				;0A8CH
	CALL	SETTODAYDISKANDREMEMBERRESULT		;033DH
	JZ	ERROREXCHANGE				;17F5H

FILEWASOPEND:				;1800H
	XRA	A
	STA	RESULT					;210FH
	CALL	COPYADRDMA				;191FH
	LHLD	EXDSC+3					;20FEH
	LXI	D,LFF80					;0FF80H
	DAD	D
	SHLD	EXDSC+3					;20FEH
	LDA	EXDSC					;20FBH
	INR	A
	JZ	WRTEXDSC				;1822H
	LXI	D,LFF80					;0FF80H
	LHLD	EXDSC+5					;2100H
	DAD	D
	SHLD	EXDSC+5					;2100H

WRTEXDSC:				;1822H
	LHLD	EXDSC+3					;20FEH
	LXI	D,SYSDMA				;80H
	DAD	D
	SHLD	EXDSC+3					;20FEH
	XCHG
	LHLD	EXDSC+5					;2100H
	CALL	SUBHLDE					;1039H
	MVI	A,0
	JNC	L184A					;184AH
;
; SET DMA ADRES
	CALL	FUN1A					;1918H
	CALL	L186F					;186FH
	CALL	SETREADTODAYDISK			;172BH
	LDA	RESULT					;210FH
	ORA	A
	JZ	WRTEXDSC				;1822H
	MVI	A,2

L184A:					;184AH
	PUSH	PSW
	LHLD	EXDSC+3					;20FEH
	XCHG
	LHLD	ADREXDSC				;20F9H
	INX	H
	INX	H
	INX	H
	MOV	M,E
	INX	H
	MOV	M,D
	CALL	COPYDMATODMA				;1914H
	POP	PSW
	MOV	C,A
	STA	RESULT					;210FH
	LDA	EXDSC					;20FBH
	INR	A
	RNZ
	MOV	A,C
	PUSH	PSW
	CALL	CLOSEEXTENT				;1357H
	POP	PSW
	STA	RESULT					;210FH
	RET

L186F:					;186FH
	LDA	EXDSC					;20FBH
	INR	A
	JZ	FUN15					;14E3H
	JMP	FUN14					;148CH

PREPEXDSC:				;1879H
	LHLD	DESYSFUNC				;205BH
	SHLD	ADREXDSC				;20F9H
	XCHG
	LXI	H,EXDSC					;20FBH
	MVI	C,7
	CALL	COPYCBYTEHLDE				;18DAH
;
; ADRESS OF FCB
	LHLD	EXDSC+1					;20FCH
	SHLD	DESYSFUNC				;205BH
	RET

FUN8032:				;188FH
	CALL	PREPEXDSC				;1879H
	CALL	SETDISKFORFCB				;16E2H
	JMP	FILEWASOPEND				;1800H

CHDESYSUNDEFINEDFILE:			;1898H
	LHLD	DESYSFUNC				;205BH

CHECKUNDEFINEDFILE:			;189BH
	LXI	B,0BH

NEXTLNAME:				;189EH
	INX	H
	MOV	A,M
	CPI	'?'	;3FH
	JNZ	NOTQ					;18A6H
	INR	B

NOTQ:					;18A6H
	DCR	C
	JNZ	NEXTLNAME				;189EH
	MOV	A,B
	ORA	A
	RET

FUN8232:				;18ADH
	LHLD	USERSTACKSTORE				;210CH
	SPHL
	LHLD	DESYSFUNC				;205BH
	JMP	BIOSDISKOPERATION			;2412H

FUN11:					;18B7H
	MVI	C,0
	XCHG
	MOV	A,M
	CPI	'?'	;3FH
	JZ	FINDFIRSTFILE				;18CEH
	CALL	SETADRZK				;0F62H
	MOV	A,M
	CPI	'?'	;3FH
	CNZ	READC2ANDC2EQU0				;101DH
	CALL	SETDISKFORFCB				;16E2H
	MVI	C,0FH

FINDFIRSTFILE:				;18CEH
	CALL	FINDFILEFORCBYTE			;115DH

COPYDIRBUF:				;18D1H
	LHLD	DIRBUFDEFDISK				;20C9H
	XCHG
	LHLD	ADRDMA					;2058H
	MVI	C,80H

COPYCBYTEHLDE:				;18DAH
	INR	C

COPYHLDE:				;18DBH
	DCR	C
	RZ
	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	JMP	COPYHLDE				;18DBH

FUN12:					;18E4H
	LHLD	FCBFORSEARCH				;2063H
	SHLD	DESYSFUNC				;205BH
	CALL	SETDISKFORFCB				;16E2H

FINDNEXTFILE:				;18EDH
	CALL	CLCREADNEXTDIR				;1172H
	JMP	COPYDIRBUF				;18D1H

FUN13:					;18F3H
	CALL	SETDISKFORFCB				;16E2H
	CALL	DELETEFORFCB				;11E3H

RESULTISRESFINDFILE:			;18F9H
	LDA	RESFINDFILE				;20E4H
	JMP	SETBYTERESULT				;0A8CH

FUN17:					;18FFH
	CALL	SETDISKFORFCB				;16E2H
	CALL	RENAMEALLFILES				;125DH
	JMP	RESULTISRESFINDFILE			;18F9H

FUN18:					;1908H
	LHLD	DISKSTATUSVECTOR			;20C1H
	JMP	SETWORDRESULT				;1960H

FUN19:					;190EH
	LDA	DEFAULTDISK				;205AH
	JMP	SETBYTERESULT				;0A8CH

COPYDMATODMA:				;1914H
	LHLD	ADRCOPYDMA				;2102H
	XCHG

FUN1A:					;1918H
	XCHG

CHANGEPDP:				;1919H
	SHLD	ADRDMA					;2058H
	JMP	RESETDMABUFER				;1087H

COPYADRDMA:				;191FH
	LHLD	ADRDMA					;2058H
	SHLD	ADRCOPYDMA				;2102H
	RET

NEXTPDP:				;1926H
	LHLD	ADRDMA					;2058H
	LXI	D,SYSDMA				;80H
	DAD	D
	JMP	CHANGEPDP				;1919H

FUN1B:					;1930H
	LHLD	ADRALVDEFDISK				;20CFH
	JMP	SETWORDRESULT				;1960H

FUN1C:					;1936H
	LXI	H,ONLYREADSTATUSVECTOR			;20BFH
	MOV	C,M
	INX	H
	MOV	B,M
	CALL	ADDDEFDISK				;0FB9H
	SHLD	ONLYREADSTATUSVECTOR			;20BFH
;
; QUANTATY OF DIR PART OF DISK
	LHLD	DPBDEFDISK+7				;20D8H
	INX	H
	XCHG
	LHLD	ADRQELEMNDIR				;20C3H

STOREDETOM:				;194AH
	MOV	M,E
	INX	H
	MOV	M,D
	RET

FUN1D:					;194EH
	LHLD	ONLYREADSTATUSVECTOR			;20BFH
	JMP	SETWORDRESULT				;1960H

FUN1E:					;1954H
	CALL	SETDISKFORFCB				;16E2H
	CALL	SETFILEATTRIBUTE			;1298H
	JMP	RESULTISRESFINDFILE			;18F9H

FUN1F:					;195DH
	LHLD	ADRDPBDEFDISK				;20CBH

SETWORDRESULT:				;1960H
	SHLD	RESULT					;210FH
	RET

FUN20:					;1964H
	MOV	A,E
	LXI	H,USER					;2060H
	CPI	0FFH
	JNZ	SETUSERCODE				;1971H
	MOV	A,M
	JMP	SETBYTERESULT				;0A8CH

SETUSERCODE:				;1971H
	ANI	1FH
	MOV	M,A
	RET

FUN21:					;1975H
	CALL	SETDISKFORFCB				;16E2H
	MVI	C,0FFH
	CALL	PREPAREFROMR0R1				;15EBH
	CZ	SEQREAD					;1494H
	RET

FUN22:					;1981H
	CALL	SETDISKFORFCB				;16E2H
	MVI	C,0
	CALL	PREPAREFROMR0R1				;15EBH
	CZ	SEQWRITE				;14EBH
	RET

FUN24:					;198DH
	LHLD	DESYSFUNC				;205BH
	LXI	D,20H
	CALL	PREPARER0R1				;1676H
	LXI	H,21H
	DAD	D
;
; R0
	MOV	M,C
	INX	H
	MOV	M,B
	INX	H
	MOV	M,A
	RET

CHANGER1R2R3:				;19A0H
	CALL	FINDADRESR0INFCB			;0F6AH
	INR	M
	RNZ
	INX	H
	INR	M
	RNZ
	INX	H
	INR	M
	RET

COPYR0R1R2FROMFCB:			;19ABH
	CALL	FINDADRESR0INFCB			;0F6AH
	XCHG
	LXI	H,COPYFCB+33				;21B5H

COPY3BYTEHLDE:				;19B2H
	MVI	C,3
	JMP	COPYCBYTEHLDE				;18DAH

COPYR0R1R2TOFCB:			;19B7H
	CALL	FINDADRESR0INFCB			;0F6AH
	LXI	D,COPYFCB+33				;21B5H
	JMP	COPY3BYTEHLDE				;19B2H

FUN25:					;19C0H
	LHLD	DESYSFUNC				;205BH

DEACTIVATEDISK:				;19C3H
	MOV	A,L
	CMA
	MOV	E,A
	MOV	A,H
	CMA
	LHLD	DISKSTATUSVECTOR			;20C1H
	ANA	H
	MOV	D,A
	MOV	A,L
	ANA	E
	MOV	E,A
	LHLD	ONLYREADSTATUSVECTOR			;20BFH
	XCHG
	SHLD	DISKSTATUSVECTOR			;20C1H
	MOV	A,L
	ANA	E
	MOV	L,A
	MOV	A,H
	ANA	D
	MOV	H,A
	SHLD	ONLYREADSTATUSVECTOR			;20BFH
	RET

FUN28:					;19E1H
	CALL	SETDISKFORFCB				;16E2H
	MVI	A,2
	STA	FLAG0D1S2W0				;20E5H
	MVI	C,0
	CALL	PREPFROMR0R1R2FORWRITEZERO		;15EFH
	CZ	SEQWRITE				;14EBH
	RET

FUN2E:					;19F2H
	MOV	A,E
	INR	A
	STA	ADREXDSC				;20F9H
	MOV	C,A
	LXI	H,1
	CALL	STEPENTWO				;0FB1H
	CALL	DEACTIVATEDISK				;19C3H
	LXI	H,ADREXDSC				;20F9H
	SHLD	DESYSFUNC				;205BH
	CALL	SETDISKFORFCB				;16E2H
	LHLD	ADRALVDEFDISK				;20CFH
	XCHG
	CALL	FINDSIZEALVTABLET			;1140H
	LXI	B,0

CLCQFULLBLOCKS:				;1A14H
	LDAX	D

CHECKALLBLOCKS:				;1A15H
	ORA	A
	JZ	FULLBLOCKSWASENDED			;1A21H

FINDFULLBLOCK:				;1A19H
	RAR
	JNC	FINDFULLBLOCK				;1A19H
	INX	B
	JMP	CHECKALLBLOCKS				;1A15H

FULLBLOCKSWASENDED:			;1A21H
	INX	D
	DCX	H
	MOV	A,L
	ORA	H
	JNZ	CLCQFULLBLOCKS				;1A14H
;
; VOLUME OF DISK INTO BLOCKS - 1
	LHLD	DPBDEFDISK+5				;20D6H
	INX	H
	MOV	A,L
	SUB	C
	MOV	L,A
	MOV	A,H
	SBB	B
	MOV	H,A
;
; BSH
	LDA	DPBDEFDISK+2				;20D3H
	MOV	C,A
	XRA	A
	CALL	STEPENTWO				;0FB1H
	XCHG
	LHLD	ADRDMA					;2058H
	MOV	M,E
	INX	H
	MOV	M,D
	INX	H
	MOV	M,A
	RET

FUN2C:					;1A44H
	MOV	A,E
	ORA	A
	JZ	FUN29					;11DCH
	CPI	81H
	JNC	FUN29					;11DCH
	STA	MULTISEKTORCOUNT			;2066H
	RET

FUN2D:					;1A52H
	MOV	A,E
	STA	ERRORREGIM				;2067H
	RET

FUN31:					;1A57H
	XCHG
	MOV	A,M
	CPI	63H
	RNC
	XCHG
	LXI	H,CSB					;201CH
	CALL	HLADDA					;100FH
	XCHG
	INX	H
	MOV	A,M
	CPI	0FEH
	JNC	SETCSB					;1A73H
	XCHG
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	JMP	SETWORDRESULT				;1960H

SETCSB:					;1A73H
	MOV	B,A
	INX	H
	MOV	A,M
	STAX	D
	INR	B
	RZ
	INX	H
	INX	D
	MOV	A,M
	STAX	D
	RET

FUN2F:					;1A7EH
	LXI	H,SYSDMA				;80H
	LXI	D,COMANDBUFER+2				;2115H
	LXI	B,7EH

COPYCOMAND:				;1A87H
	MOV	A,M
	STAX	D
	ORA	A
	JZ	ENDCOPYCOMAND				;1A97H
	INR	B
	DCR	C
	JZ	FUN00					;1C31H
	INX	H
	INX	D
	JMP	COPYCOMAND				;1A87H

ENDCOPYCOMAND:				;1A97H
	LXI	H,COMANDBUFER+1				;2114H
	MOV	M,B
	CALL	RUNCOMANDFROMHL				;0262H
	JMP	FUN00					;1C31H

FUN68:					;1AA1H
	LXI	H,DATA					;2074H
	CALL	COPY4BYTEHLDE				;1AB3H
	RET

FUN69:					;1AA8H
	LXI	H,DATA					;2074H
	XCHG
	CALL	COPY4BYTEHLDE				;1AB3H
	LDAX	D
	JMP	SETBYTERESULT				;0A8CH

COPY4BYTEHLDE:				;1AB3H
	MVI	C,4
	JMP	COPYCBYTEHLDE				;18DAH

FUN6C:					;1AB8H
	LXI	H,CODEOFRETURN				;202CH

L1ABB:					;1ABBH
	MOV	A,D
	ANA	E
	INR	A
	JNZ	STOREDETOM				;194AH
	CALL	DEM					;0F2EH
	JMP	SETWORDRESULT				;1960H

FUN6D:					;1AC7H
	LXI	H,L204F					;204FH
	JMP	L1ABB					;1ABBH

FUN6E:					;1ACDH
	MOV	A,E
	LXI	H,EOSTRINGCHAR				;2053H
	INR	A
	JNZ	STOREEOSTRINGCHAR			;1AD9H
	MOV	A,M
	JMP	SETBYTERESULT				;0A8CH

STOREEOSTRINGCHAR:			;1AD9H
	MOV	M,E
	RET

FUN6F:					;1ADBH
	XCHG
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	MOV	C,M
	INX	H
	MOV	B,M
	XCHG
;
; HL - BEGIN OF ARRAY ,  BC - SIZE OF ARRAY

CLOUTARRAY:				;1AE4H
	MOV	A,B
	ORA	C
	RZ
	PUSH	H
	PUSH	B
	MOV	C,M
	LDA	CSYSFUNC				;205FH
	CPI	6FH
	JZ	FORFUN6F				;1AF8H
	CALL	FUN05					;1E72H
	JMP	FORFUN70				;1AFBH

FORFUN6F:				;1AF8H
	CALL	FUN02					;089CH

FORFUN70:				;1AFBH
	POP	B
	POP	H
	INX	H
	DCX	B
	JMP	CLOUTARRAY				;1AE4H

CHECKLETTERINFILENAME:			;1B02H
	LDAX	D

CHECKCHARTODELETE:			;1B03H
	ORA	A
	RZ
	CPI	' '	;20H
	RC
	RZ
	CPI	'='	;3DH
	RZ
	CPI	5FH
	RZ
	CPI	'.'	;2EH
	RZ
	CPI	','	;2CH
	RZ
	CPI	':'	;3AH
	RZ
	CPI	';'	;3BH
	RZ
	CPI	'<'	;3CH
	RZ
	CPI	'>'	;3EH
	RZ
	ORA	A
	RET

FINDFIRSTSYMBOL:			;1B23H
	LDAX	D
	ORA	A
	RZ
	CPI	' '	;20H
	JZ	FINDSPACE				;1B2EH
;
; DESYSFUNC ==> E:=USER
	CPI	9
	RNZ

FINDSPACE:				;1B2EH
	INX	D
	JMP	FINDFIRSTSYMBOL				;1B23H
;
; PREPARE FCB (<H,L> - ADRESS) FROM COMAND

PREPFCBFROMCOMAND:			;1B32H
	MVI	A,0

PREPAPLUSFCBFROMCOMAND:			;1B34H
	CALL	HLADDA					;100FH
	PUSH	H
	LHLD	BEGINOFCOMAND				;2104H
	XCHG
	CALL	FINDFIRSTSYMBOL				;1B23H
	XCHG
	SHLD	REALBEGINOFCOMAND			;2106H
	XCHG
	POP	H
	PUSH	H
	LDAX	D
	CALL	MAKEBIGLETTER				;0321H
	SUI	'@'	;40H
	MOV	B,A
	INX	D
	LDAX	D
	CPI	':'	;3AH
	JZ	SETCOMANDDISK				;1B5AH
;
; DEFAULT DISK
	DCX	D
	XRA	A
	MOV	M,A
	JMP	SETDEFDISKALREADY			;1B5CH

SETCOMANDDISK:				;1B5AH
	MOV	M,B
	INX	D

SETDEFDISKALREADY:			;1B5CH
	MVI	B,8

NEXTNAMELETTER:				;1B5EH
	CALL	CHECKLETTERINFILENAME			;1B02H
	JZ	STOPNAME				;1B85H
	JC	STOPNAME				;1B85H
	INX	H
	CPI	'*'	;2AH
	JNZ	NORMNAMELETTER				;1B72H
	MVI	M,'?'	;3FH
	JMP	FINDSTARINNAME				;1B74H

NORMNAMELETTER:				;1B72H
	MOV	M,A
	INX	D

FINDSTARINNAME:				;1B74H
	DCR	B
	JNZ	NEXTNAMELETTER				;1B5EH

L1B78:					;1B78H
	CALL	CHECKLETTERINFILENAME			;1B02H
	JZ	MAKEDIMFILE				;1B8CH
	JC	MAKEDIMFILE				;1B8CH
	INX	D
	JMP	L1B78					;1B78H

STOPNAME:				;1B85H
	INX	H
	MVI	M,' '	;20H
	DCR	B
	JNZ	STOPNAME				;1B85H

MAKEDIMFILE:				;1B8CH
	MVI	B,3
	CPI	'.'	;2EH
	JNZ	WITHOUTPOINT				;1BB8H
	INX	D

SETDIMFILE:				;1B94H
	CALL	CHECKLETTERINFILENAME			;1B02H
	JZ	WITHOUTPOINT				;1BB8H
	INX	H
	CPI	'*'	;2AH
	JNZ	NORMDIMLETTER				;1BA5H
	MVI	M,'?'	;3FH
	JMP	FINDSTAR				;1BA7H

NORMDIMLETTER:				;1BA5H
	MOV	M,A
	INX	D

FINDSTAR:				;1BA7H
	DCR	B
	JNZ	SETDIMFILE				;1B94H

FINDPARAMETER:				;1BABH
	CALL	CHECKLETTERINFILENAME			;1B02H
	JZ	PREPFCBCOMAND				;1BBFH
	JC	PREPFCBCOMAND				;1BBFH
	INX	D
	JMP	FINDPARAMETER				;1BABH

WITHOUTPOINT:				;1BB8H
	INX	H
	MVI	M,' '	;20H
	DCR	B
	JNZ	WITHOUTPOINT				;1BB8H

PREPFCBCOMAND:				;1BBFH
	MVI	B,4

CPFCBC:					;1BC1H
	INX	H
	MVI	M,0
	DCR	B
	JNZ	CPFCBC					;1BC1H
	XCHG
	SHLD	BEGINOFCOMAND				;2104H
	POP	H
	MVI	C,0BH

NEXTLETNAME:				;1BCFH
	INX	H
	MOV	A,M
	CPI	61H
	JC	BIGLETTINFILENAME			;1BD9H
	ANI	5FH
	MOV	M,A

BIGLETTINFILENAME:			;1BD9H
	DCR	C
	JNZ	NEXTLETNAME				;1BCFH
	ORA	A
	RET

FUN98:					;1BDFH
	LDAX	D
	MOV	L,A
	INX	D
	LDAX	D
	MOV	H,A
	SHLD	BEGINOFCOMAND				;2104H
	INX	D
	LDAX	D
	MOV	L,A
	INX	D
	LDAX	D
	MOV	H,A
	CALL	PREPFCBFROMCOMAND			;1B32H
	LHLD	BEGINOFCOMAND				;2104H
	MOV	A,M
	ORA	A
	JMP	SETWORDRESULT				;1960H
	LXI	H,LFFFF					;0FFFFH
	JMP	SETWORDRESULT				;1960H

TYPEBIOSMSG:				;1BFEH
	ADD	A
	CALL	ADRTXTBIOS				;2415H
	CALL	HLADDA					;100FH
	MOV	C,M
	INX	H
	MOV	B,M

PECUNTILDOLLAR:				;1C08H
	LDA	EOSTRINGCHAR				;2053H
	PUSH	PSW
	MVI	A,'$'	;24H
	STA	EOSTRINGCHAR				;2053H
	CALL	PEC					;0903H
	POP	PSW
	STA	EOSTRINGCHAR				;2053H
	RET

FINDSUMSPR:				;1C19H
	LHLD	ADRESSPRPROGRAM				;20BAH
	XCHG
	LHLD	L20BC					;20BCH
	MOV	B,H
	MOV	C,L
	LXI	H,0

L1C25:					;1C25H
	LDAX	D
	CALL	HLADDA					;100FH
	INX	D
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	L1C25					;1C25H
	RET

FUN00:					;1C31H
	LXI	SP,SYSTEMSTACK				;2376H
	LDA	SPRSTATUS				;20BEH
	ORA	A
	JZ	ENTERTOMICRODOS				;1C4DH
	CALL	FINDSUMSPR				;1C19H
	XCHG
	LHLD	SUMSPR					;20B8H
	CALL	SUBHLDE					;1039H
	MOV	A,L
	ORA	H
	JZ	ENTERTOMICRODOS				;1C4DH
	CALL	RESETSYSTEM				;1C94H

ENTERTOMICRODOS:			;1C4DH
	LXI	SP,SYSTEMSTACK				;2376H
	CALL	INI2BIOS				;2403H
	CALL	CLOSECONOUTFILE				;1FB5H
	DI
	MVI	A,'$'	;24H
	STA	EOSTRINGCHAR				;2053H
	LXI	H,SYSDMA				;80H
	SHLD	ADRDMA					;2058H
	CALL	RESETDMABUFER				;1087H
	MVI	A,0C3H
	STA	0
	LXI	H,BIOS01				;0203H
	SHLD	1
	STA	GOTOBDOS				;5
	LXI	H,BDOSBEGIN				;0200H
	SHLD	GOTOBDOS+1				;6
	XRA	A
	STA	L2314					;2314H
	STA	STATUSEXCHANGECONSOLE			;2081H
	INR	A
	STA	STATUSCTRLD				;2317H
	STA	MULTISEKTORCOUNT			;2066H
	LDA	DISKTODAY				;4
	CALL	SETADISK				;1746H
	EI
	CALL	FONREGIM				;0233H
	JMP	FUN00					;1C31H

RESETSYSTEM:				;1C94H
	MVI	A,0C3H
	STA	GOTOBDOS				;5
	LXI	H,BDOSBEGIN				;0200H
	SHLD	GOTOBDOS+1				;6
	LXI	H,SYSTEMFUNC				;0630H
	SHLD	BDOSBEGIN+1				;0201H
	MVI	C,0DH
	CALL	GOTOBDOS				;5

RESETSYSWITHOUTJMP:			;1CAAH
	LXI	D,FCBCCP				;2001H
	LXI	H,COPYFCB				;2194H
	MVI	C,10H
	CALL	COPYCBYTEHLDE				;18DAH
	CALL	INPUTSPRFILE				;1CF2H
	JNZ	SPRWASNOTREAD				;1CD3H
	SHLD	ADRESSPRPROGRAM				;20BAH
	PUSH	H
	LXI	D,GOTOBDOS				;5
	DAD	D
	MOV	C,M
	INX	H
	MOV	B,M
	POP	D
	CALL	FINDSUMSPR				;1C19H
	SHLD	SUMSPR					;20B8H
	MVI	A,0FFH
	STA	SPRSTATUS				;20BEH
	RET

SPRWASNOTREAD:				;1CD3H
	XRA	A
	STA	SPRSTATUS				;20BEH
	RET

INPUTFILETO100H:			;1CD8H
	XRA	A
	STA	COPYFCB+32				;21B4H
	LXI	H,0100H
	SHLD	DSCREADTO100H+3				;1FFDH
	LXI	H,DSCREADTO100H				;1FFAH
	SHLD	DESYSFUNC				;205BH
	CALL	FUN8132					;17CBH
	CALL	SETREADTODAYDISK			;172BH
	LDA	RESULT					;210FH
	RET

INPUTSPRFILE:				;1CF2H
	LXI	H,COPYFCB+9				;219DH
	MOV	A,M
	CPI	' '	;20H
	JNZ	TYPEMSGANDQUEST				;0347H
	MVI	M,'S'	;53H
	INX	H
	MVI	M,'P'	;50H
	INX	H
	MVI	M,'R'	;52H
	LXI	D,COPYFCB				;2194H
;
; TZ := 0
	XRA	A
	STA	COPYFCB+32				;21B4H
	LHLD	GOTOBDOS+1				;6
	MVI	L,0
	SHLD	MAXADRESS				;21B8H
	XCHG
	SHLD	ADRESFCB				;21BAH
	LXI	H,LFF80					;0FF80H
	DAD	D
	SHLD	MAXADRESSMINUS80H			;21BCH
	MOV	B,H
	MOV	C,L
	LHLD	ADRDMA					;2058H
	SHLD	COPYADRESDMA				;21BEH
;
; DMA:= ((0006H) AND (0FF00H)) - 80H
	CALL	BIOSF0C					;1093H
	LHLD	DESYSFUNC				;205BH
	SHLD	COPYDESYSFUNC				;21C0H
	LHLD	ADRESFCB				;21BAH
	SHLD	DESYSFUNC				;205BH
	XCHG
;
; OPEN .SPR FILE
	CALL	FUN0F					;12ACH
	CALL	SETTODAYDISKANDREMEMBERRESULT		;033DH
	JZ	ERRWITHSPRFILE				;1E0BH
	LHLD	MAXADRESSMINUS80H			;21BCH
	MOV	B,H
	MOV	C,L
	LHLD	ADRDMA					;2058H
	SHLD	COPYADRESDMA				;21BEH
	CALL	BIOSF0C					;1093H
	CALL	READ80HFROMDISK				;1E10H
	JZ	ERRWITHSPRFILE				;1E0BH
	LHLD	MAXADRESSMINUS80H			;21BCH
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	INX	H
	MOV	C,M
	INX	H
	MOV	B,M
	XCHG
	SHLD	LINESPRFILE				;21C2H
	DAD	B
	XCHG
	LHLD	MAXADRESS				;21B8H
	XCHG
	XRA	A
	SUB	L
	MOV	L,A
	MVI	A,0
	SBB	H
	MOV	H,A
	DAD	D
	MVI	L,0
	SHLD	BEGINSPRFILE				;21C4H
	XCHG
	LXI	H,LFF80					;0FF80H
	DAD	D
	SHLD	MAXADRESSMINUS80H			;21BCH
	CALL	READ80HFROMDISK				;1E10H
	JZ	ERRWITHSPRFILE				;1E0BH
	LHLD	LINESPRFILE				;21C2H
	LXI	D,7FH
	DAD	D
	DAD	H
	MOV	A,H
	LHLD	BEGINSPRFILE				;21C4H

CLCREADSPRFILE:				;1D8FH
	STA	QBLOCKSPRFILE				;21C8H
	SHLD	ADRLOAD80HSPRFILE			;21C6H
	MOV	B,H
	MOV	C,L
	CALL	BIOSF0C					;1093H
	CALL	READ80HFROMDISK				;1E10H
	JZ	ERRWITHSPRFILE				;1E0BH
	LHLD	ADRLOAD80HSPRFILE			;21C6H
	LXI	D,SYSDMA				;80H
	DAD	D
	LDA	QBLOCKSPRFILE				;21C8H
	DCR	A
	JNZ	CLCREADSPRFILE				;1D8FH
	LHLD	MAXADRESSMINUS80H			;21BCH
	MOV	B,H
	MOV	C,L
	CALL	BIOSF0C					;1093H
	LHLD	LINESPRFILE				;21C2H
	MOV	C,L
	MOV	B,H
	XCHG
	LHLD	BEGINSPRFILE				;21C4H
	XCHG
	DAD	D
	PUSH	H
	MOV	H,D

CLCBITMAPCORRECTION:			;1DC3H
	MOV	A,C
	ORA	B
	JZ	EOBITMAP				;1DF6H
	DCX	B
	MOV	A,E
	ANI	7
	JNZ	NEXTBITFROMBITMAP			;1DE9H
	XTHL
	MOV	A,L
	ANI	7FH
	JNZ	NEXTBITMAPBYTE				;1DE5H
	PUSH	B
	PUSH	D
	PUSH	H
	CALL	READ80HFROMDISK				;1E10H
	POP	H
	POP	D
	POP	B
	LHLD	MAXADRESSMINUS80H			;21BCH
	JZ	ERRREADBITMAP				;1E0AH

NEXTBITMAPBYTE:				;1DE5H
	MOV	A,M
	INX	H
	XTHL
	MOV	L,A

NEXTBITFROMBITMAP:			;1DE9H
	MOV	A,L
	RAL
	MOV	L,A
	JNC	UNCORRECTEDBYTE				;1DF2H
	LDAX	D
	ADD	H
	STAX	D

UNCORRECTEDBYTE:			;1DF2H
	INX	D
	JMP	CLCBITMAPCORRECTION			;1DC3H

EOBITMAP:				;1DF6H
	POP	D

RESETDATAAFTERINPUTSPRFILE:		;1DF7H
	LHLD	COPYADRESDMA				;21BEH
	MOV	B,H
	MOV	C,L
	CALL	BIOSF0C					;1093H
	LHLD	COPYDESYSFUNC				;21C0H
	SHLD	DESYSFUNC				;205BH
	XRA	A
	LHLD	BEGINSPRFILE				;21C4H
	RET

ERRREADBITMAP:				;1E0AH
	POP	D

ERRWITHSPRFILE:				;1E0BH
	CALL	RESETDATAAFTERINPUTSPRFILE		;1DF7H
	DCR	A
	RET

READ80HFROMDISK:			;1E10H
	XRA	A
	STA	RESULT					;210FH
;
; SEQREAD
	CALL	FUN14					;148CH
	JMP	SETTODAYDISKANDREMEMBERRESULT		;033DH
;
; SET DISK :  OUTPUT: <H,L> - ADRES DISK PARAMETER HEADER

BIOSF09:				;1E1AH
	PUSH	B
	CALL	BIOSDPH					;240FH
	POP	B
	MOV	A,L
	ORA	A
	RZ
	MOV	A,C
	STA	DISKDSC					;1FF0H
	RET

BIOSF08:				;1E27H
	MVI	C,0

BIOSF0A:				;1E29H
	LXI	H,TRACK					;1FF4H
	MOV	M,C
	RET

BIOSF0B:				;1E2EH
	LXI	H,SEKTOR				;1FF5H
	MOV	M,C
	RET

BIOSF10:				;1E33H
	MVI	B,0
	XCHG
	DAD	B
	MOV	A,M
	MOV	L,A
	RET

BIOSF0E:				;1E3AH
	MVI	A,6
	JMP	BIOSFRW					;1E41H

BIOSF0D:				;1E3FH
	MVI	A,4

BIOSFRW:				;1E41H
	STA	FUNC					;1FF2H
	MVI	C,0AH

MOREREAD:				;1E46H
	PUSH	B
	LXI	H,COPYDISKDSC				;2082H
	CALL	MAKECOPYDISCDSC				;1E63H
	LXI	H,DISKDSC				;1FF0H
	CALL	BIOSDISKOPERATION			;2412H
	PUSH	PSW
	LXI	H,COPYDISKDSC				;2082H
	CALL	RESETDISKDSC				;1E69H
	POP	PSW
	POP	B
	ORA	A
	RZ
	DCR	C
	JNZ	MOREREAD				;1E46H
	RET

MAKECOPYDISCDSC:			;1E63H
	LXI	D,DISKDSC				;1FF0H
	JMP	COPY10HLDE				;1E6DH

RESETDISKDSC:				;1E69H
	LXI	D,DISKDSC				;1FF0H
	XCHG

COPY10HLDE:				;1E6DH
	MVI	C,0AH
	JMP	COPYCBYTEHLDE				;18DAH

FUN05:					;1E72H
	LHLD	FLAGLIST				;2046H
	JMP	OUTDEVICE				;08BCH

BIOSF0F:				;1E78H
	LHLD	FLAGLIST				;2046H
	JMP	CHECKSTATUSDEVICE			;1E8FH

FROMTOREADCONIN:			;1E7EH
	LXI	H,STATUSCONINFILE			;226AH
	LDA	STATUSCONINBUF				;2310H
	ORA	M
	CPI	0FFH
	RET

BIOSF02:				;1E88H
	CALL	FROMTOREADCONIN				;1E7EH
	RZ

CHECKCONINDEVICESTATUS:			;1E8CH
	LHLD	FLAGCONIN				;203EH

CHECKSTATUSDEVICE:			;1E8FH
	LXI	D,0CH

CLCSTATDEVICE:				;1E92H
	DAD	H
	JC	BIOSCHECKSTATUS				;2406H
	INR	D
	DCR	C
	JNZ	CLCSTATDEVICE				;1E92H
	MVI	A,0
	RET

READSIMBOLCONIN:			;1E9EH
	LDA	STATUSCONINBUF				;2310H
	INR	A
	JZ	CONINFROMBUFER				;1F0DH
	LDA	STATUSCONINFILE				;226AH
	INR	A
	JZ	CONINFROMFILE				;1EBEH

READCONINDEVICE:			;1EACH
	LHLD	FLAGCONIN				;203EH

READCHANEL:				;1EAFH
	LXI	D,0CH

SETREADCHANEL:				;1EB2H
	DAD	H
	JC	BIOSINPUT				;2409H
	INR	D
	DCR	E
	JNZ	SETREADCHANEL				;1EB2H
	MVI	A,1AH
	RET

CONINFROMFILE:				;1EBEH
	CALL	CHECKCONINDEVICESTATUS			;1E8CH
	ORA	A
	JZ	CONINDEVICEISUNREADY			;1ED0H
	CALL	READCONINDEVICE				;1EACH
	CPI	3
	JZ	L1F02					;1F02H
	CALL	L0B47					;0B47H

CONINDEVICEISUNREADY:			;1ED0H
	LXI	H,L226C					;226CH
	MOV	A,M
	MVI	M,0
	ORA	A
	JNZ	L1F03					;1F03H
	LXI	H,DATACONINFILE				;2011H
	CALL	READFROMBUFER				;0B8EH
	MOV	L,A
	JNZ	L1F06					;1F06H
	CALL	CHECKCRLF				;0B31H
	JNZ	L1F03					;1F03H
	PUSH	PSW
	LXI	H,DATACONINFILE				;2011H
	CALL	READFROMBUFER				;0B8EH
	LXI	H,L226C					;226CH
	MVI	M,1AH
	JNZ	L1F02					;1F02H
	MVI	M,0
	CALL	CHECKCRLF				;0B31H
	JZ	L1F02					;1F02H
	MOV	M,A

L1F02:					;1F02H
	POP	PSW

L1F03:					;1F03H
	CPI	1AH
	RNZ

L1F06:					;1F06H
	XRA	A
	STA	STATUSCONINFILE				;226AH
	JMP	READSIMBOLCONIN				;1E9EH

CONINFROMBUFER:				;1F0DH
	LXI	H,COUNTBUFERCONIN			;2311H
	MOV	A,M
	CPI	80H
	JNC	ENDOFCONINBUF				;1F1CH
	CALL	READFROMBUFER				;0B8EH
	MOV	L,A
	ORA	A
	RNZ

ENDOFCONINBUF:				;1F1CH
	XRA	A
	STA	STATUSCONINBUF				;2310H
	JMP	READSIMBOLCONIN				;1E9EH

SETRUSLAT:				;1F23H
	STA	CONINRUSLAT				;1FEFH
	LDA	KOI7KOI8				;2080H
	INR	A
	LDA	CONINRUSLAT				;1FEFH
	RZ
	CALL	CHANGERUSLAT				;1F78H
;
; READ SIMBOL FROM CONSOL (CONIN)

BIOSF03:				;1F31H
	CALL	READSIMBOLCONIN				;1E9EH
	MOV	C,A
	MOV	L,A
	CALL	FROMTOREADCONIN				;1E7EH
	MOV	A,C
	RZ
	CALL	CHECKRUSLAT				;1F72H
	JZ	SETRUSLAT				;1F23H
	LDA	KOI7KOI8				;2080H
	INR	A
	MOV	A,C
	RZ
	CPI	'@'	;40H
	RC
	LXI	H,CONOUTRUSLAT				;1FEEH
	LDA	CONINRUSLAT				;1FEFH
	CMP	M
	CNZ	CHANGEHIGHANDLOWLETTER			;1F5FH
	CPI	0EH
	MVI	A,80H
	JZ	LETTERISRUSSIAN				;1F5CH
	XRA	A

LETTERISRUSSIAN:			;1F5CH
	ORA	C
	MOV	L,A
	RET

CHANGEHIGHANDLOWLETTER:			;1F5FH
	MOV	A,C
	ANI	' '	;20H
	JZ	HIGHLETTER				;1F6AH
	CMA
	ANA	C
	JMP	LOWLETTER				;1F6DH

HIGHLETTER:				;1F6AH
	MVI	A,' '	;20H
	ORA	C

LOWLETTER:				;1F6DH
	MOV	C,A
	LDA	CONINRUSLAT				;1FEFH
	RET

CHECKRUSLAT:				;1F72H
	CPI	0EH
	RZ
	CPI	0FH
	RET

CHANGERUSLAT:				;1F78H
	LXI	H,CONOUTRUSLAT				;1FEEH
	CMP	M
	MOV	M,A
	RZ
	PUSH	B
	MOV	C,A
	CALL	REALCONOUT				;1FA3H
	POP	B
	RET

BIOSF04:				;1F85H
	LDA	KOI7KOI8				;2080H
	INR	A
	MOV	A,C
	JZ	REALCONOUT				;1FA3H
	CALL	CHECKRUSLAT				;1F72H
	JZ	CHANGERUSLAT				;1F78H
	CPI	'@'	;40H
	JC	REALCONOUT				;1FA3H
	RAL
	MVI	A,0EH
	JC	RUSLETTER				;1FA0H
	MVI	A,0FH

RUSLETTER:				;1FA0H
	CALL	CHANGERUSLAT				;1F78H

REALCONOUT:				;1FA3H
	PUSH	B
	MVI	D,0
	CALL	BIOSOUTPUT				;240CH
	POP	B
	LDA	PRIZNAKCONOUTFILE			;230EH
	INR	A
	LXI	H,DATACONOUTFILE			;2016H
	CZ	WRITETOBUF				;0C1BH
	RZ

CLOSECONOUTFILE:			;1FB5H
	LDA	PRIZNAKCONOUTFILE			;230EH
	INR	A
	RNZ
	LDA	USER					;2060H
	PUSH	PSW
	LDA	USERCONOUTFILE				;230FH
	STA	USER					;2060H
	MVI	A,0FFH
	STA	STATUSFROMORTOBUFER			;201BH
	LXI	H,DATACONOUTFILE			;2016H
	MOV	A,M
	CPI	0
	CNZ	RDWR80HFORCONSOLFILES			;0BBBH
	XRA	A
	STA	RESULT					;210FH
	LXI	H,FCBCONOUTFILE				;22EDH
	SHLD	DESYSFUNC				;205BH
	XCHG
;
; CLOSE FILE
	CALL	FUN10					;1354H
	CALL	SETTODAYDISKANDREMEMBERRESULT		;033DH
	XRA	A
	STA	PRIZNAKCONOUTFILE			;230EH
	POP	PSW
	STA	USER					;2060H
	RET

PRIZNAKDELETEDFILES:			;1FECH
	DB	0E5H
;
; 0 ==> RESTART AFTER DISK ERROR, -1 ==> QUEST OF MAN

FLAGQUESTFORDISKERROR:			;1FEDH
	DB	0FFH

CONOUTRUSLAT:				;1FEEH
	DB	0FH
;
; 0FH --> LAT  /  0EH --> RUS

CONINRUSLAT:				;1FEFH
	DB	0FH
;
; FOR FUN8232

DISKDSC:				;1FF0H
	DB	0

CHWORD:					;1FF1H
	DB	80H

FUNC:					;1FF2H
	DB	4

NUMB:					;1FF3H
	DB	1

TRACK:					;1FF4H
	DB	2

SEKTOR:					;1FF5H
	DB	1

ABUFF:					;1FF6H
	DW	SYSDMA					;80H

HTRACK:					;1FF8H
	DB	0

HSEKTOR:				;1FF9H
	DB	0

DSCREADTO100H:				;1FFAH
	DB	0
	DW	COPYFCB					;2194H
	DW	0100H
	DW	BDOSBEGIN				;0200H

FCBCCP:					;2001H
	DB	0,'CCP        ',0,0,0,0

DATACONINFILE:				;2011H
	DB	0
	DW	DMACONINFILE				;21C9H
	DW	FCBCONINFILE				;2249H

DATACONOUTFILE:				;2016H
	DB	0
	DW	DMACONOUTFILE				;226DH
	DW	FCBCONOUTFILE				;22EDH

STATUSFROMORTOBUFER:			;201BH
	DB	0
;
; CONTROL SYSTEM BLOCK (100 BYTE) 

CSB:					;201CH
	DB	0,0,0,0,0

VERSION:				;2021H
	DB	'1'

FLAGSOFUSERPROGRAM:			;2022H
	DB	0,0,0,0

DATASTRING:				;2026H
	DB	0,0,0,0,0,0

CODEOFRETURN:				;202CH
	DW	0
	DB	0,0,0,0,0,0,0,0

WIDTHCONSOL:				;2036H
	DB	'P'

COLUMN:					;2037H
	DB	0

LINECONSOL:				;2038H
	DB	18H
	DB	0,0,0,0,0

FLAGCONIN:				;203EH
	DW	8000H

FLAGCONOUT:				;2040H
	DW	8000H

FLAGAUXIN:				;2042H
	DW	2000H

FLAGAUXOUT:				;2044H
	DW	2000H

FLAGLIST:				;2046H
	DW	4000H
	DB	0,0,0,0,0,0,0

L204F:					;204FH
	DW	0
	DB	0,0

EOSTRINGCHAR:				;2053H
	DB	'$'

COPYTOPRINTER:				;2054H
	DB	0
	DB	0,1CH,' '

ADRDMA:					;2058H
	DW	SYSDMA					;80H

DEFAULTDISK:				;205AH
	DB	0

DESYSFUNC:				;205BH
	DW	0

FLAGFORSETREADTODAYDISK:		;205DH
	DB	0,0

CSYSFUNC:				;205FH
	DB	0

USER:					;2060H
	DB	0

CODEDIR:				;2061H
	DW	0

FCBFORSEARCH:				;2063H
	DW	0
	DB	0

MULTISEKTORCOUNT:			;2066H
	DB	1

ERRORREGIM:				;2067H
	DB	0

SYSTEMDISK:				;2068H
	DB	0
	DB	0,0,0,0,0,0,0,0,0,0,0

DATA:					;2074H
	DB	0,0,0,0,0
	DB	0,0,0,0,0,0,0
;
; 0 --> KOI8  /  -1 --> KOI7

KOI7KOI8:				;2080H
	DB	0FFH
;
; -1 ==> EXCHANGE CANNOT USED

STATUSEXCHANGECONSOLE:			;2081H
	DB	0

COPYDISKDSC:				;2082H
	DS	000AH

COPY2DISKDSC:				;208CH
	DS	002AH
	DB	0,0

SUMSPR:					;20B8H
	DB	0,0

ADRESSPRPROGRAM:			;20BAH
	DW	0

L20BC:					;20BCH
	DW	0

SPRSTATUS:				;20BEH
	DB	0

ONLYREADSTATUSVECTOR:			;20BFH
	DW	0

DISKSTATUSVECTOR:			;20C1H
	DW	0

ADRQELEMNDIR:				;20C3H
	DW	0

ADRTRACKNOW:				;20C5H
	DW	0

ADRSECTOTRACKNOW:			;20C7H
	DW	0

DIRBUFDEFDISK:				;20C9H
	DW	0

ADRDPBDEFDISK:				;20CBH
	DW	0

ADRCSVDEFDISK:				;20CDH
	DW	0

ADRALVDEFDISK:				;20CFH
	DW	0

DPBDEFDISK:				;20D1H
	DW	0
	DB	0
	DB	0
	DB	0
	DW	0
	DW	0
	DB	0
	DB	0
	DW	0
	DW	0

XLTDEFAULTDISK:				;20E0H
	DW	0

L20E2:					;20E2H
	DB	0

FLAGFFR00W:				;20E3H
	DB	0

RESFINDFILE:				;20E4H
	DB	0
;
; 0==> DIRECT WR/RD, 1==> SEQUAL WR/RD, 2==> WRITE WITH ZERO FILL

FLAG0D1S2W0:				;20E5H
	DB	0

SYSEPARAM:				;20E6H
	DB	0

SHIFTINFCBBLOCKFIELD:			;20E7H
	DB	0

REGCHERE:				;20E8H
	DB	0
;
; VOLUME DISK IN BLOCK : -1 ==> VDIB < 100H / 0 ==> VDIB >=100H

STATUSBIGQBLOCKONDEFDISK:		;20E9H
	DB	0
;
; DISK WAS ESTABLISHED BY DISK OPERATIONS 
;  (FROM FCB, THEN USER=0, THEN DISK:=A AND USER 0

READTODAYDISK:				;20EAH
	DB	0

REMEMBERDEFDISK:			;20EBH
	DB	0

COPYDEFDISK:				;20ECH
	DB	0

C4:					;20EDH
	DB	0

EXMANDZK:				;20EEH
	DB	0

TZ:					;20EFH
	DW	0
;
; NUMBER FOR 128 BYTE SUBBLOCK

NUMBER128BL:				;20F1H
	DW	0
;
; NUMBER FOR 128 BYTE SUBBLOCK (FIRST SUBBLOCK OF BLOCK)

NUMBFIRST128BLFORBLOCK:			;20F3H
	DW	0

SHIFTINDIRECTORY:			;20F5H
	DB	0

L20F6:					;20F6H
	DB	0

NSECINDIR:				;20F7H
	DW	0

ADREXDSC:				;20F9H
	DW	0

EXDSC:					;20FBH
	DB	0
	DW	0
	DW	0
	DW	0

ADRCOPYDMA:				;2102H
	DW	0

BEGINOFCOMAND:				;2104H
	DW	0

REALBEGINOFCOMAND:			;2106H
	DW	0

STATUSSHOWFILENAMEINBDOSMSG:		;2108H
	DB	0

CLMNENDSTRING:				;2109H
	DB	0

CLMNBEGINSTRING:			;210AH
	DB	0

SMBLFROMCONINTODAY:			;210BH
	DB	0

USERSTACKSTORE:				;210CH
	DW	0

LASTDEFAULTDISK:			;210EH
	DB	0

RESULT:					;210FH
	DB	0,0
;
; 00 --> NORMAL OPERATION WITH DISK

STATUSDISK:				;2111H
	DB	0

L2112:					;2112H
	DB	0

COMANDBUFER:				;2113H
	DB	0
	DB	0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0

COPYFCB:				;2194H
	DB	0
	DB	0
	DB	0,0,0
	DB	0,0,0,0
	DB	0,0,0
	DB	0
	DB	0
	DB	0
	DB	0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0
	DB	0
	DB	0,0,0

MAXADRESS:				;21B8H
	DW	0

ADRESFCB:				;21BAH
	DW	0

MAXADRESSMINUS80H:			;21BCH
	DW	0

COPYADRESDMA:				;21BEH
	DW	0

COPYDESYSFUNC:				;21C0H
	DW	0

LINESPRFILE:				;21C2H
	DW	0

BEGINSPRFILE:				;21C4H
	DW	0

ADRLOAD80HSPRFILE:			;21C6H
	DW	0

QBLOCKSPRFILE:				;21C8H
	DB	0

DMACONINFILE:				;21C9H
	DS	0080H

FCBCONINFILE:				;2249H
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0
	DB	0

STATUSCONINFILE:			;226AH
	DB	0

USERCONINFILE:				;226BH
	DB	0

L226C:					;226CH
	DB	0

DMACONOUTFILE:				;226DH
	DS	0080H

FCBCONOUTFILE:				;22EDH
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0
	DB	0
;
; 0 --> NOT OPEN,  -1 --> OPEN CONOUTFILE

PRIZNAKCONOUTFILE:			;230EH
	DB	0

USERCONOUTFILE:				;230FH
	DB	0

STATUSCONINBUF:				;2310H
	DB	0

COUNTBUFERCONIN:			;2311H
	DB	0

ADRCONINBUFER:				;2312H
	DB	0,0

L2314:					;2314H
	DB	0,0,0

STATUSCTRLD:				;2317H
	DB	0,0,0

STACKCTRLD:				;231AH
	DW	0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0

SYSTEMSTACK:				;2376H
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0

COPYOFMULTISEKTORCOUNT:			;23BCH
	DB	0

USERSTACK:				;23BDH
	DW	0
	DB	0,0,0,0,0,0,0,0,0,0

STACKFORSYSTEMFUNC:			;23C9H
	DB	0,0,0,0,0,0,0,0,0,0

STACKTOUSERPROGRAM:			;23D3H
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0

BIOSBEGIN:				;2400H
	END
