

;	    V23
;  -----------------------------------

	maclib	TEST
	IF	TEST = 1
	Common	/bufers/
	db	'bufers		v.1.17	28-dec-93$'
	ENDIF

extrn	File

	DSeg

SizeBuf	equ	100h		; 2K

	ASeg
	org	0f000h-2*SizeBuf

BufIn:
	ds	SizeBuf

BufMiddle:
;	ds	100h

BufOut:
	ds	SizeBuf

EoB:

	DSeg

public	WrtOut, ReadOut, CountOut
WrtOut:					;     
	ds	2
ReadOut:				;     
	ds	2
CountOut:				;    
	ds	2


public	WrtIn, ReadIn, CountIn
WrtIn:					;     
	ds	2
ReadIn:					;     
	ds	2
CountIn:				;    
	ds	2



	CSeg

;        128 

public	FreeBlk
FreeBlk:
	lhld	File
	xchg
	lxi	h,BufIn
	call	HLsubDE
	mov	l,h		;   256 
	mvi	h,0
	dad	h		;   128 
	ret

;   

public	IniBIn, IniBOut, ClrBuf
IniBIn:
	lxi	h,BufIn
	shld	WrtIn
	shld	ReadIn
	lxi	h,0
	shld	CountIn
	ret

IniBOut:
	lxi	h,BufOut
	shld	WrtOut
	shld	ReadOut
	lxi	h,0
	shld	CountOut
	ret

ClrBuf:
	lxi	h,BufIn
	lxi	d,EoB-BufIn
	mvi	m,0
	inx	h
	dcx	d
	mov	a,d
	ora	e
	jnz	$-6
	ret


;      Out
;  :
;    <hl> -     Out

public OutHowMany
OutHowMany:
	lhld	CountOut
	ret

;      In
;  :
;      Z=1  <A> -      
;  :
;      <hl>

public	FromIn
FromIn:
	lhld	CountIn
	mov	a,h
	ora	l
	rz
	dcx	h
	shld	CountIn

	lhld	ReadIn
	mov	a,m
	push	psw
	inx	h
	mov	a,h
	cpi	High BufMiddle
	jnz	Bound
	mvi	h,High BufIn
Bound:	shld	ReadIn
	pop	psw
	ret

;   
;  :
;    <> -  
;  :
;     <hl>  <de>

extrn	HLDE
public	FindCredit
FindCredit:
	lhld	CountIn
	xchg
	lxi	h,SizeBuf
	call	HLsubDE		; <hl> - 
	lxi	d,80h
	call	HLDE		;  > 80h ?
	mvi	a,80h
	rnc
	mov	a,l
	ret
	
;      Out
;  :
;    <a> - 
;  :
;      Z=1     
;  :
;     <hl>, <c>

public	ToOut
ToOut:
	mov	c,a
	lhld	CountOut
	mov	a,h
	cpi	High SizeBuf
	rz
	push	psw
	inx	h
	shld	CountOut
	lhld	WrtOut
	mov	m,c
	inx	h
	mov	a,h
	cpi	High EoB
	jnz	Bound2
	mvi	h,High BufOut
Bound2:	shld	WrtOut
	pop	psw
	ret


;      Out
;  :
;    <hl> - 
;    <de> - 
;  :
;    <hl> -   

public	ToBigBufer
ToBigBufer:
	push	h		; 
	lhld	CountOut
	dad	d
	mov	a,h
	cpi	High SizeBuf
	jc	GoodPlace
	lhld	CountOut	;   
	xchg
	lxi	h,SizeBuf
	call	HLsubDE
	xchg
	lxi	h,SizeBuf
GoodPlace:
	shld	CountOut
	pop	b		; 
	push	d		; 
	lhld	WrtOut		; 
clTBB:
	mov	a,d
	ora	e
	jz	exTBB
	ldax	b
	mov	m,a
	inx	h
	inx	b
	dcx	d
	mov	a,h
	cpi	High EoB
	jnz	$+5
	mvi	h,High BufOut
	jmp	clTBB
exTBB:
	shld	WrtOut
	pop	h
	ret


;      In
;  :
;    <hl> - 
;    <de> - 
;  :
;    <hl> -   

public	FromBigBufer
FromBigBufer:
	push	h		; 
	lhld	CountIn
	call	HLsubDE
	jnc	ManyPlace
	lhld	CountIn		;     
	xchg
	lxi	h,0
ManyPlace:
	shld	CountIn
	pop	b		; <bc> - 
	push	d		; <de> - 
	lhld	ReadIn		; <hl> - 
clFBB:
	mov	a,d
	ora	e
	jz	exFBB
	mov	a,m
	stax	b
	inx	h
	inx	b
	dcx	d
	mov	a,h
	cpi	High BufMiddle
	jnz	$+5
	mvi	h,High BufIn
	jmp	clFBB
exFBB:
	shld	ReadIn
	pop	h
	ret

public	HLsubDE
HLsubDE:
	mov	a,l
	sub	e
	mov	l,a
	mov	a,h
	sbb	d
	mov	h,a
	ret

;--------------------------------------------------

;    IN  Out   

DLE		equ	10h
STX		equ	02h
ETX		equ	03h

public	ToModem
ToModem:				;     
	ds	2			;     Out  

;         IN
;  :
;    <hl> -     

public	RcvInfo
RcvInfo:
	xchg
	lhld	CountIn		; .     IN
	mov	b,h
	mov	c,l
	lhld	WrtIn

InCopy:
	ldax	d		;     IN  

	inx	d
	cpi	ETX
	jz	ExitChInfo

	cpi	DLE
	jnz	$+5
	ldax	d
	inx	d

	mov	m,a
	inx	h
	mov	a,h
	cpi	High BufMiddle
	jnz	$+5
	mvi	h,High BufIn

	inx	b		;      In
	jmp	InCopy

ExitChInfo:
	shld	WrtIn

	mov	h,b
	mov	l,c
	shld	CountIn
	ret


;   

public ResFree
ResFree:
	lhld	ToModem
	mov	a,l
	ora	h
	rz				;     ?

	xchg
	lhld	CountOut		;  - 
	call	HLsubDE
	shld	CountOut

	lhld	ReadOut			;    
	dad	d
	mov	a,h
	cpi	High EoB
	jc	$+5
	mvi	h,High BufOut
	shld	ReadOut

	lxi	h,0
	shld	ToModem
	mvi	a,-1
	ora	a
	ret


;      
;  :
;    <hl> -      
;    <b> - max    
;    <c> -    
;  :
;    ToModem

public	SendInfo
SendInfo:
	push	b
	xchg
	lhld	ReadOut			; 
	xchg

CopyInf:
	ldax	d
	cpi	DLE
	jz	Special
	cpi	STX
	jz	Special
	cpi	ETX
	jnz	Ordinary
Special:
	mvi	m,DLE
	inx	h
	dcr	b
Ordinary:
	mov	m,a
	inx	h
	inx	d
	mov	a,d
	cpi	High EoB
	jnz	$+5
	mvi	d,High BufOut

	dcr	c
	jz	EoM			;   ?

	dcr	b
	jp	CopyInf			;  max    ?

EoM:
	mov	a,c			;   .  ?
	pop	b
	sub	c
	cma
	inr	a
	sta	ToModem			;     
					;   
	ret


	end


