
;****************************************	**************
;		~asy				   osnownye
;  -----------------------------------		 ------------
;  wers.2.6		data:03-MAR-92		 podprogrammy
;****************************************	**************

;	MACLIB	TV
	MACLIB	CLOCK

PUBLIC	PREPCI,RETCI,CHDIG,CHPLACE,HLSHOW,FINDALARM
	IF	TEST
PUBLIC	HLSUBDE
PUBLIC	DAYINMONTH
PUBLIC	DAYPERMONTH
PUBLIC	EXSHOW
PUBLIC	CLES
PUBLIC	INTOIND
PUBLIC	PLACETOIND
PUBLIC	TPREP
PUBLIC	PREP0,PREP1,PREP2,PREP3,PREP4,ASCLOCK,ASNORM,UBNORM
PUBLIC	SACHAR
PUBLIC	SUBMODDEHL
PUBLIC	DECHEX
PUBLIC	PREPDATA
PUBLIC	GOTOI
PUBLIC	HOURFROMIND
PUBLIC	CHECKHL
PUBLIC	HLFROMIND
PUBLIC	HEXDEC
PUBLIC	TRET
PUBLIC	RET0,RET1,RET2,RET3,RET4
	ENDIF
CORRECT	MACRO			; makroopredelenie smeny wremeni
	MOV	A,B		; sdwig po wremeni
	ORA	A
	RZ
	MVI	B,0
	ADD	M
	CMP	C		; granica o~erednoj weli~iny
	JC	$+5		;  dlq sek. i min... 60
	SUB	C		;  dlq ~as. ........ 24
	INR	B
	MOV	M,A
	ENDM

	CSEG

PUBLIC	IRQCLOCK
IRQCLOCK:
	DI

;	LDA	BUFPORTD	;GATE1:=0
;	ANI	11110111B	;
;	OUT	PD		;

;	IN	15H
;	MOV	E,A
;	IN	15H
;	MOV	D,A

;	LDA	BUFPORTD	;GATE1:=1
;	ORI	00001000B	;	
;	OUT	PD		;

	LXI	D,2998
	LXI	H,TIMER2+2
	CALL	HLSUBDE

	REPT	2
	ORA	A
	MOV	A,H
	RAR
	MOV	H,A
	MOV	A,L
	RAR
	MOV	L,A
	ENDM
	JNC	$+4
	INR	L

	LXI	D,COUNT
	MVI	B,-1
	INR	B
	MOV	C,L
	CALL	HLSUBDE
	JNC	$-5

	LHLD	TAKT		; pods~et 4 MS taktow
	MOV	A,L
	SUB	C
	JZ	$+6
	JNC	$+6
	ADI	COUNT
	INR	B
	MOV	L,A

	MOV	A,H
	ANI	7FH
	MOV	H,A
	MVI	A,COUNT/2	; priznak 1/2 sek
	CMP	L
	MOV	A,H
	JNC	$+6
	ORI	80H		; < 1/2
	MOV	H,A
	SHLD	takt

	LXI	H,SEC
	MVI	C,60
	CORRECT			; sekundy

	INX	H
	CORRECT			; minuty

	INX	H
	MVI	C,24
	CORRECT			; ~asy

	INX	H
	MOV	D,B		; <D> - poprawka w dnqh
	MVI	C,7
	CORRECT			; dni nedeli
	MOV	B,D

	INX	H		; skolxko dnej w mesqce
	MOV	A,M
	CALL	DAYINMONTH
	MOV	C,A
	INX	H
	CORRECT

	DCX	H
	MVI	C,12
	CORRECT		; mesqc

				; mesto dlq prowerki budilxnikow
	RET

HLSUBDE:
	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	RET

;  ~islo dnej w mesqce
;  whod:
;    <A> - mesqc 0..11
;  wyhod:
;    <a> - ~islo dnej w mesqce

DAYINMONTH:
	PUSH	H
	LXI	H,DAYPERMONTH
	CALL	HLADDA
	MOV	a,M
	POP	H
	RET

DAYPERMONTH:
	DB	31	; qnwarx
	DB	28	; fewralx
	DB	31	; MART
	DB	30	; aprelx
	DB	31	; maj
	DB	30	; i`nx
	DB	31	; i`lx
	DB	31	; awgust
	DB	30	; sentqbrx
	DB	31	; oktqbrx
	DB	30	; noqbrx
	DB	31	;dekabrx



;   ustanowka i wywod bufera-kopii indikatora
;  -------------------------------------------


;  podgotowitx bufer-kopi` indikatora

PREPCI:
	CALL	PREPDATA

	LDA	FS		; ustanowitx s~et~iki ustanowki
	ANI	11000000B	;   dlq miganiq razdelitelem
	ORA	E
	STA	FS

	MOV	A,D
	XCHG
	LXI	H,COPYIND
	MOV	M,A		; denx nedeli ili probel
	INX	H
	MOV	M,B		; prawyj razdelitelx
	LXI	H,COPYIND+4
	MOV	M,C		; lewyj razdelitelx

	MOV	A,D		; wywod pokazanij tipa 00 00
	CALL	DECHEX		; <DE> - lew. i praw. ~isla
	SHLD	COPYIND+2
	MOV	A,E
	CALL	DECHEX
	SHLD	COPYIND+5
	RET

;  wywesti bufer-kopi` w pamqtx

HLSHOW:
	LDA	TAKT+1			; migatx s ~astotoj 1 sek
	ORA	A
	MVI	C,-1			; ne gasitx
	JP	EXSHOW

	PUSH	H			; ukazatx mesto dlq ga{eniq
	CALL	PLACETOIND
	MOV	C,M
	POP	H

EXSHOW:
	XCHG
	LXI	H,COPYIND
	MVI	B,0

CLES:
	MOV	A,B
	CMP	C
	MOV	A,M
	JNZ	$+5
	MVI	A,SPACE		; pogasitx |to znakomesto

	ORA	A		; zamenitx cifru 0 na literu 0 dlq indikatora
	JNZ	$+5
	MVI	A,10

	STAX	D
	INX	D
	INX	H
	INR	B
	MOV	A,B
	CPI	7
	JNZ	CLES
	RET


INTOIND:				; mesto cifr w indikatore
	DB	2,3,5,6,0,4,-1,-1

PLACETOIND:
	LDA	FS
	ANI	00000111B
	LXI	H,INTOIND

PUBLIC	HLADDA
HLADDA:
	ADD	L
	MOV	L,A
	RNC
	INR	H
	RET

; adresa podprogramm podgotowki dannyh

TPREP:
	IRPC	N,01234
	DW	PREP&N
	ENDM

;  podprogramy podgotowki dannyh
;  wyhod:
;    <HL> - dannye dlq bufera-kopii (HEX ~isla)
;    <DE> - dlq dnq nedeli i ~em migatx
;    <BC> - razdeliteli


PREP0:				; budilxniki
	CALL	FINDALARM
	MOV	E,M		; minuty
	INX	H
	MOV	D,M		; ~asy
	INX	H
	XCHG

	ORA	A		; budilxnik 0 wywesti kak ~asy
	JZ	ASCLOCK
	
	LDAX	D		; denx nedeli
	CALL	SACHAR		; razdeliteli po tek. budilxniku

	MVI	E,5*8+5		; 5 pozicij dlq pereustanowki
	JMP	ASNORM

PREP1:				; ~asy
	LHLD	MIN
ASCLOCK:
	LDA	AWEEK
	CALL	SACHAR			; razdeliteli po osn.budilxniku
	LXI	D,SPACE*100H+4*8+5	; 4 pozicii dlq pereustanowki
	RET

PREP2:				; opredelenie pokazanij sekundomera
	PUSH	H		; zarezerwirowatx mesto w steke
	LXI	H,SSEC
	LXI	D,SEC
	MVI	B,60
	ORA	A
	CALL	SUBMODDEHL
	XTHL
	MOV	L,A		; sekundy
	XTHL
	CALL	SUBMODDEHL
	XTHL
	MOV	H,A		; minuty
	XTHL
	MVI	B,24
	CALL	SUBMODDEHL	
	ANI	0FH		; ~asy
	POP	H
	LXI	B,MINUS*100H+MINUS
	DCR	A		; dalee budet INR A (dlq dnq nedeli)
	JMP	UBNORM		; ne migatx i zapret pereustanowki

PREP3:				; data
	LHLD	MONTH
	LDA	WEEK
	INR	H
	INR	L
	LXI	B,SPACE*100H+POINT
	MVI	E,5*8+5		; 5 pozicii dlq pereustanowki
	JMP	ASNORM

PREP4:				; wremq wyzowa + denx nedeli
	LHLD	MIN
	LDA	WEEK
	LXI	B,SPACE*100H+MINUS

UBNORM:				; ne migatx sowsem
	MVI	E,6		; i nelxzq wkl. pereustanowku
ASNORM:
	INR	A		; denx nedeli (0..7) --> (1..7,0)
	ANI	00000111B
	MOV	D,A
	RET

;  najti adres dannyh dlq budilxnika
;  wyhod:
;    <HL> - adres 3-h bajt dannyh budilxnika
;    <A> - nomer budilxnika

FINDALARM:
	LDA	FI
	ANI	00001111B
	CPI	11
	JC	$+4
	XRA	A		; budilxniki 11..15 obrabotatx kak 0

	PUSH	B
	MOV	B,A
	ADD	A
	ADD	B
	MOV	C,A
	MOV	A,B		; wosstanowitx nomer budilxnika
	MVI	B,0
	LXI	H,TALARM-3
	DAD	B
	POP	B
	RET

;  razdeliteli dlq budilxnika

SACHAR:
	ORA	A
	LXI	B,SPACE*100H+MINUS		; budilxnik wykl.
	RP
	MVI	C,ALARMCH	; budilxnik wkl.
	RET

;  wy~itanie po modul`
;  whod:
;    flag C - zaem
;    <B> - modulx
;    <DE> - adres umenx{aemogo
;    <HL> - adres wy~itaemogo
;  wyhod:
;    <A>:=MOD([DE]-[HL],[B])
;

SUBMODDEHL:
	LDAX	D
	SBB	M
	INX	H
	INX	D
	RNC
	ADD	B
	STC
	RET

;  perewesti HEX w DEC
;  whod:
;    <A> - HEX dannoe
;    <LH> - DEC ~islo (ostorovno: obratnaq adresaciq)

DECHEX:
	MVI	L,-1
	SUI	10
	INR	L
	JNC	$-3
	ADI	10
	MOV	H,A
	RET

;  podgotowka dannyh dlq wywoda na indikator dlq wseh revimow indikacii

PREPDATA:
	LXI	H,TPREP

;  wyzow podprogrammy iz tablicy po nomeru revima
;  whod:
;    <HL> - adres tablicy perehodow

GOTOI:
	LDA	FI
	ANI	01110000B
	RRC
	RRC
	RRC
	CPI	5*2
	JC	$+5
	MVI	A,2		; newernye revimy obrabotatx kak ~asy

	MOV	E,A
	MVI	D,0
	DAD	D
	MOV	A,M
	INX	H
	MOV	H,M
	MOV	L,A
	PCHL

;   izmenenie i wozwrat dannyh iz bufera-kopii indikatora
;  -------------------------------------------------------

;  zamena cifry w bufere-kopii
;  whod:
;    <a> - cifra

CHDIG:
	MOV	C,A
	CALL	PLACETOIND
	MOV	A,M
	LXI	H,COPYIND
	CALL	HLADDA
	MOV	M,C

;  smena mesta dlq zameny

CHPLACE:
	LDA	FS
	MOV	C,A

	ANI	00111000B	; maks. zna~enie s~et~ika
	RRC
	RRC
	RRC
	MOV	B,A

	MOV	A,C		; smena mesta dlq zameny
	INR	A
	ANI	00000111B
	CMP	B
	JNZ	$+4
	XRA	A
	MOV	C,A

	LDA	FS
	ANI	11111000B
	ORA	C
	STA	FS
	RET

;  podgotowka i prowerka ~asow

HOURFROMIND:
	CALL	HLFROMIND
	LXI	B,24*100H+60

;  prowerka dannyh
;  whod:
;    <BC> - granica lew. i praw. ~isel (MAX)
;    <HL> - prowerqemye dannye
;  wyhod:
;    <A> := <L> !!!
;    flag C=0 - o{ibka w dannyh

CHECKHL:
	MOV	A,H
	CMP	B
	RNC
	MOV	A,L
	CMP	C
	RET

;  preobrazowatx dannye iz bufera w HEX formu
;  wyhod:
;    <HL> - lew. i praw. HEX ~isla (esli net o{ibki w dannyh)

HLFROMIND:
	LHLD	COPYIND+5
	CALL	HEXDEC
	MOV	E,A
	LHLD	COPYIND+2
	CALL	HEXDEC
	MOV	D,A
	XCHG
	RET

;  preobrazowatx DEC w HEX
;  whod:
;    <LH> - DEC (ostorovno: obratnaq adresaciq)
;  wyhod:
;    <A> - HEX

HEXDEC:
	MOV	A,L
	ADD	A
	ADD	A
	ADD	L
	ADD	A
	ADD	H
	RET

;  prowerka i wozwrat dannyh dlq wseh revimow
;  wyhod:
;    flag C=0 - dannye ne wozwra}eny iz-za o{ibki w nih

RETCI:
	LXI	H,TRET
	JMP	GOTOI

TRET:
	IRPC	N,01234
	DW	RET&N
	ENDM

RET0:				; budilxniki
	CALL	HOURFROMIND
	RNC
	XCHG
	CALL	FINDALARM
	MOV	M,E		; minuty
	INX	H
	MOV	M,D		; ~asy
	INX	H
	ORA	A
	STC
	RZ			; dlq budilxnika 0 tolxko ~~-mm

	LDA	COPYIND
	CPI	8
	RNC
	DCR	A		; denx nedeli 7(na ind - 0): evedn. budilxnik
	ANI	00000111B
	MOV	B,A
	MOV	A,M
	ANI	80H		; sohranitx status budilxnika
	ORA	B
	MOV	M,A		; denx nedeli (7 - razre{en)
	STC
	RET

RET1:				; ~asy
	CALL	HOURFROMIND
	RNC
	SHLD	MIN
	LXI	H,COUNT		; sbrositx s~et~ik i sekundy
	SHLD	TAKT
	XRA	A
	STA	SEC
RET2:				; sekundomer ne obrabatywatx
RET4:				; spec. wremq ne obrabatywatx
	STC			; priznak norm. wozwrata
	RET

RET3:				; data i denx nedeli
	CALL	HLFROMIND
	DCR	H
	DCR	L
	MVI	C,12
	MOV	A,L
	CALL	DAYINMONTH
	MOV	B,A
	CALL	CHECKHL
	RNC

	LDA	COPYIND		; proweritx denx nedeli
	DCR	A
	CPI	7		; movno (1..7)-1
	RNC

	STA	WEEK
	SHLD	MONTH
	RET


	END
