
;      wwod/wywod fajlow dlq SNC ==> wektor
;  -------------------------------------------
;  wers.1.2			data:29-MAY-92

PRINT	MACRO	TEXT
	LXI	D,TEXT
	MVI	C,9
	CALL	5
	ENDM

EXTRN	SNCSCR,VECSCR

	CSEG

;  wwod |krana SINCLAIR

PUBLIC	PREPSNC
PREPSNC:
	LXI	D,FCBIN
	CALL	COPYNAME

	LXI	D,FCBOUT
	CALL	COPYNAME

	LDA	6CH		; disk celi ukazan qwno ?
	ORA	A
	JZ	$+6
	STA	FCBOUT		; ustanowitx disk celi

	LXI	H,5CH+1
	MOV	A,M
	CPI	' '
	JZ	USAGE		; bez parametrow ?

	LXI	H,5CH+9
	MOV	A,M
	CPI	' '
	JNZ	ERRPA		; ukazano ras{irenie ?

	LXI	H,6CH+1
	MOV	A,M
	CPI	' '
	JZ	NEXTC		; estx wtoroj parametr ?

	CPI	'/'
	JNZ	ERRPA
	INX	H
	MOV	A,M
	CPI	'S'
	JNZ	ERRPA
	MVI	A,-1		; wtoroj parametr /S - tolxko na |kran
	STA	SCREEN

NEXTC:
	LXI	H,6CH+9
	MOV	A,M
	CPI	' '
	JNZ	ERRPA		; ukazano ras{irenie ?

	LXI	H,5CH+1
	CALL	CHECKQ
	JZ	ERRQ		; neqwnoe imq ?

	LXI	D,IDSC
	MVI	C,50
	CALL	5		; wwod fajla
	ORA	A
	JZ	CHECKLINE
	LXI	D,RDERR1
	CPI	1
	JZ	EXERR
	LXI	D,RDERR2
	CPI	2
	JZ	EXERR
	LXI	D,RDERR
EXERR:
	MVI	C,9
	CALL	5
	PRINT	TADD
	JMP	0

PUBLIC	CHECKLINE
CHECKLINE:
	LHLD	SNCSCR-3
	LXI	D,1B02H
	CALL	HLDE
	RZ

	LXI	D,TERRL
	JMP	EXERR

PUBLIC	HLDE
HLDE:
	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET

ERRQ:
	LXI	D,TQERR
	JMP	EXERR

ERRPA:
	LXI	D,TERRPA
	JMP	EXERR

	DSEG

TERRL:
	DB	1BH,5CH
	DB	0DH,0AH
	DB	'o{ibka: dlina fajla ne sootwetstwuet dampu SNC |krana'
	DB	0DH,0AH,'$'
TADD:
	DB	'dlq dopolnitelxnoj informacii: SNCSCR <wk>',0DH,0AH,'$'

TQERR:
	DB	1BH,5CH
	DB	0DH,0AH
	DB	'o{ibka: neqwnoe imq fajla',0DH,0AH,'$'

TERRPA:
	DB	1BH,5CH
	DB	0DH,0AH
	DB	'o{ibka: newerno zadany parametry',0DH,0AH,'$'

	CSEG

PUBLIC	COPY,COPYNAME
COPYNAME:
	LXI	H,5CH
	LXI	B,9
COPY:
	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	COPY
	RET

CHECKQ:
	MVI	B,8		; prowerka na '?'
CQ:	MOV	A,M
	CPI	'?'
	RZ
	INX	H
	DCR	B
	JNZ	CQ
	ORA	A
	RET

;  wywod rezulxtata

PUBLIC	SAVESCR
SAVESCR:
	LDA	SCREEN
	ORA	A
	JNZ	SHOWSCREEN

	LXI	D,FCBOUT
	MVI	C,19		; udalitx nezawer{ennyj fajl
	CALL	5
	LXI	H,FCBOUT+12
	MVI	M,0
	LXI	H,FCBOUT+32
	MVI	M,0
	LXI	D,ODSC
	MVI	C,50
	CALL	5
	ORA	A
	JZ	CLOSE

	LXI	D,WRERR1
	CPI	1
	JZ	WEXERR
	LXI	D,WRERR2
	CPI	2
	JZ	WEXERR
	LXI	D,WRERR
WEXERR:
	PUSH	D
	LXI	D,FCBOUT
	MVI	C,19		; udalitx nezawer{ennyj fajl
	POP	D
	JMP	EXERR

CLOSE:
	LXI	D,FCBOUT		; zakrytx fajl
	MVI	C,16
	CALL	5
	JMP	0

;  primer ispolxzowaniq

PUBLIC	USAGE
USAGE:
	PRINT	TXTUSAGE
	JMP	0

	DSEG

PUBLIC	FCBIN,FCBOUT,SCREEN
SCREEN:
	DB	0			; 0 - wywod fajla |krana
					;-1 - prosmotr |krana
FCBIN:
	REPT	9		; disk i imq fajla
	DB	0
	ENDM
	DB	'SNC'		; ras{irenie po umol~ani`

	REPT	33-12
	DB	0
	ENDM

FCBOUT:
	REPT	9		; disk i imq fajla
	DB	0
	ENDM
	DB	'SCR'		; ras{irenie po umol~ani`

	REPT	33-12
	DB	0
	ENDM


TXTUSAGE:
	DB	1BH,5CH,9,9,9,9,9,9,9,'(C) filippow e.w., 1992',0DH,0AH
	DB	'damp |krana "ZX SPECTRUM" -->',9,9,9,9,9,'wers.1.2',0DH,0AH
	DB	'      --> 32K damp |krana "wektor"',0DH,0AH,0AH
	DB	'ispolxzowanie:',0DH,0AH,0AH
	DB	'  C>SNCSCR FILE <CR>',0DH,0AH
	DB	'      C:FILE.SNC --> C:FILE.SCR',0DH,0AH
	DB	'  A>SNCSCR FILE C: <CR>',0DH,0AH
	DB	'      A:FILE.SNC --> C:FILE.SCR',0DH,0AH
	DB	'  C>SNCSCR A:FILE <CR>',0DH,0AH
	DB	'      A:FILE.SNC --> A:FILE.SCR',0DH,0AH
	DB	'  C>SNCSCR FILE /S',0DH,0AH
	DB	'      prosmotr fajla FILE.SNC',0DH,0AH
	DB	0AH
	DB	'prime~anie:',0DH,0AH
	DB	0AH
	DB	'  1. imq fajla ukazywatx bez ras{ireniq.',0DH,0AH
	DB	'  2. ne dopuskaetsq ispolxzowanie w imeni fajla',0DH,0AH
	DB	'     simwolow ''*'' i ''?''.',0DH,0AH
	DB	'$'

PUBLIC	DSCRD,DSCWR,IDSC,ODSC
IDSC:
	DB	129
	DW	DSCRD
ODSC:
	DB	129
	DW	DSCWR

DSCRD:
	DB	0
	DW	FCBIN
	DW	SNCSCR-3
	DW	SNCSCR+1B80H-2
DSCWR:
	DB	-1
	DW	FCBOUT
	DW	VECSCR
	DW	VECSCR+7FFFH


RDERR:
	DB	1BH,05CH
	DB	0DH,0AH
	DB	'o{ibka pri ~tenii ishodnogo fajla',0DH,0AH,'$'

RDERR1:
	DB	1BH,05CH
	DB	0DH,0AH
	DB	'o{ibka: net ishodnogo fajla',0DH,0AH,'$'

RDERR2:
	DB	1BH,05CH
	DB	0DH,0AH
	DB	'o{ibka: ishodnyj fajl koro~e dampa |krana ZX SPECTRUM'
	DB	0DH,0AH,'$'

WRERR:
	DB	1BH,05CH
	DB	0DH,0AH
	DB	'o{ibka pri zapisi wyhodnogo fajla',0DH,0AH,'$'

WRERR1:
	DB	1BH,05CH
	DB	0DH,0AH
	DB	'o{ibka: net mesta w oglawlenii',0DH,0AH,'$'

WRERR2:
	DB	1BH,05CH
	DB	0DH,0AH
	DB	'o{ibka: net mesta na diske',0DH,0AH,'$'


	CSEG

PUBLIC	SHOWSCREEN
SHOWSCREEN:
	LXI	H,VECSCR	; spasti damp |krana
	LXI	D,SNCSCR
	LXI	B,8000H
	CALL	COPY

	DI
	LXI	H,0
	SHLD	1
	LXI	H,IRQ
	SHLD	39H

	EI
	HLT
	HLT

	XRA	A
	OUT	10H

	LXI	H,SNCSCR+7FFFH	; wywesti na |kran
	LXI	D,0FFFFH
CLSC:
	MOV	A,M
	STAX	D
	DCX	H
	DCX	D
	MOV	A,D
	CPI	7FH
	JNZ	CLSC

	LXI	H,LIGHT+15
	SHLD	TABLCLR
	EI			; pereustanowitx cwet
	HLT
	JMP	$-2

PUBLIC	IRQ
IRQ:
	PUSH	PSW
	PUSH	H
	PUSH	D
	PUSH	B
	LXI	D,100FH
	LHLD	TABLCLR
CLT:
	MOV	A,E
	OUT	2
	MOV	A,M
	OUT	0CH
	PUSH	H
	POP	H
	PUSH	H
	POP	H
	DCX	H
	DCR	E
	DCR	D
	OUT	0CH
	JNZ	CLT

	MVI	A,-1		; rolik
	OUT	3

	POP	B
	POP	D
	POP	H
	POP	PSW
	EI
	RET

	DSEG

TABLCLR:
	DW	DARK+15
DARK:
	DB	0,0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0
LIGHT:
	DB	000H,080H,010H,012H,006H,086H,016H,036H
	DB	039H,0D0H,022H,0C0H,002H,098H,052H,0ADH

	END
