;  izmeneniq dlq ispolxzowaniq neqwnyh imen pri wwode
;  --------------------------------------------------
;  wers.1.12			       data:25-maj-92

	MACLIB	EDISK

BIGLETTER		EQU	064CH
FINDREALCHAR		EQU	22F1H
READCHARFROMSTRING	EQU	0644H
ADRNEXTCHARINCOMSTRING	EQU	274FH
ALLPOPRETURN		EQU	1FCCH

	ORG	1A2DH
	CALL	CHECKQ		; izmenenie W komandy

	ORG	095BH

L095B:
	INR	C
	INX	D
	STAX	D

L095E:
	CPI	1AH
	RZ
	CPI	1BH
	RZ
	ORA	A
	RET

;  podgotowka imeni w FCB
;  whod:
;    <DE> - adres FCB

PREPFCB:
	PUSH	B
	PUSH	D
	PUSH	H
	PUSH	D
	XRA	A
	MVI	C,10H

L096D:
	STAX	D
	INX	D
	DCR	C
	JNZ	L096D
	POP	D

	PUSH	D
	LHLD	ADRNEXTCHARINCOMSTRING
	CALL	FINDREALCHAR
	INX	D
	MVI	C,11			; imq iz 11 liter
	CALL	L09F4
	POP	D

	INX	D			; prowerka: imq ne pustoe ?
	LDAX	D
	DCX	D
	CPI	' '
	JZ	BADFILENAME
	ORA	A
	JZ	BADFILENAME
	CALL	FINDREALCHAR
	CALL	READCHARFROMSTRING
	SHLD	ADRNEXTCHARINCOMSTRING
	CALL	L095E
	JZ	ALLPOPRETURN

BADFILENAME:
	CALL	0534H
	DB	'INVALID FILE NAME',0

L09F3:
	INX	H

L09F4:
	CALL	L0A12
	JZ	EON
	STAX	D
	INX	D
	DCR	C
	JNZ	L09F4

L0A00:
	CALL	L0A12
	JNZ	L0A00
	RET

EON:
	CPI	'*'		; dobitx imq do konca 00H ili '?'
	MVI	A,0
	JNZ	L0A08
	MVI	A,'?'
	INX	H		; propustitx '*'
L0A08:
	STAX	D
	INX	D
	DCR	C
	JNZ	L0A08
	RET

L0A12:
	MOV	A,M
	CALL	L0A1D
	RZ
	INX	H
	CALL	BIGLETTER
	ORA	A
	RET

L0A1D:
	CPI	'*'		; dalx{e - wse '?'
	RZ
;	CPI	'?'
;	RZ
	CPI	1FH		; 00-1F - ograni~iteli
	RNC
	CMP	A
	RET

;  podgotowka FCB i prowerka nali~iq '?' w imeni
;  wyhod:
;    flag Z=1 - neqwnoe imq
CHECKQ:
	CALL	PREPFCB
	PUSH	D
	LXI	B,11*100H+'?'
CLCH:
	INX	D
	LDAX	D
	CMP	C
	JZ	BADFILENAME
	DCR	B
	JNZ	CLCH
	POP	D
	CMP	C
	RET


;------------------------------------
;  ras{irenie swobodnoj zony do 1A00H

	ORG	1A1AH
	JC	FILEFOUND

	ORG	0622H
	CPI	'Y'
	JZ	YKOMAND

CI			EQU	2322H
FCBADDFILE		EQU	26F8H
OPENFILE		EQU	1FF4H
MAYBECHECKINTERRUPT	EQU	23D6H

	ORG	18BEH
	JMP	CI
YKOMAND:
	LXI	D,FCBADDFILE
	CALL	PREPFCB
	CALL	OPENFILE	; 1FF4H
	JNZ	FILEFOUND
FILENOTFOUND:
	CALL	0534H
	DB	'FILE NOT FOUND',0
FILEFOUND:
	CALL	MAYBECHECKINTERRUPT
	JMP	1A00H

;--------------------------------------------

COUNT			EQU	2758H
ERRINCOMSTRING		EQU	051DH

ADDKOMAND:
	JZ	0835H		; FKOMAND
	CPI	'T'
	JZ	ADDTKOMAND
	CPI	'P'
	JZ	ADDPKOMAND
	CPI	'H'
	JZ	ADDHKOMAND
	CPI	'B'
	JZ	ADDBKOMAND
	CPI	'C'
	JZ	ADDCKOMAND
	CPI	'O'
	JZ	ADDOKOMAND
	CPI	'R'
	JZ	ADDRKOMAND
	CPI	'U'
	JZ	ADDUKOMAND
	CPI	'L'
	JZ	ADDLKOMAND
	JMP	05E2H

PREPPRN:
	LDA	DIRECT		; tolxko wpered
	ORA	A
	JNZ	ERRINCOMSTRING

	MVI	A,12		; perekl`~itx wywod na pe~atx
	STA	25A1H
	MVI	A,JMP		; i razre{itx wywod us liter
	STA	254AH
	RET

;  analog komandy T - wywod na pe~atx

ADDTKOMAND:
	CALL	PREPPRN
	LHLD	COUNT
PT:	PUSH	H
	CALL	ONETDOWN
	CALL	ONELDOWN
	POP	H
	SHLD	COUNT
	JMP	DECCOUNT

ONELDOWN:
	XRA	A
	LXI	H,1
	JMP	HLAL

;  analog komandy P - wywod na pe~atx

ADDPKOMAND:
	CALL	PREPPRN

	LDA	COUNTL
	ORA	A
	JZ	PRINTFF
				; pe~atx stranicami fiksirowannoj dliny
PRINTLIST:
	LHLD	COUNT
	PUSH	H
	MOV	L,A
	MVI	H,0
CLP:	CALL	PT
	LHLD	COUNT
	MOV	A,H
	ORA	L
	JNZ	CLP
	POP	H
	SHLD	COUNT

	MVI	A,0CH		; CTRL-L (FF)
	CALL	259EH		; CONOUT

	JMP	DECCOUNT

				; pe~atx stranicami po CTRL+L
PRINTFF:
	XRA	A
	STA	CTRLL
	LHLD	COUNT
	PUSH	H
	CALL	ONETDOWN
	CALL	ONELDOWN
	POP	H
	LDA	CTRLL		; w stroke byl obnaruven CTRL+L
	ORA	A
	SHLD	COUNT
	JNZ	DECCOUNT
	RET

;  peredwivenie po stranicam

ADDLKOMAND:
	LHLD	COUNT
	PUSH	H
	LHLD	COUNTL
	MVI	H,0
	LDA	DIRECT
	CALL	HLAL
	POP	H
	SHLD	COUNT
	JMP	DECCOUNT

;  ustanowka cweta bukwy

ADDBKOMAND:
;	CALL	CHECKCNT
	RST	6
	STA	CLRCHR
;	JMP	CLRCNT
	RST	1

;  ustanowka cweta fona

ADDCKOMAND:
;	CALL	CHECKCNT
	RST	6
	STA	CLRFON
;	JMP	CLRCNT
	RST	1

;  ustanowka tipa printera

ADDRKOMAND:
;	CALL	CHECKCNT
	RST	6
	DCR	A
	JM	$+4
	JNZ	ERRINCOMSTRING
	ANI	80H
	STA	PRINTM		; 80H - FX800 / 00H - FX85
;	JMP	CLRCNT
	RST	1

;  ustanowka ~isla strok na stranice raspe~atki

ADDHKOMAND:
;	CALL	CHECKCNT
	RST	6
	CPI	81
	JNC	ERRINCOMSTRING
	STA	COUNTL
;	JMP	CLRCNT
	RST	1

QEXIT:
	XRA	A
	STA	FCB2+17
	STA	WMBACKFCB+17
	CALL	CLEARBUFTXT
	JMP	04B9H

; ustanowka revima ovidaniq w konce stranicy

ADDOKOMAND:
;	CALL	CHECKCNT
	RST	6
	CPI	2
	JNC	ERRINCOMSTRING
	STA	WAITCELL
;	JMP	CLRCNT
	RST	1

; ustanowka razmera bufera
ADDUKOMAND:
	RST	6		; CHECKCNT
	SUI	4
	CPI	13-4
	JNC	ERRINCOMSTRING
	ADI	4
	STA	NBUFER
;	JMP	CLRCNT
	RST	1

;EOFBUF:
;	LXI	H,ADDBUFER
;	MVI	M,0DH
;	INX	H
;	MVI	M,0AH
;	INX	H
;	MVI	M,1AH
;	DCX	H
;	DCX	H
;	RET

;DOP:
;	RST	2
;	CPI	' '
;	RNZ
;	LXI	H,0
;CLD:
;	MOV	A,M
;	CALL	LBYTE
;	MVI	C,' '
;	RST	3
;	INX	H
;	MOV	A,L
;	ANI	0FH
;	JNZ	CLD
;
;	MVI	C,' '
;	RST	3
;	MOV	A,L
;	SUI	10H
;	CALL	LBYTE
;	MVI	C,0DH
;	RST	3
;	MVI	C,0AH
;	RST	3
;	MOV	A,L
;	ORA	A
;	JNZ	CLD
;	RET


	ORG	04B6H
	JZ	QEXIT

	ORG	05DFH
	JMP	ADDKOMAND

	ORG	0505H
	CPI	'E'
	JZ	04B3H
	CPI	'H'
	JNZ	519H
HELP:	CALL	INFORM
;	CALL	DOP
	JMP	MAINCIRCLE

	ORG	570H
	CPI	'H'
	JZ	HELP

;	ORG	1A09H		; posl.blok sdelatx EOF
;	CC	EOFBUF

	END
