
;  Basic Animation Sprite Subroutene
;  ---------------------------------
;	   date:02-jan-93

	maclib	BAS

public	SetGB, SetShow, SetCoord, SetSc1, SetSc2, SetOCB
public	SetAct, SetPass, SetMove, ReadX, ReadY
public	SetF, SeeF, ShowP
extrn	FindOCB, BadParam, BadMode, Return, HLaddA, BgnObject
extrn	ErrReturn

;       
;  :
;    USR(BASS+6),BgnChar,BgnBuf
;  :
;    BgnChar -  
;    BgnBuf  -   

extrn	SetGenChar, SetBufer
SetGB:
	pop	h
	pop	h
	pop	h
	call	Param
	push	h

;      !!!

	mov	b,d
	mov	c,e
	call	SetGenChar

	pop	h
	call	Param
	push	h

;      !!!

	mov	b,d
	mov	c,e
	call	SetBufer
	jmp	Return

;   OCB
;  :
;    USR(BASS+9),DObj
;  :
;    DObj	-   DIM DObj(2),    OCB

extrn	SearOCB, SetName
SetOCB:
	pop	h
	pop	h
	pop	h
	call	SearOCB
	push	h
	jmp	Return

;     '
;  :
;    USR(BASS+15),Out
;  :
;    Out	-   (0 -  , 1 -  )

extrn	UseShow
SetShow:
	pop	h
	pop	h
	pop	h
	call	Param		; Out

	mov	a,e
	ora	a
	jz	$+8
	cpi	1
	jnz	BadParam
	mov	c,a

	call	FindOCB
	push	h
	call	UseShow
	jmp	ErrReturn
;	jc	BadMode		;     ?
;	jmp	Return


;    '
;  :
;    USR(BASS+18),X,Y

extrn	SetXY
SetCoord:
	pop	h
	pop	h
	pop	h
	call	Param		; x
	mov	b,e
	push	b
	call	Param		; y
	pop	b
	mov	c,e

	call	FindOCB
	push	h
	call	SetXY
	jmp	ErrReturn
;	jc	BadMode		;     ?
;	jmp	Return

;    '
;  :
;    X=USR(BASS+21)
;    Y=USR(Bass+24)

extrn	SeeXY
ReadX:
	pop	h
	pop	h
	pop	h
	call	FindOCB
	push	h
	call	SeeXY
	mov	a,b		; X
	jmp	Return

ReadY:
	pop	h
	pop	h
	pop	h
	call	FindOCB
	push	h
	call	SeeXY
	mov	a,c		; Y
	jmp	Return


;    '     
;  :
;    USR(BASS+27),Scn
;  :
;    Scn	-  

extrn	ScenaStop
SetSc1:
	pop	h
	pop	h
	pop	h
	call	Param		; Scn
	mov	a,e
	push	h
	call	FindScena	;    
	pop	h
	call	FindOCB
	push	h
	call	ScenaStop
	jmp	ErrReturn
;	jc	BadMode
;	jmp	Return

;    '     
;  :
;    USR(BASS+30),Scn
;  :
;    Scn	-  

extrn	ScenaMove
SetSc2:
	pop	h
	pop	h
	pop	h
	call	Param		; Scn
	mov	a,e
	push	h
	call	FindScena	;    
	pop	h
	call	FindOCB
	push	h
	call	ScenaMove
	jmp	ErrReturn
;	jc	BadMode
;	jmp	Return

;   '
;  :
;    USR(BASS+33)

extrn	Active
SetAct:
	pop	h
	pop	h
	pop	h
	call	FindOCB
	push	h
	call	Active
	jmp	ErrReturn
;	jc	BadMode
;	jmp	Return

;   '
;  :
;    USR(BASS+36)

extrn	Passive
SetPass:
	pop	h
	pop	h
	pop	h
	call	FindOCB
	push	h
	call	Passive
	jmp	ErrReturn
;	jc	BadMode
;	jmp	Return

;   '
;  :
;    USR(BASS+39)

extrn	MoveObj
SetMove:
	pop	h
	pop	h
	pop	h
	call	FindOCB
	push	h
	call	MoveObj
	jmp	ErrReturn
;	jc	BadMode
;	jmp	Return

;    
;  :
;    USR(BASS+42),F

extrn	SetPhase
SetF:
	pop	h
	pop	h
	pop	h
	call	Param		; 
	mov	c,e

	call	FindOCB
	push	h
	call	SetPhase
	jmp	ErrReturn
;	jc	BadMode		;     ?
;	jmp	Return

;     
;  :
;    F=USR(BASS+45)

extrn	SeePhase
SeeF:
	pop	h
	pop	h
	pop	h
	call	FindOCB
	push	h
	call	SeePhase
	jmp	Return

;    ' (  )
;  :
;    USR(BASS+48),X,Y
;  :
;    X,Y	-   
;    DObj	-   DIM DObj(2),    OCB

extrn	Picture, XYStore
ShowP:
	pop	h
	pop	h
	pop	h
	call	Param		; x
	mov	b,e
	push	b
	call	Param		; y
	pop	b
	mov	c,e

	call	FindOCB
	push	h
	call	XYStore
	jc	BadMode		;     ?
	call	Picture
	jmp	Return

;--------------------------------------------------------------
;    
;  :
;    <a> -  
;  :
;    <bc> -  
;  :
;             

public	FindScena
FindScena:
	ora	a		;     0 !!!
	jz	BadParam
	mov	e,a
	lhld	BgnObject
NextScn:
	mov	a,m
	inx	h
	mov	b,h		;   
	mov	c,l
	dcr	e
	rz
	ora	a
	jz	BadMode		;      ?
	call	HLaddA
	jmp	NextScn	

;   
;  :
;    <hl> -   BASIC 
;  :
;    <de> - 

Param:
	rst	1
	db	','
	call	COMPUTEINT
	ret

	end
