;;						- 1 -
;;**************************************
;;	DISASSEMBLER INTEL 8080
;;  ---------------------------------
;;  V.0.4.11		DATA:26-NOV-91
;;**************************************
;;
CPU	EQU	1530H
;;
	ORG	100H
;;
		DS	3
		JMP	CPU		; GOTO ON CPU-PROGRAM
COMPLEX:	DS	3
CBYTE:		DS	3
PEC:		DS	3
PRIWORDLABEL:	DS	3
;;
PC:		DS	1		; GLOBAL DATA FIELD
PCHIGH:		DS	1		;   FOR RESRC & CPU
OFFSET:		DS	1
OFFSHIGH:	DS	1
MODECOD:	DS	1
PCPLUSOFFSET:	DS	2
;;;;						- 2 -
	ORG	CPU
;;
INTEL:
	DAD	D
	SHLD	PCPLUSOFFSET
	PUSH	H
	LHLD	PC
	INX	H
	SHLD	PC
	POP	H
	MOV	A,M
	MOV	B,A
	LXI	H,CODTAB-6
	LXI	D,6
CODSEARCH: 
	DAD	D
	MOV	A,M
	ORA	A
	JZ	NOCOD
	ANA	B
	MOV	C,A
	INX	H
	MOV	A,M
	CMP	C
	JNZ	CODSEARCH
	INX	H
	MOV	A,M
	STA	MODECOD
	MVI	B,4
PRIBASICOM: 
	INX	H
	MOV	A,M
	CPI	'.'	;2EH
	CNZ	COMPLEX
	DCR	B
	JNZ	PRIBASICOM
	LHLD	PC
	LDA	MODECOD
	CPI	4
	JC	NE45678
	CPI	9
	JNC	NE45678
	INX	H
	CPI	6
	JC	FOR45
	INX	H
FOR45: 
	SHLD	PC
NE45678: 
	MOV	E,A
	MVI	D,0
	LXI	H,GOTOMODECOM
	DAD	D
	DAD	D
	DAD	D
	PUSH	H
	LHLD	PCPLUSOFFSET
	RET
;;;;						- 3 -
GOTOMODECOM: 
	JMP	MODE0
	JMP	MODE1
	JMP	MODE2
	JMP	MODE3
	JMP	MODE4
	JMP	MODE5
	JMP	MODE6
	JMP	MODE7
	JMP	MODE8
	JMP	MODE9
	JMP	MODEA
	JMP	MODEB
MODE0: 
	JMP	CRLF
; AS ADC
MODE1: 
	CALL	PRITAB
PRINTREG: 
	CALL	REG210B
	JMP	CRLF
; AS INR
MODE2: 
	CALL	PRITAB
	CALL	REG543B
	JMP	CRLF
; AS DAD
MODE3: 
	CALL	PRITAB
	CALL	REGPAIR
	JMP	CRLF
; AS MVI
MODE4: 
	CALL	PRITAB
	CALL	REG543B
	CALL	PRIZPT
	JMP	INXADRPRIHEX
;;;;						- 4 -
; AS ACI
MODE5: 
	CALL	PRITAB
INXADRPRIHEX: 
	LHLD	PCPLUSOFFSET
	INX	H
	SHLD	PCPLUSOFFSET
PRIHEX: 
	LHLD	PCPLUSOFFSET
	MOV	A,M
	CPI	' '	;20H
	JC	LT1F
	CPI	5BH
	JNC	LT1F
	LDA	MODECOD
	CPI	4
	JC	LT1F
	CPI	6
	JNC	LT1F
	MOV	A,M
	CALL	PRICHAR
	MVI	A,''''	;27H
	CALL	COMPLEX
	CALL	PRITAB
	CALL	PRIPM
LT1F: 
	MOV	A,M
	CPI	0AH
	JC	LE9
	CALL	ZEROCBYTE
	MVI	A,'H'	;48H
	CALL	COMPLEX
	JMP	CRLF
LE9: 
	ADI	'0'	;30H
	CALL	COMPLEX
	JMP	CRLF
; AS LXI
MODE6: 
	CALL	PRITAB
	LHLD	PCPLUSOFFSET
	MOV	A,M
	CALL	REGPAIR
	CALL	PRIZPT
	MVI	A,86H			; no commentS
	STA	MODECOD
WORDARGUM: 
	LHLD	PCPLUSOFFSET
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	XRA	A				; izmenenie dlq wersii 2
	STA	MODECOD				;
	CALL	PRIWORDLABEL
	JMP	CRLF
;;;;						- 5 -
; AS CALL
MODE7: 
	CALL	PRITAB
	JMP	WORDARGUM
; AS C-CONDITION
MODE8: 
	CALL	CONDITIONS
	JMP	MODE7
; AS R-CONDITION
MODE9: 
	CALL	CONDITIONS
	JMP	CRLF
; AS RST
MODEA: 
	CALL	PRITAB
	LHLD	PCPLUSOFFSET
	MOV	A,M
	RAR
	RAR
	RAR
	ANI	7
	ORI	'0'	;30H
	CALL	COMPLEX
	JMP	CRLF
; AS MOV
MODEB: 
	CALL	PRITAB
	LHLD	PCPLUSOFFSET
	MOV	A,M
	CALL	REG543B
	CALL	PRIZPT
	MOV	A,M
	JMP	PRINTREG
PRIZPT: 
	MVI	A,','	;2CH
	JMP	COMPLEX
PRITAB: 
	MVI	A,9
	JMP	COMPLEX
PRIPM: 
	MVI	A,';'	;3BH
	JMP	COMPLEX
CRLF:
	MVI	A,0DH
	CALL	COMPLEX
	MVI	A,0AH
	JMP	COMPLEX
NOCOD: 
	CALL	PEC
	DB	'DB',9,0
	MVI	A,4
	STA	MODECOD
	JMP	PRIHEX
;;;;						- 6 -
CONDITIONS: 
	LHLD	PCPLUSOFFSET
	MOV	A,M
	RAR
	RAR
	ANI	0EH
	LXI	H,MODEGOTO
	CALL	HLADDA
	MOV	A,M
	CALL	COMPLEX
	INX	H
	MOV	A,M
	CPI	'.'	;2EH
	CNZ	COMPLEX
	RET
PRICHAR: 
	PUSH	PSW
	MVI	A,''''	;27H
	CALL	COMPLEX
	POP	PSW
	CPI	''''	;27H
	JNZ	COMPLEX
	PUSH	PSW
	CALL	COMPLEX
	POP	PSW
	JMP	COMPLEX
REGPAIR: 
	LHLD	PCPLUSOFFSET
	MOV	A,M
	RAR
	RAR
	RAR
	ANI	6
	CPI	6
	JNZ	PRIREG
	MOV	A,M
	ANI	0CFH
	CPI	0C1H
	JZ	PRIPSW
	CPI	0C5H
	JZ	PRIPSW
	MVI	A,'S'	;53H
	CALL	COMPLEX
	MVI	A,'P'	;50H
	JMP	COMPLEX
PRIPSW: 
	CALL	PEC
	DB	'PSW',0
	RET
;;;;						- 7 -
REG543B: 
	LHLD	PCPLUSOFFSET
	MOV	A,M
	RAR
	RAR
	RAR
	JMP	PRIREG
REG210B: 
	LHLD	PCPLUSOFFSET
	MOV	A,M
PRIREG: 
	LXI	H,REGISTR
	ANI	7
	CALL	HLADDA
	MOV	A,M
	JMP	COMPLEX
HLADDA: 
	ADD	L
	MOV	L,A
	RNC
	INR	H
	RET
ZEROCBYTE: 
	CPI	0A0H
	JC	CBYTE
	PUSH	PSW
	MVI	A,'0'	;30H
	CALL	COMPLEX
	POP	PSW
	JMP	CBYTE
BMCO: 
	MOV	A,M
	CALL	COMPLEX
	INX	H
	DCR	B
	JNZ	BMCO
	RET
;;
MODEGOTO: 
	DB	'NZZ.NCC.POPEP.M.'
REGISTR: 
	DB	'BC'
	DB	'DEHLMA'
;;;;						- 8 -
CODTAB: 
	DB	0FFH,0CEH, 5,'ACI.'
	DB	0F8H,088H, 1,'ADC.'
	DB	0F8H,080H, 1,'ADD.'
	DB	0FFH,0C6H, 5,'ADI.'
	DB	0F8H,0A0H, 1,'ANA.'
	DB	0FFH,0E6H, 5,'ANI.'
	DB	0C7H,0C4H, 8,'C...'
	DB	0FFH,0CDH, 7,'CALL'
	DB	0FFH,02FH, 0,'CMA.'
	DB	0FFH,03FH, 0,'CMC.'
	DB	0F8H,0B8H, 1,'CMP.'
	DB	0FFH,0FEH, 5,'CPI.'
	DB	0FFH,027H, 0,'DAA.'
	DB	0CFH,009H, 3,'DAD.'
	DB	0C7H,005H, 2,'DCR.'
	DB	0CFH,00BH, 3,'DCX.'
	DB	0FFH,0F3H, 0,'DI..'
	DB	0FFH,0FBH, 0,'EI..'
	DB	0FFH,076H, 0,'HLT.'
	DB	0FFH,0DBH, 5,'IN..'
	DB	0C7H,004H, 2,'INR.'
	DB	0CFH,003H, 3,'INX.'
	DB	0C7H,0C2H, 8,'J...'
	DB	0FFH,0C3H, 7,'JMP.'
	DB	0FFH,03AH, 7,'LDA.'
	DB	0EFH,00AH, 3,'LDAX'
	DB	0FFH,02AH, 7,'LHLD'
	DB	0CFH,001H, 6,'LXI.'
	DB	0C0H,040H,11,'MOV.'
	DB	0C7H,006H, 4,'MVI.'
	DB	0FFH,000H, 0,'NOP.'
	DB	0F8H,0B0H, 1,'ORA.'
	DB	0FFH,0F6H, 5,'ORI.'
	DB	0FFH,0D3H, 5,'OUT.'
	DB	0FFH,0E9H, 0,'PCHL'
	DB	0CFH,0C1H, 3,'POP.'
	DB	0CFH,0C5H, 3,'PUSH'
	DB	0C7H,0C0H, 9,'R...'
	DB	0FFH,017H, 0,'RAL.'
	DB	0FFH,01FH, 0,'RAR.'
	DB	0FFH,0C9H, 0,'RET.'
	DB	0FFH,00FH, 0,'RRC.'
	DB	0FFH,007H, 0,'RLC.'
	DB	0C7H,0C7H,10,'RST.'
	DB	0F8H,098H, 1,'SBB.'
	DB	0FFH,0DEH, 5,'SBI.'
	DB	0FFH,022H, 7,'SHLD'
	DB	0FFH,0F9H, 0,'SPHL'
	DB	0FFH,032H, 7,'STA.'
	DB	0EFH,002H, 3,'STAX'
	DB	0FFH,037H, 0,'STC.'
	DB	0F8H,090H, 1,'SUB.'
	DB	0FFH,0D6H, 5,'SUI.'
	DB	0FFH,0EBH, 0,'XCHG'
	DB	0F8H,0A8H, 1,'XRA.'
	DB	0FFH,0EEH, 5,'XRI.'
	DB	0FFH,0E3H, 0,'XTHL'
	DB	0
;;
	END
