
;         '
;  -----------------------------------
;  .1.8		:06-sep-92

	equ	8000H
	equ	2000H
	equ	8000H

	maclib	ObjMode

	DSeg

public	, iBufer, GenChar, OldTV, NewTV

:			;    '
	ds	2

iBufer:				;   BAT
	ds	2

GenChar:			;  
	ds	2

	CSeg

;     

public	ShowPassive, ShowActive, ShowMove, ShowUnMove

ShowActive:
	call	PrepStop
	lxi	h,SPOElement
	jnz	WorkAllObject
	lxi	h,ShowElement
	jmp	WorkAllObject

ShowPassive:
	call	PrepStop
	lxi	h,LoadElement
	jnz	WorkAllObject
	lxi	h,ClrElement
	jmp	WorkAllObject

ShowMove:
	Call	PrepMove
	lxi	h,LSPOElement
	jnz	WorkAllObject

modMove	equ	$+1
	lxi	h,0
	jmp	WorkAllObject

ShowUnMove:				;   
	Call	PrepStop
	lxi	h,LSPOElement
	jnz	WorkAllObject
	lxi	h,ShowElement		; .. '  
	jmp	WorkAllObject

LSPOElement:
	lhld	iBufer
	push	h
	call	LoadElement
	pop	h
	shld	iBufer
SPOElement:
	call	SaveElement
	jmp	PutOnElement

CSElement:
	Call	ClrElement
	jmp	ShowElement

;      '
;  :
;    <de> - OCB '

public	PrepStop
PrepStop:
	ldax	d		;  
	sta	OldTV
	sta	NewTV
	inx	d
	ldax	d
	sta	OldTV+1
	sta	NewTV+1
	dcx	d

	
	mov	b,m		; 
	inx	h
	mov	c,m		; 

	DOB
	inx	h

extrn	HLaddA

	mov	a,b
	add	a		;  * 3
	add	b	
	call	HLaddA

	inx	h		;   

	HLHL			;  SB
	mov	a,c
	add	a
	add	c
	add	a
	add	a
	call	HLaddA		; SB + 12* =      

	inx	h
	inx	h
	shld			;  

	jmp	Forward


;     ,    
;  :
;    <de> - OCB '

public	PrepMove
PrepMove:
	
	mov	b,m		; 
	inx	h
	mov	c,m		; 
	push	h		;   

	DOB
	inx	h

extrn	HLaddA

	mov	a,b
	add	a		;  * 3
	add	b	
	call	HLaddA

	mov	a,c
	inr	a		;  +:= 1
	cmp	m		;    
	jc	$+4		;   <   ?
	xra	a
	pop	b
	stax	b		;  := MOD(+1, )
	mov	c,a

	inx	h
	HLHL			;  SB
	mov	a,c
	add	a
	add	c
	add	a
	add	a
	call	HLaddA		; SB + 12* =      

	ldax	d
	sta	OldTV		;   
	inx	d
	add	m
	mov	c,a		; Y +:= DY

	inx	h
	ldax	d
	sta	OldTV+1		;   
	dcx	d
	add	m
	mov	b,a		; X +:= DX

	inx	h
	shld			;      '

extrn	XYStore

	call	XYStore		;    OCB


;     '
;  : <DE> - OCB '

public	Directory
Directory:
	lxi	h,CSElement
	shld	modMove

	lhld	OldTV

	inx	d
	ldax	d		; NewX-OldX
	sta	NewTV+1
	dcx	d
	sub	h
	ldax	d
	sta	NewTV

	jz	CheckY		;   ?

	mvi	a,-1		;   DX
	jp	$+5
	mvi	a,1
	jmp	ModifyDir


CheckY:
	sub	l		; NexY-OldY

	jnz	$+9
	lxi	h,ShowElement	;   ,  '  
	shld	modMove

	mvi	a,-1
	jp	$+5
	mvi	a,1

public	ModifyDir
ModifyDir:
	ora	a
	mvi	a,sui
	lxi	b,2523h		; dcr h, inx h
	lxi	h,IniElB
	jm	ForBack

;      Forward

public	Forward
Forward:
	mvi	a,adi
	lxi	b,2400h		; inr h, nop
	lxi	h,IniElF
ForBack:
	sta	mod1		;   
	mov	a,b
	sta	mod2
	mov	a,c
	sta	mod3		
	shld	modIni

	
	mov	a,m			;    ' !!!
	ani	01000000b
	ret

;     '
;  :
;    <de> - OCB '
;    <hl> - a  
;
;   :
;    1.  
;    2.  NewTV / OldTV    
;	   '

public	WorkAllObject
WorkAllObject:

	shld	ModWork

	lda	NewTV+1		;    
	ori	high()
	sta	NewTV+1
	lda	OldTV+1
	ori	high()
	sta	OldTV+1

	BF			;   
	shld	iBufer

	push	d
	LY
	mov	c,m		;   Y
	inx	h
	mov	b,m		;   X

modIni	equ	$+1
	jmp	0

public	IniElB,IniElF
IniElB:
	mov	a,c		; hy := 8*ly
	add	a
	add	a
	add	a
	mov	l,a		;  hl -  
	mov	h,b
	jmp	$+6
IniElF:
	lxi	h,0

	mov	d,c		;  ly  hy
	mov	e,l

public	clx,cly
clx:
	mov	c,d		;    hy
	mov	l,e
	push	d

cly:
	push	h
	push	b
	shld	Element

ModWork	equ	$+1		;   
	call	0

	pop	b
	pop	h

	mov	a,l
mod1:	adi	8		; hy +/- := 8 <--    y
	mov	l,a

	dcr	c
	jp	cly
	pop	d

mod2:	inr	h		; hx +/- := 1 <--    x

	dcr	b
	jp	clx

	pop	d
	ret


;   

NextScr	macro
	mov	a,l
	sui	8
	mov	l,a
	mov	a,h
	adi	high ()
	mov	h,a
	endm

;  /   

public	SaveElement, LoadElement

SaveElement:
	lxi	h,Save
	jmp	$+6
LoadElement:
	lxi	h,Load
	shld	ModBuf

	lhld	iBufer
mod3:	nop			; f: nop, b: inx h
	mov	a,m
	inr	a
	rz			;   ?
	dcr	a

extrn	BAT, HLaddA, TabBuf

	add	a		;  
	mov	c,a
	lhld	BAT
	call	HLaddA
	shld	iBufer

	mvi	b,0
	lhld	TabBuf
	dad	b
	mov	c,m
	inx	h
	mov	b,m

	lhld	Element

ModBuf	equ	$+1
	jmp	0

public	Load, Save
Load:

OldTv	equ	$+1		;   .   '
	lxi	d,0
	dad	d
cLd:
	rept	8
	ldax	b
	mov	m,a
	inx	b
	inr	l
	endm

	NextScr
	jnc	cLd
	ret

Save:

NewTV	equ	$+1		;   .   '
	lxi	d,0
	dad	d
cSv:
	rept	8
	mov	a,m
	stax	b
	inx	b
	inr	l
	endm

	NextScr
	jnc	cSv
	ret


;      '  

public	PutOnElement
PutOnElement:
	di			; !!!
	lxi	h,-2
	dad	sp
	shld	Picture

	lhld	GenChar
	mov	b,h
	mov	c,l
	lhld	
	mov	e,m
	inx	h
	mov	d,m
	inx	h
	xchg
	dad	b		;    
	shld	
	xchg

public	clPutOn
clPutOn:
	mov	e,m
	inx	h
	mov	d,m
	inx	h
	push	h
	
Element	equ	$+1		;  
	lxi	b,0

	equ	$+1		;  
	lxi	h,0
	dad	b		;    
	sphl

	lhld	GenChar
	dad	d
	dad	b		;    
	xchg

	lhld	NewTV
	dad	b		;    
	xchg

	rept	4
	pop	b
	ldax	d		; 
	ana	c		; 
	ora	m		; 
	stax	d
	inr	l		;    100H !!!
	inr	e
	ldax	d		; 
	ana	b		; 
	ora	m		; 
	stax	d
	inr	l		;    100H !!!
	inr	e
	endm

Picture	equ	$+1
	lxi	sp,0

	pop	h

	lda	NewTV+1
	adi	high()
	sta	NewTV+1
	jnc	clPutOn
	ei				; !!!
	jmp	ExNew


;      '

public	ShowElement
ShowElement:

	lhld	Element			;  
	mov	b,h
	mov	c,l

	lhld	
	inx	h
	inx	h

public	clShE
clShE:
	mov	e,m
	inx	h
	mov	d,m
	inx	h
	push	h

	lhld	GenChar		;   
	dad	d
	dad	b
	xchg

	lhld	NewTV		;   
	dad	b

	rept	8
	ldax	d
	mov	m,a
	inr	e		;    100H !!!
	inr	l
	endm

	pop	h

	lda	NewTV+1
	adi	high()
	sta	NewTV+1
	jnc	clShE

public	ExNew
ExNew
	lda	NewTV+1
	sui	high()
	sta	NewTV+1
	ret


;     

public	ClrElement
ClrElement:
	lhld	OldTV
	xchg
	lhld	Element		;   
	dad	d

public	cClr
cClr:
	lxi	b,8

public	cClr8
cClr8:
	mov	m,c
	inr	l
	dcr	b
	jnz	cClr

	NextScr
	jnc	cClr
	ret


	end
