;;						- 1 -
;;**************************************
;;	RESOURCE - DISASSEMBLER
;;  ----------------------------------
;;  V.2.7		DATA:19-JAN-92
;;**************************************
;;
	ORG	0100H
;;
CTLTBL	EQU	1D00H
SYMTBL	EQU	CTLTBL+600H
FCB	EQU	5CH
PDP	EQU	80H
RAM	EQU	06H
SYSTEM	EQU	05H
;;
	JMP	BEGIN
;;
CPU:	DS	3			; GOTO FOR CPU-PROGRAM
	JMP	COMPLEX
	JMP	CBYTE
	JMP	PEC
	JMP	PRIWORDLABEL
;;
PC:		DB	0		; GLOBAL DATA FIELD
PCHIGH:		DB	1		;   FOR RESRC & CPU
OFFSET:		DB	0
OFFSHIGH:	DB	0
MODECOD:	DB	0
PCPLUSOFFSET:	DW	100H
;;
BEGIN: 
	CALL	ADVERT
	DB	'RESOURCE BY WARD CHRISTENSEN'
	DB	0DH,0AH,'(AS OF 01/08/80)'
	DB	0DH,0AH,'MODIFIED BY E.FILIPPOFF'
	DB	0DH,0AH,'(AS OF 19/01/92)'
	DB	0DH,0AH,'$Copyright 1980'
ADVERT: 
	POP	D
	MVI	C,9
	CALL	SYSTEM	;5
	LXI	H,0
	DAD	SP
	SHLD	SAVESTACK
	LXI	SP,SAVESTACK
	CALL	ZEROPEC
	DB	0DH,0AH,'Memory open to '
	DB	0
	LHLD	RAM	;6
	DCX	H
	CALL	CADDR
	CALL	CRLF
	CALL	CRLF
DROP: 
	CALL	BGNALL
KOMANDA: 
	XRA	A
	STA	MASKDISK
	STA	CONTRCONOUT
	LXI	SP,SAVESTACK
	CALL	GETCOMAND
;;;;						- 2 -
FROMQCOM: 
	LXI	H,BUFCOM+2
	MOV	A,M
	CPI	0DH
	JZ	KOMANDA
	CPI	';'	;3BH
	JZ	PMCOMAND
	CPI	'A'	;41H
	JZ	ACOMAND
	CPI	'B'	;42H
	JZ	BCOMAND
	CPI	'C'	;43H
	JZ	CCOMAND
	CPI	'D'	;44H
	JZ	DCOMAND
	CPI	'E'	;45H
	JZ	ECOMAND
	CPI	'F'	;46H
	JZ	FCOMAND
	CPI	'K'	;4BH
	JZ	KCOMAND
	CPI	'L'	;4CH
	JZ	LCOMAND
	CPI	'O'	;4FH
	JZ	OCOMAND
	CPI	'P'	;50H
	JZ	PCOMAND
	CPI	'Q'	;51H
	JZ	QCOMAND
	CPI	'R'	;52H
	JZ	RCOMAND
	CPI	'S'	;53H
	JZ	SCOMAND
	CPI	'U'	;55H
	JZ	UCOMAND
	CPI	'X'	;58H
	JZ	XCOMAND
	CPI	'Z'	;5AH
	JZ	ZCOMAND
	CPI	'?'	;3FH
	JZ	QUECOMAND
ERROR: 
	XRA	A
	STA	MASKDISK
	STA	CONTRCONOUT
	CALL	ZEROPEC
	DB	'?',0DH,0AH,0
	JMP	KOMANDA
XCOMAND: 
	CALL	ZEROPEC
	DB	'Y/N purge all symbols & '
	DB	'CTL?',0
	CALL	GETCOMAND
	LDA	BUFCOM+2
	CPI	'Y'	;59H
	JZ	DROP
	CPI	'N'	;4EH
	JZ	KOMANDA
	JMP	XCOMAND
;;;;						- 3 -
PCOMAND: 
	LXI	H,BUFCOM+3
	MOV	A,M
	CPI	0DH
	JZ	ERROR
	CALL	FINDADRESS
	CPI	' '	;20H
	JZ	PSCNDPARM
	CPI	','	;2CH
	JNZ	ERROR
PSCNDPARM: 
	INX	H
	PUSH	D
	PUSH	H
	MVI	A,1
	STA	MASKDISK
	CALL	PEC
	DB	9,'ORG',9,0
	POP	H
	POP	D
	MOV	A,D
	CALL	ZEROCBYTE
	MOV	A,E
	CALL	CBYTE
	MVI	A,'H'	;48H
	CALL	COMPLEX
	CALL	CRLF
	PUSH	D
	CALL	FINDADRESS
	CPI	0DH
	JNZ	ERROR
	POP	B
	LXI	H,SYMTBL
PCIRCLE: 
	INX	H
	INX	H
	MOV	A,M
	ORA	A
	JZ	KOMANDA
	DCX	H
	DCX	H
	MOV	A,M
	SUB	C
	INX	H
	MOV	A,M
	SBB	B
	JC	GOODBOUNDARY
	DCX	H
	MOV	A,M
	SUB	E
	INX	H
	MOV	A,M
	SBB	D
	JC	NOTOBOUNDARY
;;;;						- 4 -
GOODBOUNDARY: 
	PUSH	H
	PUSH	B
	INX	H
	MOV	B,M
	PUSH	H
	INX	H
	MOV	A,M
	DCX	H
	CPI	'A'	;41H
	JC	NOPRILABEL
CHECKPLUSMINUS: 
	INX	H
	MOV	A,M
	CPI	'+'	;2BH
	JZ	NOPRILABEL
	CPI	'-'	;2DH
	JZ	NOPRILABEL
	DCR	B
	JNZ	CHECKPLUSMINUS
	POP	H
	MOV	B,M
	MVI	A,1
	STA	MASKDISK
PRIPLABEL: 
	INX	H
	MOV	A,M
	CALL	COMPLEX
	DCR	B
	JNZ	PRIPLABEL
	CALL	PRICOLP
	CALL	PEC
	DB	'EQU',9,0
	POP	B
	POP	H
	MOV	A,M
	ORA	A
	CNZ	ZEROCBYTE
	DCX	H
	MOV	A,M
	CALL	CBYTE
	MVI	A,'H'	;48H
	CALL	COMPLEX
	CALL	CRLF
	XRA	A
	STA	MASKDISK
	INX	H
NOTOBOUNDARY: 
	INX	H
	MOV	A,M
	CALL	HLADDA
	INX	H
	CALL	QUESTSTOP
	JMP	PCIRCLE
;;;;						- 5 -
NOPRILABEL: 
	POP	H
	POP	B
	POP	H
	JMP	NOTOBOUNDARY
QCOMAND: 
	MVI	A,1
	STA	CONTRCONOUT
	LXI	D,BUFCOM+2
	LXI	H,BUFCOM+3
SHIFTCOMAND: 
	MOV	A,M
	STAX	D
	INX	H
	INX	D
	CPI	0DH
	JNZ	SHIFTCOMAND
	JMP	FROMQCOM
	DB	'Congratulations, you found '
	DB	'the patch area!'
DCOMAND: 
	LHLD	DBEGIN
	PUSH	H
	XCHG
	LHLD	DLENGHT
	DAD	D
	SHLD	DEND
	POP	D
	LXI	H,BUFCOM+3
	MOV	A,M
	CPI	0DH
	JZ	DREGIM
	CPI	'S'	;53H
	JZ	DSREGIM
	CPI	'='	;3DH
	JZ	DEQREGIM
	CPI	','	;2CH
	JZ	DMREGIM
DPARAM: 
	CALL	FINDADRESS
	PUSH	H
	LHLD	DLENGHT
	DAD	D
	SHLD	DEND
	POP	H
;;;;						- 6 -
DMREGIM: 
	CPI	0DH
	JZ	MISDPARAM
	CPI	' '	;20H
	JZ	DSCPARAM
	CPI	','	;2CH
	JNZ	ERROR
DSCPARAM: 
	INX	H
	PUSH	D
	CALL	FINDADRESS
	XCHG
	SHLD	DEND
	POP	D
MISDPARAM: 
	LHLD	OFFSET
	PUSH	H
	DAD	D
	SHLD	DBEGIN
	LHLD	DEND
	POP	D
	DAD	D
	SHLD	DEND
	CPI	0DH
	JNZ	ERROR
DREGIM: 
	LHLD	DBEGIN
NEXTD: 
	CALL	QUESTSTOP
	PUSH	H
	CALL	SUBOFFSET
	CALL	CADDR
	POP	H
	PUSH	H
	CALL	SPACE
PRIBYTE: 
	MOV	A,M
	CALL	CBYTE
	INX	H
	MOV	A,L
	ANI	3
	CZ	SPACE
	MOV	A,L
	ANI	7
	CZ	SPACE
	MOV	A,L
	ANI	0FH
	JNZ	PRIBYTE
	CALL	PROMT
	POP	H
DCHAR: 
	MOV	A,M
	CPI	' '	;20H
	JC	MLE1F
	CPI	7FH
	JC	MNORM
;;;;						- 7 -
MLE1F: 
	MVI	A,'.'	;2EH
MNORM: 
	CALL	COMPLEX
	INX	H
	MOV	A,L
	ANI	0FH
	JZ	DENDLINE
	ANI	7
	CZ	SPACE
	JMP	DCHAR
DENDLINE: 
	CALL	PROMT
	CALL	CRLF
	SHLD	DBEGIN
	LDA	DEND
	SUB	L
	LDA	DENDHIGH
	SBB	H
	JNC	NEXTD
	JMP	KOMANDA
DEQREGIM: 
	INX	H
	CALL	FINDADRESS
	INX	H
	DCX	D
	XCHG
	SHLD	DLENGHT
	XCHG
	CPI	','	;2CH
	JZ	DPARAM
	CPI	' '	;20H
	JZ	DPARAM
	CPI	0DH
	JZ	KOMANDA
	JMP	ERROR
DSREGIM: 
	LXI	H,BUFCOM+4
	MOV	A,M
	CPI	'.'	;2EH
	JNZ	DSNOPARM
	CALL	LABLENGHT
	CALL	LABADRESS
	JNC	FROMLABEL
	LHLD	LABINSYM
	JMP	FROMLABEL
;;;;						- 8 -
DSNOPARM: 
	LXI	H,SYMTBL
FROMLABEL: 
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	MOV	A,M
	ORA	A
	JZ	KOMANDA
	XCHG
	CALL	CADDR
	XCHG
	MOV	B,M
	INX	H
PRILABEL: 
	MOV	A,M
	CALL	COMPLEX
	INX	H
	DCR	B
	JNZ	PRILABEL
	CALL	CRLF
	CALL	QUESTSTOP
	JMP	FROMLABEL
ONLYO: 
	LHLD	OFFSET
	CALL	CADDR
	CALL	CRLF
	JMP	KOMANDA
OCOMAND: 
	LXI	H,BUFCOM+3
	MOV	A,M
	CPI	0DH
	JZ	ONLYO
	CALL	FINDADRESS
	CPI	0DH
	JNZ	ERROR
	XCHG
	SHLD	OFFSET
	JMP	KOMANDA
;;;;						- 9 -
PREPFCB: 
	LDA	CONTRDISK
	ORA	A
	JNZ	NOOPENFILE
	STA	FCB	;5CH
	STA	FCB+12	;68H
	LXI	H,BUFCOM+3
	LDA	BUFCOM+4
	CPI	' '	;20H
	JZ	ERROR
	CPI	':'	;3AH
	JNZ	DISKLESS
	LDA	BUFCOM+3
	SUI	'@'	;40H
	STA	FCB	;5CH
	INX	H
	INX	H
DISKLESS: 
	LXI	D,FCB+1	;5DH
	MVI	B,8
	CALL	MOVENAME
	MVI	B,3
	CALL	MOVENAME
	RET
MOVENAME: 
	MOV	A,M
	CPI	0DH
	JZ	SPACETONAME
	INX	H
	CPI	'.'	;2EH
	JZ	SPACETONAME
	STAX	D
	INX	D
	DCR	B
	JNZ	MOVENAME
NOTFROMNAME: 
	MOV	A,M
	CPI	0DH
	RZ
	CPI	'.'	;2EH
	INX	H
	RZ
	JMP	NOTFROMNAME
SPACETONAME: 
	MVI	A,' '	;20H
	STAX	D
	INX	D
	DCR	B
	JNZ	SPACETONAME
	RET
;;;;						- 10 -
ACOMAND: 
	MVI	A,1
	STA	ASWITCH
	XRA	A
	STA	BSWITCH
	JMP	BGNABL
BCOMAND: 
	MVI	A,1
	STA	BSWITCH
	JMP	BGNABL
LCOMAND: 
	XRA	A
	STA	BSWITCH
	STA	ASWITCH
BGNABL: 
	XRA	A
	STA	MASKDISK
	LDA	LINEABL
	STA	CNTLINEABL
	STA	MASKCNTABL
	LXI	H,BUFCOM+3
	MOV	A,M
	CPI	0DH
	JZ	ABLCR
	CPI	','	;2CH
	JZ	ABLSCNDPARM
	CPI	' '	;20H
	JZ	ABLSCNDPARM
	CPI	'='	;3DH
	JZ	ABLEQUREG
ABLFRSTPARM: 
	CALL	FINDADRESS
	XCHG
	SHLD	PC
	XCHG
	CPI	0DH
	JZ	ABLCR
	CPI	' '	;20H
	JZ	ABLSCNDPARM
	CPI	','	;2CH
	JNZ	ERROR
ABLSCNDPARM: 
	INX	H
	CALL	FINDADRESS
	XCHG
	SHLD	ENDABL
	XRA	A
	STA	MASKCNTABL
ABLCR: 
	CALL	QUESTSTOP
	LDA	MASKCNTABL
	ORA	A
	JZ	CHENDABL
	LDA	CNTLINEABL
	DCR	A
	JM	KOMANDA
	JMP	NEXTLNABL
;;;						- 11 -
CHENDABL: 
	LHLD	ENDABL
	LDA	PC
	SUB	L
	LDA	PCHIGH
	SBB	H
	JNC	KOMANDA
NEXTLNABL: 
	LDA	ASWITCH
	ORA	A
	JZ	NOTAREGIM
	LHLD	PC
	XCHG
	LHLD	OFFSET
	DAD	D
	MVI	B,8
CHECK8CHAR: 
	MOV	A,M
	CALL	CHECKCHAR
	JC	NOTAREGIM
	INX	H
	DCR	B
	JNZ	CHECK8CHAR
CHADDICT: 
	MOV	A,M
	CALL	CHECKCHAR
	INX	H
	JNC	CHADDICT
	DCX	H
	CALL	SUBOFFSET
	XCHG
	PUSH	D
	LHLD	PC
	XCHG
	MVI	A,'T'			; izmenenie dlq wersii 2
	CALL	CHANGECTL
	POP	D
	MVI	A,'I'	;49H
	CALL	CHANGECTL
NOTAREGIM: 
	LHLD	DOCBGN
	MOV	A,H
	ORA	L
	JZ	DOCNOTEXIST
	LHLD	PC
	XCHG
	CALL	DOCLINESEARCH
	JC	DOCNOTEXIST
	INX	H
	INX	H
	MOV	B,M
PRINEXTDOC: 
	MVI	A,1
	STA	MASKDISK
	CALL	PRIPM
	XRA	A
	ORA	B
	JZ	ENDEDDOC
;;;;						- 12 -
CHARFROMDOC: 
	INX	H
	MOV	A,M
	CPI	5CH
	JNZ	DOPOLNLINE
	CALL	CRLF
	DCR	B
	JMP	PRINEXTDOC
DOPOLNLINE: 
	CALL	COMPLEX
	DCR	B
	JNZ	CHARFROMDOC
ENDEDDOC: 
	CALL	CRLF
DOCNOTEXIST: 
	LHLD	PC
	XCHG
	CALL	CTLSEARCH
	DCX	H
	JC	PCNOTFOUND
	INX	H
	INX	H
	INX	H
PCNOTFOUND: 
	MOV	A,M
	CPI	'I'	;49H
	JZ	ABLIREGIM
	CPI	'E'	;45H
	JZ	ZCOMAND
	PUSH	PSW
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	PUSH	D
	LHLD	PC
	XCHG
	CALL	PRILABADR
	POP	H
	SHLD	ENDDB
	XCHG
	XRA	A
	STA	MASKDISK
	POP	PSW
	STA	DBREGIM			; izmenenie dlq wersii 2
	CPI	'T'			;
	JZ	ABLDB			;
	CPI	'S'	;53H
	JZ	ABLDS
	CPI	'B'	;42H
	JZ	ABLDB
	CPI	'W'	;57H
	JZ	ABLDW
	CALL	COMPLEX
	CALL	ZEROPEC
	DB	': INVALID CTL ENTRY',0DH
	DB	0AH,0
	JMP	KOMANDA
;;;;						- 13 -
ABLIREGIM: 
	CALL	MNEMOKOD
	XRA	A
	STA	MASKDISK
	JMP	ABLCR
ABLEQUREG: 
	INX	H
	CALL	FINDADRESS
	MOV	A,E
	ORA	A
	JZ	ERROR
	STA	LINEABL
	MOV	A,M
	INX	H
	CPI	','	;2CH
	JZ	ABLFRSTPARM
	CPI	' '	;20H
	JZ	ABLFRSTPARM
	CPI	0DH
	JZ	KOMANDA
	JMP	ERROR
ABLDS: 
	PUSH	D
	LDA	PC
	CMA
	MOV	L,A
	LDA	PCHIGH
	CMA
	MOV	H,A
	INX	H
	DAD	D
	MVI	A,1
	STA	MASKDISK
	CALL	PEC
	DB	'DS',9,0
	MOV	A,H
	CALL	ZEROCBYTE
	MOV	A,L
	CALL	CBYTE
	MVI	A,'H'	;48H
	CALL	COMPLEX
	CALL	CRLF
	POP	H
	SHLD	PC
	JMP	ABLCR
;;;;						- 14 -
ABLDW: 
	MVI	A,1
	STA	MASKDISK
	CALL	PEC
	DB	'DW',9,0
	LHLD	PC
	XCHG
	LHLD	OFFSET
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M
	CALL	PRIWORDLABEL
	CALL	CRLF
	LHLD	PC
	INX	H
	INX	H
	SHLD	PC
	JMP	ABLCR
CRLFTHENABL: 
	CALL	CRLF
	JMP	ABLCR
ABLDB: 
	XRA	A
	STA	DBCOUNT
	INR	A
	STA	MASKDISK
	CALL	PEC
	DB	'DB',9,0
NEXTDBHEX: 
	LHLD	PC
	XCHG
	LHLD	OFFSET
	DAD	D
	LDA	DBREGIM				;  izmeneniq dlq wersii 2
	CPI	'B'				;
	MOV	A,M
	JZ	DBLTSPACE			;  izmeneniq dlq wersii 2
	CPI	0AH
	JC	DBLESS10
	CPI	' '	;20H
	JC	DBLTSPACE
	CPI	7FH
	JC	DBLE7F
DBLTSPACE: 
	CALL	ZEROCBYTE
	MVI	A,'H'	;48H
	CALL	COMPLEX
	LDA	DBCOUNT
	ADI	2
	STA	DBCOUNT
	JMP	DBHEX
;;;;						- 15 -
DBLESS10: 
	ORI	'0'	;30H
	CALL	COMPLEX
DBHEX: 
	INX	H
	XCHG
	LHLD	PC
	INX	H
	SHLD	PC
	XCHG
DBZPT: 
	LDA	ENDDB
	CMP	E
	JNZ	DB1ENDED
	LDA	HIGHENDDB
	CMP	D
	JZ	NEXTABL
DB1ENDED: 
	LHLD	PC
	XCHG
	CALL	FINDLABEL
	JNC	CRLFTHENABL
	LDA	DBCOUNT
	ADI	2
	STA	DBCOUNT
	CPI	19H
	JNC	CRLFTHENABL
	MVI	A,','	;2CH
	CALL	COMPLEX
	JMP	NEXTDBHEX
DBLE7F: 
	MVI	A,''''	;27H
	CALL	COMPLEX
	LDA	DBCOUNT
	INR	A
	STA	DBCOUNT
	MOV	A,M
NXTCHAR: 
	CALL	COMPLEX
	MOV	A,M
	CPI	''''	;27H
	CZ	COMPLEX
	INX	H
	XCHG
	LHLD	PC
	INX	H
	SHLD	PC
	XCHG
	LDA	ENDDB
	CMP	E
	JNZ	DB2ENDED
	LDA	HIGHENDDB
	CMP	D
	JZ	CLOSTXTDB
;;;;						- 16 -
DB2ENDED: 
	PUSH	H
	LHLD	PC
	XCHG
	CALL	FINDLABEL
	POP	H
	JNC	CLOSTXTDB
	LDA	DBCOUNT
	INR	A
	STA	DBCOUNT
	CPI	'#'	;23H
	JNC	CLOSTXTSHORT
	CPI	19H
	JC	TXTSHORT
	DCX	H
	MOV	A,M
	INX	H
	CPI	' '	;20H
	JZ	CLOSTXTDB
TXTSHORT: 
	MOV	A,M
	CPI	' '	;20H
	JC	CLOSTXTSHORT
	CPI	7FH
	JC	NXTCHAR
CLOSTXTSHORT: 
	MVI	A,''''	;27H
	CALL	COMPLEX
	JMP	DBZPT
CLOSTXTDB: 
	MVI	A,''''	;27H
	CALL	COMPLEX
NEXTABL: 
	CALL	CRLF
	JMP	ABLCR
QUECOMAND: 
	CALL	ZEROPEC
	DB	'SYMTBL=',0
	LXI	H,SYMTBL
	CALL	CADDR
	LHLD	ENDSYM
	CALL	CADDR
	CALL	CRLF
	CALL	ZEROPEC
	DB	'PC    =',0
	LHLD	PC
	CALL	CADDR
	CALL	CRLF
;;;;						- 17 -
	CALL	ZEROPEC
	DB	'OFFSET=',0
	LHLD	OFFSET
	CALL	CADDR
	CALL	CRLF
	LHLD	DOCBGN
	MOV	A,H
	ORA	L
	JZ	PRIADRCTL
	CALL	ZEROPEC
	DB	'COMNTS=',0
	LHLD	DOCBGN
	CALL	CADDR
	LHLD	DOCEND
	CALL	CADDR
	CALL	CRLF
PRIADRCTL: 
	CALL	ZEROPEC
	DB	'CTLTBL=',0
	LXI	H,CTLTBL
	CALL	CADDR
SEARCHCTLEND: 
	MOV	A,M
	INX	H
	ANA	M
	INX	H
	INX	H
	INR	A
	JNZ	SEARCHCTLEND
	DCX	H
	DCX	H
	DCX	H
	CALL	CADDR
	CALL	CRLF
	JMP	KOMANDA
FCOMAND: 
	LXI	H,BUFCOM+3
	MOV	A,M
	CPI	0DH
	JZ	FPARMEND
	CALL	FINDADRESS
	XCHG
	SHLD	WORD
	LHLD	OFFSET
	SHLD	FINDBGN
	XCHG
	CPI	0DH
	JZ	FPARMEND
	CPI	' '	;20H
	JZ	FSCNDPARM
	CPI	','	;2CH
	JNZ	ERROR
;;;;						- 18 -
FSCNDPARM: 
	INX	H
	CALL	FINDADRESS
	CPI	0DH
	JNZ	ERROR
	LHLD	OFFSET
	DAD	D
	SHLD	FINDBGN
FPARMEND: 
	LHLD	WORD
	XCHG
FCIRCLE: 
	CALL	QUESTSTOP
	LHLD	FINDBGN
	MOV	A,M
	INX	H
	SHLD	FINDBGN
	CMP	E
	JNZ	FCIRCLE
	MOV	A,M
	CMP	D
	JNZ	FCIRCLE
	PUSH	H
	PUSH	D
	CALL	SUBOFFSET
	DCX	H
	CALL	CADDR
	POP	D
	POP	H
	CALL	SPACE
	JMP	FCIRCLE
SUBOFFSET: 
	LDA	OFFSET
	CMA
	MOV	E,A
	LDA	OFFSHIGH
	CMA
	MOV	D,A
	INX	D
	DAD	D
	RET
ZCOMAND: 
	CALL	PRILABADR
	MVI	A,1
	STA	MASKDISK
	CALL	PEC
	DB	'END',0DH,0AH,0
	XRA	A
	STA	MASKDISK
	LDA	CONTRDISK
	ORA	A
	JZ	KOMANDA
	MVI	A,1AH
	CALL	DRWRDISK
	CALL	CLOSEFILE
	XRA	A
	STA	CONTRDISK
	CALL	ZEROPEC
	DB	'++ASM FILE CLOSED++',0DH
	DB	0AH,0
	JMP	KOMANDA
;;;;						- 19 -
RCOMAND: 
	CALL	PREPFCB
	LDA	CONTRDISK
	ORA	A
	JNZ	NOOPENFILE
	LXI	H,FCB+9	;65H
	LXI	D,SYMFILE
	MVI	C,3
	CALL	TEXTCHECK
	JNZ	READNOSYM
	LXI	H,SYMTBL
	CALL	RDSYMFILE
	SHLD	ENDSYM
	INX	H
	INX	H
	MVI	M,0
	JMP	QUECOMAND
READNOSYM: 
	LXI	H,FCB+9	;65H
	LXI	D,COMFILE
	MVI	C,3
	CALL	TEXTCHECK
	JNZ	NOCOMSYM
	CALL	OPENFILE
	LHLD	OFFSET
	MOV	A,H
	CPI	HIGH(SYMTBL)
	JC	NOREADCOM
	LXI	D,100H
	DAD	D
NEWCOMREAD: 
	PUSH	H
	XCHG
	MVI	C,1AH
	CALL	SYSTEM	;5
	LXI	D,FCB	;5CH
	MVI	C,14H
	CALL	SYSTEM	;5
	ORA	A
	JNZ	EXREADCOM
	POP	H
	LXI	D,PDP	;80H
	DAD	D
	JMP	NEWCOMREAD
EXREADCOM: 
	POP	H
	CALL	CADDR
	CALL	SUBOFFSET
	CALL	CADDR
	CALL	CRLF
	LXI	D,PDP	;80H
	MVI	C,1AH
	CALL	SYSTEM	;5
	JMP	KOMANDA
NOCOMSYM: 
	LXI	H,FCB+9	;65H
	LXI	D,CTLFILE
	MVI	C,3
	CALL	TEXTCHECK
	JNZ	NOCTLCOMSYM
	JMP	RDCTLFILE
;;;;						- 20 -
NOCTLCOMSYM: 
	LXI	H,FCB+9	;65H
	LXI	D,DOCFILE
	MVI	C,3
	CALL	TEXTCHECK
	JNZ	ERROR
	CALL	CHECKBGNDOC
	LHLD	DOCBGN
	CALL	RDSYMFILE
	SHLD	DOCEND
	MVI	M,0FFH
	INX	H
	MVI	M,0FFH
	JMP	QUECOMAND
NOREADCOM: 
	CALL	ZEROPEC
	DB	'++NO, THAT WOULD OVERLAY '
	DB	'THE DISASSEMBLER',0DH,0AH
	DB	'BECAUSE OFFSET IS TOO SMALL: '
	DB	0
	JMP	ONLYO
RDSYMFILE: 
	CALL	OPENFILE
RDLINESYM: 
	CALL	DRVRDISC
	CPI	1AH
	RZ
	CPI	9
	JZ	RDLINESYM
	CPI	0DH
	JZ	RDLINESYM
	CPI	0AH
	JZ	RDLINESYM
	CALL	RDADDR
	MOV	M,E
	INX	H
	MOV	M,D
	INX	H
	PUSH	H
	INX	H
	MVI	B,0
RDONELABEL: 
	CALL	DRVRDISC
	CPI	9
	JZ	RDNEXTLABEL
	CPI	0DH
	JZ	RDNEXTLABEL
	MOV	M,A
	INX	H
	INR	B
	JMP	RDONELABEL
RDNEXTLABEL: 
	XTHL
	MOV	M,B
	POP	H
	JMP	RDLINESYM
;;;;						- 21 -
RDADDR: 
	LXI	D,0
CLCRDADDR: 
	CPI	' '	;20H
	RZ
	CPI	1AH
	JZ	UNEXPEOF
	CPI	':'	;3AH
	JC	DECREAD
	SUI	7
DECREAD: 
	SUI	'0'	;30H
	XCHG
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	ADD	L
	MOV	L,A
	XCHG
	CALL	DRVRDISC
	CPI	1AH
	JZ	UNEXPEOF
	JMP	CLCRDADDR
SCOMAND: 
	CALL	PREPFCB
	LDA	CONTRDISK
	ORA	A
	JNZ	NOOPENFILE
	LXI	H,FCB+9	;65H
	LXI	D,SYMFILE
	MVI	C,3
	CALL	TEXTCHECK
	JNZ	STONEXT
	LXI	H,SYMTBL
STOFILEDOC: 
	CALL	CREATEFILE
STOSLINE: 
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	MOV	A,M
	INX	H
	MOV	B,A
	ORA	A
	JZ	ENDSTOSYM
	CALL	ADDRTODISC
	MVI	A,' '	;20H
	CALL	DRWRDISK
STOLABEL: 
	MOV	A,M
	CALL	DRWRDISK
	INX	H
	DCR	B
	JNZ	STOLABEL
	MVI	A,0DH
	CALL	DRWRDISK
	MVI	A,0AH
	CALL	DRWRDISK
	JMP	STOSLINE
;;;;						- 22 -
ENDSTOSYM: 
	MVI	A,1AH
	CALL	DRWRDISK
	CALL	CLOSEFILE
	JMP	KOMANDA
ADDRTODISC: 
	MOV	A,D
	CALL	HIGHA
	CALL	DRWRDISK
	MOV	A,D
	CALL	LOWA
	CALL	DRWRDISK
	MOV	A,E
	CALL	HIGHA
	CALL	DRWRDISK
	MOV	A,E
	CALL	LOWA
	JMP	DRWRDISK
STONEXT: 
	LXI	H,FCB+9	;65H
	LXI	D,CTLFILE
	MVI	C,3
	CALL	TEXTCHECK
	JZ	STOCTL
	LXI	H,FCB+9	;65H
	LXI	D,DOCFILE
	MVI	C,3
	CALL	TEXTCHECK
	JZ	STODOC
	LXI	H,FCB+9	;65H
	LXI	D,ASMFILE
	MVI	C,3
	CALL	TEXTCHECK
	JNZ	ERROR
	MVI	A,1
	STA	CONTRDISK
	XRA	A
	STA	MASKDISK
	CALL	CREATEFILE
	CALL	ZEROPEC
	DB	'++WRITING .ASM ENABLED'
	DB	0DH,0AH,'USE Z COMMAND OR '
	DB	'E CONTROL TO CLOSE FILE++'
	DB	0DH,0AH,0
	JMP	KOMANDA
STODOC: 
	CALL	CHECKBGNDOC
	LHLD	DOCEND
	INX	H
	INX	H
	MVI	M,0
	LHLD	DOCBGN
	JMP	STOFILEDOC
; YOU CANN'T OPEN NEW FILE
NOOPENFILE: 
	CALL	ZEROPEC
	DB	'++NO FILE ACCESSES PERMITTED '
	DB	'UNTIL .ASM CLOSED',0DH,0AH
	DB	0
	JMP	KOMANDA
;;;;						- 23 -
UNEXPEOF: 
	CALL	ZEROPEC
	DB	'++UNEXPECTED EOF',0DH,0AH
	DB	0
	JMP	KOMANDA
CCOMAND: 
	LXI	H,BUFCOM+3
	MOV	A,M
	CPI	0DH
	JZ	CBK
	CALL	FINDADRESS
	CPI	0DH
	JZ	CONEPARM
	CPI	' '	;20H
	JZ	CSCNDPARM
	CPI	','	;2CH
	JNZ	ERROR
CSCNDPARM: 
	INX	H
	MOV	A,M
	CALL	CTLCHANGE
	JMP	KOMANDA
CHANGECTL: 
	PUSH	H
	PUSH	D
	PUSH	PSW
	CALL	CTLSEARCH
	DCX	H
	JC	LASTCTL
	INX	H
	INX	H
	INX	H
LASTCTL: 
	POP	PSW
	POP	D
	CMP	M
	POP	H
	RZ
CTLCHANGE: 
	STA	MODECOD
	CALL	CTLSEARCH
	JC	ADDCTL
	LDA	MODECOD
	CPI	'I'	;49H
	JZ	TOCTL
	CPI	'W'	;57H
	JZ	TOCTL
	CPI	'B'	;42H
	JZ	TOCTL
	CPI	'T'				; izmeneniq dlq wersii 2
	JZ	TOCTL				;
	CPI	'S'	;53H
	JZ	TOCTL
	CPI	'E'	;45H
	JZ	TOCTL
	CPI	'K'	;4BH
	JNZ	ERROR
	XCHG
	LXI	H,3
	DAD	D
	XCHG
;;;;						- 24 -
KILLCTL: 
	MOV	A,M
	INX	H
	ANA	M
	DCX	H
	INR	A
	JZ	KILLALREADY
	MVI	B,3
CTLDECR: 
	LDAX	D
	MOV	M,A
	INX	D
	INX	H
	DCR	B
	JNZ	CTLDECR
	JMP	KILLCTL
KILLALREADY: 
	DCX	H
	DCX	H
	DCX	H
	JMP	PRIADRCTL
ADDCTL: 
	LDA	MODECOD
	CPI	'K'	;4BH
	JZ	ERROR
	CPI	'E'	;45H
	JZ	ADDTOCTL
	CPI	'B'	;42H
	JZ	ADDTOCTL
	CPI	'T'				; izmenenie dlq wersii 2
	JZ	ADDTOCTL			;
	CPI	'W'	;57H
	JZ	ADDTOCTL
	CPI	'I'	;49H
	JZ	ADDTOCTL
	CPI	'S'	;53H
	JNZ	ERROR
ADDTOCTL: 
	PUSH	D
	PUSH	H
	LXI	H,CTLTBL
FINDCTLEND: 
	MOV	A,M
	INX	H
	ANA	M
	INX	H
	INX	H
	INR	A
	JNZ	FINDCTLEND
	INX	H
	INX	H
	INX	H
	XCHG
	LXI	H,-3
	DAD	D
	POP	B
;;;;						- 25 -
CTLINCR: 
	DCX	H
	DCX	D
	MOV	A,M
	STAX	D
	MOV	A,E
	CMP	C
	JNZ	CTLINCR
	MOV	A,D
	CMP	B
	JNZ	CTLINCR
	MOV	H,B
	MOV	L,C
	POP	D
	MOV	M,E
	INX	H
	MOV	M,D
	INX	H
	LDA	MODECOD
	MOV	M,A
	RET
TOCTL: 
	INX	H
	INX	H
	MOV	M,A
	RET
CTLSEARCH: 
	LXI	H,CTLTBL
NEXTCTL: 
	MOV	A,M
	INX	H
	ANA	M
	DCX	H
	INR	A
	STC
	RZ
	INX	H
	MOV	A,D
	CMP	M
	DCX	H
	RC
	JNZ	CTLSHIFT
	MOV	A,E
	CMP	M
	RZ
	RC
CTLSHIFT: 
	INX	H
	INX	H
	INX	H
	JMP	NEXTCTL
CONEPARM: 
	CALL	CTLSEARCH
	JMP	SEECTL
;;;;						- 26 -
CBK: 
	LXI	H,CTLTBL
SEECTL: 
	CALL	QUESTSTOP
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	MOV	A,D
	ANA	E
	INR	A
	JNZ	SEELINECTL
	JMP	PRIADRCTL
SEELINECTL: 
	PUSH	D
	PUSH	H
	CALL	FINDLABEL
	JC	LABELESS
PRICTLLAB: 
	MOV	A,M
	CALL	COMPLEX
	INX	H
	DCR	B
	JNZ	PRICTLLAB
	MVI	A,':'	;3AH
	CALL	COMPLEX
	CALL	CRLF
LABELESS: 
	POP	H
	POP	D
	CALL	SPACE
	CALL	SPACE
	XCHG
	CALL	CADDR
	MVI	A,','	;2CH
	CALL	COMPLEX
	XCHG
	MOV	A,M
	CALL	COMPLEX
	CALL	CRLF
	INX	H
	JMP	SEECTL
;;;;						- 27 -
STOCTL: 
	CALL	CREATEFILE
	LXI	H,CTLTBL
CTLTODISC: 
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	MOV	A,D
	ANA	E
	INR	A
	JZ	EXSTOCTL
	CALL	ADDRTODISC
	MVI	A,','	;2CH
	CALL	DRWRDISK
	MOV	A,M
	CALL	DRWRDISK
	MVI	A,0DH
	CALL	DRWRDISK
	MVI	A,0AH
	CALL	DRWRDISK
	INX	H
	JMP	CTLTODISC
EXSTOCTL: 
	MVI	A,1AH
	CALL	DRWRDISK
	CALL	CLOSEFILE
	JMP	KOMANDA
RDCTLFILE: 
	CALL	OPENFILE
	LXI	H,CTLTBL
RDLNCTL: 
	CALL	DRVRDISC
	LXI	D,0
RDDECCTL: 
	CPI	1AH
	JZ	EXPEOFCTL
	CPI	','	;2CH
	JZ	RDADRCTL
	CPI	':'	;3AH
	JC	DECCTLRD
	SUI	7
DECCTLRD: 
	SUI	'0'	;30H
	XCHG
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	ADD	L
	MOV	L,A
	XCHG
	CALL	DRVRDISC
	JMP	RDDECCTL
;;;;						- 28 -
RDADRCTL: 
	MOV	M,E
	INX	H
	MOV	M,D
	INX	H
	CALL	DRVRDISC
	MOV	M,A
	INX	H
	JMP	RDLNCTL
EXPEOFCTL: 
	MVI	M,0FFH
	INX	H
	MVI	M,0FFH
	JMP	PRIADRCTL
; COMAND <;>
PMCOMAND: 
	CALL	CHECKBGNDOC
	LXI	H,BUFCOM+3
	MOV	A,M
	CPI	0DH
	JZ	PMCR
	CALL	FINDADRESS
	INX	H
	CPI	0DH
	JZ	PMADDRCR
	CPI	' '	;20H
	JZ	PMSCNDPARM
	CPI	','	;2CH
	JNZ	ERROR
PMSCNDPARM: 
	PUSH	H
	CALL	DOCLINESEARCH
	JC	NOFDOC
	CALL	DELDOCLINE
	POP	H
	PUSH	H
	MOV	A,M
	CPI	0DH
	JZ	KOMANDA
;;;;						- 29 -
NOFDOC: 
	LHLD	DOCEND
	MOV	M,E
	INX	H
	MOV	M,D
	INX	H
	POP	D
	MVI	B,0
	PUSH	H
TODOC: 
	INX	H
	LDAX	D
	MOV	M,A
	INX	D
	INR	B
	LDAX	D
	CPI	0DH
	JNZ	TODOC
	INX	H
	SHLD	DOCEND
	MVI	M,0FFH
	INX	H
	MVI	M,0FFH
	POP	H
	MOV	M,B
	JMP	KOMANDA
DOCLINESEARCH: 
	LHLD	DOCBGN
DOCSEARCH: 
	MOV	A,M
	INX	H
	ANA	M
	DCX	H
	INR	A
	STC
	RZ
	INX	H
	MOV	A,D
	CMP	M
	DCX	H
	JNZ	DOCNOTEQ
	MOV	A,E
	CMP	M
	RZ
DOCNOTEQ: 
	INX	H
	INX	H
	MOV	A,M
	CALL	HLADDA
	INX	H
	JMP	DOCSEARCH
PMADDRCR: 
	CALL	DOCLINESEARCH
	JMP	PRILNDOC
;;;;						- 30 -
PMCR: 
	LHLD	DOCBGN
PRILNDOC: 
	CALL	QUESTSTOP
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	MOV	A,D
	ANA	E
	INR	A
	JZ	KOMANDA
	XCHG
	CALL	CADDR
	XCHG
	MVI	A,';'	;3BH
	CALL	COMPLEX
	MOV	B,M
PRIDOC: 
	INX	H
	MOV	A,M
	CALL	COMPLEX
	DCR	B
	JNZ	PRIDOC
	CALL	CRLF
	INX	H
	JMP	PRILNDOC
DELDOCLINE: 
	MOV	A,M
	INX	H
	ANA	M
	INR	A
	RZ
	DCX	H
	PUSH	D
	MOV	D,H
	MOV	E,L
	INX	H
	INX	H
	MOV	A,M
	CALL	HLADDA
	INX	H
	MVI	B,0
DELONEDOC: 
	MOV	A,M
	STAX	D
	INX	H
	INX	D
	MOV	C,A
	ANA	B
	INR	A
	MOV	B,C
	JNZ	DELONEDOC
	XCHG
	DCX	H
	DCX	H
	SHLD	DOCEND
	POP	D
	RET
;;;;						- 31 -
CHECKBGNDOC: 
	LHLD	DOCBGN
	MOV	A,H
	ORA	L
	RNZ
	CALL	ZEROPEC
	DB	'++COMMAND IGNORED++',0DH
	DB	0AH,'++Issue ''UNNNN'' to tell '
	DB	'RESOURCE to use address '
	DB	'NNNN',0DH,0AH,'as the start '
	DB	'of the comments table',0DH
	DB	0AH,0
	JMP	KOMANDA
UCOMAND: 
	LXI	H,BUFCOM+3
	MOV	A,M
	CPI	0DH
	JZ	ERROR
	CPI	'.'	;2EH
	JZ	ERROR
	CALL	FINDADRESS
	XCHG
	MOV	A,H
	CPI	1FH
	JC	ERRU
	SHLD	DOCBGN
	SHLD	DOCEND
	MVI	M,0FFH
	INX	H
	MVI	M,0FFH
	JMP	KOMANDA
ERRU: 
	CALL	ZEROPEC
	DB	'++NO!! <1F00H!',0DH,0AH
	DB	0
	JMP	KOMANDA
;;;;						- 32 -
PRILABADR: 
	PUSH	D
	PUSH	H
	MVI	A,1
	STA	MASKDISK
	LHLD	PC
	XCHG
	CALL	FINDLABEL
	JC	LASTLABEL
	MOV	C,B
	PUSH	H
PLUSMINUSCHECK: 
	MOV	A,M
	CPI	'+'	;2BH
	JZ	NOPRILAB
	CPI	'-'	;2DH
	JZ	NOPRILAB
	INX	H
	DCR	C
	JNZ	PLUSMINUSCHECK
	POP	H
	CALL	CRLFDISK		; izmeneniq dlq wersii 2
	CALL	BMCO
	MVI	A,':'	;3AH
	CALL	COMPLEX
	CALL	PRICOLL		; izmeneniq dlq wersii 2
	CALL	PRIPM
	LHLD	PC
	XCHG				; izmenenie dlq wersii 2
	CALL	CADDRLABEL		;
	CALL	CRLF
	JMP	LASTLABEL
NOPRILAB: 
	POP	H
LASTLABEL: 
	XRA	A
	STA	MASKDISK
	CALL	SPACE
	CALL	SPACE
	LHLD	PC
	CALL	CADDR
	MVI	A,1
	STA	MASKDISK
	CALL	PRITAB
	POP	H
	POP	D
	RET

CRLFDISK:				; izmeneniq dlq wersii 2
	LDA	CONTRDISK		;
	ORA	A			;
	CNZ	CRLF			;
	RET				;

PRICOLP:				;
	MVI	B,32			;
	JMP	CHECKCOL		;
PRICOLL:				; izmeneniq dlq wersii 2
	MVI	B,40			;
	JMP	CHECKCOL		;
PRICOLPARM:				;
	MVI	B,56			;
CHECKCOL:				;
	LDA	COUNTCOMPLEX		;
	CMP	B			;
	RNC				;
	CALL	PRITAB			;
	JMP	CHECKCOL		;
;;;;						- 33 -
MNEMOKOD: 
	CALL	PRILABADR
	LHLD	PC
	XCHG
	LHLD	OFFSET
	JMP	CPU
;;
PRIWORDLABEL: 
	PUSH	D
	CALL	FINDLABEL
	JNC	LBLPRINT
	LDA	BSWITCH
	ORA	A
	JZ	NOBSWITCH
	POP	D
	PUSH	D
	CALL	LABLXXXX
	JMP	NOBSWITCH
;;
LBLPRINT: 
	CALL	BMCO
	LDA	MODECOD
	ORA	A
	POP	D
	RM			; NO COMMENTS ?
;;
	PUSH	D
	CALL	PRICOLPARM		; izmenenie dlq wersii 2
	CALL	PRIPM
NOBSWITCH: 
	POP	D

CADDRLABEL:				; izmenenie dlq wersii 2
	MOV	A,D
	ORA	E
	MVI	A,'0'	;30H
	JZ	WORDZERO
	MOV	A,D
	ORA	A
	JZ	ONLYBYTE
	CALL	ZEROCBYTE
	MOV	A,E
	CALL	CBYTE
PRIH: 
	MVI	A,'H'	;48H
WORDZERO: 
	JMP	COMPLEX
ONLYBYTE: 
	MOV	A,E
	CPI	0AH
	JC	LESSTHEN10
	CALL	ZEROCBYTE
	JMP	PRIH
LESSTHEN10: 
	ADI	'0'	;30H
	JMP	WORDZERO
PRITAB: 
	MVI	A,9
	JMP	COMPLEX
PRIPM: 
	MVI	A,';'	;3BH
	JMP	COMPLEX
;;;;						- 34 -
HLADDA: 
	ADD	L
	MOV	L,A
	RNC
	INR	H
	RET
ZEROCBYTE: 
	CPI	0A0H
	JC	CBYTE
	PUSH	PSW
	MVI	A,'0'	;30H
	CALL	COMPLEX
	POP	PSW
	JMP	CBYTE
BMCO: 
	MOV	A,M
	CALL	COMPLEX
	INX	H
	DCR	B
	JNZ	BMCO
	RET
LABLXXXX: 
	LXI	H,BUFCOM
	MVI	M,'L'	;4CH
	INX	H
	MOV	A,D
	CALL	MBYTE
	MOV	A,E
	CALL	MBYTE
	LXI	H,BUFCOM
	MVI	B,5
NEWLABEL: 
	CALL	LABADRESS
	JC	NOFINDLABEL
	MOV	M,E
	INX	H
	MOV	M,D
	RET
;;;;						- 35 -
NOFINDLABEL: 
	PUSH	H
	PUSH	D
	PUSH	B
	LHLD	ENDSYM
	MOV	D,H
	MOV	E,L
	MOV	A,B
	ADI	3
	ADD	L
	MOV	L,A
	MOV	A,H
	ACI	0
	MOV	H,A
	SHLD	ENDSYM
	INX	H
	INX	H
	MVI	M,0
	DCX	H
	DCX	H
	MOV	B,H
	MOV	C,L
	LHLD	LABINSYM
SPACETOSYM: 
	MOV	A,E
	CMP	L
	JNZ	HETAMETKA
	MOV	A,D
	CMP	H
	JZ	RAZDWINULI
HETAMETKA: 
	DCX	D
	DCX	B
	LDAX	D
	STAX	B
	JMP	SPACETOSYM
;;;;						- 36 -
RAZDWINULI: 
	POP	B
	POP	D
	MOV	M,E
	INX	H
	MOV	M,D
	INX	H
	MOV	M,B
	POP	D
NEWTOSYM: 
	INX	H
	LDAX	D
	MOV	M,A
	INX	D
	DCR	B
	JNZ	NEWTOSYM
	RET
; FIND ADRESS FOR A LABEL, AND SYNTAXIS FIND
LABADRESS: 
	PUSH	D
	PUSH	H
	LXI	H,SYMTBL
SEESYM: 
	POP	D
	PUSH	D
	INX	H
	INX	H
	PUSH	H
	MOV	A,M
	INX	H
	ORA	A
	JZ	BADEXIT
	CMP	B
	JC	SHORTLABEL
	JNZ	LONGLABEL
	MOV	C,A
	CALL	TEXTCHECK
	JZ	FINDEXIT
	JC	BADEXIT
REPEAT: 
	POP	H
	MOV	A,M
	INX	H
	ADD	L
	MOV	L,A
	JNC	SEESYM
	INR	H
	JMP	SEESYM
FINDEXIT: 
	POP	H
	DCX	H
	DCX	H
	POP	D
	POP	D
	ORA	A
	RET
SHORTLABEL: 
	MOV	C,A
	CALL	TEXTCHECK
	JNC	REPEAT
	JMP	BADEXIT
;;;;						- 37 -
LONGLABEL: 
	MOV	C,B
	CALL	TEXTCHECK
	JZ	BADEXIT
	JNC	REPEAT
BADEXIT: 
	POP	H
	DCX	H
	DCX	H
	SHLD	LABINSYM
	POP	H
	POP	D
	STC
	RET
; FIND LABEL FOR HER ADRESS
FINDLABEL: 
	LXI	H,SYMTBL
NEXTLABEL: 
	MOV	A,M
	INX	H
	CMP	E
	JNZ	NOEQADR
	MOV	A,M
	CMP	D
	JZ	LABFIND
NOEQADR: 
	INX	H
	MOV	A,M
	ORA	A
	STC
	RZ
	INX	H
	ADD	L
	MOV	L,A
	JNC	NEXTLABEL
	INR	H
	JMP	NEXTLABEL
LABFIND: 
	INX	H
	MOV	A,M
	INX	H
	MOV	B,A
	ORA	A
	RNZ
	STC
	RET
;;;;						- 38 -
ECOMAND: 
	LXI	H,BUFCOM+3
	CALL	FINDADRESS
	MOV	A,M
	CPI	' '	;20H
	JZ	ESCNDPARM
	CPI	','	;2CH
	JNZ	ERROR
ESCNDPARM: 
	INX	H
	MOV	A,M
	CPI	'.'	;2EH
	JNZ	ERROR
	PUSH	D
	CALL	LABLENGHT
	POP	D
	CALL	NEWLABEL
	JMP	KOMANDA
	RET
KCOMAND: 
	LXI	H,BUFCOM+3
	MOV	A,M
	CPI	'.'	;2EH
	JNZ	ERROR
	CALL	LABLENGHT
	CALL	LABADRESS
	JC	ERROR
	MOV	B,H
	MOV	C,L
	INX	H
	INX	H
	MOV	A,M
	ADD	L
	MOV	L,A
	MOV	A,H
	ACI	0
	MOV	H,A
	INX	H
	XCHG
	LHLD	ENDSYM
THROW: 
	MOV	A,E
	CMP	L
	JNZ	NEXTMOVE
	MOV	A,D
	CMP	H
	JZ	EXTHROW
NEXTMOVE: 
	LDAX	D
	STAX	B
	INX	B
	INX	D
	JMP	THROW
EXTHROW: 
	MOV	H,B
	MOV	L,C
	SHLD	ENDSYM
	INX	H
	INX	H
	MVI	M,0
	JMP	KOMANDA
;;;;						- 39 -
LABLENGHT: 
	INX	H
	MVI	B,0
	PUSH	H
GOODCHAR: 
	MOV	A,M
	INX	H
	INR	B
	CPI	'+'	;2BH
	JZ	GOODCHAR
	CPI	'-'	;2DH
	JZ	GOODCHAR
	CPI	'0'	;30H
	JC	BADCHAR
	CPI	':'	;3AH
	JC	GOODCHAR
	CPI	'A'	;41H
	JC	BADCHAR
	CPI	5BH
	JC	GOODCHAR
	CPI	'a'	;61H			; izmenenie dlq wersii 2
	JC	BADCHAR				;
	CPI	7BH				;
	JC	GOODCHAR			;
BADCHAR: 
	DCR	B
	JZ	ERROR
	DCX	H
	XCHG
	POP	H
	RET
MBYTE: 
	PUSH	PSW
	CALL	HIGHA
	MOV	M,A
	INX	H
	POP	PSW
	CALL	LOWA
	MOV	M,A
	INX	H
	RET
HIGHA: 
	RAR
	RAR
	RAR
	RAR
LOWA: 
	ANI	0FH
	CPI	0AH
	JC	DECA
	ADI	7
DECA: 
	ADI	'0'	;30H
	RET
CBYTE: 
	PUSH	PSW
	CALL	HIGHA
	CALL	COMPLEX
	POP	PSW
	CALL	LOWA
	JMP	COMPLEX
;;;;						- 40 -
CADDR: 
	MOV	A,H
	CALL	CBYTE
	MOV	A,L
	CALL	CBYTE
SPACE: 
	MVI	A,' '	;20H
	JMP	COMPLEX
FINDADRESS: 
	MOV	A,M
	CPI	'.'	;2EH
	JZ	WORKWITHLABEL
	LXI	D,0
INPHEX: 
	MOV	A,M
	CPI	'0'	;30H
	RC
	CPI	':'	;3AH
	JC	GOODHEX
	CPI	'A'	;41H
	RC
	CPI	'G'	;47H
	RNC
	SUI	7
GOODHEX: 
	SUI	'0'	;30H
	XCHG
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	ADD	L
	MOV	L,A
	XCHG
	INX	H
	JMP	INPHEX
WORKWITHLABEL: 
	CALL	LABLENGHT
	PUSH	D
	CALL	LABADRESS
	JC	ERROR
	MOV	E,M
	INX	H
	MOV	D,M
	POP	H
	MOV	A,M
	RET
;;;;						- 41 -
OPENFILE: 
	PUSH	H
	LXI	H,BEGIN
	SHLD	COUNTW
	XRA	A
	STA	FCB+32	;7CH
	LXI	D,FCB	;5CH
	MVI	C,0FH
	CALL	SYSTEM	;5
	POP	H
	INR	A
	RNZ
	CALL	ZEROPEC
	DB	'++FILE NOT FOUND',0DH,0AH
	DB	0
	JMP	KOMANDA
DRVRDISC: 
	PUSH	H
	LHLD	COUNTW
	MOV	A,H
	CPI	1
	JNZ	FROMBUF
	PUSH	B
	PUSH	D
	LXI	D,FCB	;5CH
	MVI	C,14H
	CALL	SYSTEM	;5
	ORA	A
	POP	D
	POP	B
	LXI	H,PDP	;80H
	JNZ	READEOF
FROMBUF: 
	MOV	A,M
	INX	H
	SHLD	COUNTW
	POP	H
	RET
READEOF: 
	CPI	3
	JC	NORMEOF
	CALL	ZEROPEC
	DB	'++UNEXPECTED EOF',0DH,0AH
	DB	0
	JMP	KOMANDA
NORMEOF: 
	MVI	A,1AH
	MOV	M,A
	JMP	FROMBUF
;;;;						- 42 -
CREATEFILE: 
	PUSH	H
	LXI	D,FCB	;5CH
	MVI	C,13H
	CALL	SYSTEM	;5
	LXI	D,FCB	;5CH
	MVI	C,16H
	CALL	SYSTEM	;5
	INR	A
	JZ	ERROR
	XRA	A
	STA	FCB+32	;7CH
	LXI	H,PDP	;80H
	SHLD	COUNTW
	POP	H
	RET
CLOSEFILE: 
	LXI	D,FCB	;5CH
	MVI	C,15H
	CALL	SYSTEM	;5
	ORA	A
	JNZ	PRIWRERR
	LXI	D,FCB	;5CH
	MVI	C,10H
	CALL	SYSTEM	;5
	INR	A
	RNZ
	CALL	ZEROPEC
	DB	'++CLOSE ERROR',0DH,0AH,0
	JMP	KOMANDA
PRIWRERR: 
	CALL	ZEROPEC
	DB	'++WRITE ERROR',0DH,0AH,0
DRWRDISK: 
	PUSH	H
	LHLD	COUNTW
	MOV	M,A
	INR	L
	SHLD	COUNTW
	POP	H
	RNZ
	PUSH	B
	PUSH	D
	PUSH	H
	LXI	D,FCB	;5CH
	MVI	C,15H
	CALL	SYSTEM	;5
	ORA	A
	JNZ	PRIWRERR
	LXI	H,PDP	;80H
	SHLD	COUNTW
	POP	H
	POP	D
	POP	B
	RET
;;;;						- 43 -
CRLF: 
	MVI	A,0DH
	CALL	COMPLEX
	MVI	A,0AH
	JMP	COMPLEX
PROMT: 
	MVI	A,'*'	;2AH
COMPLEX: 
	PUSH	B
	PUSH	D
	PUSH	H
	MOV	E,A
	LXI	H,COUNTCOMPLEX			; izmenenie dlq wersii 2
	CPI	9				;
	MVI	A,1				;
	JNZ	NOTTAB				;
	MOV	A,M				;
	ANI	0F8H				;
	MOV	M,A				;
	MVI	A,8				;
NOTTAB:
	ADD	M				;
	MOV	M,A				;
	PUSH	D
	MVI	C,2
	LDA	CONTRCONOUT
	ORA	A
	CZ	SYSTEM	;5
	POP	D
	LDA	CONTRDISK
	LXI	H,MASKDISK
	ANA	M
	MOV	A,E
	CNZ	DRWRDISK
	MOV	A,E
	CPI	0AH
	JNZ	EXCOMPLEX
	XRA	A				; izmenenie dlq wersii 2
	STA	COUNTCOMPLEX			;
	LDA	MASKCNTABL
	ORA	A
	JZ	EXCOMPLEX
	LXI	H,CNTLINEABL
	DCR	M
EXCOMPLEX: 
	POP	H
	POP	D
	POP	B
	RET
;;;;						- 44 -
GETCOMAND: 
	CALL	PROMT
	LXI	D,BUFCOM
; LINE OF CONSOLE INPUT BUFER NO MORE THEN 78 CHARACTER
	MVI	A,'N'	;4EH
	STAX	D
	MVI	C,0AH
	CALL	SYSTEM	;5
	LXI	H,BUFCOM+1
	MOV	E,M
	MVI	D,0
	DAD	D
	INX	H
	MVI	M,0DH
	LXI	H,BUFCOM+1
BIGLETTER: 
	INX	H
	MOV	A,M
	CPI	0DH
	JZ	CRLF
	CPI	61H
	JC	BIGLETTER
	CPI	7BH
	JNC	BIGLETTER
;	ANI	5FH			; izmenenie dlq wersii 2
	MOV	M,A
	JMP	BIGLETTER
ZEROPEC: 
	XRA	A
	STA	MASKDISK
	STA	CONTRCONOUT
PEC: 
	XTHL
CLCPEC: 
	MOV	A,M
	CALL	COMPLEX
	INX	H
	MOV	A,M
	ORA	A
	JNZ	CLCPEC
	INX	H
	XTHL
	RET
;;;;						- 45 -
BGNALL: 
	XRA	A
	STA	SYMTBL+2
	LXI	H,SYMTBL
	SHLD	ENDSYM
	MVI	A,0DH
	STA	BUFCOM+3
	LXI	H,0FFFFH
	SHLD	CTLTBL
; FOR WORK WITH FIRST LINE CTLTAB
	MVI	A,'I'	;49H
	STA	CTLTBL-1
	LHLD	DOCBGN
	MOV	A,H
	ORA	L
	RZ
	SHLD	DOCEND
	MVI	M,0FFH
	INX	H
	MVI	M,0FFH
	RET

;  proweritx 2 tekst. stroki na sowpadenie
;  whod:
;    <HL> i <DE> - adresa strok obrazca i prowerqemoj stroki
;    <C> - dlina prowerqemoj posledowatelxnosti
;  wyhod:
;    flag Z=1 - sowpadenie strok
;    togda
;      flag C=0 - pered obrazcom, =1 - posle obrazca

TEXTCHECK: 
	PUSH	B		;
	MOV	A,M		;
	ANI	5FH		;
	MOV	B,A		;
	LDAX	D		;  izmenenie dlq wersii 2.1
	ANI	5FH		;
	CMP	B		;
	POP	B		;
	RNZ
	INX	D
	INX	H
	DCR	C
	JNZ	TEXTCHECK
	RET
QUESTSTOP: 
	PUSH	B
	PUSH	D
	PUSH	H
; STATUS CONSOLE
	MVI	C,0BH
	CALL	SYSTEM	;5
	ORA	A
	JZ	POPEXIT
	MVI	C,1
	CALL	SYSTEM	;5
	CPI	3
	JZ	QUESTYN
	CALL	CRLF
	JMP	KOMANDA
QUESTYN: 
	CALL	ZEROPEC
	DB	0DH,0AH,'ABORT Y/N ',0
	MVI	C,1
	CALL	SYSTEM	;5
	ANI	5FH
	CPI	'Y'	;59H
	JZ	0
	JMP	KOMANDA
POPEXIT: 
	POP	H
	POP	D
	POP	B
	RET
;;;;						- 46 -
CHECKCHAR: 
	CPI	0DH
	RZ
	CPI	0AH
	RZ
	ORA	A
	RZ
	CPI	' '	;20H
	RC
	CPI	7FH
	CMC
	RET
;;
	POP	D
	MVI	C,9
	CALL	SYSTEM	;5
	LHLD	SAVESTACK
	SPHL
	RET
;;;;						- 47 -
DBEGIN: 
	DW	BEGIN
DEND: 
	DB	80H
DENDHIGH: 
	DB	1
ENDSYM: 
	DW	SYMTBL
ENDABL: 
	DW	BEGIN
DOCBGN: 
	DW	0
DOCEND: 
	DW	0
FINDBGN: 
	DW	0
WORD: 
	DW	0
DLENGHT: 
	DW	7FH
LINEABL: 
	DB	0AH
CNTLINEABL: 
	DB	0AH
MASKCNTABL: 
	DB	1
ASMFILE: 
	DB	'ASM'
COMFILE: 
	DB	'COM'
CTLFILE: 
	DB	'CTL'
SYMFILE: 
	DB	'SYM'
DOCFILE: 
	DB	'DOC'
MASKDISK: 
	DB	0
CONTRDISK: 
	DB	0
CONTRCONOUT: 
	DB	0
COUNTCOMPLEX:				; izmenenie dlq wersii 2
	DB	0			;
;;;;						- 48 -
DBREGIM:				; izmeneniq dlq wersii 2
	DB	'T'			;
ENDDB: 
	DB	0
HIGHENDDB: 
	DB	0
DBCOUNT: 
	DB	0
LABINSYM: 
	DW	0
COUNTW: 
	DW	0
ASWITCH: 
	DB	0
BSWITCH:
	DB	0
BUFCOM: 
	DS	00DCH
SAVESTACK: 
	DB	0,0
;;
	END
