;;						- 1 -
;;**************************************
;;	podgotowka fajlow .KEY
;;  ----------------------------------
;;  wers.3.4.27		data:09-FEB-90
;;**************************************
;;
FCB		EQU	0005CH	; buf dlq tek.fajla
KEYTAB		EQU	00800H	; tabl. fajla .KEY
FILEBGN		EQU	01800H	; na~alo oblasti SINCLAIR zapisi
;;
	ORG	100H
;;
	LXI	SP,KEYTAB-1
	CALL	PROGRAM
	LXI	D,literal
;;
;;  wyhod w sistemu s soob}eniem
;;  whod:
;;    <D,E> - adres soob}eniq
ERROR:
	CALL	PEC
	JMP	WARM
;;
NUMFL:	DS	1		; nomer tek.fajla
ERRFL:	DS	1		; kod priema tek.fajla
FILE:	DS	2		; na~alo tek.fajla
ENDFL:	DS	2		; adres za tek.fajlom
LINEFL:	DS	2		; dlina tek.zapisi dlq INFFILE
;;
MAXADR:	DS	2		; MAX dopustimyj adres ozu
DISK:	DW	0080H		; adres pdp disk.fajla
DCOUNT:	DW	DISK		; s~et~ik dlq ~teniq disk.fajla
KEYCNT:	DW	KEYTAB		; s~et~ik dlq raboty s KEYTAB
ENDKEY:	DW	KEYTAB+1	; adres za ukazatelem konca KEYTAB
;;
BDOSBP:	DS	1		; kod operacii ras{.BDOS
	DS	2		; parametr
;;
PFCB:	DS	2		; adres imeni fajla
	DS	2		; adres FCB
;;;;						- 2 -
;;  rabota s operaciqmi mikro-dos
;;  -----------------------------
SYSTEM	MACRO	NN
	MVI	C,NN
	CALL	0005H
	ENDM
;;
;;  wwod litery s konsoli
CI:
	PUSH	H
	PUSH	D
	PUSH	B
	MVI	E,0FDH
	SYSTEM	6
	JMP	EXSYS
;;
;;  wywod stroki na konsolx
;;  whod:
;;    <D,E> - adres tekst.stroki
PEC:
	PUSH	H
	PUSH	D
	PUSH	B
	SYSTEM	9
	JMP	EXSYS
;;
CRLF:
	MVI	C,0DH
	CALL	CO
	MVI	C,0AH
;;
;;  wywod na konsolx
CO:
	PUSH	H
	PUSH	D
	PUSH	B
	MOV	E,C
	SYSTEM	2
EXSYS:
	POP	B
	POP	D
	POP	H
	RET
;;
;;  wyhod w sistemu
WARM:
	LXI	D,literal
	CALL	PEC
	SYSTEM	0
	JMP	100H
;;;;						- 3 -
;;  proweritx imq na neodnozna~nostx
;;  whod: <D,E> - FCB
;;  wyhod: flag Z=1 - imq s ras{ireniem
WITHQ:
	PUSH	D
	LXI	B,11*100H+'?'
CWTH:
	LDAX	D
	CMP	C
	JZ	EXWTH
	INX	D
	DCR	B
	JNZ	CWTH
	INR	B
EXWTH:
	POP	D
	RET
;;
;;  otkrytx diskowyj fajl
;;  wyhod: flag Z=1 - fajl otsutstwuet
SNCNAME:
	LXI	H,SNCFILE	; ras{irenie .SNC
	JMP	$+6
KEYNAME:
	LXI	H,KEYFILE	; ras{irenie .KEY
	LXI	D,FCB+9
	LXI	B,3
	CALL	MOVE
	LXI	D,FCB
	CALL	WITHQ
	LXI	D,NONAME	; newerno zadano imq fajla
	JZ	ERROR		;  na diske
;;
;;  wywod imeni tek.fajla
wywimq:
	LXI	D,Timq
	CALL	PEC
	LXI	H,FCB
;;
;;  wywod imeni fajla
;;  whod: <H,L> - adres FCB
SEENAME:
	SHLD	BDOSBP+1
	LXI	D,BDOSBP
	MVI	A,242
	STAX	D
	SYSTEM	32H
;;
;;  otkratx fajl
otkrytx:
	LXI	H,FCB+12	; podgotowitx FCB
	MVI	A,36-12
	CALL	CLR
	LXI	D,FCB
	SYSTEM	0FH		; otkrytx fajl
	INR	A
	LXI	D,NOFILE
	RET
;;;;						- 4 -
;;  wwesti blok iz diska w ozu
;;  whod: <B,C> - dlina bloka
;;	  <D,E> - adres na~ala bloka
;;  wyhod:<flag C>=1 - END OF FILE !!!
INPBLC:
	MVI	A,-2		; ~islo wwodimyh blokow
	STA	INPLESS
;;
	LHLD	DCOUNT
INPBC:
	MOV	A,B
	ORA	C
	JZ	EXINP
;;
	MOV	A,L
	ANI	7FH
	JNZ	INPBYTE
;;
	MOV	A,C
	ANI	80H
	ORA	B
	JNZ	SPEED		; wwod polnogo bloka 128 bajt
;;
	LHLD	DISK
	XCHG
	CALL	NEWBLC
	XCHG
INPBYTE:
	MOV	A,M
	INX	H
	STAX	D
	INX	D
	DCX	B
	JMP	INPBC
;;
SPEED:
	LDA	READFLAG		; byla situaciq EOF?
	ORA	A
	STC
	RNZ
;;
	CALL	NEWBLC
	PUSH	H
	LXI	H,-80H
	DAD	B
	MOV	B,H
	MOV	C,L
INPLESS	EQU	$+1
	MVI	A,0		; modificiruemaq komanda
	ORA	A
	JZ	$+12
	INR	A
	STA	INPLESS
	LXI	H,80H
	DAD	D
	XCHG
	POP	H
	JMP	INPBC
;;
READFLAG:	DB	0		; flag END OF FILE
;;
EXINP:
	SHLD	DCOUNT
	RET
;;;						- 5 -
;;  s~itatx o~erednoj blok fajla
;;  whod: <D,E> - na~alo oblasti
NEWBLC:
	PUSH	H
	PUSH	D
	PUSH	B
;;
	SYSTEM	1AH		; ustanowitx pdp
;;
	LXI	D,FCB		; ~itatx blok
	SYSTEM	14H
	CPI	0FFH
	LXI	D,READERR
	JZ	ERROR
	STA	READFLAG	; modifikaciq programmy
	POP	B
	POP	D
	POP	H
	RET
;;;;						- 6 -
;;  blok dopoln.podprogramm
;;  -----------------------
;;  srawnitx <H,L> i <D,E>
HLDE:
	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET
;;
;;  <H,L>:=<H,L>-<D,E>
SUHLDE:
	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	RET
;;
;;  perewod HEX w ASCII
;;  whod:
;;    <A> - HEX
;;  wyhod:
;;    <A> - ASCII
ASCII:
	ANI	0FH
	ADI	'0'
	CPI	'9'+1
	RC
	ADI	'A'-'0'-10
	RET
;;
;;  wywod adresa
;;  whod:
;;    <H,L> - adres
CADDR:
	MOV	A,H
	CALL	CBYTE
	MOV	A,L
;;
;;  1-h bajt. perem. -> ASCII wywod
;;  whod:
;;    <A> - bajt
CBYTE:
	PUSH	PSW
	RRC
	RRC
	RRC
	RRC
	CALL	CLOW
	POP	PSW
CLOW:
	CALL	ASCII
	PUSH	B
	MOV	C,A
	CALL	CO
	POP	B
	RET
;;;;						- 7 -
CMEM:
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	XCHG
	CALL	CADDR
	XCHG
	RET
;;
SPACE:
	MVI	C,' '
	JMP	CO
;;
BCO:
	CALL	CO
	DCR	B
	JNZ	$-4
	RET
;;
MOVE:
	MOV	A,M
	INX	H
	STAX	D
	INX	D
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	MOVE
	RET
;;
BMCO:
	MOV	C,M
	MOV	A,C
	INX	H
	CPI	80H
	JNC	ERRCHR
	CPI	20H
	JNC	$+5
ERRCHR:
	MVI	C,'?'	 	; zamena 00H-1FH, 80H-0FFH
	CALL	CO
	DCR	B
	JNZ	BMCO
	RET
;;
;;  steretx oblastx
;;  whod:
;;    <H,L> - adres na~ala
;;    <A> - dlina
CLR:
	MVI	M,0
	DCR	A
	INX	H
	JNZ	$-4
	RET
;;;;						- 8 -
;;  s~itatx zapisx SINCLAIR
;;  whod:   FILE - adres na~ala zapisi
;;  wyhod:  ENDFL - adres za fajlom
;;	    flag <C>=1 - s~itan priznak konca fajla
INPFILE:
	LHLD	FILE
	XCHG
	LXI	B,2
	CALL	INPBLC
	LHLD	FILEBGN		; dlina zapisi
	MOV	A,H
	ORA	L
	STC
	RZ			; priznak posl.zapisi
	MOV	A,H
	MOV	B,H
	MOV	C,L
	CALL	INPBLC
	XCHG
	SHLD	ENDFL
	RET
;;;;						- 9 -
;;  wywod informacii o fajle
;;  whod:
;;    NUMFL,ERRFL,FILE
INFFILE:
	LHLD	KEYCNT
	INX	H
	MOV	A,M
	ORA	A
	PUSH	H
	LXI	D,zagtip
	CZ	PEC
	POP	H
	CALL	CRLF
	LXI	B,220H
	CALL	BCO
	MOV	A,M
	INR	A
	CALL	CBYTE		; nomer zapisi
	LXI	B,220H
	CALL	BCO
	MOV	A,M
	ORA	A
	INX	H
	JZ	$+6
	LXI	H,pustimq
	MVI	B,8
	CALL	BMCO
	LXI	B,220H
	CALL	BCO
;;
	LDA	NUMFL		; nomer fajla
	CALL	CBYTE
	CALL	SPACE
;;
	LHLD	FILE
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	XCHG
	SHLD	LINEFL
	XCHG
	MOV	A,M
	CALL	CBYTE		; nulewoj bajt zapisi
	MOV	A,M
	ORA	A
	JZ	zagolowok
;;
	LXI	B,23*100H+' '
	JMP	NOSTFL
;;;;						- 10 -
zagolowok:
	CALL	SPACE
	INX	H
	MOV	A,M		; tip zagolowka
	CPI	4
	JC	STANDART
;;
	CALL	CBYTE		; zagolowok 4...255
	LXI	B,20*100H+' '
NOSTFL:
	CALL	BCO
	LHLD	LINEFL		; dlina fajla dejstw.
	DCX	H
	DCX	H
	CALL	CADDR
	JMP	ostatok
;;
STANDART:
	ADD	A
	ADD	M
	ADD	A
	LXI	D,tip
	ADD	E
	MOV	E,A
	JNC	$+4
	INR	D
	CALL	PEC
;;
	CALL	SPACE
	INX	H
	MVI	B,10		; standart.tip zagolowka
	CALL	BMCO
;;
	CALL	SPACE
	LHLD	FILE
	LXI	D,16		; na~alo fajla dannyh
	DAD	D
	CALL	CMEM
;;
	CALL	SPACE
	LHLD	FILE
	LXI	D,14		; dlina fajla dannyh
	DAD	D
	CALL	CMEM
;;
ostatok:
	RET
;;;;						- 11 -
;;  smena tek.nomerow w KEYTAB
WORKEY:
	LHLD	KEYCNT
	MOV	A,M
	ORA	A
	JZ	CHNGKEY	
	MVI	M,0		; nepraw.konec KEYTAB
	LXI	D,10H
	DAD	D
	MVI	M,0FFH
	INX	H
	MVI	M,0FFH		; ne na~alo programmy
CHNGKEY:
	LXI	H,KEYTAB
	INX	H
	XRA	A		; perwaq zapisx - na~alo programmy
	MOV	M,A
	MOV	B,A		; tek.nomer zapisi
	DCX	H
CKLCHG:
	MOV	A,M
	ORA	A
	INX	H
	SHLD	ENDKEY
	RNZ			; priznak konca KEYTAB?
	MOV	A,M
	ORA	A
	JNZ	$+5
	MVI	B,-1		; nowaq programma
	INR	B
	MOV	M,B
	LXI	D,10H-1
	DAD	D
	JMP	CKLCHG
;;;;						- 12 -
PROGRAM:
	LXI	D,ADVERT
	CALL	PEC
	LHLD	0006H
	SHLD	MAXADR
	LHLD	DISK
	SHLD	DCOUNT
;;
	CALL	KEYNAME
	JZ	NOKEYFILE
	XRA	A
	STA	MODEXIT
	LXI	D,KEYTAB
IKEY:
	LXI	B,10H
	CALL	INPBLC
	LXI	H,-10H
	DAD	D
	MOV	A,M
	ORA	A
	JZ	IKEY
	JMP	SNCINP
NOKEYFILE:
	MVI	A,0FFH
	STA	MODEXIT		; zapretitx wyhod po 'e'
	CALL	PEC
	LXI	H,KEYTAB
	MVI	M,0FFH
	INX	H
	MVI	A,15
	CALL	CLR
;;
SNCINP:
	LXI	H,FILEBGN
	SHLD	FILE
	LXI	H,KEYTAB
	SHLD	KEYCNT
	LHLD	DISK
	SHLD	DCOUNT
	XRA	A
	STA	READFLAG
	STA	NUMFL
	CALL	SNCNAME
	JZ	ERROR
;;;;						- 132 -
wwesti:
	CALL	INPFILE
	JC	konec
;;
	LXI	H,NUMFL		; uwel. nomer fajla
	INR	M
;;
SEELINE:
	CALL	WORKEY
	CALL	INFFILE		; wywesti informaci`
wwod:
	CALL	CI
	CPI	'B'
	JZ	SNCINP
	CPI	';'
	JZ	BGNPRG
	CPI	'-'
	JZ	NOPRG
	CPI	'E'
	JZ	konecwopr
NEXTLINE:
	LHLD	KEYCNT		; smenitx zapisx w KEYTAB
	LXI	D,10H
	DAD	D
	SHLD	KEYCNT
	JMP	wwesti
;;
NOPRG:
	LHLD	KEYCNT
	INX	H
	MVI	M,0FFH		; ubratx priznak na~ala programmy
	MVI	C,19H
	CALL	CO
	JMP	SEELINE
BGNPRG:
	LXI	D,tprg
	CALL	PEC
	LHLD	KEYCNT
	MVI	B,10
	MVI	M,' '
	INX	H
	DCR	B
	JNZ	$-4
;;
	LHLD	KEYCNT
	PUSH	H
	MVI	M,8
	XCHG
	SYSTEM	0AH		; wwesti tekst s konsoli
	POP	H
	MVI	M,0		; tek.zapisx
	INX	H
	MVI	M,0		; na~alo programmy
	JMP	SEELINE	
;;;;						- 14 -
konecwopr:
MODEXIT	EQU	$+1
	MVI	A,0		; modificiruemaq komanda
	ORA	A
	JNZ	wwod		; wyhod po 'e' zapre}en ?
konec:
	CALL	KEYNAME
	LXI	D,FCB
	SYSTEM	13H		; udalitx fajl
	LXI	D,FCB
	SYSTEM	16H		; sozdatx fajl
	CALL	otkrytx
	LHLD	ENDKEY
	MVI	M,0
	INX	H
	MOV	A,L
	ANI	7FH
	JNZ	$-6
	LXI	D,KEYTAB
	CALL	SUHLDE
	DAD	H
OUTKEY:
	PUSH	H
	PUSH	D
	SYSTEM	1AH		; ustanowitx pdp
	LXI	D,FCB
	SYSTEM	15H		; posled.zapisx
	POP	D
	LXI	H,80H
	DAD	D
	XCHG			; smenitx adres pdp
	POP	H
	DCR	H		; s~et~ik blokow
	JNZ	OUTKEY
	LXI	D,FCB
	SYSTEM	10H		; zakrytx fajl
	JMP	WARM
;;;;						- 15 -
;;  oblastx tektowyh soob}enij
;;  --------------------------
ADVERT:
	DB	0CH,1BH,5EH,1BH,'b',1BH,']'
	DB	' SINCLAIR KEYS PROGRAM ',18H,18H
	DB	' VERS.3.4.27 '
	DB	0DH,0AH,1BH,5CH
	DB	' (s)1990,filippow e.w. ',18H,18H
	DB	'  09-FEB-90  '
	DB	0DH,0AH,1BH,'a',1BH,5EH,0FH,'$'
	DB	1BH,'a',1BH,5EH,0FH,'$'
tip:
	DB	'BASIC$'
	DB	'DIGIT$'
	DB	'CHAR $'
	DB	'CODE $'
zagtip:
	DB	0DH,0AH,1BH,05CH,1BH,'b',0DH,0AH
	DB	' nom. imq prg.  N  Z  tip   ...imq.... na~. dln. '
	DB	1BH,'a',0DH,0AH,0FH,'$'
;;
literal:
	DB	1BH,5CH,'$'
;;
READERR:
	DB	1BH,5CH
	DB	0DH,0AH,'o{ibka pri ~tenii fajla',0FH,'$'
FILEEND:
	DB	1BH,5CH
	DB	0DH,0AH,'fajl zakon~en',0FH,'$'
;;
timq:
	DB	0DH,0AH,1BH,5CH,'imq fajla:',0FH,'$'
tprg:
	DB	0DH,0AH,1BH,5CH,'imq programmy:',0FH,'$'
;;
NOFILE:
	DB	1BH,5CH
	DB	0DH,0AH,'net fajla',0FH,'$'
NONAME:
	DB	1BH,5CH
	DB	0DH,0AH,'newerno ukazano imq fajla',0FH,'$'
;;
ENDMEM:
	DB	1BH,5CH
	DB	0DH,0AH,'ne hwataet pamqti',0FH,'$'
;;
SNCFILE:
	DB	'SNC'
KEYFILE:
	DB	'KEY'
pustimq:
	DB	'        ',0
;;
;;
	ORG	($ OR 0FH) + 1
;;
	DB	'----------------'
	DB	'  filippow e.w. '
	DB	'    g.ki{inew   '
	DB	'   t.52-80-27   '
	DB	'   wers.3.4.27  '
	DB	'----------------'
;;
	END
NEWKEY			; sbrositx KEY fajl
	MVI	M,0FFH
;;
COMAND:
	LXI	SP,FIELD-1
;;
	LHLD	NEWKEY			; wosstanowitx tek. adres dlq
	SHLD